function data = getData(str)

    data.positions = parseJson(str,'position','char');
    data.channels = parseJson(str,'channel','char');
    data.acquiredTimepoints = parseJson(str,'acquire_time','num');
    data.expectedTimepoints = parseJson(str,'expected_acquire_time','num');
    data.exposureTimes = parseJson(str,'exposure_time','num');
    
end

% Sub-function
function data = parseJson(str,dataName,dataType)

    switch(dataType)
        case 'char'
            expStr = strcat('"',dataName,'":"([^"])+"');
        case 'num'
            expStr = strcat('"',dataName,'":(\d+)');
        otherwise
            error('Wrong data type provided, cannot parse JSON');
    end

    data = regexp(str,expStr,'tokens');

    if isempty(data)
        disp(['No matches to pattern ' expStr]);
    end

    data = data';

    if strcmp(dataType,'char')    
        data = [data{:}];
    else
        data = uint64(cellfun(@str2double,data));
    end

end