function roi = getRoi(str,channelNames)

roi = cell(1,length(channelNames));

for i = 1:length(channelNames)
    
    channelStr = strcat('"channel":"',channelNames{i},'"');
    xExp = strcat('"ROI-x":"([^"])+".*,',channelStr);
    
    % assume all rois are the same for each channel.
    x = regexp(str,xExp,'tokens','dotexceptnewline','once');
    
    if ~isempty(x)
        
        yExp = strcat('"ROI-y":"([^"])+".*,',channelStr);
        widthExp = strcat('"ROI-width":"([^"])+".*,',channelStr);
        heightExp = strcat('"ROI-height":"([^"])+".*,',channelStr);
        
    else % try to swap ROI and channel in regexp
        
        xExp = strcat(channelStr,'.*,"ROI-x":"([^"])+"');
        x = regexp(str,xExp,'tokens','dotexceptnewline','once');
        
        if ~isempty(x)
            
            yExp = strcat(channelStr,'.*,"ROI-y":"([^"])+"');
            widthExp = strcat(channelStr,'.*,"ROI-width":"([^"])+"');
            heightExp = strcat(channelStr,'.*,"ROI-height":"([^"])+"');
            
        else % no ROI specified for this channel
            
            roi{i} = NaN(1,4);
            continue;
            
        end
    end
    
    y = regexp(str,yExp,'tokens','dotexceptnewline','once');
    width = regexp(str,widthExp,'tokens','dotexceptnewline','once');
    height = regexp(str,heightExp,'tokens','dotexceptnewline','once');
    
    roi{i} = uint16([str2double(x{1})+1, str2double(y{1})+1, ...
                     str2double(width{1}), str2double(height{1})]);    

end

end