function spotIntensities = computeSpotIntensities(im,mask)
% Compute average spot fluorescence insensities in microarray image *im* 
% using a binary image *mask* with spot locations.
% Return 96*164 matrix with spot intensities.
props = regionprops(mask,im,'MeanIntensity');
NROWS = 96;
NCOLS = 82;
spotIntensities = reshape([props.MeanIntensity],NROWS,NCOLS*2);