function [dwellTimes,dwellTimesFromTo,tracesCompactStart,tracesCompactEnd] = calcDwellTimesV2(traces,numStates)

dwellTimes=cell(1,numStates);
dwellTimesFromTo=cell(numStates,numStates);

numTraces=numel(traces);
tracesCompactStart=cell(1,numTraces);
tracesCompactEnd=cell(1,numTraces);
numDwellInds=ones(1,numStates);
numDwellIndsFromTo=ones(numStates,numStates);
preAlloc=1000;
for j=1:numStates
    dwellTimes{j}=zeros(1,preAlloc);
end

for j=1:numStates
    for jj=1:numStates
        dwellTimesFromTo{j,jj}=zeros(1,preAlloc);
    end
end    
    
for i=1:numTraces
    traceL=numel(traces{i}(2,:));
    event=find(diff(traces{i}(2,:))~=0);
    startIndex=[1 event+1];
    endIndex=[event traceL];
    currDwellTimes=traces{i}(1,endIndex)-traces{i}(1,startIndex);
    currDwellInd=traces{i}(2,startIndex);
    tracesCompactStart{i}=traces{i}(:,startIndex);
    tracesCompactEnd{i}=traces{i}(:,endIndex);
   % currNextInd=traces{i}(2,endIndex);
    k=1;
    for j=currDwellInd
        dwellTimes{j}(numDwellInds(j))=currDwellTimes(k);
        numDwellInds(j)=numDwellInds(j)+1;
        if k<numel(currDwellInd)
            dwellTimesFromTo{j,currDwellInd(k+1)}(numDwellIndsFromTo(j,currDwellInd(k+1)))=currDwellTimes(k);
            numDwellIndsFromTo(j,currDwellInd(k+1))=numDwellIndsFromTo(j,currDwellInd(k+1))+1;
        end
        k=k+1;
    end
end

for j=1:numStates
    if numDwellInds(j)-1<preAlloc
        dwellTimes{j}=dwellTimes{j}(1:numDwellInds(j)-1);        
    end
end    

for j=1:numStates
    for jj=1:numStates
         if numDwellIndsFromTo(j,jj)-1<preAlloc
            dwellTimesFromTo{j,jj}=dwellTimesFromTo{j,jj}(1:numDwellIndsFromTo(j,jj)-1);
         end
    end
end

