function [dwellTimes,dwellTimesFromTo,tracesCompactStart,tracesCompactEnd] = calcDwellTimesV4(traces,numStates)
%V3 handle macroscopically dissociated state
%V4 returns the upper bound of the dwell time, that is the transation time
%from a state to another is counted for all dwelltimes
dwellTimes=cell(1,numStates);
dwellTimesFromTo=cell(numStates+1,numStates+1);

numTraces=numel(traces);
tracesCompactStart=cell(1,numTraces);
tracesCompactEnd=cell(1,numTraces);
numDwellInds=ones(1,numStates);
numDwellIndsFromTo=ones(numStates+1,numStates+1);
preAlloc=1000;
for j=1:numStates
    dwellTimes{j}=zeros(1,preAlloc);
end

for j=1:numStates+1
    for jj=1:numStates+1
        dwellTimesFromTo{j,jj}=zeros(1,preAlloc);
    end
end    
    
for i=1:numTraces
    traceL=numel(traces{i}(2,:));
    event=find(diff(traces{i}(2,:))~=0);
    startIndex=[1 event+1];
    endIndex=[event traceL]; 
    currDwellTimes=traces{i}(1,endIndex+1)-traces{i}(1,startIndex); %endIndex+1 to get dwell time until entered the next state
    currDwellInd=traces{i}(2,startIndex);
    tracesCompactStart{i}=traces{i}(:,startIndex);
    tracesCompactEnd{i}=traces{i}(:,endIndex);
   % currNextInd=traces{i}(2,endIndex);
    k=1;
    for j=currDwellInd(1:end-1)
        dwellTimes{j}(numDwellInds(j))=currDwellTimes(k);
        numDwellInds(j)=numDwellInds(j)+1;
        if k<numel(currDwellInd)
            dwellTimesFromTo{j,currDwellInd(k+1)}(numDwellIndsFromTo(j,currDwellInd(k+1)))=currDwellTimes(k);
            numDwellIndsFromTo(j,currDwellInd(k+1))=numDwellIndsFromTo(j,currDwellInd(k+1))+1;
        end
        k=k+1;
    end
end

for j=1:numStates
    if numDwellInds(j)-1<preAlloc
        dwellTimes{j}=dwellTimes{j}(1:numDwellInds(j)-1);        
    end
end    

for j=1:numStates+1
    for jj=1:numStates+1
         if numDwellIndsFromTo(j,jj)-1<preAlloc
            dwellTimesFromTo{j,jj}=dwellTimesFromTo{j,jj}(1:numDwellIndsFromTo(j,jj)-1);
         end
    end
end

