function [dwellTimes,dwellTimesFromTo,transMatr] = calcDwellTimes_andTransMatrV2(traces,numStates)

dwellTimes=cell(1,numStates);
dwellTimesFromTo=cell(numStates,numStates);

transMatr=zeros(numStates,numStates);
numTraces=numel(traces);
numDwellInds=ones(1,numStates);
numDwellIndsFromTo=ones(numStates,numStates);
preAlloc=1000;
for j=1:numStates
    dwellTimes{j}=zeros(1,preAlloc);
end

for j=1:numStates
    for jj=1:numStates
        dwellTimesFromTo{j,jj}=zeros(1,preAlloc);
    end
end    
    

for i=1:numTraces
    traceL=numel(traces{i}(2,:));
    event=find(diff(traces{i}(2,:))~=0);
    startIndex=[1 event+1];
    endIndex=[event traceL];
    currDwellTimes=traces{i}(1,endIndex)-traces{i}(1,startIndex);
    currDwellInd=traces{i}(2,startIndex);
    k=1;
    for j=currDwellInd
        dwellTimes{j}(numDwellInds(j))=currDwellTimes(k);
        numDwellInds(j)=numDwellInds(j)+1;
        
        if k<numel(currDwellInd)
            dwellTimesFromTo{j,currDwellInd(k+1)}(numDwellIndsFromTo(j,currDwellInd(k+1)))=currDwellTimes(k);
            numDwellIndsFromTo(j,currDwellInd(k+1))=numDwellIndsFromTo(j,currDwellInd(k+1))+1;
        end
        
        k=k+1;
    end
    
    for theindex=1:numel(traces{i}(2,:))-1
        currInd=traces{i}(2,theindex);
        nextInd=traces{i}(2,theindex+1);
        transMatr(currInd,nextInd)=transMatr(currInd,nextInd)+1;
    end
end

for j=1:numStates
    if numDwellInds(j)-1<preAlloc
        dwellTimes{j}=dwellTimes{j}(1:numDwellInds(j)-1);        
    end
end 


for j=1:numStates
    for jj=1:numStates
         if numDwellIndsFromTo(j,jj)-1<preAlloc
            dwellTimesFromTo{j,jj}=dwellTimesFromTo{j,jj}(1:numDwellIndsFromTo(j,jj)-1);
         end
    end
end


end

