function [distSquared,bestX,bestY] = findShortestDist(xPoints,yPoints,xNorm,yNorm,fun,xRange,numGuess)

nPoints=numel(xPoints);
distSquared=zeros(nPoints,1);
bestX=zeros(nPoints,1);
bestY=zeros(nPoints,1);
for j=1:nPoints
    xPoint=xPoints(j);
    yPoint=yPoints(j);
    funDiffSquared = @(x) ((xPoint-x)/xNorm)^2+((yPoint-fun(x))/yNorm)^2;
    
    xvals=zeros(1,numGuess);
    diffSquared=zeros(1,numGuess);
    opts=optimset('Display','off','Tolfun',1e-2,'TolX',1e-2);
    for i=1:numGuess
        x0=(xRange(2)-xRange(1))*rand();
        
        [xvals(i),diffSquared(i)]=fminsearch(funDiffSquared,x0,opts);
        
    end
    
    
    [distSquared(j),bestInd]=min(diffSquared);
    bestX(j)=xvals(bestInd);
    bestY(j)=fun(bestX(j));
end

end

