function [distsSquared,kdModel,kaModel] = funDiffStepModelRegionsTimesODEsFast(params,nsteps,kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,regionsAdded,seqIdentifier,dissocConc,assocConc,dissocMeasTimes,assocMeasTimes,retslope,analytic)
%Returns the differens between the model and  function values given by 
%[kdExpValsAll kaExpValsAll]
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob %outerlockeprob ]% probabilities are to go from state j+1 to j, so inwards
%in the model, towards sfully pecifically bound state. State 1 is the fully
%specifically bound state.
%Times Extended model, so that every state has a time spent in this state
%(effectively rates of transitions, not transition probabilities)
%params(1) = kaMax
%params(2) = kOffMicroDeep
%params(3:sum(regionsAdded)+2) = tranition probabilities inwards (towards
%specificillary bound
%params(sum(regionsAdded)+3:end) = 1/averae time spend in this testing
%state




numVals=numel(kdExpValsAll);
kdModel=zeros(numVals,1);
kaModel=zeros(numVals,1);

distsSquared=zeros(numVals,1);

currParams=zeros(1,nsteps+2);
currParams(1:2)=params(1:2);
currinvTimesParams=zeros(1,nsteps);
k=1;
paramsSplitRegions=cell(1,nsteps);
invTimesSplitRegions=cell(1,nsteps-1);
numTransitionProbs=sum(regionsAdded);
for i=1:nsteps
    paramsSplitRegions{i}=params(2+k:2+k+regionsAdded(i)-1);
  
    invTimesSplitRegions{i}=params(numTransitionProbs+2+k:numTransitionProbs+2+k+regionsAdded(i)-1);
   
    k=k+regionsAdded(i);
end

for i=1:numVals
    for j=1:nsteps
        currParams(2+j)=paramsSplitRegions{j}(seqIdentifier(i,j));
        currinvTimesParams(j)=invTimesSplitRegions{j}(seqIdentifier(i,j));
        
    end
    
   
    rates=modelRatesVecTimesODEsFast(currParams(1),currParams(2),currParams(3:end),currinvTimesParams,dissocConc,assocConc,dissocMeasTimes,assocMeasTimes,retslope,analytic);
    kd=rates(1);
    ka=rates(2);
    distsSquared(i)=((kdExpValsAll(i)-kd)/kdNorm)^2+((kaExpValsAll(i)-ka)/kaNorm)^2;
    kdModel(i)=kd;
    kaModel(i)=ka;
end



end

