function [distsSquared,kdModel,kaModel] = funDiffStepModelRegionsdeltaGandRates(params,nsteps,kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,regionsAdded,seqIdentifier)
%Returns the differens between the model and  function values given by 
%[kdExpValsAll kaExpValsAll]
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob %outerlockeprob ]% probabilities are to go from state j+1 to j, so inwards
%in the model, towards sfully pecifically bound state. State 1 is the fully
%specifically bound state.

kdPos=kdExpValsAll;
kaPos=kaExpValsAll;
if min(kdExpValsAll)<0

minkdPos=min(kdExpValsAll(kdExpValsAll>0));
kdPos(kdPos<=0)=minkdPos;

end

if min(kaExpValsAll)<0

minkaPos=min(kaExpValsAll(kaExpValsAll>0));
kaPos(kaPos<=0)=minkaPos;

end

deltaGExp=log(kdPos)-log(kaPos);

numVals=numel(kdExpValsAll);
kdModel=zeros(numVals,1);
kaModel=zeros(numVals,1);

distsSquared=zeros(numVals,1);

currParams=zeros(1,nsteps+2);
currParams(1:2)=params(1:2);
k=1;
paramsSplitRegions=cell(1,nsteps);
for i=1:nsteps
    paramsSplitRegions{i}=params(2+k:2+k+regionsAdded(i)-1);
    k=k+regionsAdded(i);
end

for i=1:numVals
    for j=1:nsteps
        currParams(2+j)=paramsSplitRegions{j}(seqIdentifier(i,j));
    end
    rates=modelRatesVec(currParams(1),currParams(2),currParams(3:end));
    kd=rates(1);
    ka=rates(2);
    
    deltaGmodel=log(kd)-log(ka);
    
    distsSquared(i)=(deltaGExp(i)-deltaGmodel)^2+((kdExpValsAll(i)-kd)/kdNorm)^2+((kaExpValsAll(i)-ka)/kaNorm)^2;
    kdModel(i)=kd;
    kaModel(i)=ka;
end



end

