function [distSquared,closestkd,closestka,currparams] = funDiffStepModelRetPointandParam(params,kdExp,kaExp,kdNorm,kaNorm,currStep)
%Returns the closest point between points [kdExp,kaExp] adn the model given
%by params, by changing the probaiblity defined by currStep. This funcion is ued to give
%the transition probabilites for a certain measurement point according to
%the model
%
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob
%outerlockeprob. Probabilies is to go from state i+1 to i State 1 is
%deepest specifically bound state

currParamInd=currStep+2;

funDiffSquared = @(x) funDiffSquaredModelParams(kdExp,kaExp,kdNorm,kaNorm,[params(1:2) params(3:currParamInd-1) 10^x params(currParamInd+1:end)]);
numGuess=100;
lb=-20;
ub=log10(params(currParamInd));

 opts=optimset('Display','off','Tolfun',1e-4,'TolX',1e-4);
 for i=1:numGuess
      x0=lb*rand();
     
     [xvals(i),diffSquared(i)]=fmincon(funDiffSquared,x0,[],[],[],[],lb,ub,[],opts);
     
 end
 
 [distSquared,ind]=min(diffSquared);
 
 currparams = params;
 
 currparams(currParamInd)=10^xvals(ind);
 
 rates=modelRatesVec(currparams(1),currparams(2),currparams(3:end));

 closestkd=rates(1);
 closestka=rates(2);
end

