function [transMatr] = genStepTransMatr(Pvals)
% generate the transiation probability matrix of a stepwise model,
% transtion prbabilities are given as the dim-2 x 1 vector Pvals, where
% Pvals(i) = probability of transiation from state i+1 to i.

%transMatr=[0 1 0 0;P21 0 1-P21 0;0 P32 0 1-P32;0 0 1 0];
dim=size(Pvals,2)+2;

transMatr=zeros(dim,dim);

transMatr(1,2)=1;
k=1;
for i=2:dim-1
    transMatr(i,i-1)=Pvals(k);
    transMatr(i,i+1)=1-Pvals(k);
    k=k+1;
end
transMatr(end,end-1)=1;
end

