function [transMatr] = genStepTransMatrExtended(Pvals,Pstarvals)
% generate the transiation probability matrix of a stepwise model,
% transtion prbabilities are given as the dim-2 x 1 vector Pvals, where
% Pvals(i) = probability of transiation from state i+1 to i.
%ExtendedPstarvals= The probability NOT to dissocate at this testing state dissocatie = pstar,
%so that 1-pstar is the probaiblity to disocate macroscopically directly from this
%state. pstarvals(i) is this probability at testing state i+1
%transMatr=[0 1 0 0;P21 0 Pstar-Pstar2 1-Pstar2;0 P32 0 1-P32;0 0 1 0];
dim=size(Pvals,2)+2;

transMatr=zeros(dim,dim);

transMatr(1,2)=1;
k=1;
for i=2:dim-2
    transMatr(i,i-1)=Pvals(k);
    transMatr(i,i+1)=Pstarvals(k)-Pvals(k);
    transMatr(i,end)=1-Pstarvals(k);
    k=k+1;
end

transMatr(end-1,end-2)=Pvals(k);
transMatr(end-1,end)=1-Pvals(k);
transMatr(end,end-1)=1;
end

