function [transMatr,reBindTimes,currSaveInd]=generateReMeetDistrHopv3(D1,hopRate,hopLength,DNAends,DNA,xStep,nSimul)
%v2: Normally distributed sampled hopsizes
%v3: Can hop out of DNA 
DNAdiscr=DNA/xStep;
DNAendsdiscr=DNAends/xStep;
x0=[1 zeros(size(DNA))]; %[nonspeciically bound /slidng, operator 1 bound state, operator 2 bound state, operator 3 bound state...];
transMatr = zeros(numel(DNA)+1,numel(DNA)+1);
reBindTimes=cell(numel(DNA)+1,numel(DNA)+1);
currSaveInd=ones(numel(DNA)+1,numel(DNA)+1);
moves=[-1 1 round(-hopLength/xStep) round(hopLength/xStep)];
Xall=zeros(1,1000);
Tall=zeros(1,1000);
ind=1;
tEnds=zeros(1,nSimul);
startIndAll=zeros(1,nSimul);
sampled_rxnAll=zeros(1,nSimul);
period=10;
numDNA=numel(DNA);
for i=1:numDNA+1
  for j=1:numDNA+1
    reBindTimes{i,j}=zeros(1,nSimul);
    
  end
end
for startInd = 1:numel(DNAdiscr)
    startPos=DNAdiscr(startInd);
    parfor i=1:nSimul
        % simulation time is kept in t.
        t = 0;
        % The protein can start either one bp to the left or right
        x=startPos+moves((rand()<0.5)+1)/xStep;
        Ti=1;
        % The simulation will be stopped after the system state has been saved at
        % the last time point in T.
        is_running=true;
        
        %s=zeros(1,4);
        s=zeros(1,3);
        while is_running
            %  Xall(ind)=x;
            %  Tall(ind)=t;
            
            % s is a vector containing the rate for each reaction, in this
            % case diffusion to either side
            s(1:2) = getDiffrates(x,D1,xStep,DNAendsdiscr);
            %s(3:4) = [hopRate/2 hopRate/2];
            s(3)=[hopRate];
            
            %sample the time until any evet will happen
            trxn = exprnd(1/(sum(s)));
            
            t = t + trxn;
            
            sampled_rxn = find(rand() <= cumsum(s)./sum(s),1);
            xExact=0;
            if sampled_rxn==3
                bpStep=normrnd(0,hopLength);
                numberTurns=round(bpStep/period,0);
                theStep=round(numberTurns*period/xStep,0);
                xExact=x+bpStep/xStep;
                x=x+theStep;
               
            else
                x=x+moves(sampled_rxn);
                xExact=x;
            end
            % check if hop was outside DNA, dissociation
            toHigh=xExact>DNAendsdiscr(2);
            toLow=xExact<DNAendsdiscr(1);
            
            
            if toHigh||toLow
                sampled_rxn=numDNA+1;
                startIndAll(i)=startInd;
                sampled_rxnAll(i)=sampled_rxn;
                tEnds(i)=t;
                
                is_running=false;
            end
            
            %ind=ind+1;
            
            % CHeck if on operator
            if sum((x==DNAdiscr))>0 %
                
                %sampled_rxn = find(rand() <= cumsum(r)./sum(r),1);
                sampled_rxn=find(x==DNAdiscr>0);
                startIndAll(i)=startInd;
                sampled_rxnAll(i)=sampled_rxn;
                tEnds(i)=t;
                
                is_running=false;
                
                
            end
            
        end
    end
    for i=1:nSimul
      startInd=startIndAll(i);  
      sampled_rxn=sampled_rxnAll(i);
      
      transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
      reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = tEnds(i);
      currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
    end
end

end