function [transMatrTraces,traces,totTime]=generateTracesSwitchingv2(koffVec,konInd,startInd,operators,kD,reBindDistr,maxDissocTraces,forbiddenState)


transMatrTraces=zeros(numel(operators),numel(operators));
reBindTimesCell=cell(numel(operators),numel(operators));
numReBindSamples=zeros(numel(operators),numel(operators));

transMatrProb=zeros(numel(operators),numel(operators));

currSaveInd=reBindDistr.currSaveInd{konInd};
transMatr=reBindDistr.transMatr{konInd};
reBindTimes=reBindDistr.reBindTimes{konInd};

for i=1:numel(operators)
    transMatrProb(i,:)=transMatr(i,:)/(sum(transMatr(i,:)));
    for j=1:numel(operators)
        reBindTimesCell{i,j}=reBindTimes{i,j}(1:currSaveInd(i,j)-1);
        numReBindSamples(i,j)=numel(reBindTimesCell{i,j});
    end
end

go = true;
startPos=operators(startInd);
traceInd=1;
currNDissoc=0;
totTime=0;
while go
    % simulation time is kept in t.
    t = 0;
    
    x=startPos;
    
    Xall=zeros(1,10000);
    Tall=zeros(1,10000);
    
    ind=1;
    
    
    is_running=true;
    Xall(ind)=x;
    Tall(ind)=t;
    
    ind=ind+1;
    while is_running
        
        % r is a vector containing the rate for each reaction
        r = (operators==x).*koffVec;%getRates(x,konVec,DNAdiscr);
        
        %sample the time until the dissocation accours
        trxn = exprnd(1/(sum(r)));
        
        t = t + trxn;
        
        Xall(ind)=x;
        Tall(ind)=t;
        
        ind=ind+1;
        
        currNDissoc=currNDissoc+1;
        
        % sample the operator where the protein rebinds
        
        
        
        
        % sample the operator where the protein rebinds
        
        
        sampled_rxn = find(rand() <= cumsum(transMatrProb(x,:))./sum(transMatrProb(x,:)),1);
        
        timeInd=ceil(rand()* numReBindSamples(x,sampled_rxn));
        
        trxn=reBindTimesCell{x,sampled_rxn}(timeInd);
        tMacroDissoc=exprnd(1/kD);
        if tMacroDissoc>trxn %Stays on the DNA
            
            
            if sum(sampled_rxn==forbiddenState)>0
                is_running=false;
            else
                
                transMatrTraces(x,sampled_rxn)=transMatrTraces(x,sampled_rxn)+1;
                t=t+trxn;
                x=sampled_rxn;
                Xall(ind)=x;
                Tall(ind)=t;
                
                ind=ind+1;
            end
            
        else % Macroscopical dissociation
            is_running=false;
        end
        
        if currNDissoc>=maxDissocTraces %Enough microscopical dissociations sampled?
            is_running=false;
            go=false;
        end
        
        if ~is_running
            traces{traceInd}=[Tall(1:ind-1);Xall(1:ind-1)];
            traceInd=traceInd+1;
            totTime=totTime+t;
            
        end
        
    end    
end