function [kdModel,kaModel,paramsSep,invTimesSep]= getParamsAndRates(seqIdentifier,params,ODEModelUsed,regionsAdded,dissocConc,assocConc,dissocMeasTimes,assocMeasTimes,retslope,analytic)
% Given a matrix of seqIdentifers, and parameters of a model, this function
% calcualtes the on and offrates of of all sequences according to the
% model. Also returns the parameters for each sequence, seperated out.
%ver2: Bug dixing to make thi function work without hte ODEmodel (infinitely short times spent in testing state)

numVals=size(seqIdentifier,1);
nsteps=size(seqIdentifier,2);
kdModel=zeros(numVals,1);
kaModel=zeros(numVals,1);


currParams=zeros(1,nsteps+2);
currParams(1:2)=params(1:2);
currinvTimesParams=zeros(1,nsteps);
k=1;
paramsSplitRegions=cell(1,nsteps);
if ODEModelUsed==1
    invTimesSplitRegions=cell(1,nsteps);
end
numTransitionProbs=sum(regionsAdded);

paramsSep=NaN*zeros(numVals,nsteps+2);
if ODEModelUsed==1
    invTimesSep=NaN*zeros(numVals,nsteps);
else
    invTimesSep=[];
end
   
for i=1:nsteps
    paramsSplitRegions{i}=params(2+k:2+k+regionsAdded(i)-1);
    if ODEModelUsed==1
        invTimesSplitRegions{i}=params(numTransitionProbs+2+k:numTransitionProbs+2+k+regionsAdded(i)-1);
    end
    k=k+regionsAdded(i);
end

for i=1:numVals
    if sum(seqIdentifier(i,:)==0)>0 %This part sequence region was not present in the training dataset
        kdModel(i)=NaN;
        kaModel(i)=NaN;
        paramsSep(i,:)=NaN;
        
    else
        if ODEModelUsed==1
            
            for j=1:nsteps
                currParams(2+j)=paramsSplitRegions{j}(seqIdentifier(i,j));
                if ODEModelUsed==1
                    currinvTimesParams(j)=invTimesSplitRegions{j}(seqIdentifier(i,j));
                end
            end
            
            if ODEModelUsed==1
                rates=modelRatesVecTimesODEs(currParams(1),currParams(2),currParams(3:end),currinvTimesParams,dissocConc,assocConc,dissocMeasTimes,assocMeasTimes,retslope,analytic);
            else
                rates=modelRatesVec(currParams(1),currParams(2),currParams(3:end));
            end
            kd=rates(1);
            ka=rates(2);
            kdModel(i)=kd;
            kaModel(i)=ka;
            paramsSep(i,:)=currParams;
            if ODEModelUsed==1
                invTimesSep=currinvTimesParams;
            end
        end
    end
end


end

