function [vals2D,ticks,tickslabels]=make2Dmapver2(vals,sequences,onTarget,spacing)
% This function makes 2D heatmap of values for single and double mutants
% compared to the on target
%Ver2: DOnt have zeros when ther is no measurement

numPos=numel(onTarget);
numSeq=numel(sequences);
vals2D = ones(3*numPos+spacing*numPos+1+spacing,3*numPos+spacing*numPos+1+spacing);
baseOrder='ACGT';

    for i = 1: numSeq
        mutCheck=sequences{i}-onTarget;
        mutPos=find(mutCheck~=0);
        mutBase='';
        coords=[1 1];
        for j=1:numel(mutPos) 
            mutBase(j)=sequences{i}(mutPos(j));
            onBase=onTarget(mutPos(j));
            currMuts=setdiff(baseOrder,onBase);
            mutInd=find(currMuts-mutBase(j)==0);
            coords(j)=(mutPos(j)-1)*3+(mutPos(j)-1)*spacing+mutInd;
            
        end
        
        if coords(2)==1
            vals2D(1,coords(1)+1+spacing)=vals(i);
        else
            vals2D(coords(1)+1+spacing,coords(2)+1+spacing)=vals(i);
        end
    end
    
    
    ticks=zeros(3*numPos+1,1);
    tickslabels=cell(3*numPos+1,1);
    tickslabels{1}='SM';
    ticks(1)=1;
    k=2;
    for i=1:numPos
       
            onBase=onTarget(i);
            currMuts=setdiff(baseOrder,onBase);
        for j=1:3  
            tickslabels{k}=char(currMuts(j));
            ticks(k)=(i-1)*3+(i-1)*spacing+j+1+spacing;
            k=k+1;
        end
    end
    
  
end

