function [traces,endTimes] = markovTraces(startInd,endInd,rateMatr,nTraces)
%markovTraces returns traces for a continues markovchain with transistion
%matrix rateMatr
     
traces=cell(1,nTraces);
endTimes=zeros(1,nTraces);

parfor traceInd=1:nTraces

t=0;
x=startInd;
runLoop=true;
Xall=zeros(1,10000);
Tall=zeros(1,10000);
ind=1;

Tall(ind)=0;
Xall(ind)=x;
ind=ind+1;
while runLoop
    xPrev=x;
    rates=rateMatr(x,:);
    
    sampled_rxn= find(rand() <= cumsum(rates)./sum(rates),1);
    x=sampled_rxn;
    trxn = exprnd(1/(sum([rates])));
    t = t + trxn;
    
    Tall(ind)=t;
    Xall(ind)=xPrev;
    
    ind=ind+1;
    
    Tall(ind)=t;
    Xall(ind)=x;
    
    if x==endInd
        runLoop=false;
    end
    
    if ~runLoop
        endTimes(traceInd)=t;
        traces{traceInd}=[Tall(1:ind-1);Xall(1:ind-1)];
    end    
end
end

