function [PForward,PBackward] = modelProbsJohan(pvals)
%Function gives probabilities to transition to reach all states of the
%model, before transiatoning back to the end states (as defined in the
%manuscript), but with notation and parameters as in the function
%modelRatesVec
%(kaMax,kOffMicroDeep,pvals), where pvals is a
%vector with probabilities, pvals(i)= probability to transiation from state
%i+1 to i, where state 1 is the completeley specifically bound state (with microscopic offrate kOffMicroDeep)

numTesting=numel(pvals);
newprobs=1-pvals; %To get probabilities in the other direction. newprobs(i) is the probability to transition from state i to state i+1


PForward=zeros(1,numTesting);
PBackward=zeros(1,numTesting);
PForward(1)=1;%The probability to reach the first testing state is always 1

for i=2:numTesting
    talj=newprobs(i-1);
    for j=2:i-1
        talj=talj*newprobs(j-1)/(1-newprobs(j));
        
    end
    
    PForward(i)=talj/((1-newprobs(1))+talj);   
    
end


end

