function [kd,ka] = modelRatesMultCurvesv2LogRange(kaMax,kOffMicroDeep,nsteps,PvalsMatr,PRanges,numPoints)
% nteps = number of steps in the testing of binding mechanism. The simples
% 3 state mdoel has nsteps=1
%Pranges(i,2:3)= rangge in witch transition probabiliy PRanges(i,1)varies.
%Tje Other transition probabilites are then given by PvalsMatr(i,:)
%PvalsMatr(i,j is not i) = probability of transiation from state j+1 to j.

%numPoints=100;
numRanges=size(PRanges,1);
dim=nsteps+2;
timesOn=zeros(dim,1);
timesOn(end)=1/kaMax;

timesOff=zeros(dim,1);
timesOff(1)=1/kOffMicroDeep;

ka=zeros(numRanges,numPoints);
kd=zeros(numRanges,numPoints);
k=1;
for j=1:numRanges
    Pvec=logspace(PRanges(j,2),PRanges(j,3),numPoints);
    Pvals=PvalsMatr(PRanges(j,1),:);
    for i=1:numel(Pvec)
        PvalsTemp=Pvals;
        PvalsTemp(PRanges(j,1))=Pvec(i);
        
        transMatr=genStepTransMatr(PvalsTemp);
        
        [onMatr,offMatr] = getTimeMatr(transMatr);
        
        solutionOn=onMatr\timesOn;
        solutionOff=offMatr\timesOff;
        
        ka(j,i)=1./solutionOn(end);
        kd(j,i)=1./solutionOff(1);
        k=k+1;
        
    end
end

end

