function [theInEq,theDiff] = modelRatesVecDiffConInEq(kaMax,kOffMicroDeep,pvals,kdRef,kaRef)
%This function returns difference ratesModel-ratesRef, where ratesModel=[kd,ka] for a multistep sequential binding
%process parameterised by (kaMax,kOffMicroDeep,pvals), where pvals is a
%vector with probabilities, pvals(i)= probability to transiation from state
%i+1 to i, where state 1 is the completeley specifically bound state (with microscopic offrate kOffMicroDeep)
%ratesRef=[kdRef,kaRef]
%For to be use as constraints, with inequalites
 ratesModel=modelRatesVec(kaMax,kOffMicroDeep,pvals);
        
 %ratesRef=[kdRef,kaRef];
 
 theInEq=zeros(1,4);
 
 theInEq(1) = -(ratesModel(1)-kdRef(1));
 theInEq(2)=ratesModel(1)-kdRef(2);
 theInEq(3)= -(ratesModel(2)-kaRef(1));
 theInEq(4)=ratesModel(2)-kaRef(2);
 
 theDiff=-1;
    
end

