addpath(genpath('Functions'));

%% Simualted ka vs kd space, sampling from known distributions of K_D and koff_micro

perc=0.32; %confidence interval, when estimating the variation
konmaxParam=1;
numSamples=10000;
KDMaxparam=50;
KDMinparam=0.1;
koffmicrominparam=0.01;
wantedFac=0.1;
numToShow=1000;%Number of operators to show in the plot;
% For plotting
edgeslim=[-1.5/20 1.5*5 -1/20 1*5];
extray=0.05;
extrax=0.05;

rng(1);

%KDsamples=10.^(log10(KDMinparam)+rand(1,numSamples)*(log10(KDMaxparam)-log10(KDMinparam)));
%KDsamples=KDMinparam+rand(1,numSamples)*(KDMaxparam-KDMinparam);
%KDsamples=2*randn(1,numSamples)+3;
%KDsamples(KDsamples<0.1)=0.1;
KDsamples=zeros(1,numSamples);
k=1;
while k<=numSamples
   KDsamples(k)=2*randn(1,1)+0.5;
   %KDsamples(k)=10.^(log10(KDMinparam)+rand(1,1)*(log10(KDMaxparam)-log10(KDMinparam)));
   if KDsamples(k)>KDMinparam
       k=k+1;
   end
end
%KDsamples=(kamax/koffmicrotot)*(kdvals(okinds)./kavals(okinds))';
%numSamples=numel(KDs(okinds));
% [counts,bins]=hist(KDsamples,logspace(log10(KDMinparam),log10(KDMaxparam),50));
% figure();
% hold on;
% plot(bins,counts,'b');
% test=gca;
% test.XScale='log';

numSimul=500;
koffmicroMeanParam=1;
koffMicroMinVec=logspace(-3,log10(0.99),numSimul);

%koffMacroMaxVec=-koffmicroMeanParam*lambertw(-koffMicroMinVec.*exp(-koffMicroMinVec/koffmicroMeanParam)/koffmicroMeanParam); %To get correct mean for koffmicro distribution
koffMicroMaxVec=2*koffmicroMeanParam-koffMicroMinVec;
koffMicroStdVec=logspace(-2,3,numSimul);


kaSamples=zeros(numSimul,numSamples);
kdSamples=zeros(numSimul,numSamples);
koffmicroSamples=zeros(numSimul,numSamples);
ptotSamples=zeros(numSimul,numSamples);
ptotMean=zeros(numSimul,1);
ptotVar=zeros(numSimul,1);
koffmicroMean=zeros(numSimul,1);
koffmicroVar=zeros(numSimul,1);

minkoffmicros=zeros(numSimul,1);
maxkoffmicros=zeros(numSimul,1);
minptots=zeros(numSimul,1);
maxptots=zeros(numSimul,1);
centerptots=zeros(numSimul,1);
centerkoffmicros=zeros(numSimul,1);

for i=1:numSimul
    %koffmicroSamples(i,:)=koffMicroMinVec(i)+rand(1,numSamples)*(koffMicroMaxVec(i)-koffMicroMinVec(i));
    k=1;
    while k<=numSamples
        koffmicroSamples(i,k)=koffmicroMeanParam+randn(1,1).*koffMicroStdVec(i);
        %KDsamples(k)=10.^(log10(KDMinparam)+rand(1,1)*(log10(KDMaxparam)-log10(KDMinparam)));
        if koffmicroSamples(i,k)>koffmicrominparam
            k=k+1;
        end
    end
    %koffmicroSamples(i,:)=koffmicroMeanParam+randn(1,numSamples).*koffMicroStdVec(i);
    %koffmicroSamples(i,koffmicroSamples(i,:)<0)=0;
    ptotSamples(i,:)=koffmicroSamples(i,:)./(KDsamples.*konmaxParam+koffmicroSamples(i,:));
    kaSamples(i,:)=konmaxParam*ptotSamples(i,:);
    kdSamples(i,:)=koffmicroSamples(i,:).*(1-ptotSamples(i,:));
    
    ptotMean(i)=mean(ptotSamples(i,:));
    ptotVar(i)=var(ptotSamples(i,:));
    
    koffmicroMean(i)=mean(koffmicroSamples(i,:));
    koffmicroVar(i)=var(koffmicroSamples(i,:));
    
    [sortedkoffmicros,sortinds]=sort(koffmicroSamples(i,:),'ascend');
    numToExcludeEachSide=round((perc/2)*numSamples);
    startind=numToExcludeEachSide+1;
    endind=numSamples-numToExcludeEachSide;
    
    minkoffmicros(i)=sortedkoffmicros(startind);
    maxkoffmicros(i)=sortedkoffmicros(endind);
    
    [sortedptots,sortinds]=sort(ptotSamples(i,:),'ascend');
    
    minptots(i)=sortedptots(startind);
    maxptots(i)=sortedptots(endind);
    
    centerkoffmicros(i)=mean(sortedkoffmicros(startind:endind));
    centerptots(i)=mean(sortedptots(startind:endind));
    
end
koffmicroStdovermean=sqrt(koffmicroVar)./koffmicroMean;
ptotStdovermean=sqrt(ptotVar)./ptotMean;

%ptotVarMeausure=(maxptots-minptots)./ptotMean;
%koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./koffmicroMean;

ptotVarMeausure=(maxptots-minptots)./centerptots;
koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./centerkoffmicros;
figure();

%plot(koffmicroStdovermean,ptotStdovermean);
%xlabel('koffmicroStdovermean');
%ylabel('ptotStdovermean');

figure;
plot(koffmicroVarMeasure./ptotVarMeausure)
xlabel('simul N');
ylabel('koffmicroVarMeasure/ptotVarMeasure')



figure;
plot(koffmicroStdovermean./ptotStdovermean)
xlabel('simul N');
ylabel('koffmicroStdovermean./ptotStdovermean')


%[~,simInd]=min(abs(koffmicroStdovermean./ptotStdovermean-wantedFac));
[~,simInd]=min(abs(koffmicroVarMeasure./ptotVarMeausure-wantedFac));

%fig=figure();
%hold on;
%title(['simInd: ' num2str(simInd)]);
%scatter(kdSamples(simInd,:),kaSamples(simInd,:),1,'b');
heatscatterver3(kdSamples(simInd,1:numToShow)',kaSamples(simInd,1:numToShow)','','','400',edgeslim,numToShow);



fig=gcf;
test=gca;
axis square
cf=corrcoef(kdSamples(simInd,:),kaSamples(simInd,:));
cf=cf(1,2);
legend(['corr. coef. = ' num2str(cf)],'Location','Northoutside');
ylabel('k_a');
xlabel('k_d');
xlim([0-extrax 1+extrax]);
ylim([0-extray 1+extray]);
axis square;
box on;
fig.Children(2).Label.String='Number of operators in neighborhood';
theclim=fig.Children(3).CLim;
fig.Children(3).CLim=theclim;
fig.Children(2).Location='southoutside';
fig.Position=[500 200 400 400];
thef=gca;
thef.Position=[0.15 0.3 ((1+2*extrax)/1.5)*0.18 0.18];
fig.Children(2).Position(1)=0.8;
%fig.Children(1).Position(2)=0.8;
fig.Children(2).Position=[0.16 0.16 0.12 0.02];
daspect([1.5 1 1]);
%% Simualted ka vs kd space, sampling from known distributions of K_D and koff_micro same var
konmaxParam=1;

wantedFac=1;

rng(2);
%KDsamples=10.^(log10(KDMinparam)+rand(1,numSamples)*(log10(KDMaxparam)-log10(KDMinparam)));
%KDsamples=KDMinparam+rand(1,numSamples)*(KDMaxparam-KDMinparam);
%KDsamples=2*randn(1,numSamples)+3;
%KDsamples(KDsamples<0.1)=0.1;
% KDsamples=zeros(1,numSamples);
% k=1;
% while k<=numSamples
%    KDsamples(k)=2*randn(1,1)+2;
%    if KDsamples(k)>KDMinparam
%        k=k+1;
%    end
% end

% [counts,bins]=hist(KDsamples,logspace(log10(KDMinparam),log10(KDMaxparam),50));
% figure();
% hold on;
% plot(bins,counts,'b');
% test=gca;
% test.XScale='log';

numSimul=500;
koffmicroMeanParam=1;
koffMicroMinVec=logspace(-3,log10(0.99),numSimul);

%koffMacroMaxVec=-koffmicroMeanParam*lambertw(-koffMicroMinVec.*exp(-koffMicroMinVec/koffmicroMeanParam)/koffmicroMeanParam); %To get correct mean for koffmicro distribution
koffMicroMaxVec=2*koffmicroMeanParam-koffMicroMinVec;
koffMicroStdVec=logspace(-2,3,numSimul);


kaSamples=zeros(numSimul,numSamples);
kdSamples=zeros(numSimul,numSamples);
koffmicroSamples=zeros(numSimul,numSamples);
ptotSamples=zeros(numSimul,numSamples);
ptotMean=zeros(numSimul,1);
ptotVar=zeros(numSimul,1);
koffmicroMean=zeros(numSimul,1);
koffmicroVar=zeros(numSimul,1);

for i=1:numSimul
    %koffmicroSamples(i,:)=koffMicroMinVec(i)+rand(1,numSamples)*(koffMicroMaxVec(i)-koffMicroMinVec(i));
    k=1;
    while k<=numSamples
        koffmicroSamples(i,k)=koffmicroMeanParam+randn(1,1).*koffMicroStdVec(i);
        %KDsamples(k)=10.^(log10(KDMinparam)+rand(1,1)*(log10(KDMaxparam)-log10(KDMinparam)));
        if koffmicroSamples(i,k)>koffmicrominparam
            k=k+1;
        end
    end
    %koffmicroSamples(i,:)=koffmicroMeanParam+randn(1,numSamples).*koffMicroStdVec(i);
    %koffmicroSamples(i,koffmicroSamples(i,:)<0)=0;
    ptotSamples(i,:)=koffmicroSamples(i,:)./(KDsamples.*konmaxParam+koffmicroSamples(i,:));
    kaSamples(i,:)=konmaxParam*ptotSamples(i,:);
    kdSamples(i,:)=koffmicroSamples(i,:).*(1-ptotSamples(i,:));
    
    ptotMean(i)=mean(ptotSamples(i,:));
    ptotVar(i)=var(ptotSamples(i,:));
    
    koffmicroMean(i)=mean(koffmicroSamples(i,:));
    koffmicroVar(i)=var(koffmicroSamples(i,:));
    
    [sortedkoffmicros,sortinds]=sort(koffmicroSamples(i,:),'ascend');
    numToExcludeEachSide=round((perc/2)*numSamples);
    startind=numToExcludeEachSide+1;
    endind=numSamples-numToExcludeEachSide;
    
    minkoffmicros(i)=sortedkoffmicros(startind);
    maxkoffmicros(i)=sortedkoffmicros(endind);
    
    [sortedptots,sortinds]=sort(ptotSamples(i,:),'ascend');
    
    minptots(i)=sortedptots(startind);
    maxptots(i)=sortedptots(endind);
    centerkoffmicros(i)=mean(sortedkoffmicros(startind:endind));
    centerptots(i)=mean(sortedptots(startind:endind));
    
    
end
koffmicroStdovermean=sqrt(koffmicroVar)./koffmicroMean;
ptotStdovermean=sqrt(ptotVar)./ptotMean;


%ptotVarMeausure=(maxptots-minptots)./ptotMean;
%koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./koffmicroMean;

ptotVarMeausure=(maxptots-minptots)./centerptots;
koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./centerkoffmicros;

figure();

%plot(koffmicroStdovermean,ptotStdovermean);
%xlabel('koffmicroStdovermean');
%ylabel('ptotStdovermean');

figure;
plot(koffmicroVarMeasure./ptotVarMeausure)
xlabel('simul N');
ylabel('koffmicroVarMeasure/ptotVarMeasure')



figure;
plot(koffmicroStdovermean./ptotStdovermean)
xlabel('simul N');
ylabel('koffmicroStdovermean./ptotStdovermean')


%[~,simInd]=min(abs(koffmicroStdovermean./ptotStdovermean-wantedFac));
[~,simInd]=min(abs(koffmicroVarMeasure./ptotVarMeausure-wantedFac));

%fig=figure();
%hold on;
%title(['simInd: ' num2str(simInd)]);
%scatter(kdSamples(simInd,:),kaSamples(simInd,:),1,'b');
heatscatterver3(kdSamples(simInd,1:numToShow)',kaSamples(simInd,1:numToShow)','','','400',edgeslim,numToShow);
fig=gcf;
test=gca;
axis square
cf=corrcoef(kdSamples(simInd,:),kaSamples(simInd,:));
cf=cf(1,2);
legend(['corr. coef. = ' num2str(cf)],'Location','Northoutside');
ylabel('k_a');
xlabel('k_d');
xlim([0-extrax 2+extrax]);
ylim([0-extray 1+extray]);
box on;
axis square;
fig.Children(2).Label.String='Number of operators in neighborhood';
theclim=fig.Children(3).CLim;
fig.Children(3).CLim=theclim;
fig.Children(2).Location='southoutside';
fig.Position=[500 200 400 400];
thef=gca;
thef.Position=[0.15 0.3 ((2+2*extrax)/1.5)*0.18 0.18];
fig.Children(2).Position(1)=0.8;
%fig.Children(1).Position(2)=0.8;
fig.Children(2).Position=[0.16 0.16 0.12 0.02];
daspect([1.5 1 1]);
%% Simualted ka vs kd space, sampling from known distributions of K_D and ptot
konmaxParam=1;


%KDMaxparam=5;
%KDMinparam=0.1;
wantedFac=10;

rng(3);

%KDsamples=10.^(log10(KDMinparam)+rand(1,numSamples)*(log10(KDMaxparam)-log10(KDMinparam)));
%KDsamples=KDMinparam+rand(1,numSamples)*(KDMaxparam-KDMinparam);
%KDsamples=2*randn(1,numSamples)+3;
%KDsamples(KDsamples<0)=0;
% [counts,bins]=hist(KDsamples,logspace(log10(KDMinparam),log10(KDMaxparam),50));
% figure();
% hold on;
% plot(bins,counts,'b');
% test=gca;
% test.XScale='log';

numSimul=500;
ptotMeanParam=0.5;
ptotStdVec=logspace(-2,0,numSimul);


kaSamples=zeros(numSimul,numSamples);
kdSamples=zeros(numSimul,numSamples);
koffmicroSamples=zeros(numSimul,numSamples);
ptotSamples=zeros(numSimul,numSamples);
ptotMean=zeros(numSimul,1);
ptotVar=zeros(numSimul,1);
koffmicroMean=zeros(numSimul,1);
koffmicroVar=zeros(numSimul,1);

for i=1:numSimul
    %koffmicroSamples(i,:)=koffMicroMinVec(i)+rand(1,numSamples)*(koffMicroMaxVec(i)-koffMicroMinVec(i));
    %ptotSamples(i,:)=ptotMeanParam+randn(1,numSamples).*ptotStdVec(i);
    %ptotSamples(i,ptotSamples(i,:)<0)=0;
    %ptotSamples(i,ptotSamples(i,:)>1)=1;
    k=1;
    while k<=numSamples
       ptotSamples(i,k)=ptotMeanParam+randn(1,1).*ptotStdVec(i);
        
        if ptotSamples(i,k)>0&&ptotSamples(i,k)<1
            k=k+1;
        end
    end
    koffmicroSamples(i,:)=KDsamples*konmaxParam.*ptotSamples(i,:)./(1-ptotSamples(i,:));
    kaSamples(i,:)=konmaxParam*ptotSamples(i,:);
    kdSamples(i,:)=koffmicroSamples(i,:).*(1-ptotSamples(i,:));
    
    ptotMean(i)=mean(ptotSamples(i,:));
    ptotVar(i)=var(ptotSamples(i,:));
    
    koffmicroMean(i)=mean(koffmicroSamples(i,:));
    koffmicroVar(i)=var(koffmicroSamples(i,:));
    
    [sortedkoffmicros,sortinds]=sort(koffmicroSamples(i,:),'ascend');
    numToExcludeEachSide=round((perc/2)*numSamples);
    startind=numToExcludeEachSide+1;
    endind=numSamples-numToExcludeEachSide;
    
    minkoffmicros(i)=sortedkoffmicros(startind);
    maxkoffmicros(i)=sortedkoffmicros(endind);
    
    [sortedptots,sortinds]=sort(ptotSamples(i,:),'ascend');
    
    minptots(i)=sortedptots(startind);
    maxptots(i)=sortedptots(endind);
    centerkoffmicros(i)=mean(sortedkoffmicros(startind:endind));
    centerptots(i)=mean(sortedptots(startind:endind));
    
    
end
koffmicroStdovermean=sqrt(koffmicroVar)./koffmicroMean;
ptotStdovermean=sqrt(ptotVar)./ptotMean;

%ptotVarMeausure=(maxptots-minptots)./ptotMean;
%koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./koffmicroMean;

ptotVarMeausure=(maxptots-minptots)./centerptots;
koffmicroVarMeasure=(maxkoffmicros-minkoffmicros)./centerkoffmicros;

figure();

%plot(koffmicroStdovermean,ptotStdovermean);
%xlabel('koffmicroStdovermean');
%ylabel('ptotStdovermean');

figure;
plot(koffmicroVarMeasure./ptotVarMeausure)
xlabel('simul N');
ylabel('koffmicroVarMeasure/ptotVarMeasure')



figure;
plot(koffmicroStdovermean./ptotStdovermean)
xlabel('simul N');
ylabel('koffmicroStdovermean./ptotStdovermean')


%[~,simInd]=min(abs(koffmicroStdovermean./ptotStdovermean-wantedFac));
[~,simInd]=min(abs(koffmicroVarMeasure./ptotVarMeausure-wantedFac));

%fig=figure();
%hold on;
%title(['simInd: ' num2str(simInd)]);
%scatter(kdSamples(simInd,:),kaSamples(simInd,:),1,'b');
heatscatterver3(kdSamples(simInd,1:numToShow)',kaSamples(simInd,1:numToShow)','','','400',edgeslim,numToShow);
fig=gcf;
test=gca;
axis square
cf=corrcoef(kdSamples(simInd,:),kaSamples(simInd,:));
cf=cf(1,2);
legend(['corr. coef. = ' num2str(cf)],'Location','Northoutside');
ylabel('k_a');
xlabel('k_d');
xlim([0-extrax 4+extrax]);
ylim([0-extray 1+extray]);
box on;
fig.Children(2).Label.String='Number of operators in neighborhood';
theclim=fig.Children(3).CLim;
fig.Children(3).CLim=theclim;
fig.Children(2).Location='southoutside';
fig.Position=[500 200 400 400];
thef=gca;
thef.Position=[0.15 0.3 ((4+2*extrax)/1.5)*0.18 0.18];
fig.Children(2).Position(1)=0.8;
%fig.Children(1).Position(2)=0.8;
fig.Children(2).Position=[0.16 0.16 0.12 0.02];
daspect([1.5 1 1]);
%%
