%% Fig 2 C
theName='fig_2_C';
fig=openfig([theName '.fig']);
set(fig,'renderer','Painters')
set(fig, 'PaperPositionMode','auto')
fig.Position=[500 200 350 175];

for i=1:2
    ax=nexttile(i);
    box(ax,'on');
    ax.FontSize=7;
    ax.FontName='Arial';
    ax.XColor=[0 0 0];
    ax.YColor=[0 0 0];
    ax.XLabel.FontSize=7;
    ax.YLabel.FontSize=7;

    ax.Children(1).SizeData=3.676;
    ax.Children(2).SizeData=3.676;
end

savefig([theName '_formatted.fig']);
print('-depsc','-r300','-painters',[theName '_formatted.eps']);
%% Fig 2D
theName='fig_2_D';
fig=openfig([theName '.fig']);

set(fig,'renderer','Painters')
% set(fig, 'PaperPositionMode','auto')
fig.Position=[400 100 600 600];

ax=gca;
box(ax,'off');
ax.FontSize=7;
ax.FontName='Arial';
ax.XColor=[0 0 0];
ax.YColor=[0 0 0];
ax.XLabel.FontSize=7;
ax.YLabel.FontSize=7;

ax.Children(1).SizeData=25;
ax.Children(2).SizeData=25;
ax.Children(3).SizeData=25;
ax.Children(4).SizeData=14;
ax.Children(5).SizeData=14;
ax.Position=[0.1 0.3 0.4 0.4];

h=findobj(fig.Children,'Type','Colorbar');
h.Label.FontSize=7;
h.Label.Color=[0 0 0];
h.FontSize=7;
h.Color=[0 0 0];
h.Position=[0.75 0.3 0.02 0.15];

savefig([theName '_formatted.fig']);
print('-depsc','-r300','-painters',[theName '_formatted.eps']);
%% 
theName='fig_S1_B';
fig=openfig([theName '.fig']);
set(fig,'renderer','Painters')
set(fig, 'PaperPositionMode','auto')
fig.Position=[400 100 750 375];

for i=1:2
    ax=nexttile(i);
    title(ax,'');
    box(ax,'off');
    ax.FontSize=7;
    ax.FontName='Arial';
    ax.XColor=[0 0 0];
    ax.YColor=[0 0 0];
    ax.XLabel.FontSize=7;
    ax.YLabel.FontSize=7;


    ax.Children(1).SizeData=25;
    ax.Children(2).SizeData=25;
    ax.Children(3).SizeData=25;
    ax.Children(4).SizeData=14;
    ax.Children(5).SizeData=14;
end

hs=findobj(fig,'Type','Colorbar');
for i=1:2
    h=hs(i);
    h.Label.FontSize=7;
    h.Label.Color=[0 0 0];
    h.FontSize=7;
    h.Color=[0 0 0];
    h.Label.String = 'Number of operators in neighboorhood';
    if i==1
        h.Position=[0.5 0.6 0.02 0.15];
    else
        h.Position=[0.92 0.6 0.02 0.15];
    end
end



savefig([theName '_formatted.fig']);
print('-depsc','-r300','-painters',[theName '_formatted.eps']);
%%
theName='fig_S1_C';
fig=openfig([theName '.fig']);
set(fig,'renderer','Painters')
set(fig, 'PaperPositionMode','auto')

for i=1:3
    ax=nexttile(i);
    box(ax,'on');
    ax.FontSize=7;
    ax.FontName='Arial';
    ax.XColor=[0 0 0];
    ax.YColor=[0 0 0];
    ax.XLabel.FontSize=7;
    ax.YLabel.FontSize=7;
    ax.XTick=[1 10 100];
    ax.YTick=[1 10 100];

    set(ax.Children(1),'LineWidth',0.75,'MarkerSize',5)
    set(ax.Children(2),'SizeData',3.676,'Marker','.')
end

fig.Position=[500 200 525 175];

savefig([theName '_formatted.fig']);
print('-depsc','-r300','-painters',[theName '_formatted.eps']);