function [autcorrs2d,autcorrs2dshifted] = calcSplitAutocorrelation(intensityTraces,norm,useTraceMean,minLevel,maxLevel)
%This function calcualtes autocorrelation functions of traces, but without
%averaging over the different time. So for every trace you get a 2d
%autocorrealtion function autcorr2d(i,j) where i is the reference time, and
%j-1 is the timelag. Reutnrs cell array with autocorrelation functions, also
%autcorrs2dshifted wher the autocorrelation function for time point i has
%been shifted to start at the ith column.

% - if norm is 1, the first point for all split autorrelation by dividing
% with the value first point for the first point

numTraces=numel(intensityTraces);
autcorrs2d=cell(1,numTraces);
autcorrs2dshifted=cell(1,numTraces);
sumInt=0;
totPoints=0;
for i=1:numTraces
    trace=intensityTraces{i};
    trace(trace<minLevel)=minLevel;
    trace(trace>maxLevel)=maxLevel;
    sumInt=sumInt+sum(trace);
    totPoints=totPoints+numel(trace);
end

totMean=sumInt/totPoints;
for i=1:numTraces
    trace=intensityTraces{i};
    trace(trace<minLevel)=minLevel;
    trace(trace>maxLevel)=maxLevel;
    if useTraceMean
        ymean=mean(trace);
    else
        ymean=totMean;
        
    end
    numTimePoints=numel(trace);
    autcorrs2d{i}=NaN*zeros(numTimePoints,numTimePoints);
    autcorrs2dshifted{i}=NaN*zeros(numTimePoints,numTimePoints);
    for j=1:numTimePoints
        yt=trace(j);
        currAutoCorr=zeros(1,numTimePoints-j+1);
        numlagscurr=numel(currAutoCorr);
        for k=1:numlagscurr
            currAutoCorr(k)=(yt-ymean)*(trace(j+k-1)-ymean);    
        end    
        if norm==1
            currAutoCorr=curAutoCor/currAutoCorr(1);
        end
        autcorrs2d{i}(j,1:numlagscurr)=currAutoCorr;
        autcorrs2dshifted{i}(j,j:end)=currAutoCorr;
    end    
 
end    

end

