function [kaOperators,kaStrainsFit] = fitAdditiveModel(expkasStrains,containsOperator,numGuesses,guessMin,guessMax)
%UThis function returns assocation rates from the addive for strains Hammar
%et al, Science 2012
funDiff = @(x) sum((expkasStrains-getRatesForPetterStrains(x,containsOperator)).^2);

numOperators=size(containsOperator,2);

lb=ones(1,numOperators)*-inf;
ub=ones(1,numOperators)*inf;




options=optimoptions('fmincon','Display','off','TolX',1e-5,'TolFun',1e-5);
paramsAll=zeros(numGuesses,numel(lb));
resnormAll=zeros(numGuesses,1);
for j= 1:numGuesses
    
    params0=(guessMin+rand(1,numel(lb)).*(guessMax-guessMin));
    
    
    
    [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
    resnormAll(j)=resnorm;
    paramsAll(j,:)=paramsCurr;
    
    
end

[bestResNorm,bestind]=min(resnormAll);
bestParams=paramsAll(bestind,:);
kaOperators=bestParams;
kaStrainsFit=getRatesForPetterStrains(kaOperators,containsOperator);
end

