function [kdFromSlope,kaFromSlope,intensityAllTime,intensityFirstTime] = getRatesIntensityMethod(traces,timeVec,startTimeAllTimes,protconc,intBounds,minLevel,maxLevel,fitPointsSlopeoff,fitPointsSlopeon)
%This function estiamtes on and offrates based on fitting a slope to the
%sum of the fluorescence intensity, reconstructed from single molecule data. 
%Slope in the beginning of curve is used to estimate the on and offrate


[~,startIndAll]=min(abs(timeVec-startTimeAllTimes));
numTraces=numel(traces);
numBoundsCorr=numel(intBounds);
numTimePoints=numel(traces{1});
intensityFirstTime=zeros(numBoundsCorr,numTimePoints);
intensityAllTime=zeros(numBoundsCorr,numTimePoints);

for i=1:numTraces
    
    intenseFirst=(traces{i}(1));
    trace=traces{i}';
    trace(trace<minLevel)=minLevel;
    trace(trace>maxLevel)=maxLevel;
    
    [~,ind]=min(abs(intBounds-intenseFirst));
    intensityFirstTime(ind,:)=intensityFirstTime(ind,:)+trace;
    for j=startIndAll:numTimePoints
        [~,ind]=min(abs(intBounds-trace(j)));
        intensityAllTime(ind,1:numTimePoints-j+1)=intensityAllTime(ind,1:numTimePoints-j+1)+trace(j:end);%nansum([autoCorrsAllTime(ind,:);autcorrs2d{i}(j,:)]);
        %if ind==numel(intBounds)
        %    break;
        %end
    end
end
if maxLevel<inf
    intensityFirstTime=intensityFirstTime/(numTraces*maxLevel);
else
    intensityFirstTime=intensityFirstTime/numTraces;
    
end
p=polyfit(timeVec(1:fitPointsSlopeon),intensityFirstTime(1,1:fitPointsSlopeon),1);
slopeon=p(1);
kaFromSlope=slopeon/protconc;
intensityAllTimeNew=zeros(numBoundsCorr,numTimePoints-1);
for i=1:numBoundsCorr
    correction=movmean(intensityAllTime(i,:),2);
    intensityAllTimeNew(i,:)=[intensityAllTime(i,1) correction(3:end)];
end

intensityAllTime=intensityAllTimeNew;
p=polyfit(timeVec(1:fitPointsSlopeoff),intensityAllTime(end,1:fitPointsSlopeoff)/intensityAllTime(end,1),1);
% p=polyfit(timeVec(1:fitPointsSlopeoff),intensityAllTime(end,1:2:2*fitPointsSlopeoff-1)/intensityAllTime(end,1),1);
slopeoff=p(1);
kdFromSlope=-slopeoff;


end

