function [kd,background] = getkdFromSlopeandSteady(slopeoff,steadyStateLevel,ka,kbleach)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

numCurves=numel(slopeoff);

thefun = @(x) [(steadyStateLevel-theorySteadyState(x(1:numCurves),x(end),ka,kbleach)).^2  (slopeoff-theorySlopeOff(x(1:numCurves),x(end),ka,kbleach)).^2];

funDiff = @(x) sum((steadyStateLevel-theorySteadyState(x(1:numCurves),x(end),ka,kbleach)).^2) + sum((slopeoff-theorySlopeOff(x(1:numCurves),x(end),ka,kbleach)).^2)*1000;
lb=[1e-5*ones(1,numCurves) 0*ones(1,numCurves)];
ub=[1e5*ones(1,numCurves) steadyStateLevel*0.9*ones(1,numCurves)];

guessMaxLog10=[-5*ones(1,numCurves) -5];
guessMinLog10=[0*ones(1,numCurves) 0];


options=optimoptions('fmincon','Display','off','TolX',1e-8,'TolFun',1e-8,'MaxFunctionEvaluations',5000);
numGuesses=5;
paramsAll=zeros(numGuesses,numel(lb));
resnormAll=zeros(numGuesses,1);
for i= 1:numGuesses
    
    %params0=10.^(guessMinLog10+rand(1,numel(lb)).*(guessMaxLog10-guessMinLog10));
    
    
    
   [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
    %[paramsCurr,resnorm]=fsolve(thefun,params0,options);
    resnormAll(i)=sum(resnorm);
    paramsAll(i,:)=paramsCurr;
    
    
end

[bestResNorm,bestind]=min(resnormAll);
bestParams=paramsAll(bestind,:);

kd =bestParams(1:end-1);
background=bestParams(end);

bgVals=0:0.01:1;
kdVals=logspace(-5,0.5,100);
funValues=zeros(numel(kdVals),numel(bgVals));
for i=1:numel(kdVals)
   for j=1:numel(bgVals) 
        funValues(i,j)=funDiff([kdVals(i) bgVals(j)]);
       
   end
end 
figure();
surf(bgVals,kdVals,funValues)
xlabel('bg')
ylabel('kd')
test=gca
test.YScale='log'
test.ZScale='log'
test.ColorScale='log'  
end



