function [rotatedCoord] = applyRotationToPoint(sizeIm, pointCoord, rotAngle)
    
    % rotation matrix
    T = [ cos(deg2rad(rotAngle)) -sin(deg2rad(rotAngle)) 0;
          sin(deg2rad(rotAngle))  cos(deg2rad(rotAngle)) 0;
          0 0 1];
    
    % rotation aorund the center of the image, not the image origin
    rotCenter = [ceil(sizeIm(1)/2); ceil(sizeIm(2)/2)];
    
    a = [1 0 rotCenter(1); 0 1 rotCenter(2); 0 0 1];
    c = [1 0 -rotCenter(2); 0 1 -rotCenter(1); 0 0 1];
    
    M = a*T*c;
    
    rotatedCoord = M*[pointCoord(1) pointCoord(2) 1]';
    rotatedCoord = rotatedCoord(1:2)';
end