function [Y] = bandpasstest(theim,nsteps,startrow,startcol,stoprow,stopcol)
% Bandpass filters and image along the diagonal in the fourier space. 
    Y=fft2(theim);
    stepy=(stoprow-startrow+1)/nsteps;
    stepx=(stopcol-startcol+1)/nsteps;
    [nrows,ncols]=size(theim);
    figure();
    imagesc(log(abs(Y)+1));
    rowindexes=startrow:stepy:stoprow;
    colindexes=startcol:stepx:stopcol;
    title('Fourier transform');
    figure();
    subplot(1,2,1);
    imagesc(theim);
    colormap(gray);
    colorbar;
    subplot(1,2,2);
    imagesc(log(abs(Y)+1))
    title('Fourier transform');
    
    for index=1:nsteps;
        i=rowindexes(index);
        j=colindexes(index);
        filter=zeros(nrows,ncols);
        filter(i:i+stepy-1,j:j+stepx-1)=ones(stepy,stepx);
        filter(nrows-i-stepy+2:nrows-i+1,ncols-j-stepx+2:ncols-j+1)=ones(stepy,stepx);
        %filter(i:i+stepy-1,ncols-j-stepx+2:ncols-j+1)=ones(stepy,stepx);
        %filter(nrows-i-stepy+2:nrows-i+1,j:j+stepx-1)=ones(stepy,stepx);
        newY=Y.*filter;
        newim=ifft2(newY);
        figure();
        subplot(1,2,1);
        imagesc(real(newim));
        colormap(gray);
        colorbar;
        title(['Frequancy filtered, row: ' num2str(i) ' column: ' num2str(j)]);
        subplot(1,2,2);
        imagesc(log(abs(newY)+1))
        title('Fourier transform');
    end
    
end

