function [Y] = bandpasstestshift(theim,nsteps,startrow,startcol,stoprow,stopcol)
% Bandpass filters and image along the diagonal in the fourier space. 
    Y=fftshift(fft2(theim));
    stepy=(stoprow-startrow+1)/nsteps;
    stepx=(stopcol-startcol+1)/nsteps;
    [nrows,ncols]=size(theim);
    figure();
    imagesc(log(abs(Y)+1));
    rowindexes=startrow:nsteps:stoprow;
    colindexes=startcol:nsteps:stopcol;
    title('Fourier transform');
    for index=1:nsteps;
        i=rowindexes(index);
        j=colindexes(index);
        filter=zeros(nrows,ncols);
        filter(i:i+stepy-1,j:j+stepx-1)=ones(stepy,stepx);
        filter(nrows-i-stepy+1:nrows-i,ncols-j-stepx+1:ncols-j)=ones(stepy,stepx);
        filter(i:i+stepy-1,ncols-j-stepx+1:ncols-j)=ones(stepy,stepx);
        filter(nrows-i-stepy+1:nrows-i,j:j+stepx-1)=ones(stepy,stepx);
        newY=Y.*filter;
        newim=ifft2(newY);
        figure();
        imagesc(real(newim));
        colormap(gray);
        colorbar;
        title(['Frequancy filtered, row: ' num2str(i) ' column: ' num2str(j)]);
    end
    
end

