function [Y] = bandpasstestshift(theim,nsteps,startrow,startcol,stoprow,stopcol)
% Bandpass filters and image along the diagonal in the fourier space. 
    Y=fftshift(fft2(theim));
    stepy=(stoprow-startrow)/nsteps;
    stepx=(stopcol-startcol)/nsteps;
    [nrows,ncols]=size(theim);
    figure();
    imagesc(log(abs(Y)+1));
    rowindexes=startrow:stepy:stoprow;
    colindexes=startcol:stepx:stopcol;
    title('Fourier transform');
    for index=1:nsteps;
        i=rowindexes(index);
        j=colindexes(index);
        filter=zeros(nrows,ncols);
        sizey=nrows-2*i+2;
        sizex=ncols-2*j+2;
        filter(i:nrows-i+1,j:ncols-j+1)=ones(sizey,sizex);
        newY=Y.*filter;
        newim=ifft2(ifftshift(newY));
        
        figure();
        subplot(1,2,1);
        imagesc(real(newim));
        colormap(gray);
        colorbar;
        title(['Frequancy filtered, row: ' num2str(i) ' column: ' num2str(j)]);
        subplot(1,2,2);
        imagesc(log(abs(newY)+1))
        title('Fourier transform');
        
    end
    
end

