function [background] = calcBackgroundStartFrame(POLIMG,nmin,nmax,startframe)
%input:
%- POLIMG = [rows,cols,2 images, umber of pixels] with intensity values
%- nmin and nmax define the number of smallest and largest points to
%include in the calculation in the cluster centroids, and thus the cutoff
%for classiying points to clusters

numframes=length(POLIMG(1,1,1,startframe:end));
[nrows,ncols,~,~]=size(POLIMG);
background=cell(1,2);
background{1}=zeros(nrows,ncols);

for i=1:nrows
    %disp(i);
    for j = 1:ncols
        dataPol1=reshape(POLIMG(i,j,1,startframe:end),[numframes 1 1 1]);
        dataPol2=reshape(POLIMG(i,j,2,startframe:end),[numframes 1 1 1]);
        [sortedValsPol1,~]=sort(dataPol1,'descend');
        [sortedValsPol2,~]=sort(dataPol2,'descend');
        %calcualte centroids from the nmin smalels and nmin lagerst pixel
        %intesnities
        Cpol1(1)=mean(sortedValsPol1(end-(nmin-1):end));
        Cpol1(2)=mean(sortedValsPol1(1:nmax));
        cutoff1=(Cpol1(1)+Cpol1(2))/2;
        %Tpol1=kmeans(dataPol1,2,'MaxIter',1,'Start',Cpol1');
        %calculate backgroudn as mean of the smalles cluster
        background{1}(i,j)=mean(dataPol1(dataPol1<cutoff1));
        
    
        %calcualte centroids from the nmin smalels and nmin lagerst pixel
        %intesnities
        Cpol2(1)=mean(sortedValsPol2(end-(nmin-1):end));
        Cpol2(2)=mean(sortedValsPol2(1:nmax));
        cutoff2=(Cpol2(1)+Cpol2(2))/2;
        %Tpol2=kmeans(dataPol2,2,'MaxIter',1,'Start',Cpol2');
        %calculate backgroudn as mean of the smalles cluster
        background{2}(i,j)=mean(dataPol2(dataPol2<cutoff2));
        
         
    end
end
end

