function [background] = calcBackgroundkmeans(POLIMG,startframe,k)
%input:
%- POLIMG = [rows,cols,2 images, umber of pixels] with intensity values
%- nmin and nmax define the number of smallest and largest points to
%include in the calculation in the cluster centroids, and thus the cutoff
%for classiying points to clusters

numframes=length(POLIMG(1,1,1,startframe:end));
[nrows,ncols,~,~]=size(POLIMG);
background=cell(1,2);
background{1}=zeros(nrows,ncols);
background{2}=zeros(nrows,ncols);
for i=1:nrows
  %  disp(i);
    for j = 1:ncols
        dataPol1=reshape(POLIMG(i,j,1,startframe:end),[numframes 1 1 1]);
        dataPol2=reshape(POLIMG(i,j,2,startframe:end),[numframes 1 1 1]);
        [~,clustcenters1]=kmeans(dataPol1,k);
        [~,clustcenters2]=kmeans(dataPol2,k);
        background{1}(i,j)=min(clustcenters1);
        background{2}(i,j)=min(clustcenters2);
       
    end
end
end

