function [background] = calcBackgroundkmeansBinnedpixels(POLIMG,startframe,k,pixelbin)
%input:
%- POLIMG = [rows,cols,2 images, umber of pixels] with intensity values
%- nmin and nmax define the number of smallest and largest points to
%include in the calculation in the cluster centroids, and thus the cutoff
%for classiying points to clusters

numframes=length(POLIMG(1,1,1,startframe:end));
[nrows,ncols,~,~]=size(POLIMG);
background=cell(1,2);
background{1}=zeros(nrows,ncols);
background{2}=zeros(nrows,ncols);

for i=1:pixelbin:nrows-pixelbin+1

    for j = 1:pixelbin:ncols-pixelbin+1
        lastindi=i+pixelbin-1;
        lastindj=j+pixelbin-1;
        dataPol1=reshape(mean(mean(POLIMG(i:lastindi,j:lastindj,1,startframe:end))),[numframes 1 1 1]);
        dataPol2=reshape(mean(mean(POLIMG(i:lastindi,j:lastindj,2,startframe:end))),[numframes 1 1 1]);
        [~,clustcenters1]=kmeans(dataPol1,k);
        [~,clustcenters2]=kmeans(dataPol2,k);
        vals1=sort(clustcenters1,'ascend');
        vals2=sort(clustcenters2,'ascend');
        background{1}(i:lastindi,j:lastindj)=vals1(1)*ones(pixelbin,pixelbin);
        background{2}(i:lastindi,j:lastindj)=vals2(1)*ones(pixelbin,pixelbin);
    end
end
end

