function [background] = calcBackgroundlowpassver6(POLIMG,edgerem,cut,startframe)
%input:
%- POLIMG = [rows,cols,2 images, umber of pixels] with intensity values
%Edgerem: Describing how many pixels closest in edge in fourier space to
%use when calcualting background
%Also adding cut parameter, to not get enitire border, but only the pixels
%closest to corner, smaller than cut.

[nrows,ncols,~,~]=size(POLIMG);

iters=10;
perc=0;
figure();
imMean=zeros(nrows,ncols,2);
imMean(:,:,1)=mean(POLIMG(:,:,1,:),4);
imMean(:,:,2)=mean(POLIMG(:,:,2,:),4);
plot(imMean(156,:,2))
hold on;
k=0;
for i=1:iters,

    filter=ones(nrows,ncols);
    
    filter(1:edgerem,1:cut)=zeros(edgerem,cut);
    filter(1:edgerem,end-cut+1:end)=zeros(edgerem,cut);
    
    filter(end-edgerem+1:end,1:cut)=zeros(edgerem,cut);
    filter(end-edgerem+1:end,end-cut+1:end)=zeros(edgerem,cut);
    
    filter(1:cut,1:edgerem)=zeros(cut,edgerem);
    filter(end-cut+1:end,1:edgerem)=zeros(cut,edgerem);
    
    filter(1:cut,end-edgerem+1:end)=zeros(cut,edgerem);
    filter(end-cut+1:end,end-edgerem+1:end)=zeros(cut,edgerem);
    
    filter=ones(nrows,ncols)-filter;
    background=calcBackgroundbandpass(imMean,filter,startframe);
    inds1=imMean(:,:,1)>background{1}*(1+perc);
    tempMean1=imMean(:,:,1);
    tempMean1(inds1)=background{1}(inds1);
    
    
    inds2=imMean(:,:,2)>background{2}*(1+perc);
    tempMean2=imMean(:,:,2);
    tempMean2(inds2)=background{2}(inds2);
   
    imMean(:,:,1)=tempMean1;
    imMean(:,:,2)=tempMean2;
  
    
    plot(background{2}(156,:),'r')
    
    %edgerem=edgerem-1;
    %cut=cut-1;
    
end
end

