function [background] = calcBackgroundminwindow(POLIMG,startframe,window)
%input:
%- POLIMG = [rows,cols,2 images, umber of pixels] with intensity values
%- nmin and nmax define the number of smallest and largest points to
%include in the calculation in the cluster centroids, and thus the cutoff
%for classiying points to clusters

numframes=length(POLIMG(1,1,1,startframe:end));
[nrows,ncols,~,~]=size(POLIMG);
background=cell(1,2);
background{1}=zeros(nrows,ncols);
background{2}=zeros(nrows,ncols);
for i=1:nrows
    for j = 1:ncols
        tic;
        dataPol1=reshape(POLIMG(i,j,1,startframe:end),[numframes 1 1 1]);
        dataPol2=reshape(POLIMG(i,j,2,startframe:end),[numframes 1 1 1]);
        [theL,~]=size(dataPol1);
        bg1=zeros(theL-window,1);
        bg2=zeros(theL-window,1);
        for k=1:theL-window
            bg1(k)=mean(dataPol1(k:k+window));
            bg2(k)=mean(dataPol2(k:k+window));
        end
       
        background{1}(i,j)=min(bg1);
        background{2}(i,j)=min(bg2);
       toc
    end
end
end

