function [] =  clearExtendedBorders(pathPhase, pathSegmented,pathOut, strelRadius)

    if nargin < 4 
        strelRadius = 6;
    end
    
    listPhase = dir(strcat(pathPhase,filesep,'*.tif*'));
    listSegmented = dir(strcat(pathSegmented,filesep,'*.tif*'));
    se = strel('disk',strelRadius,4);
    
    for ii = 1:length(listPhase)
        currPhase = imread(strcat(pathPhase,filesep,listPhase(ii).name));
        currSegmented = imread(strcat(pathSegmented,filesep,listSegmented(ii).name));
        
        extendedBorder = currPhase == 0;
        extendedBorder(1,:) = 1;
        extendedBorder(:,1) = 1;
        extendedBorder(size(extendedBorder,1),:) = 1;
        extendedBorder(:,size(extendedBorder,2)) = 1;
        extendedBorder = imdilate(extendedBorder,se);
        binSegmented = im2bw(currSegmented,0.00000001);
        binSegmented = max(binSegmented, extendedBorder);
        clearedIm = imclearborder(binSegmented);
        labeledIm = bwlabel(clearedIm,4);
        imwrite(uint16(labeledIm),strcat(pathOut,filesep,listSegmented(ii).name));
    end
end