function displayDots(imFolder, trackedCellFile, imRange, imRatio)

if nargin < 4
    imRatio = 1;
end

cellMatFile = load(trackedCellFile);
fieldName = fieldnames(cellMatFile);
cellStruct = cellMatFile.(fieldName{1});

imList = dir(strcat(imFolder,filesep,'*.tif*'));

for imIdx = imRange
    currIm = imread(strcat(imFolder,filesep,imList(imIdx).name));
    
    figure, imagesc(currIm), colormap(gray), hold on
    
    currCellStruct = cellStruct(vertcat(cellStruct.movieIdx) == imIdx);
    
    for cellIdx = 1:length(currCellStruct)
        currCell = currCellStruct(cellIdx);

        for partIdx = 1:length(currCell.particles)
            plot(currCell.particles(partIdx).trajImageCoord(1)*imRatio,currCell.particles(partIdx).trajImageCoord(2)*imRatio,'rx','MarkerSize',8, 'LineWidth',3), hold on
        end
    end
end

set(gca, 'xticklabel',[])
set(gca, 'yticklabel',[])
set(gca, 'position', [0 0 1 1], 'units', 'normalized')
