function [] = displayDotsOnFluo(sourceFolder, outputFolder, parameterFile)

    positionList = dir(strcat(sourceFolder,filesep,'Pos*'));
    se = strel('disk',3,8);
    
    if nargin<4
        parameters = parseParameterFile();
    else
        parameters = parseParameterFile(parameterFile);
    end
    
    %% Preprocessing
    disp('Preprocessing.');
    for positionIdx = 1:length(positionList)
        disp(positionList(positionIdx).name);
        
        cellMatList = dir(strcat(outputFolder,filesep,positionList(positionIdx).name,filesep,'*.mat'));
        cellMatFile = load(strcat(outputFolder,filesep,positionList(positionIdx).name,filesep,cellMatList(1).name));
        fieldName = fieldnames(cellMatFile);
        cellStruct = cellMatFile.(fieldName{1});
        inFluoList = dir(strcat(sourceFolder,filesep,positionList(positionIdx).name,filesep,'*.tif*'));
        
        for fluoIdx = 1:length(inFluoList)
            [currentFluoImage, numberOfFrames] = BuildTrajectories.ML_loadStack2(strcat(sourceFolder,filesep,positionList(positionIdx).name,filesep,inFluoList(fluoIdx).name),2500);
            for fIdx = 1:numberOfFrames
                currFluo = currentFluoImage(:,:,fIdx);
            
                currCellStruct = cellStruct(vertcat(cellStruct.movieIdx) == fluoIdx);
                
                for cellIdx = 1:length(currCellStruct)
                    currCell = currCellStruct(cellIdx);
                    
                    for partIdx = 1:length(currCell.particles)
                        
                        if currCell.particles(partIdx).firstFrame == fIdx
                            figure, imagesc(currFluo), colormap(gray), hold on;
                            plot(currCell.particles(partIdx).trajImageCoord(1,1),currCell.particles(partIdx).trajImageCoord(1,2),'r.')
                            pause
                        end
                    end
                end
                
            end
        end
    end
    
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            