function [loglikelihoodX,loglikelihoodY] = getSlidingLikelihood(thetraj,Dx,Dy,scale,deltat)
%Given a trajectory with pixel values as two first column, and 1d diffusion
%constants in um^2/s, calcualtes the likelihood of the trajectory given the
%model (Dx and Dy). scale is the size of pixels in nm and deltat is the
%timestep in ms.

DxConv=Dx*10^6*((1/scale)^2);
DyConv=Dy*10^6*((1/scale)^2);

gammaX=(4*DxConv*deltat*10^-3)^-1;
gammaY=(4*DyConv*deltat*10^-3)^-1;

[numsteps,~]=size(thetraj);
deltaX=diff(thetraj(:,1));
deltaY=diff(thetraj(:,2));
loglikelihoodX=(numsteps-1)*log(gammaX/pi)/2-sum(gammaX*deltaX.^2);
loglikelihoodY=(numsteps-1)*log(gammaY/pi)/2-sum(gammaY*deltaY.^2);
if isnan(loglikelihoodX)&&Dx==0
    loglikelihoodX=-inf;
end
if isnan(loglikelihoodY)&&Dy==0
    loglikelihoodY=-inf;
end
%for i=1:numsteps-1;
%    xContr=log(gammaX/pi)/2-gammaX*deltaX(i)^2;
%    yContr=log(gammaY/pi)/2-gammaY*deltaY(i)^2;
%    loglikelihoodX=loglikelihoodX+xContr;
%    loglikelihoodY=loglikelihoodY+yContr;
%end


end

