function [xTrans, yTrans,xForward,yForward,xBackward,yBackward] = getTranslationFromGridSkipTop(inImg, displayRegistration,imgTop,imgMid)

% Get the middle of the image and separate the two channels
%imgMid = round((size(inImg,1)+imgTop)/2);
imCutOff=0;
image1 = inImg(imgTop:imgMid,:);
image2 = inImg(imgMid+1:end,:);

image1(image1<imCutOff)=0;
image2(image2<imCutOff)=0;

[optimizer, metric]=imregconfig('multimodal');

optimizer.MaximumIterations = 10000;

% Register image2 to image1
[lol1, ~, TmatrixForward]=imregister2(image2,image1,'translation',optimizer,metric);

% Register image1 to image2
[lol2, ~, TmatrixBackward]=imregister2(image1,image2,'translation',optimizer,metric);

% Average the two
xForward = TmatrixForward.T(3,1);
yForward = TmatrixForward.T(3,2);

xBackward = -TmatrixBackward.T(3,1);
yBackward = -TmatrixBackward.T(3,2);

xTrans = mean([xForward xBackward]);
yTrans = mean([yForward yBackward]);

if displayRegistration
    figure, imshowpair(lol1,image1)
    figure, imshowpair(lol2,image2)
end
end