function [trajPol] = polIntensitieswbgandGapPerFramever2(thePOLIMG,traj,square,background)
%calculates the polarization signals of the trajectory traj, intesnitiy
%information in thePOLIMG{1}and {2}. square givs size of integration domain.
%backgrounds is subtracted. If the dot points was interpolated (gap) the
%intensity is set to NaN
%PerFrame: background{polImgIndex,frame}, is specified for each frame
%of the movies
%ver2; Changed indexing of background cell (frames now i nmatrix, not cell) 

centers=round(traj(:,1:2));
numsteps=length(centers);
trajPol=zeros(numsteps,2);
[limy,limx]=size(thePOLIMG(:,:,1));
for i=1:numsteps
    frameNumber=traj(i,4); 
    ymin=centers(i,2)-square;
    ymax=centers(i,2)+square;
    xmin=centers(i,1)-square;
    xmax=centers(i,1)+square;
    
    if ymin<1||ymax>limy||xmin<1||xmax>limx||isnan(traj(i,1))||isnan(traj(i,7))||isnan(traj(i,1))||isnan(traj(i,2))
        trajPol(i,1)=NaN;
        trajPol(i,2)=NaN;
    else
     trajPol(i,1)=sum(sum(thePOLIMG(ymin:1:ymax,xmin:1:xmax,1,traj(i,4))))-sum(sum(background{1}(ymin:1:ymax,xmin:1:xmax,frameNumber)));
    trajPol(i,2)=sum(sum(thePOLIMG(ymin:1:ymax,xmin:1:xmax,2,traj(i,4))))-sum(sum(background{2}(ymin:1:ymax,xmin:1:xmax,frameNumber)));   
    end
    
    
    
    
end

