function [transformationMatrix] = registerWithLandmarks(phaseIm, brightFieldIm)

% Select control points
[phasePoints, brightFieldPoints] = cpselect(phaseIm, brightFieldIm,'Wait',true);

% Fine tune control points
phasePoints = cpcorr(phasePoints, brightFieldPoints, phaseIm, brightFieldIm);

% Estimate transformation
transformation = cp2tform(phasePoints, brightFieldPoints,'affine');
transformationMatrix = transformation.tdata.T;

%% To display the result
%info = imfinfo(brightField);
%phase_registered = imtransform(phaseIm,t_concord,'XData',[1 info.Width],'YData',[1 info.Height]);
%figure, imshow(imfuse(phase_registered,brightFieldIm,'falsecolor','Scaling','joint','ColorChannels',[1 2 0]));