function [] = removeBackground(pathImages,pathOutput)
% Based on Mats Waldén work, removes the white stripes at top and bottom of
% the phase contrast images and then rescales the images and saves them as
% uint16

    listIm = dir(strcat(pathImages,filesep,'*.tif*'));

    % Remove the background
    for imIdx = 1:length(listIm)
        im = uint16(imread(strcat(pathImages,filesep,listIm(imIdx).name)));
        spectrum=fft2(im);
        spectrum(:,1)=0;
        imwrite(real(ifft2(spectrum)),strcat(pathOutput,filesep,'Rescaled_',listIm(imIdx).name));
    end
    
    % Find the min and max value in the dataset
    maxVal = -1;
    minVal = 65536;
    for imIdx = 1:length(listIm)
        im = uint16(imread(strcat(pathOutput,filesep,'Rescaled_',listIm(imIdx).name)));
        if max(max(im)) > maxVal
            maxVal = max(max(im));
        end
        if min(min(im)) < minVal
            minVal = min(min(im));
        end
    end
    
    % Compute the rescaling ratio
    newRatio = 65535/(maxVal-minVal);
    
    % Rescale and save the images
    for imIdx = 1:length(listIm)
        im = uint16(imread(strcat(pathOutput,filesep,'Rescaled_',listIm(imIdx).name)));
        tempIm = (im-minVal).*newRatio;
        outIm = uint16(tempIm);
        imwrite(outIm,strcat(pathOutput,filesep,'Rescaled_',listIm(imIdx).name));
    end
end