function [] = reorientImages(sourceFolder,outputFolder, rotationIn, flipDim1, flipDim2, imRange)
% Function to reorient the images regarding: rotation by an angle of 90
% degrees, up/down flip and left/right flip. Set the different flags for
% the different changes and it will apply them and save the images in the
% output folder.
%
% Inputs:
%       - imRange : range of indecies of images to be processed

    listImages = dir(strcat(sourceFolder,filesep,'*.tif*'));
    
    if nargin < 6
       imRange = 1:length(listImages);
    end
    
    for imIdx=imRange
        Im = imread(strcat(sourceFolder,filesep,listImages(imIdx).name));
        
        if rotationIn ~= 0
            Im = rot90(Im,rotationIn);
        end
        if flipDim1
            Im = flipdim(Im,1);
        end
        if flipDim2
            Im = flipdim(Im,2);
        end
        
        imwrite(Im,strcat(outputFolder,filesep,'Or_',listImages(imIdx).name));
    end
end