function [] = resizeImages(pathImages, outputPath, outSize, imRange)
% Resizes all the images in the pathImages folder to the outSize and saves
% them in outputPath.
%
% Inputs:
%       - imRange : range of indecies of images to be processed

    list = dir(strcat(pathImages,filesep,'*.tif'));
    tiffBool = false;
    
    if isempty(list)
        list = dir(strcat(pathImages,filesep,'*.tiff'));
        tiffBool = true;
        if isempty(list)
            disp('The file format is neither .tif or .tiff, aborting.');
            return;
        end
    end
    
    if nargin < 4
        imRange = 1:length(list);
    end
    
    % Resize the images and save them
    for imIdx = imRange
        im = uint16(imread(strcat(pathImages,filesep,list(imIdx).name)));
        imOut = uint16(imresize(im,outSize));
        if tiffBool
            imwrite(imOut,strcat(outputPath,filesep,'resized_',list(imIdx).name(1:end-1)));
        else
            imwrite(imOut,strcat(outputPath,filesep,'resized_',list(imIdx).name(1:end)));
        end
    end
end