function [stackedImgnew] = stackHalfImagesEliasRemoveEdge(inImg, inxTrans, inyTrans,newxMax,newyMax)

% Round the translation components
xTrans = round(inxTrans);
yTrans = round(inyTrans);

% Get the middle of the image and separate the two channels
imgMid = round(size(inImg,1)/2);

origImg1 = inImg(1:imgMid,:,:);
origImg2 = inImg(imgMid+1:end,:,:);

% Apply the translation to the second half of the image
transImg2 = imtranslate(origImg2,[xTrans yTrans]);

% Stack the images together
stackedImg = zeros(imgMid,size(inImg,2),2,size(inImg,3));
stackedImgnew=zeros(newyMax,newxMax,2,size(inImg,3));
for frameIdx = 1:size(inImg,3)
    stackedImg(:,:,1,frameIdx) = origImg1(:,:,frameIdx);
    stackedImg(:,:,2,frameIdx) = transImg2(:,:,frameIdx);
    nonzeros=stackedImg(:,:,2,frameIdx)>0;
    Im1=stackedImg(:,:,1,frameIdx);
    Im2=stackedImg(:,:,2,frameIdx);
    stackedImgnew(:,:,1,frameIdx)=reshape(Im1(nonzeros),[newyMax newxMax]);
    stackedImgnew(:,:,2,frameIdx)=reshape(Im2(nonzeros),[newyMax newxMax]);
end
