function [stackedImgSafety] = stackHalfImagesEliasRemoveEdgeSafetySkipTop(inImg,inxTrans,inyTrans,xMax,yMax,safety,imgTop,imgMid)


% Round the translation components
xTrans = round(inxTrans);
yTrans = round(inyTrans);

newxMaxtemp=xMax-abs(xTrans);
newyMaxtemp=yMax-abs(yTrans);
newxMax=newxMaxtemp-safety;
newyMax=newyMaxtemp-safety;
newyMin=safety;
newxMin=safety;

% Get the middle of the image and separate the two channels
%imgMid = round(size(inImg,1)/2);

origImg1 = inImg(imgTop:imgMid,:,:);
origImg2 = inImg(imgMid+1:end,:,:);

% Apply the translation to the second half of the image
transImg2 = imtranslate(origImg2,[xTrans yTrans]);

% Stack the images together
stackedImg = zeros(imgMid,size(inImg,2),2,size(inImg,3));
stackedImgnew=zeros(newyMaxtemp,newxMaxtemp,2,size(inImg,3));
stackedImgSafety=zeros(newyMax-newyMin+1,newxMax-newxMin+1,2,size(inImg,3));
for frameIdx = 1:size(inImg,3)
    stackedImg(:,:,1,frameIdx) = origImg1(:,:,frameIdx);
    stackedImg(:,:,2,frameIdx) = transImg2(:,:,frameIdx);
    nonzeros=stackedImg(:,:,2,frameIdx)>0;
    Im1=stackedImg(:,:,1,frameIdx);
    Im2=stackedImg(:,:,2,frameIdx);
    stackedImgnew(:,:,1,frameIdx)=reshape(Im1(nonzeros),[newyMaxtemp newxMaxtemp]);
    stackedImgnew(:,:,2,frameIdx)=reshape(Im2(nonzeros),[newyMaxtemp newxMaxtemp]);
    stackedImgSafety(:,:,1,frameIdx)=stackedImgnew(newyMin:newyMax,newxMin:newxMax,1,frameIdx);
    stackedImgSafety(:,:,2,frameIdx)=stackedImgnew(newyMin:newyMax,newxMin:newxMax,2,frameIdx);
end
