function trajForAnalysis = trajFromOneMovie(cellStruct)
%%% This function extract trajectories from the current ImAnalysis pipeline
%%% results from one .mat file,
% Input:
%   - cellStruct: cell structure of all saved results
%
% Output:
%   - trajForAnalysis
%
% Author: Vladimir Curic, 2015-01-21
counter = 1;
for ii = 1:size(cellStruct,2)
    trajTemp = cellStruct(ii).particles;
    
    for jj = 1:size(trajTemp,2)
        trajectoryTemp =  cellStruct(ii).particles(jj).trajImageCoord;
        trajectoryFirstFrame = cellStruct(ii).particles(jj).firstFrame;
        trajForAnalysis{counter} = horzcat(trajectoryTemp,(trajectoryFirstFrame:1:trajectoryFirstFrame+size(trajectoryTemp,1)-1)');
        counter = counter + 1;
        
    end
    
end
if isempty(trajTemp)
    trajForAnalysis = [];
end