function trajForAnalysisCutted = trajFromOneMovieCut(cellStruct,minLengthPiece)
%%% This function extract trajectories from the current ImAnalysis pipeline
%%% results from one .mat file, i.e., for one movie and cut them into small
%%% pieces to use for the analysis of MSD
%
% Input:
%   - cellStruct: cell structure of all saved results
%   - minLengthPiece: minimal length of the trajectory piece
%
% Output:
%   - trajFor analysis
%
% Author: Vladimir Curic, 2015-01-21

counter = 0;
for ii = 1:size(cellStruct,2)
    trajTemp = cellStruct(ii).particles;
    
    for jj = 1:size(trajTemp,2)
        trajectoryTemp =  cellStruct(ii).particles(jj).trajImageCoord;
        trajectoryFirstFrame = cellStruct(ii).particles(jj).firstFrame;
        formTrajAndFrameNumber = horzcat(trajectoryTemp,(trajectoryFirstFrame:1:trajectoryFirstFrame+size(trajectoryTemp,1)-1)');
        trajCut = cutTrajPipeline(formTrajAndFrameNumber,minLengthPiece);
        
        for kk = 1:length(trajCut)
            counter = counter + 1;
            trajForAnalysisCutted{counter} = trajCut{1,kk};
        end
        
    end
    
end