function [dots,matchingCoords,origin]=unionOfDotsMean(dots1,dots2,xTrans,yTrans,maxDist)
%Origin = 1 if dot was from set 1, orgigin(i)=2 if orgigin was from set 2,
%origin(i)=3 if present in both sets (mix);
tolerance=1e-8;
numFrames=dots1(end,3);
[numDots1,~]=size(dots1);
[numDots2,~]=size(dots2);
allindex1=1:numDots1;
allindex2=1:numDots2;

dots=[];
matchingCoords=cell(1,numFrames);
dots2(:,1)=dots2(:,1)+xTrans;
dots2(:,2)=dots2(:,2)+yTrans;
origin=[];
for i=1:numFrames
    pickOriginal1=zeros(1,numDots1);
    pickOriginal2=zeros(1,numDots2);
    rows1=dots1(:,3)==i;
    rows2=dots2(:,3)==i;
    
    numrows1=sum(rows1);
    numrows2=sum(rows2);
  
    coords=[dots1(rows1,1:2) ones(numrows1,1) ones(numrows1,1);dots2(rows2,1:2) 2*ones(numrows2,1) ones(numrows2,1)];
    matchingCoords{i}=BuildTrajectories.buildTrajectories2D(coords,1,maxDist,2);
    numMatching=length(matchingCoords{i});
    index1=allindex1(rows1);
    index2=allindex2(rows2);
    pickOriginal1(index1)=ones(1,numrows1);
    pickOriginal2(index2)=ones(1,numrows2);
    dotsMatching=zeros(numMatching,4);
    for j=1:numMatching
        coords1=matchingCoords{i}{j}(1,1:2);
        coords2=matchingCoords{i}{j}(2,1:2);
        for k=index1
            if abs(coords1(1)-dots1(k,1))<tolerance&&abs(coords1(2)-dots1(k,2))<tolerance
                %Found dot which was also present in the other channel
                pickOriginal1(k)=0;
                break;
            end
        end
        for k=index2
            if abs(coords2(1)-dots2(k,1))<tolerance&&abs(coords2(2)-dots2(k,2))<tolerance
                %Found dot which was also present in the other channel
                pickOriginal2(k)=0;
                break;
            end
        end
        dotsMatching(j,:)=[mean(matchingCoords{i}{j}(1:2,1:2)) i 1];
    end
    dots=[dots;dots1(pickOriginal1==1,:);dots2(pickOriginal2==1,:);dotsMatching];
    origin =[origin ones(1,sum(pickOriginal1==1)) 2*ones(1,sum(pickOriginal2==1)) 3*ones(1,numMatching)];
end

end