function varargout = plusTipTrackerPackageGUI(varargin)
% Launch the GUI for the u-Track Package
%
% This function calls the generic packageGUI function, passes all its input
% arguments and returns all output arguments of packageGUI
%
%
% Sebastien Besson 5/2011
%
%
% Copyright (C) 2014 LCCB 
%
% This file is part of u-track.
% 
% u-track is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% u-track is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with u-track.  If not, see <http://www.gnu.org/licenses/>.
% 
% 

options = {'packageConstr', @PlusTipTrackerPackage};
if nargin>0 && isa(varargin{1},'MovieList')  
    varargout{1} = packageGUI('TrackingPackage',...
        [varargin{1}.getMovies{:}],varargin{2:end},options{:},'ML',varargin{1});
else
    varargout{1} = packageGUI('TrackingPackage',varargin{:},options{:});
end

end