% ========================================================================= 
% trj2aviMovie.m, part of the trjbrowser suite for visualizing SPT
% trajectories. Copyright (C) 2015 Martin Lindén and Vladimir Curic
% E-mail: bmelinden@gmail.com, vladacuric@gmail.com
% =========================================================================
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or any
% later version.  This program is distributed in the hope that it will
% be useful, but WITHOUT ANY WARRANTY; without even the implied
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
% the GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
% =========================================================================
%
function trj=f(trj)

% select destination file
[filename, pathname] = uiputfile('trjMovie.avi', 'Save movie file as');
 if isequal(filename,0) || isequal(pathname,0)
     return
end

% init movie object
vidObj = VideoWriter(fullfile(pathname,filename),'Motion JPEG AVI');
disp('Initialized matlab VideoWriter object with Motion JPEG AVI profile')

open(vidObj);
disp('writing movie . . .')
for m=1:trj.maxFrame
   trj=trjBrowser_updateFrame(trj,m);
   
   % Write each frame to the file.
   currFrame = getframe;
   writeVideo(vidObj,currFrame);
end
close(vidObj);
disp(' done!')


