% Paramter file for PipeLine for sliding polarizaton analysis. Run this file to run analysis
%ver5: Fit exponential to HMM fitted data
%Ver7: Only do dot detection and tracking in the DNA channel.
%ver8: total intesnity at dna dots fitting. ALso Correcting for the fact that there can be some amount of nonspecific
%binding
%Ver9: cleaing up and removing things not used in the script


%% Add path
addpath(genpath('../../../../../../fig_4_andrestofs2/Pol_MatLabScript'))

%%
%LacIDim2 parameters set B
%B change: sqquare changed to 3 to give smaller area for integration for
%polarization intensity
%plot options
%ver3: background clacualted and used by frame, so each frame has seperate
%background



%plot options
showdots=0;
additionalplots=0;

parameterset='A';



%% Parameters that are the same for different experiments

folderPath='../../';
traceFile='tracesAndDNACoords.mat';
load([folderPath traceFile]);
savepath='';
isSim=1;
DNALocNoise=0.25;

%200519 O1
numExps=180;


parameters.square=3;
square=parameters.square; %distane from center in pixels to count intensity
parameters.windowLims=[0 0 0 0];
trans=0;
anglerot=0; %angle to rotate the image
safety=parameters.square; %windsafety if removeEdgeTrajs used


% Standard parameters:
%   - uTrackWindow = 1
%   - uTrackmergeSplit = 0
%   - uTrackminTrackLen = 2
%   - uTrackminSearchRadius = 2
%   - uTrackmaxSearchRadius = 5 (This is very important parameter to tune!)
%   - uTrackbrownStdMult = 3
%   - uTracklinearMotion = 1 (0 if use only motion)

expectedD = 0.1; %(in um^2/s), used to calc maxDist
perc = 0.90; %Percantage of the probability mass that is possible to be considered in berofre cutoff with MaxDist (asuming only 1D diffusion)
parameters.dotTrackingAlg='danuser';
%parameters.scale=scale;
%parameters.maxDist=maxDist;
parameters.minPoints=2;
parameters.useUTrack=1;
parameters.uWindow = 2;%uWindow-1 gives maximum lengthnof gaps allowed
parameters.uMergeSplit = 2;
parameters.uMinTrackLen = 2;
parameters.uMinSearchRadius = 0;
parameters.uBrownStdMult = 100;
parameters.uLinearMotion = 0; %(0 if use only motion)
parameters.numExperiments=1;
parameters.uMaxSearchRadius=2.5;
%parameters.negToPos= 1;

parametersCoLoc=parameters;
parametersCoLoc.uWindow=1;

parameters.smoothparam=500000; % for calculating background with smoothn


analyseLength=4;
analyseLengthHMM=2;
analyseTime=20;
%analyseLengthCoLoc=1; %For the simulation this is okay
analyseLengthCoLocVec=1*ones(1,numExps);
maxDist=2.5; %Between trajectory in DNA and protein laser channel (in piexels);
numSlopePoints=3;




%% Specify pamters that differ for different experiments (paths and so on)




%numSalts=6;
%numFrameRates=3;

numkoffmicros=numel(numel(koffMicros));

allExpInds=(1:numExps);

for i=1:numSalts:numExps
    saltconckon(i:i+numSalts-1)=[250 200 150 125  100 1];
end
protconc=0.5*ones(1,numExps);
protconckon=protconc;

expsToAnalyse=[1:numExps];%[1:13];
expsToAnalyseFitkon=[1:numExps];



%Distributuion fit

maxT=300*ones(1,100);
maxTFit=100*ones(1,100);
binStep=2*ones(1,100);
maxTFitDwell=100*ones(1,100);
binStepDwell=2*ones(1,100);
normIndDistr=19;

%experiments{1}.gridpath='/crex/proj/uppstore2018129/elflab/Projects/Operator_number/experiments from mao/200519 O1 Far2 Kon Koff salt titration/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';

experiments{1}.gridFrame=22;

experiments{1}.imscale=[200 10000];

%experiments{1}.datapath='/crex/proj/uppstore2018129/elflab/Projects/Operator_number/experiments from mao/200519 O1 Far2 Kon Koff salt titration';

experiments{1}.doDotdetect=1;

experiments{1}.doTracking=1;

experiments{1}.imOrders=0;%Which laser channel is which

experiments{1}.coLocFrames=1:3;

experiments{1}.doPolInt=1;

experiments{1}.dobackgroundCalc=1;

experiments{1}.backgroundparam=0;%0; % relative start frame when calcualting background, [1 numFrames] -> [0 1

%experiments{1}.foldersel='/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1*';

experiments{1}.startframe=1;

experiments{1}.startframeFit=1;

experiments{1}.endframeFit=50;

%experiments{1}.timeStep=2;

experiments{1}.numSlopePoints=3;

experiments{1}.DNAChannelBegin=1; %is the DNa channel laser on in the beginning of the move, or is it flipping back and fort between frame?
%experiments{1}.timeVec=0:1:599;

%'/home/samba/elflab/Projects/polarization/151201/Grid_Binning1/Pos0/img_000000000_Default_000.tif';



%1
experiments{1}.noiseTreshold = 3; % For getDot(), 3 for example
experiments{1}.waveletPlane=2;% For dot detection
experiments{1}.scale = 80; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
experiments{1}.deltat =1000; %in ms
experiments{1}.Dimension =2;%Of camera
experiments{1}.yMax=1024;%szie of image
experiments{1}.xMax=1024;%size of image

imgTop=350;
imgMid=695;



%For the HMM analysis, wteh odel of what experiment is used for calculating
%the new viterbi traces

numCurves=numExps/numSalts;
setIndexes=cell(numCurves,1);
k=1;
for i=1:numCurves
    
    setIndexes{i}=allExpInds(k:k+numSalts-1);
    k=k+numSalts;
    
end  
%modelInds(1:18)=6;
%modelInds(19:36)=24;
%modelInds(37:54)=42;
%modelInds(55:72)=60;
%modelInds(73:90)=78;


%%
for i=1:numExps
    experiments{i}=experiments{1};
    experiments{i}.gridpath=[folderPath 'simResultSMeagol_' num2str(i) '_1.tif'];
    experiments{i}.timeStep=timeStepMicroscopeSim(i);
end



for i=1:numExps
    experiments{i}.dobackgroundCalc=1;
    experiments{i}.doDotdetect=0;
    experiments{i}.doTracking=0;
    experiments{i}.doPolInt=0;
    experiments{i}.doDotdetectCoLoc=1;
    experiments{i}.doTrackingCoLoc=1;
    experiments{i}.doPolIntCoLoc=1;
     
     
end


%% Start analysis



tic;
test=0;
xTransAll=zeros(1,numExps);
yTransAll=zeros(1,numExps);
parfor theExp=expsToAnalyse
    %% Set the parameters for this experiment
    %pause(mod(theExp,10)*10);
    if isSim==0
        xTrans=0;
        yTrans=0;
        
    end
    
    noiseTreshold = experiments{theExp}.noiseTreshold; % For getDot(), 3 for example
    waveletPlane=experiments{theExp}.waveletPlane;% For dot detection
    scale = experiments{theExp}.scale; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
    deltat =experiments{theExp}.deltat; %in ms
    Dimension =experiments{theExp}.Dimension;%Of camera
    yMax=experiments{theExp}.yMax;%szie of image
    xMax=experiments{theExp}.xMax;%size of image
    backgroundparam=experiments{theExp}.backgroundparam;
    coLocFrames=experiments{theExp}.coLocFrames;
    
    % paramters for classifciation of sliding
    
    
    
    
    imOrders=experiments{theExp}.imOrders;
    gridpath=experiments{theExp}.gridpath;
    %datapath=experiments{theExp}.datapath;
    datapath=gridpath;
    imscale=experiments{theExp}.imscale;
    gridFrame=experiments{theExp}.gridFrame;
    
   
    
    %% Extract polarization images and get translation of images from grid
    if isSim==0
    thegrid=imrotate(imread(gridpath,gridFrame),anglerot);
    %thegrid=IMG{7}(:,:,100);
    %thegrid=IMG{1}(:,:,50);
    figure();
    [xTrans,yTrans,xForward,yForward,xBackward,yBackward]=getTranslationFromGridSkipTop(thegrid,0,imgTop,imgMid);
    disp(['Image registration for experiment :' num2str(theExp) ' xTrans: ' num2str(xTrans) 'yTrans :' num2str(yTrans)]);
    windowLims=zeros(1,4);
    
    newxMax=xMax-abs(round(xTrans));
    newyMax=yMax-abs(round(yTrans));
    
%     if xTrans>0
%         windowLims(1)=1+parameters.square+safety;
%         windowLims(2)=newxMax-parameters.square-safety;
%     else
%         windowLims(1)=1+parameters.square+safety;
%         windowLims(2)=newxMax-parameters.square-safety;
%     end
%     if yTrans>0
%         windowLims(3)=1+parameters.square+safety;
%         windowLims(4)=newyMax-parameters.square-safety;
%     else
%         windowLims(3)=1+parameters.square+safety;
%         windowLims(4)=newyMax-parameters.square-safety;
%     end
    % newWindowLims is windowLims without the square (radius of dot)
    % removed, used when border is handled in dotdetection instead of after
    %newWindowLims=[windowLims(1)-parameters.square windowLims(2)+parameters.square windowLims(3)-parameters.square windowLims(4)+parameters.square];
    %parameters.windowLims=windowLims;
    experiments{theExp}.xTransCalc=xTrans;
    experiments{theExp}.yTransCalc=yTrans;
    
    %Paramters for Remove edge of polarization images before dot detection
    %(where the second poalrization image has 0 values)
    elseif isSim==1
        experiments{theExp}.xTrans=0;
        experiments{theExp}.yTrans=0;
        xTrans=0;
        yTrans=0;
    end
    
    xTransAll(theExp)=xTrans;
    yTransAll(theExp)=yTrans;
    
end

%%
xTransToUse=zeros(1,numExps);
yTransToUse=zeros(1,numExps);

for i=1:numel(setIndexes)
   currExpInds=setIndexes{i};
   currXTrans=median(xTransAll(currExpInds));
   currYTrans=median(yTransAll(currExpInds));
    for j=currExpInds
        xTransToUse(j)=currXTrans;
        yTransToUse(j)=currYTrans;
        
        experiments{j}.xTrans=currXTrans;
        experiments{j}.yTrans=currYTrans;
    end
end    
%%
for theExp=expsToAnalyse
    %% Load Img
    
     %% Set the parameters for this experiment
    pause(mod(theExp,10)*10);
    if isSim==0
        dnaCoordsCell=[];
        
    else
     temp= load([folderPath traceFile],'dnaCoordsCell');  
     dnaCoordsCell=temp.dnaCoordsCell;  
    end
    
    noiseTreshold = experiments{theExp}.noiseTreshold; % For getDot(), 3 for example
    waveletPlane=experiments{theExp}.waveletPlane;% For dot detection
    scale = experiments{theExp}.scale; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
    deltat =experiments{theExp}.deltat; %in ms
    Dimension =experiments{theExp}.Dimension;%Of camera
    yMax=experiments{theExp}.yMax;%szie of image
    xMax=experiments{theExp}.xMax;%size of image
    backgroundparam=experiments{theExp}.backgroundparam;
    coLocFrames=experiments{theExp}.coLocFrames;
    xTrans=experiments{theExp}.xTrans;
    yTrans=experiments{theExp}.yTrans;
    
    
    % paramters for classifciation of sliding
    
    
    
    
    imOrders=experiments{theExp}.imOrders;
    gridpath=experiments{theExp}.gridpath;
    %datapath=experiments{theExp}.datapath;
    datapath=gridpath;
    imscale=experiments{theExp}.imscale;
    gridFrame=experiments{theExp}.gridFrame;
    
   
    disp(['Analysing experiment nr : ' num2str(theExp) ' found in folder : ' datapath]);
    
    dirs=dir([datapath]);
    numStacks = length(dirs);
    experiments{theExp}.numStacks=numStacks;
    IMG=cell(1,numStacks);
    % if ~exist('Stacks')
    Stacks=cell(1,numStacks);
    %end
    numFrames=0;
    startframe=experiments{theExp}.startframe*ones(1,numStacks);
    fluorIMGS=cell(1,numStacks);
    backgroundallFrames=cell(1,numStacks);
    DotsCoor=cell(1,numStacks);
    DotsCoorCoLoc=cell(1,numStacks);
    %%
    if test==0
        try
            %%
            for stack=1:numStacks
                %pause different workers for different times to not use so much
                %memory
                
                % pause(mod(stack,10)*10);
                disp(['loading stack nr: ' num2str(theExp) ' with file name: ' num2str(dirs(stack).name)]);
                
                %imfolder = [datapath '/' dirs(stack).name];
                %im = dir([imfolder '/*.tif']);
                im = dir(datapath);
                
                %Extract the number of frames from the tiff file's information. The
                %number of columns in structure is equal to the number of frames.
                %imageInfo=imfinfo([imfolder '/' im.name]);
                
                imageInfo=imfinfo(datapath);
                numFrames=length(imageInfo);
                
                %Pre-size the movie matrix
                imSize=[imageInfo(1).Height,imageInfo(1).Width,numFrames-startframe(stack)+1];
                %myMovie=ones(zeros(imSize));
                IMG{stack} = zeros(imSize);
                k=1;
                
                for frame=startframe(stack):numFrames
                    %90 deg rotation added
                    IMG{stack}(:,:,k)=imrotate(imread(datapath,frame),anglerot);
                    if trans
                        IMG{stack}(:,:,k)=IMG{stack}(:,:,k)';
                    end
                    k=k+1;
                end
                
                %% Get Pol Image according to translation data
                
                disp(['Extracting fluor channel images for stack : ' num2str(theExp)]);
                if isSim==0
                    fluorIMGS{stack}=stackHalfImagesEliasRemoveEdgeSkipTop(IMG{stack},xTrans,yTrans,xMax,yMax,imgTop,imgMid); % Change so that different images returned in different variables
                    if experiments{theExp}.DNAChannelBegin==0
                        tempIMGS=fluorIMGS{stack};
                        fluorIMGS{stack}=zeros(size(tempIMGS,1),size(tempIMGS,2),2,ceil(numFrames/2));
                        k=1;
                        for frame =1:numFrames
                            if mod(frame,2)==0
                                fluorIMGS{stack}(:,:,1,k)=tempIMGS(:,:,1,frame-1);
                                fluorIMGS{stack}(:,:,2,k)=tempIMGS(:,:,2,frame);
                                k=k+1;
                            end
                            
                        end
                    end
                elseif isSim==1 %JFor simplcity to make it go through the same pipeline as experimental data, set both fluorescence images the same
                    [xDim,yDim,~]=size(IMG{stack});
                    fluorIMGS{stack}=zeros(xDim,yDim,2,numFrames);
                    
                    for frame=1:numFrames
                        fluorIMGS{stack}(:,:,1,frame)=IMG{stack}(:,:,frame);
                        fluorIMGS{stack}(:,:,2,frame)=IMG{stack}(:,:,frame);
                        
                    end
                    
                end
                
                IMG{stack}=[];
                
                %% Calculate background
                
                
                if experiments{theExp}.dobackgroundCalc
                    disp(['Calculating background for stack: ' num2str(theExp)]);
                    [~,~,~,stackL]=size(fluorIMGS{stack});
                    backgroundstartframe=round(backgroundparam*stackL)+1;
                    %          %backgroundall{stack}{1} = smoothn(mean(POLIMGS{stack}(:,:,1,:),4),parameters.smoothparam,'robust');
                    %          %backgroundall{stack}{2} = smoothn(mean(POLIMGS{stack}(:,:,2,:),4),parameters.smoothparam,'robust');
                    bgFrames=cell(2,1);
                    for index=backgroundstartframe:stackL
                        %backgroundallFrames{stack}{1,index}=zeros(size(POLIMGS{stack}(:,:,1,1)));
                        %backgroundallFrames{stack}{2,index}=zeros(size(POLIMGS{stack}(:,:,1,1)));
                        bgFrames{1}(:,:,index) =smoothn(fluorIMGS{stack}(:,:,1,index),parameters.smoothparam,'robust');
                        bgFrames{2}(:,:,index) =smoothn(fluorIMGS{stack}(:,:,2,index),parameters.smoothparam,'robust');
                    end
                    bgMeans=zeros(1,stackL-backgroundstartframe+1);
                    for index=backgroundstartframe:stackL
                        temp=bgFrames{2}(:,:,index);
                        bgMeans(index)=mean(temp(:));
                    end
                    experiments{theExp}.bgMeans=bgMeans;
                    
                    
                else
                    %bgFrames=experiments{theExp}.backgroundallFrames;
                    bgFrames=[];
                end
                
               
%                                      figure();
%                                      exampleImgInd=2; % pol img index, 1 or 2
%                                      imagesc(bgFrames{exampleImgInd}(:,:,300),[400 12000]);
%                                      axis equal;
%                                      colormap(gray);
%                                      colorbar;
%                                      title('Example background');
%                                      figure();
%                                       plot(fluorIMGS{stack}(192,:,exampleImgInd,300));
%                                       hold on;
%                                      plot(bgFrames{exampleImgInd}(192,:,300),'r');
%                                      figure();
%                                       exampleImgInd=2; % pol img index, 1 or 2
%                                      imagesc(mean(fluorIMGS{stack}(:,:,2,:),4),[400 12000]);
%                                       axis equal;
%                                       colormap(gray);
%                                       colorbar;
%                                       title('average image');
%                 
                
                
                %% Calcualte sum of polIMGS to use for dot detection
                %disp(['calculating imagesum for stack: ' num2str(stack)]);
                %[~,~,~,stackL]=size(POLIMGS{stack});
                % calculate IMG sum
                Stacks{stack}.imageStack1=reshape(fluorIMGS{stack}(:,:,1,:),[size(fluorIMGS{stack},1) size(fluorIMGS{stack},2) size(fluorIMGS{stack},4)]);
                Stacks{stack}.imageStack2=reshape(fluorIMGS{stack}(:,:,2,:),[size(fluorIMGS{stack},1) size(fluorIMGS{stack},2) size(fluorIMGS{stack},4)]);
                %% DO dot detection
                if experiments{theExp}.doDotdetect
                    disp(['Doing dot detection for stack nr:' num2str(theExp)]);
                    % Handling border (don't detect dots here) in do detection
                    % instead of after traj building
                    %mask=zeros(yMax,xMax,stackL);
                    %mask(newWindowLims(3):newWindowLims(4),newWindowLims(1):newWindowLims(2),:)=ones(newWindowLims(4)-newWindowLims(3)+1,newWindowLims(2)-newWindowLims(1)+1,stackL);
                    bgRem=Stacks{stack}.imageStack2(:,:,:)-bgFrames{2}(:,:,:);
                    
                    for i=1:size(bgRem,3)
                        bgRem(:,:,i)=bgRem(:,:,i)-min(min(bgRem(:,:,i)));
                        
                    end
                    
                    Stacks{stack}.dots=BuildTrajectories.getDotsSelPlane_ver3(bgRem,noiseTreshold,showdots,waveletPlane,imscale);
                    %Stacks{stack}.dots=BuildTrajectories.getDotsFRS(Stacks{stack}.imageStack,[1 2 3],2,0,2,10,showdots);
                    %getDotsFRS(imageStack,radii,alphaParameter,betaParameter,radiusForThreshold,thresholdParameter,showDots)
                    %DotsCoor{stack}=Stacks{stack}.dots;
                else
                    %Stacks{stack}.dots=experiments{theExp}.Stacks{stack}.dots;
                end
                %% Do tracking
                if experiments{theExp}.doTracking
                    disp(['Building trajsfor stack nr:' num2str(theExp)]);
                    Stacks{stack}.finalTraj = BuildTrajectories.buildTrajectories(Stacks{stack}.dots,size(Stacks{stack}.imageStack2,3), parameters );
                    
                    
                    for i = 1:length(Stacks{stack}.finalTraj)
                        [l,~]=size(Stacks{stack}.finalTraj{i});
                        Stacks{stack}.finalTraj{i} = [Stacks{stack}.finalTraj{i} stack*ones(l,1) zeros(l,4)]; % 6th column is stack index,col 7 set to NaN later if a gap ehre , col 8 is intensity in pol channel 1, col 9 is intensity in pol channel 2, col 10 is error to be calcualted from gain
                    end
                else
                   % Stacks{stack}.finalTraj=experiments{theExp}.Stacks{stack}.finalTraj;
                end
                
                %% DO dot detection in DNA channel
                if isSim==0
                    if experiments{theExp}.doDotdetectCoLoc
                        disp(['Doing dot detection in DNA channel for stack nr:' num2str(theExp)]);
                        % Handling border (don't detect dots here) in do detection
                        % instead of after traj building
                        %mask=zeros(yMax,xMax,stackL);
                        %mask(newWindowLims(3):newWindowLims(4),newWindowLims(1):newWindowLims(2),:)=ones(newWindowLims(4)-newWindowLims(3)+1,newWindowLims(2)-newWindowLims(1)+1,stackL);
                        
                        bgRem=Stacks{stack}.imageStack1(:,:,coLocFrames)-bgFrames{1}(:,:,coLocFrames);
                        
                        for i=1:size(bgRem,3)
                            bgRem(:,:,i)=bgRem(:,:,i)-min(min(bgRem(:,:,i)));
                            
                        end
                        
                        Stacks{stack}.dotsCoLoc=BuildTrajectories.getDotsSelPlane_ver3(bgRem,noiseTreshold,showdots,waveletPlane,imscale);
                        %Stacks{stack}.dots=BuildTrajectories.getDotsFRS(Stacks{stack}.imageStack,[1 2 3],2,0,2,10,showdots);
                        %getDotsFRS(imageStack,radii,alphaParameter,betaParameter,radiusForThreshold,thresholdParameter,showDots)
                        %DotsCoorCoLoc{stack}=Stacks{stack}.dotsCoLoc;
                    else
                        %Stacks{stack}.dotsCoLoc=experiments{theExp}.Stacks{stack}.dotsCoLoc;
                    end
                elseif isSim==1 %Get the DNA localisation from the simulation result
                    disp(['Getting DNA coordianted for stack nr' num2str(theExp)])
                    numDNAs=size(dnaCoordsCell{theExp},1);
                    rng(theExp);
                    %Add some noise to add uncerteinty in DNA localisation
                    %and image registration
                    dnaCoordsNew=dnaCoordsCell{theExp}(:,1:2)+randn(numDNAs,2)*DNALocNoise;
                    Stacks{stack}.dotsCoLoc=zeros(numel(coLocFrames)*numDNAs,4)
                    k=1;
                    for i = coLocFrames
                        Stacks{stack}.dotsCoLoc(k:k+numDNAs-1,:) =[ dnaCoordsNew i*ones(numDNAs,1) ones(numDNAs,1)];
                        k=k+numDNAs;
                    end
                end    
                
                %% Do tracking in DNA channel
                if experiments{theExp}.doTrackingCoLoc
                    disp(['Building trajs in DNA channel for stack nr:' num2str(theExp)]);
                    Stacks{stack}.finalTrajCoLoc = BuildTrajectories.buildTrajectories(Stacks{stack}.dotsCoLoc,numel(coLocFrames), parametersCoLoc );
                   % numRealFrames=size(fluorIMGS{stack},4);
                    numRealFrames=size(Stacks{stack}.imageStack1,3);
                    for i = 1:length(Stacks{stack}.finalTrajCoLoc)
                        [l,~]=size(Stacks{stack}.finalTrajCoLoc{i});
                        Stacks{stack}.finalTrajCoLoc{i} = [Stacks{stack}.finalTrajCoLoc{i} stack*ones(l,1) zeros(l,4)]; % 6th column is stack index,col 7 set to NaN later if a gap ehre , col 8 is intensity in pol channel 1, col 9 is intensity in pol channel 2, col 10 is error to be calcualted from gain
                        xPos=mean(Stacks{stack}.finalTrajCoLoc{i}(:,1));
                        yPos=mean(Stacks{stack}.finalTrajCoLoc{i}(:,2));
                        
                        Stacks{stack}.finalTrajCoLocAllFrames{i}=[xPos*ones(numRealFrames,1) yPos*ones(numRealFrames,1) Stacks{stack}.finalTrajCoLoc{i}(1,3)*ones(numRealFrames,1) [1:numRealFrames]' repmat(Stacks{stack}.finalTrajCoLoc{i}(1,5:end),numRealFrames,1)];
                        
                        
                    end
                else
                    %Stacks{stack}.finalTrajCoLoc=experiments{theExp}.Stacks{stack}.finalTrajCoLoc;
                end
                
                %% Calculate fluorescence intensity of trajectory
                
                if experiments{theExp}.doPolInt
                    disp(['Calcualting fluorescne intensities for trajectories in stack nr:' num2str(theExp)]);
                    numStacktrajs=length(Stacks{stack}.finalTraj);
                    trajStackInts=cell(1,numStacktrajs);
                    for i=1:numStacktrajs
                        trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},Stacks{stack}.finalTraj{i},square,bgFrames);
                        %trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},experiments{25}.alltrajs{i},square,bgFrames);
                        if imOrders==0 %(upper H lower V, to get PHV)
                            Stacks{stack}.finalTraj{i}(:,8:9)=trajStackInts{i};
                        elseif imOrders==1 %Reerse intensiti order (upper V lower H)
                            Stacks{stack}.finalTraj{i}(:,8:9)=trajStackInts{i}(:,[2 1]);
                        end
                    end
                    
                end
                if experiments{theExp}.doPolIntCoLoc
                    
                    disp(['Calcualting fluorescne intensities for DNA trajectories in stack nr:' num2str(theExp)]);
                    numStacktrajsCoLocAllFrames=length(Stacks{stack}.finalTrajCoLocAllFrames);
                    trajStackIntsCoLocAllFrames=cell(1,numStacktrajsCoLocAllFrames);
                    for i=1:numStacktrajsCoLocAllFrames
                        trajStackIntsCoLocAllFrames{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},Stacks{stack}.finalTrajCoLocAllFrames{i},square,bgFrames);
                        %trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},experiments{25}.alltrajs{i},square,bgFrames);
                        if imOrders==0 %(upper H lower V, to get PHV)
                            Stacks{stack}.finalTrajCoLocAllFrames{i}(:,8:9)=trajStackIntsCoLocAllFrames{i};
                        elseif imOrders==1 %Reerse intensiti order (upper V lower H)
                            Stacks{stack}.finalTrajCoLocAllFrames{i}(:,8:9)=trajStackIntsCoLocAllFrames{i}(:,[2 1]);
                        end
                    end
                    
                    
                    
                end
                %Comment away if you wanna keep these images in memorey (to look at
                %in the plot GUI for example)
                fluorIMGS{stack}=[];
                Stacks{stack}.imageStack=[];
                Stacks{stack}.imageStack1=[];
                Stacks{stack}.imageStack2=[];
                backgroundallFrames{stack}=bgFrames;
                bgRem=[];
            end
            
            
            %% Finnish up trajecotires
            if experiments{theExp}.doTracking
                numtrajs=0;
                alltrajs=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajsfor stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTraj)
                        [l,~]=size(Stacks{stack}.finalTraj{i});
                        alltrajs{1,numtrajs+i} = [Stacks{stack}.finalTraj{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajs = numtrajs+length(Stacks{stack}.finalTraj);
                end
                rawtrajs=alltrajs;
                trajIndex=1:numtrajs;
                numtrajs=length(alltrajs);
                
                alltrajs=interpolateGaps(alltrajs);
                experiments{theExp}.numtrajs=numtrajs;
                experiments{theExp}.trajIndex=trajIndex;
                experiments{theExp}.rawtrajs=rawtrajs;
                experiments{theExp}.alltrajs=alltrajs;
                
            end
            
            if  experiments{theExp}.doTrackingCoLoc
                numtrajsCoLoc=0;
                alltrajsCoLoc=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajs CoLoc for stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTrajCoLoc)
                        [l,~]=size(Stacks{stack}.finalTrajCoLoc{i});
                        alltrajsCoLoc{1,numtrajsCoLoc+i} = [Stacks{stack}.finalTrajCoLoc{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajsCoLoc = numtrajsCoLoc+length(Stacks{stack}.finalTrajCoLoc);
                end
                rawtrajsCoLoc=alltrajsCoLoc;
                trajIndexCoLoc=1:numtrajsCoLoc;
                numtrajsCoLoc=length(alltrajsCoLoc);
                
                alltrajsCoLoc=interpolateGaps(alltrajsCoLoc);
                
                numtrajsCoLocAllFrames=0;
                alltrajsCoLocAllFrames=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajs CoLoc all frames for stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTrajCoLocAllFrames)
                        [l,~]=size(Stacks{stack}.finalTrajCoLocAllFrames{i});
                        alltrajsCoLocAllFrames{1,numtrajsCoLocAllFrames+i} = [Stacks{stack}.finalTrajCoLocAllFrames{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajsCoLocAllFrames = numtrajsCoLocAllFrames+length(Stacks{stack}.finalTrajCoLocAllFrames);
                end
                rawtrajsCoLocAllFrames=alltrajsCoLocAllFrames;
                trajIndexCoLocAllFrames=1:numtrajsCoLocAllFrames;
                numtrajsCoLocAllFrames=length(alltrajsCoLocAllFrames);
                
                
                
             
                %clear alltrajs;
                experiments{theExp}.alltrajsCoLoc=alltrajsCoLoc;
                experiments{theExp}.alltrajsCoLocAllFrames=alltrajsCoLocAllFrames;
                %clear alltrajsCoLoc;
               
                
            end
            experiments{theExp}.Stacks=Stacks;
        catch le
            getReport(le)
            disp(['Failed at experiment ' num2str(theExp)]);
        end
        
        %%
        
        
        
        
    end 
end
analysisiTime=toc;
%%

save([savepath 'results for parameters ' parameterset ' ' datestr(now)],'-v7.3');


%% Plotting and data interpretation analysis
for theExp=expsToAnalyse
    [~,okDNAInds]=selectTrajsonL(experiments{theExp}.alltrajsCoLoc,analyseLengthCoLocVec(theExp),inf);
    alltrajsCoLocAllFrames=cell(1,numel(okDNAInds));
    okDNAIndsNotNan=[];
    intensity=zeros(1,size(experiments{theExp}.alltrajsCoLocAllFrames{1},1));
    numFrames=size(experiments{theExp}.alltrajsCoLocAllFrames{1},1);
    for i=1:numel(okDNAInds)
        alltrajsCoLocAllFrames{i}=experiments{theExp}.alltrajsCoLocAllFrames{okDNAInds(i)};
        intensity=nansum([intensity;alltrajsCoLocAllFrames{i}(:,9)'],1);
        
        
    end
    
   %figure();
   %hold on;
   %title(['Experiment number :' num2str(theExp)]);
   %plot(1:numFrames,intensity);
   
   %xlabel('Frame number');
   %ylabel('Intensity');
    %
    
end

%%
newTimeStep=0.5; %Chose a smaller timestep that all, all traces are changed to have this tiemtep (just add extra timepoints wit same value)
underSampleTimeOff=6; %If frame rate is fater than this, frames in between are removed.  
underSampleTimeOn=2;
doUnderSample=0;
numEmissions=80;
  numEmissionsHist=1600;
 maxLevel=5e4;%max(maxLevelAll);
 minLevel=-2e4;%min(minLevelAll);
 minBoundInt=-inf;
 xValsModel=linspace(minLevel,maxLevel,numEmissions);
 
 %Extra filtering
 filter.rollingAvgTime=12;
 filter.minMaxMean=5e4;%-inf;
 extraAddStart=3;
parfor theExp=expsToAnalyseFitkon
     if isSim==0
        startFrameFitNew=experiments{theExp}.startframeFit+extraAddStart;
     else
      startFrameFitNew=experiments{theExp}.startframeFit+extraAddStart;   
     end
    disp(theExp)
    timeStep=experiments{theExp}.timeStep;
    
    
    [~,okDNAInds]=selectTrajsonL(experiments{theExp}.alltrajsCoLoc,analyseLengthCoLocVec(theExp),inf);
    alltrajsCoLocAllFrames=cell(1,numel(okDNAInds));
    okDNAIndsNotNan=[];
    for i=1:numel(okDNAInds)
        alltrajsCoLocAllFrames{i}=experiments{theExp}.alltrajsCoLocAllFrames{okDNAInds(i)};
        rollingMean=movmean(alltrajsCoLocAllFrames{i}(startFrameFitNew:end,9),round(filter.rollingAvgTime/timeStep));
        maxMean=max(rollingMean);
        
        if sum(isnan(alltrajsCoLocAllFrames{i}(:,9)))==0&&maxMean>filter.minMaxMean
            okDNAIndsNotNan=[okDNAIndsNotNan i];
        end
        
    end
    %
   % clusterLowAll=zeros(1,numel(okDNAIndsNotNan));
   % clusterHighAll=zeros(1,numel(okDNAIndsNotNan));
   % for trajInd=1:numel(okDNAIndsNotNan)
   %    try
   %    [idx,C]=kmeans(alltrajsCoLocAllFrames{okDNAIndsNotNan(trajInd)}(:,9),2);
%       Csort=sort(C,'ascend');
   %    clusterLowAll(trajInd)=Csort(1);
   %    clusterHighAll(trajInd)=Csort(2);
   %    catch
   %        clusterLowAll(trajInd)=NaN;
   %        clusterHighAll(trajInd)=NaN;
   %    end
   % end
    
   % okDNAIndsNotNan=okDNAIndsNotNan(clusterHighAll>-inf);
    
   %[sortedHighClust,sortIndsHighClust]=sort(clusterHighAll,'descend');
    
    %notNaNInds=~isnan(sortedHighClust);
    
    %okDNAIndsSorted=sortIndsHighClust(notNaNInds);
    
    
    %%
  
    
    maxLevelAll=zeros(1,numel(okDNAIndsNotNan));
    minLevelAll=zeros(1,numel(okDNAIndsNotNan));
    %for i=1:numel(okDNAIndsNotNan)
    %    
    %   maxLevelAll(i)=max(alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(experiments{theExp}.startframeFit:end,9));
    %    minLevelAll(i)=min(alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(experiments{theExp}.startframeFit:end,9));
    %end
    
   if doUnderSample==1
    newStepUnderSampleOn=ceil(underSampleTimeOn/timeStep);
    newStepUnderSampleOff=ceil(underSampleTimeOff/timeStep);
    
   else
       newStepUnderSampleOn=1;
       newStepUnderSampleOff=1;
       
   end
    timeStepOn=newStepUnderSampleOn*timeStep;
    timeStepOff=newStepUnderSampleOff*timeStep;
   
    seqIntegers=cell(1,numel(okDNAIndsNotNan));
    intensityTracesOn=cell(1,numel(okDNAIndsNotNan));
    intensityTracesOff=cell(1,numel(okDNAIndsNotNan));
    allInts=[];
    for i=1:numel(okDNAIndsNotNan)
        intensityTracesOn{i}=alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:newStepUnderSampleOn:end,9);
        intensityTracesOff{i}=alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:newStepUnderSampleOff:end,9);
        seqIntegers{i}=round((alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:end,9)-minLevelAll(i)-minLevel)*numEmissions/(maxLevel-minLevel))';
        seqIntegers{i}(seqIntegers{i}<1)=1;
        seqIntegers{i}(seqIntegers{i}>numEmissions)=numEmissions;
        seqIntegers{i}=repmat(seqIntegers{i},[timeStep/newTimeStep 1]);
        seqIntegers{i}=seqIntegers{i}(:)';
        allInts=[allInts alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:end,9)];
    end
        experiments{theExp}.intensityTracesOn=intensityTracesOn;
        experiments{theExp}.intensityTracesOff=intensityTracesOff;
        experiments{theExp}.seqIntegers=seqIntegers;
        experiments{theExp}.allInts=allInts;
        experiments{theExp}.okDNAIndsNotNan=okDNAIndsNotNan;
        experiments{theExp}.timeStepOff=timeStepOff;
        experiments{theExp}.timeStepOn=timeStepOn;
        
 end   
 
 

%% Calculate sum of fluorescence at DNA location
 norm=0;
 toSave=zeros(1,100);
 useTraceMean=0;
 
 %maxLevelCorr=7e4;%max(maxLevelAll);
 %minLevelCorr=1e4;%min(minLevelAll);
 numBoundsCorr=3;
 %autoCorrIntBounds=linspace(minLevelCorr,maxLevelCorr,numBoundsCorr);
 %intBounds=[1e4 3e4 5e4];
 intBounds=[2e4 2.000001e4 3.5e4 3.50001e4];
 
 doGroundTruth=0;
 
 startTimeAllTimes=0; %time in sec when to start, f you dont wish tto count very beginning of traces/timepoints when calculating the dissociation curve.
 endTimeAllTimes=200;
 endTimeAllTimesBleach=200;
 maxLevel=5e4;%4e4;%max(maxLevelAll);
 minLevel=0e4;%-2e4;%2e4;%min(minLevelAll);
 fitTimeOn=4;
 fitTimeOffVec=[6*ones(1,6*4) 12*ones(1,6) 6*ones(1,6*4) 12*ones(1,6)  6*ones(1,6*4) 12*ones(1,6) 6*ones(1,6*4) 12*ones(1,6) 6*ones(1,6*4) 12*ones(1,6)  6*ones(1,6*4) 12*ones(1,6)];
 %fitPointsOff=2;
 fitTimeSlope=2;
 onConvolutePoints=3;

% fitPointsSlopeon=7;
 
 numBoots=500;
 


if isSim==1
   illumTime=2;
    setIndexesNew=setIndexes;
   
    %onIndexes=[repmat(setIndexesNew{1},[1 3]) repmat(setIndexesNew{4},[1 3]) repmat(setIndexesNew{7},[1 3]) repmat(setIndexesNew{10},[1 3]) repmat(setIndexesNew{13},[1 3])]; %Fo each experiment, which experiment does the onrate come from (can't estiamte on rate from off experiemnts)
    
    onIndexes=[setIndexesNew{1} repmat(setIndexesNew{2},[1 4]) setIndexesNew{6} repmat(setIndexesNew{7},[1 4]) setIndexesNew{11} repmat(setIndexesNew{12},[1 4]) setIndexesNew{16} repmat(setIndexesNew{17},[1 4]) setIndexesNew{21} repmat(setIndexesNew{22},[1 4]) setIndexesNew{26} repmat(setIndexesNew{27},[1 4])];
    
    normInds(1:6)=6; %For eeach experiment, what is the experiment index of this set to normalize to when doing nomrmalized plots (high ka low kd)
    normInds(7:12)=12; 
    normInds(13:18)=18;
    normInds(19:24)=24;
    normInds(25:30)=30;
    
    normInds(31:36)=36;
    normInds(37:42)=42;
    normInds(43:48)=48;
    normInds(49:54)=54;
    normInds(55:60)=60;
    
    normInds(61:66)=66;
    normInds(67:72)=72;
    normInds(73:78)=78;
    normInds(79:84)=84;
    normInds(85:90)=90;
    
    normInds(91:96)=96;
    normInds(97:102)=102;
    normInds(103:108)=108;
    normInds(109:114)=114;
    normInds(115:120)=120;
    
    normInds(121:126)=121;
    normInds(127:132)=127;
    normInds(133:138)=133;
    normInds(139:144)=139;
    normInds(145:150)=145;
    
    normInds(151:156)=151;
    normInds(157:162)=157;
    normInds(163:168)=163;
    normInds(169:174)=169;
    normInds(175:180)=175;
    
    
   
    %bleachInds(1:6)=6;  %For each experiment, what experiment to use bleachig epxeriment from (preferebly low kd high ka, high frame rate)
    %bleachInds(7:12)=6;
    %bleachInds(13:18)=6;
    
    %bleachInds(19:24)=24;
    %bleachInds(25:30)=24;
    %bleachInds(31:36)=24;
    
    %bleachInds(37:42)=42;
    %bleachInds(43:48)=42;
    %bleachInds(49:54)=42;
    
    %bleachInds(55:60)=55;
    %bleachInds(61:66)=55;
    %bleachInds(67:72)=55;
    
    %bleachInds(73:78)=73;
    %bleachInds(79:84)=73;
    %bleachInds(85:90)=73;
    

    
else
    illumTime=1;
    setIndexesNew=setIndexes;
    setIndexesNew{5}=setIndexes{5}(1:end-1);
    onIndexes=[ones(1,24) setIndexesNew{5} ones(1,13) repmat(setIndexesNew{8},[1 3]) repmat(setIndexesNew{11},[1 3]) repmat(setIndexesNew{14},[1 3]) repmat(setIndexesNew{17},[1 4])  repmat(setIndexesNew{21},[1 3]) repmat(setIndexesNew{24},[1 3])];
    k=0;
    for i=1:numel(setIndexesNew)
        normInds(k+1:k+numSaltsVec(i))=setIndexesNew{i}(1);
        k=k+numSaltsVec(i);
    end
    bleachInds(1:42)=1;
    
%     bleachInds(43:48)=43;
%     bleachInds(49:54)=43;
%     bleachInds(55:60)=43;
% 
%     bleachInds(61:66)=61;
%     bleachInds(67:72)=61;
%     bleachInds(73:78)=61;
%     
%     bleachInds(79:84)=79;
%     bleachInds(85:90)=79;
%     bleachInds(91:96)=79;
%     
%     bleachInds(97:102)=97;
%     bleachInds(103:108)=97;
%     bleachInds(109:114)=97;
%     bleachInds(115:120)=97;
bleachInds(25:42)=25;    
bleachInds(43:120)=61;
bleachInds(139:159)=61;    
    TvecCell=cell(1,numExps);
   XCell=cell(1,numExps);
end

kdFromSlopeRaw=zeros(1,numExps);
 kaFromSlopeRaw=zeros(1,numExps);
 kbleachFromSlope=zeros(1,numExps);
 
 % ontraces should be from the associatio nexperiments in all datasets
 
 
 
 for theExp=expsToAnalyseFitkon
     try
    experiments{theExp}.intensityTracesOn=experiments{onIndexes(theExp)}.intensityTracesOn;
    experiments{theExp}.timeStepOn=experiments{onIndexes(theExp)}.timeStepOn;
     catch 
         disp([num2str(theExp) ]);
         
     end
 end

%%
fractionNonSpecBind=zeros(1,numExps);
steadyStateLevel=zeros(1,numExps);
kdFromRawSlope=zeros(1,numExps);
kaFromRawSlope=zeros(1,numExps);
bgLevel=zeros(1,numExps);
kdFromSlope=zeros(1,numExps);
kaFromSlope=zeros(1,numExps);
numUniqueOn=zeros(1,numExps);
numUniqueOff=zeros(1,numExps);
%%
parfor theExp=expsToAnalyseFitkon
   % try
     disp(theExp);
    timeStep=experiments{theExp}.timeStep;
    seqIntegers=experiments{theExp}.seqIntegers;
    allInts=experiments{theExp}.allInts;
    okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
    intensityTracesOn=experiments{theExp}.intensityTracesOn;
    intensityTracesOff=experiments{theExp}.intensityTracesOff;
    numTimePointsOn=numel(intensityTracesOn{1});
    numTimePointsOff=numel(intensityTracesOff{1});
    numTracesOn=numel(intensityTracesOn);
    numTracesOff=numel(intensityTracesOff);
    
    timeStepOn=experiments{theExp}.timeStepOn;
    timeStepOff=experiments{theExp}.timeStepOff;

    
     traces=cell(1,numTracesOn);
    if doGroundTruth==1
    %  intBounds=[0 0.5 1];  
    %   maxLevel=inf;
    %  minLevel=-inf;
      timeStepOn=TvecCell{theExp}(2)-TvecCell{theExp}(1);
      timeStepOff=timeStepOn;
      numTimePointsOn=size(XCell{theExp},1);
      numTimePointsOff=numTimePointsOn;
      numTraces=size(XCell{theExp},2);
      for i=1:numTraces
        traces{i}=XCell{theExp}(:,i);
      end
      tracesOn=traces;
      tracesOff=traces;
    else
        tracesOn=intensityTracesOn;
        tracesOff=intensityTracesOff;
    end   
    
    
  
    timeVecOn=0:timeStepOn:timeStepOn*(numTimePointsOn-1);
    timeVecOff=0:timeStepOff:timeStepOff*(numTimePointsOff-1);
    %fitPointsSlope=2;
    %fitPointsOn=round(fitTimeOn/timeStep);
    %fitPointsOff=round(fitTimeOff/timeStep);
    fitTimeOff=fitTimeOffVec(theExp);
    [~,fitPointsOn]=min(abs(timeVecOn-fitTimeOn));
    [~,fitPointsOff]=min(abs(timeVecOff-fitTimeOff));
   
    
     
        
       
     
    

    
    [kd,ka,intensityAllTime,intensityFirstTime,results] = getRatesIntensityMethodver16OnConvolNewCorr(tracesOff,timeVecOff,tracesOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints,illumTime);
    %[~,ka,~,intensityFirstTime] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
    %[kd,ka,intensityAllTime,intensityFirstTime] = getRatesIntensityMethod(traces,timeVec,startTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsSlopeoff,fitPointsSlopeon);
    %kdFromRawSlope(theExp)=-log(-kd*(fitTimeOff*0.5)+1)/(fitTimeOff*0.5);
    %kaFromRawSlope(theExp)=-log(-ka*(fitTimeOn*0.5)+1)/(fitTimeOn*0.5);
   
     kdFromRawSlope(theExp)=kd;
     kaFromRawSlope(theExp)=ka;
     
     numUniqueOff(theExp)=results.numUniqueOff;
     numUniqueOn(theExp)=results.numUniqueOn;
     
    %steadyStateLevel(theExp)=mean(experiments{theExp}.intensityFirstTime(1,end-50:end));
    
  %  [kd,background] = getkdFromSlopeandSteady(-kdFromRawSlope(theExp),steadyStateLevel(theExp),ka*protconckon(theExp),kbleachingRef(theExp));
    
   % ka=kaFromSlope(theExp);
   % slopeoff=-kd;
   % steadyState=steadyStateLevel(theExp);
   % kbleach=kbleachingRef(theExp);
  
 %   kdFromSlopeCorrection(theExp)=-(ka*slopeoff*steadyState)/(ka + slopeoff*steadyState);
 %   bgLevel(theExp)=(steadyState*(ka*kbleach + ka*slopeoff + slopeoff^2*steadyState - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState))/(ka*kbleach - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState)
 %   
  
    
    kaRawBootSamples=zeros(1,numBoots);
    kdRawBootSamples=zeros(1,numBoots);
    
    for i=1:numBoots
        tracesCurrOn=cell(1,numTracesOn);
        tracesCurrOff=cell(1,numTracesOff);
        for j=1:numTracesOn
            currind=ceil(rand()*numTracesOn);
            tracesCurrOn{j}=tracesOn{currind};
            
            
        end
        for j=1:numTracesOff
            currind=ceil(rand()*numTracesOff);
            
            tracesCurrOff{j}=tracesOff{currind};
            
        end
        
        % [kdRawBootSamples(i),~,~,~] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesCurrOff,timeVecOff,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
        % [~,kaRawBootSamples(i),~,~] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesCurrOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
        [kdRawBootSamples(i),kaRawBootSamples(i),~,~,~] = getRatesIntensityMethodver16OnConvolNewCorr(tracesCurrOff,timeVecOff,tracesCurrOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints,illumTime);
        
    end
    
    meankdBoot(theExp)=mean(kdRawBootSamples);
    meankaBoot(theExp)=mean(kaRawBootSamples);
    
    errorkd(theExp)=std(kdRawBootSamples);
    errorka(theExp)=std(kaRawBootSamples);
    
    
    
    
    experiments{theExp}.kdRawBootSamples=kdRawBootSamples;
    experiments{theExp}.kaRawBootSamples=kaRawBootSamples;
    experiments{theExp}.intensityFirstTime=intensityFirstTime;
    experiments{theExp}.intensityAllTime=intensityAllTime;
   % experiments{theExp}.newOffCurve=newOffCurve;
    %experiments{theExp}.bestParams=bestParams;
   % fractionNonSpecBind(theExp)=bestParams(4)/(bestParams(4)+bestParams(6));
    experiments{theExp}.results=results;
   % catch
   %    disp(['Experiment failed: ' num2str(theExp)]) 
   % end
end



%% Solve symbolic equations


syms kd background ka kbleach slopeoff steadyState
eqn1 = ((ka/(ka+kd))*(kd/(kbleach+kd)))/(((ka/(ka+kd))*(kd/(kbleach+kd)))+background)*(-1)*(kd+kbleach)-slopeoff == 0;
eqn2= ((ka/(ka+kd))*(kd/(kbleach+kd))) +background - steadyState == 0;
S=solve([eqn1 eqn2],[kd background]);

%solutionkd=-(ka*slopeoff*steadyState)/(ka + slopeoff*steadyState)
%solutionbackground =(steadyState*(ka*kbleach + ka*slopeoff + slopeoff^2*steadyState - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState))/(ka*kbleach - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState)



%%
onsetplot=setIndexes{7};%[97:102]+12;%[43:48];%43:48;
%onsetplot=setIndexes{10};%setIndexes(11,:)

figure();
hold on;
for theExp=onsetplot
    timeStep=experiments{theExp}.timeStepOn;

    numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
    plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:));
    
end
legend(strsplit(num2str(onsetplot)))

title('association');


offsetplot=onsetplot+12;

figure();
hold on;
for theExp=offsetplot
    timeStep=experiments{theExp}.timeStepOff;
    
    numTimePoints=size(experiments{theExp}.intensityAllTime,2);
    plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1));
    
end
legend(strsplit(num2str(offsetplot)))
title('dissocation')




%%

for theExp=expsToAnalyseFitkon
    disp(theExp)
    relka(theExp)=kaFromRawSlope(theExp)/kaFromRawSlope(normInds(theExp));
    relkd(theExp)=kdFromRawSlope(theExp)-kdFromRawSlope(normInds(theExp));
    if isSim==1
        relkaModel(theExp)=kaSim(theExp)/kaSim(normInds(theExp));
        relkdModel(theExp)=kdSim(theExp)-kdSim(normInds(theExp));
    end
    relkaBoots=zeros(1,numBoots);
    relkdBoots=zeros(1,numBoots);
    
    for i=1:numBoots
        relkaBoots(i)=experiments{theExp}.kaRawBootSamples(i)/experiments{normInds(theExp)}.kaRawBootSamples(i);
        relkdBoots(i)=experiments{theExp}.kdRawBootSamples(i)-experiments{normInds(theExp)}.kdRawBootSamples(i);
    end   
    meanrelkaBoot(theExp)=mean(relkaBoots);
    meanrelkdBoot(theExp)= mean(relkdBoots);
    
     
    errorrelka(theExp)=std(relkaBoots);
    errorrelkd(theExp)=std(relkdBoots);
    
    
    lowErrorka(theExp)=(meankaBoot(theExp)+errorka(theExp)/2)-kaFromRawSlope(theExp);
    highErrorka(theExp)=kaFromRawSlope(theExp)-(meankaBoot(theExp)-errorka(theExp)/2);
    
    lowErrorrelka(theExp)=(meanrelkaBoot(theExp)+errorrelka(theExp)/2)-relka(theExp);
    highErrorrelka(theExp)=relka(theExp)-(meanrelkaBoot(theExp)-errorrelka(theExp)/2);
    
    lowErrorkd(theExp)=(meankdBoot(theExp)+errorkd(theExp)/2)-kdFromRawSlope(theExp);
    highErrorkd(theExp)=kdFromRawSlope(theExp)-(meankdBoot(theExp)-errorkd(theExp)/2);
    
    lowErrorrelkd(theExp)=(meanrelkdBoot(theExp)+errorrelkd(theExp)/2)-relkd(theExp);
    highErrorrelkd(theExp)=relkd(theExp)-(meanrelkdBoot(theExp)-errorrelkd(theExp)/2);
end

%% Bleaching callibration

signs{1}={'.b','b-','b'};
signs{2}={'.r','r-','r'};
signs{3}={'.m','m-','m'};
signs{4}={'.c','c-','c'};

%refInds{1}=[25 43 43+6 43+12];
%refInds{2}=[61 61+6 61+12];
%refInds{3}=[98 98+6 98+12];
%refInds{4}=[139 139+7 139+14];

fractionlaserOnTime{1}= [1/2 1/3 1/6];
%fractionlaserOnTime{2}=[1/2 1/3 1/6];
%fractionlaserOnTime{3}=[1/2 1/3 1/6];
%fractionlaserOnTime{4}=[1/2 1/3 1/6];

refInds{1}=[6+6 6+12 6+16];

%fractionlaserOnTime{1}=[1 2/3 1/3];
facLaserOnTime=1; % if 1/timeStep isn't the fraction of time the laser is on


kbleach=zeros(1,numel(refInds));
figure();
hold on;
bleachpoly=cell(1,numel(refInds));
kbleachBoots=zeros(numBoots,numel(refInds));
for i=1:numel(refInds)
    errorbar(fractionlaserOnTime{i},kdFromRawSlope(refInds{i}),lowErrorkd(refInds{i}),highErrorkd(refInds{i}),signs{i}{1});
    bleachpoly{i}=polyfit(fractionlaserOnTime{i},kdFromRawSlope(refInds{i}),1);
    fracsplot=[0:0.01:1];
    plot(fracsplot,polyval(bleachpoly{i},fracsplot),signs{i}{2})
    kbleach(i)=bleachpoly{i}(1);
  
    for j=1:numBoots
        currkd=zeros(1,numel(refInds{i}));
        for k=1:numel(refInds{i})
            currkd(k)=experiments{refInds{i}(k)}.kdRawBootSamples(j);
            
        end
        
        bp=polyfit(fractionlaserOnTime{i},currkd,1);
        kbleachBoots(j,i)=bp(1);
        
    end
end

xlim([0 1]);
ylim([0 0.04]);

kbleachAll=kbleach(1);
kbleachAllBoots=kbleachBoots(:,1);

kdMin=zeros(1,numExps);
kdMinBoots=zeros(numBoots,numExps);
kdFromSlopeCorrected=zeros(1,numExps);
kdFromSlopeCorrectedBoots=zeros(numBoots,numExps);

for theExp=expsToAnalyseFitkon
    kdMin(theExp)=facLaserOnTime*kbleachAll*(1/experiments{theExp}.timeStep);
    kdFromSlopeCorrected(theExp)=kdFromRawSlope(theExp)-kdMin(theExp);
    for j=1:numBoots
        kdMinBoots(j,theExp)=facLaserOnTime*kbleachAllBoots(j)*(1/experiments{theExp}.timeStep);
        kdFromSlopeCorrectedBoots(j,theExp)=experiments{theExp}.kdRawBootSamples(j)-kdMinBoots(j,theExp);
        
    end
end

%% Estiamte koff micros

onset{1}=setIndexesNew{2};
onset{2}=setIndexesNew{7};
onset{3}=setIndexesNew{12};
onset{4}=setIndexesNew{17};
onset{5}=setIndexesNew{22};
onset{6}=setIndexesNew{27};

%normIndCurves(1)=6;
%normIndCurves(2)=6;
%normIndCurves(3)=6;
%normIndCurves(4)=1;
%normIndCurves(5)=1;

set{1}=onset{1}+12; 
set{2}=onset{2}+12;
set{3}=onset{3}+12;
set{4}=onset{4}+12;
set{5}=onset{5}+12;
set{6}=onset{6}+12;

defineAveraging{1}=1:numel(onset{1});
defineAveraging{2}=1:numel(onset{2});
defineAveraging{3}=1:numel(onset{3});
defineAveraging{4}=1:numel(onset{4});
defineAveraging{5}=1:numel(onset{5});
defineAveraging{6}=1:numel(onset{6});

%onset{1}=[43:48];
%onset{2}=[25:29];
%onset{3}=[79:82 84];
%onset{4}=97:102;
%onset{5}=[61:66];
%onset{6}=[139:145];

%set{1}=onset{1}+12; %Four the on rates, should be an assocation experiemnt
%set{2}=onset{2};
%set{3}=onset{3}+12;
%set{4}=onset{4}+12;
%set{5}=onset{5}+12;
%set{6}=onset{6}+7;%set{6}=onset{6}+7

%defineAveraging{1}=[1 2 2 3 3 4];
%defineAveraging{2}=1:numel(onset{2});
%defineAveraging{3}=1:numel(onset{3});
%defineAveraging{4}=1:numel(onset{4});
%defineAveraging{5}=1:numel(onset{5});
%defineAveraging{6}=1:numel(onset{6});



%normIndCurves(1)=61;
%normIndCurves(2)=61;
%normIndCurves(3)=61;
%normIndCurves(4)=61;

kaValsSelected=cell(1,numel(onset));
kdValsSelected=cell(1,numel(onset));

kaValsBootsSelected=cell(1,numel(onset));
kdValsBootsSelected=cell(1,numel(onset));

errorkaSelected=cell(1,numel(onset));
errorkdSelected=cell(1,numel(onset));

lowerBoundkaSelected=cell(1,numel(onset));
upperBoundkaSelected=cell(1,numel(onset));

lowerBoundkdSelected=cell(1,numel(onset));
upperBoundkdSelected=cell(1,numel(onset));



koffMicrosMeas=zeros(1,numel(onset));
koffMicrosBootkoffMicrosBoot=zeros(numBoots,numel(onset));

kaMax=zeros(1,numel(onset));
%kdMin=zeros(1,numel(onset));
kdMinAll=0;%min(kdFromRawSlope(set{2}));

koffMicrosMeanBoot=zeros(1,numel(onset));
koffMicrosError=zeros(1,numel(onset));
lowerBoundkoffMicros=zeros(1,numel(onset));
upperBoundkoffMicros=zeros(1,numel(onset));
perc=0.67;
for i=1:numel(onset)
    % pointsPerCurve=numel(onset{i});
    % kaVals=kaFromRawSlope(onset{i});
    % kdVals=kdFromRawSlope(set{i});
    
    pointsPerCurve=defineAveraging{i}(end);
    
    kdValsSelected{i}=zeros(1,pointsPerCurve);
    kaValsSelected{i}=zeros(1,pointsPerCurve);
    
    for j=1:pointsPerCurve
        kaValsSelected{i}(j)=mean(kaFromRawSlope(onset{i}(defineAveraging{i}==j)));
        kdValsSelected{i}(j)=mean(kdFromSlopeCorrected(set{i}(defineAveraging{i}==j)));
    end
    
    
    
    %pfit{i}=polyfit(kdValsSelected{i},kaValsSelected{i},1);
    %reversePoly=polyfit(kaValsSelected{i},kdValsSelected{i},1);
    
    normX=std(kdValsSelected{i});
    normY=std(kaValsSelected{i});
    relX=kdValsSelected{i}/normX;
    relY=kaValsSelected{i}/normY;
    
    bestParams=fitLineErrorxyver3(relX,relY,10,0.5,1.5,1e-3,1e-3);
   
    
    pfit{i} = [bestParams(1)*normY/normX bestParams(2)*normY];
    
    %figure();
    %plot(relX,relY,'bx');
    %hold on;
    %plot(relX,polyval(bestParams,relX,1));
    
    %kaMax(i)=kaFromRawSlope(normIndCurves(i));
    %kdMin(i)=polyval(reversePoly,kaMax(i));
    
    if pfit{i}(1)>0
        
        if std(kdValsSelected{i})<1e-3%pfitCurr(2)<0%pfit{i}(1)>(max(kaValsSelected{i})/(max(kdValsSelected{i})-min(kdValsSelected{i}))) %A very steep slope,s => koff,micro is essentialy 0
             koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1);
        else
            koffMicrosMeas(i)=inf;
        end
    else
        %koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1)-kdVals(normIndCurves(i));
        
        koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1);
    end
    kdValsBootsSelectedTemp=zeros(numBoots,pointsPerCurve);
    kaValsBootsSelectedTemp=zeros(numBoots,pointsPerCurve);
    if numBoots>5
        for j=1:numBoots
            disp(j);
            kaValsCurr=zeros(1,pointsPerCurve);
            kdValsCurr=zeros(1,pointsPerCurve);
            
            for k=1:pointsPerCurve
                onInds=onset{i}(defineAveraging{i}==k);
                offInds=set{i}(defineAveraging{i}==k);
                for index=1:numel(onInds)
                    kdValsCurr(k)=kdValsCurr(k)+kdFromSlopeCorrectedBoots(j,offInds(index));
                    
                    kaValsCurr(k)= kaValsCurr(k)+experiments{onInds(index)}.kaRawBootSamples(j);
                end
                
                kaValsCurr(k)=kaValsCurr(k)/numel(onInds);
                kdValsCurr(k)=kdValsCurr(k)/numel(onInds);
            end
            kaValsBootsSelectedTemp(j,:)=kaValsCurr;
            kdValsBootsSelectedTemp(j,:)=kdValsCurr;
            
            % pfitCurr=polyfit(kdValsCurr,kaValsCurr,1);
            %reversePoly=polyfit(kaValsCurr,kdValsCurr,1);
            %kaMaxCurr=kaFromRawSlope(normIndCurves(i));experiments{normIndCurves(i)}.kaRawBootSamples(j);
            %kdMinCurr=polyval(reversePoly,kaMaxCurr);
            
            kdMinCurr=kdMin(set{i}(1));
            
            normX=std(kdValsCurr);
            normY=std(kaValsCurr);
            relX=kdValsCurr/normX;
            relY=kaValsCurr/normY;
            
            
            bestParams=fitLineErrorxyver3(relX,relY,10,0.5,1.5,1e-3,1e-3);
            
            
            pfitCurr = [bestParams(1)*normY/normX bestParams(2)*normY];
            
            
            if pfitCurr(1)>0
                if std(kdValsCurr)<1e-3%pfitCurr(1)>(max(kaValsCurr)/(max(kdValsCurr)-min(kdValsCurr)))*10 %A very steep slope, => koff,micro is essentialy 0
                    koffMicrosBoot(j,i)=-pfitCurr(2)/pfitCurr(1);
                else
                    koffMicrosBoot(j,i)=inf;
                end
            else
                koffMicrosBoot(j,i)=-pfitCurr(2)/pfitCurr(1);
                
            end
        end
        kaValsBootsSelected{i}=kaValsBootsSelectedTemp;
        kdValsBootsSelected{i}=kdValsBootsSelectedTemp;
        
        errorkaSelected{i}=std(kaValsBootsSelected{i});
        errorkdSelected{i}=std(kdValsBootsSelected{i});
        
        lowerBoundkaSelected{i}=zeros(1,pointsPerCurve);
        upperBoundkaSelected{i}=zeros(1,pointsPerCurve);
        
        lowerBoundkdSelected{i}=zeros(1,pointsPerCurve);
        upperBoundkdSelected{i}=zeros(1,pointsPerCurve);
        
        
        for j=1:pointsPerCurve
            sortedkas=sort(kaValsBootsSelected{i}(:,j),'ascend');
            sortedkds=sort(kdValsBootsSelected{i}(:,j),'ascend');
            
            borderInd=round(numBoots*(1-perc)/2);
            
            lowerBoundkaSelected{i}(j)=sortedkas(borderInd);
            upperBoundkaSelected{i}(j)=sortedkas(end-borderInd);
            
            lowerBoundkdSelected{i}(j)=sortedkds(borderInd);
            upperBoundkdSelected{i}(j)=sortedkds(end-borderInd);
        end
        
        koffMicrosMeanBoot(i)=mean(koffMicrosBoot(:,i));
        koffMicrosError(i)=std(koffMicrosBoot(:,i));
        temp=koffMicrosBoot(:,i);
        
        sortedkoffs=sort(temp,'ascend');
        
        borderInd=round(numBoots*(1-perc)/2);
        
        lowerBoundkoffMicros(i)=sortedkoffs(borderInd);
        upperBoundkoffMicros(i)=sortedkoffs(end-borderInd);
    end
    
    
end
%%
save([savepath 'Intensities with bootstrappig calculated' parameterset ' ' datestr(now)],'-v7.3');
%% Barchat of koffmicro coloc, errorbars from repeats
 
%  meansColoc= [mean(koffMicrosMeas(5:6)) mean(koffMicrosMeas(3:4)) mean(koffMicrosMeas(1:2))];
%  lowEColoc = [std(koffMicrosMeas(5:6))/sqrt(2) std(koffMicrosMeas(3:4))/sqrt(2) std(koffMicrosMeas(1:2))/sqrt(2)];
%  highEColoc= [std(koffMicrosMeas(5:6))/sqrt(2) std(koffMicrosMeas(3:4))/sqrt(2) std(koffMicrosMeas(1:2))/sqrt(2)];
%  
%  thef=figure();
%  bar(meansColoc,'b');
%  hold on;
%  errorbar(1:3,meansColoc,lowEColoc,highEColoc,'k');
%  test=gca;
%  test.YScale='log';
%  test.Children(1).LineStyle='none';
%  ylim([5e-4 0.5]);
%  xlim([0.5 3.5])
%  xticks([1 2 3])
%  ylabel('koffmicro (s^-^1')
%  
%  savefig(thef,'koffmicro_coloc.fig');
% 
% %%
% for i=1:numel(onset)
%     figure();
%     title(num2str(onset{i}));
%     hist(koffMicrosBoot(:,i));
% end

%% Do on verseus off plots for 5 selected sets
%onset{1}=setIndexesNew{1};
%onset{2}=setIndexesNew{4};
%onset{3}=setIndexesNew{7};
%onset{4}=setIndexesNew{10};
%onset{5}=setIndexesNew{13};

%set{1}=onset{1}+12; %Four the on rates, should be an assocation experiemnt
%set{2}=onset{2}+12;
%set{3}=onset{3}+12;
%set{4}=onset{4}+12;
%set{5}=onset{5}+12;



signs{1}={'.b','b','b'};
signs{2}={'.r','r','r'};
signs{3}={'.c','c','c'};
signs{4}={'.m','m','m'};
signs{5}={'.y','y','y'};
signs{6}={'.k','k','k'};

%signs{1}={'.b','b-','b'};
%signs{2}={'xb','b-','b'};
%signs{3}={'.m','m-','m'};
%signs{4}={'xm','m-','m'};
%signs{5}={'.r','r-','r'};
%signs{6}={'xr','r-','r'};

h1=figure;
hold on;
%plot(kdFromSlope(set1),kaFromSlope(onset1),'bx');
%plot(kdFromSlope(set2),kaFromSlope(onset2),'rx');
%plot(kdFromSlope(set3),kaFromSlope(onset3),'cx');
%plot(kdFromSlope(set4),kaFromSlope(onset4),'mx');
%plot(kdFromSlope(set5),kaFromSlope(onset5),'kx');
kdPlot=-0.005:0.0005:0.1;
for i=1:numel(onset)
errorbar(kdValsSelected{i},kaValsSelected{i},kaValsSelected{i}-lowerBoundkaSelected{i},upperBoundkaSelected{i}-kaValsSelected{i},kdValsSelected{i}-lowerBoundkdSelected{i},upperBoundkdSelected{i}-kdValsSelected{i},signs{i}{1});
plot(kdPlot,polyval(pfit{i},kdPlot),signs{i}{2});
end

xlim([-0.005 0.05]);
ylim([0 0.2]);
hold on;
%xlim([0.01 0.1]);
%ylim([0 0.06]);
ylabel('kon s^-^1 nM^-^1')
xlabel('koff s^-^1')
title('From fluorescence intensity slopes')
savefig(h1,'ka_vs_kd_colocsim.fig');

%%
% %% Relative sccale for ka plots
% 
% 
% %onset{1}=setIndexesNew{1};
% %onset{2}=setIndexesNew{4};
% %onset{3}=setIndexesNew{7};
% %onset{4}=setIndexesNew{10};
% %onset{5}=setIndexesNew{13};
% 
% %set{1}=onset{1}+12; %Four the on rates, should be an assocation experiemnt
% %set{2}=onset{2}+12;
% %set{3}=onset{3}+12;
% %set{4}=onset{4}+12;
% %set{5}=onset{5}+12;
% 
% 
% 
% %signs{1}={'.b','b','b'};
% %signs{2}={'.r','r','r'};
% %signs{3}={'.c','c','c'};
% %signs{4}={'.m','m','m'};
% %signs{5}={'.k','k','k'};
% 
% signs{1}={'.b','b-','b'};
% signs{2}={'.r','r-','r'};
% signs{3}={'.m','m-','m'};
% signs{4}={'.b','b-','b'};
% 
% 
% h1=figure;
% hold on;
% %plot(kdFromSlope(set1),kaFromSlope(onset1),'bx');
% %plot(kdFromSlope(set2),kaFromSlope(onset2),'rx');
% %plot(kdFromSlope(set3),kaFromSlope(onset3),'cx');
% %plot(kdFromSlope(set4),kaFromSlope(onset4),'mx');
% %plot(kdFromSlope(set5),kaFromSlope(onset5),'kx');
% kdPlot=0:0.0005:0.1;
% for i=1:numel(onset)
% errorbar(kdFromRawSlope(set{i})-kdMin(set{i}(1)),relka(onset{i}),lowErrorrelka(onset{i}),highErrorrelka(onset{i}),lowErrorkd(set{i}),highErrorkd(set{i}),signs{i}{1});
% plot(kdPlot-kdMin(set{i}(1)),polyval(pfit{i},kdPlot)/kaFromRawSlope(normInds(onset{i}(1))),signs{i}{2});
% end
% 
% xlim([-0.005 0.07]);
% ylim([0 1.5]);
% hold on;
% %xlim([0.01 0.1]);
% %ylim([0 0.06]);
% ylabel('relative kon')
% xlabel('koff s^-^1')
% title('From fluorescence intensity slopes')
% 
% %% Add comparision with ground truth to the plots
% 
% koffDirect1=0*(1/100);
% koffDirect2=0*(1/100);
% koffDirect3=0*(1/100);
% koffDirect4=0*(1/100);
% koffDirect5=0*(1/100);
% 
% figure(h1);
% hold on;
% plot(kdSim(set{1})+koffDirect1,kaSim(onset{1}),'bo-');
% plot(kdSim(set{2})+koffDirect2,kaSim(onset{2}),'ro-');
% plot(kdSim(set{3})+koffDirect3,kaSim(onset{3}),'co-');
% plot(kdSim(set{4})+koffDirect4,kaSim(onset{4}),'mo-');
% plot(kdSim(set{5})+koffDirect5,kaSim(onset{5}),'ko-');
% 
% %% Do on verseus off plots for 5 selected sets on relative scales
% 
% 
% 
% 
% h1=figure;
% hold on;
% plot(kdFromSlope(set1)-kdFromSlope(set1(normInd1)),kaFromSlope(onset1)/kaFromSlope(onset1(normInd1)),'bx');
% plot(kdFromSlope(set2)-kdFromSlope(set2(normInd2)),kaFromSlope(onset2)/kaFromSlope(onset2(normInd2)),'rx');
% plot(kdFromSlope(set3)-kdFromSlope(set3(normInd3)),kaFromSlope(onset3)/kaFromSlope(onset3(normInd3)),'cx');
% plot(kdFromSlope(set4)-kdFromSlope(set4(normInd4)),kaFromSlope(onset4)/kaFromSlope(onset4(normInd4)),'mx');
% plot(kdFromSlope(set5)-kdFromSlope(set5(normInd5)),kaFromSlope(onset5)/kaFromSlope(onset5(normInd5)),'kx');
% hold on;
% %xlim([0.01 0.1]);
% %ylim([0 0.06]);
% ylabel('relative kon s^-^1 nM^-^1')
% xlabel('relative koff s^-^1')
% title('From fluorescence intensity slopes')
% %% For the relative plots
% 
% 
% 
% figure(h1);
% hold on;
% plot(kdSim(set1)-kdSim(set1(normInd1)),kaSim(onset1)/kaSim(onset1(normInd1)),'bo-');
% plot(kdSim(set2)-kdSim(set2(normInd2)),kaSim(onset2)/kaSim(onset2(normInd2)),'ro-');
% plot(kdSim(set3)-kdSim(set3(normInd3)),kaSim(onset3)/kaSim(onset3(normInd3)),'co-');
% plot(kdSim(set4)-kdSim(set4(normInd4)),kaSim(onset4)/kaSim(onset4(normInd4)),'mo-');
% plot(kdSim(set5)-kdSim(set5(normInd5)),kaSim(onset5)/kaSim(onset5(normInd5)),'ko-');
% 
% 
% 
% %%
% 
% %relkaModel1=kaSim(onset{1})/kaSim(onset{1}(normInd1));
% %relkaModel2=kaSim(onset{2})/kaSim(onset{2}(normInd2));
% %relkaModel3=kaSim(onset3)/kaSim(onset3(normInd3));
% %relkaModel4=kaSim(onset{4})/kaSim(onset{4}(normInd4));
% %relkaModel5=kaSim(onset{5})/kaSim(onset{4}(normInd5));
% 
% %relkdModel1=kdSim(set{1})-kdSim(set{1}(normInd1));
% %relkdModel2=kdSim(set{2})-kdSim(set{2}(normInd2));
% %relkdModel3=kdSim(set{3})-kdSim(set{3}(normInd3));
% %relkdModel4=kdSim(set{4})-kdSim(set{4}(normInd4));
% %relkdModel5=kdSim(set{5})-kdSim(set{5}(normInd5));
% 
% %relkaExp1=kaFromSlope(onset{1})/kaFromSlope(onset{1}(normInd1));
% %relkaExp2=kaFromSlope(onset{2})/kaFromSlope(onset{2}(normInd2));
% %relkaExp3=kaFromSlope(onset{3})/kaFromSlope(onset{3}(normInd3));
% %relkaExp4=kaFromSlope(onset{4})/kaFromSlope(onset{4}(normInd4));
% %relkaExp5=kaFromSlope(onset{5})/kaFromSlope(onset5(normInd5));
% 
% %relkdExp1=kdFromSlope(set{1})-kdFromSlope(set{1}(normInd1));
% %relkdExp2=kdFromSlope(set{2})-kdFromSlope(set{2}(normInd2));
% %relkdExp3=kdFromSlope(set{3})-kdFromSlope(set{3}(normInd3));
% %relkdExp4=kdFromSlope(set{4})-kdFromSlope(set{4}(normInd4));
% %relkdExp5=kdFromSlope(set5)-kdFromSlope(set5(normInd5));
% 
% t1=figure();
% 
% 
% plot([1e-4 0.1],[1e-4 0.1],'Color',[.7 .7 .7]);
% hold on;
% for i=1:numel(onset)
%     errorbar(relkdModel(set{i}),relkd(set{i}),lowErrorrelkd(set{i}),highErrorrelkd(set{i}),signs{i}{1});
% end 
%  
%     
% xlabel('True model k_d [s^-^1]');
% ylabel('Estimated k_d [s^-^1]');
% %t1.Children.XScale='log';
% %t1.Children.YScale='log';
% 
% t2=figure();
% 
% 
% plot([0.03 1.5],[0.03 1.5],'Color',[.7 .7 .7]);
% hold on;
% 
% for i=1:numel(onset)
%     errorbar(relkaModel(onset{i}),relka(onset{i}),lowErrorrelka(onset{i}),highErrorrelka(onset{i}),signs{i}{1});
% end   
% 
% xlabel('True model k_a [s^-^1 nM^-^1]');
% ylabel('Estimated k_a [s^-^1 nM^-^1]');
% %t2.Children.XScale='log';
% %t2.Children.YScale='log';

%% Absoluate values


t1=figure();


plot([-0.001 0.03],[-0.001 0.03],'Color',[.7 .7 .7]);
hold on;
for i=1:numel(onset)
    errorbar(kdSim(set{i}),kdValsSelected{i},kdValsSelected{i}-lowerBoundkdSelected{i},upperBoundkdSelected{i}-kdValsSelected{i},signs{i}{1});
end 
xlim([-0.001 0.028]);
ylim([-0.001 0.028]);
    
xlabel('True model k_d [s^-^1]');
ylabel('Estimated k_d [s^-^1]');
%t1.Children.XScale='log';
%t1.Children.YScale='log';
savefig(t1,'kd_true_vs_est.fig');

t2=figure();


plot([0 0.2],[0 0.2],'Color',[.7 .7 .7]);
hold on;

for i=1:numel(onset)
    errorbar(kaSim(onset{i}),kaValsSelected{i},kaValsSelected{i}-lowerBoundkaSelected{i},upperBoundkaSelected{i}-kaValsSelected{i},signs{i}{1});
end   
xlim([0 0.2]);
ylim([0 0.2]);
xlabel('True model k_d [s^-^1]');
ylabel('Estimated k_d [s^-^1]');

savefig(t2,'ka_true_vs_est.fig');

% %% Testing
% 
% 
% step=0.01;
% 
% lambda=3;
% times=0:step:lambda*20;
% survivalfunc=zeros(1,numel(times));
% numSamples=10000;
% 
% 
% for i=1:numSamples
%   time=exprnd(1/lambda);  
%   currtime=time;  
%   while currtime>=0
%       survivalfunc(times<=currtime)=survivalfunc(times<=currtime)+1;
%       currtime=currtime-step;
%   end
%     
%     
% end
% survivalfunc=survivalfunc/survivalfunc(1);
% figure();
% plot(times,survivalfunc,'b');
% hold on;
% truth=exp(-lambda*times);
% p=polyfit(times(1:2),survivalfunc(1:2),1);
% slope=p(1);
% plot(times,exp(-lambda*times),'r--');
% 
% 
% %% Testigg count ground truth dwelltime from traces
% onlyCountFirstWait=0;
% for theExp=expsToAnalyse
%     disp(theExp);
%     newTimeStep=1;
%     numTraces=size(XCell{theExp},2);
%     traces=cell(1,numTraces);
%     for i=1:numTraces
%         traces{i}=XCell{theExp}(:,i)+1;
%     end
%     
%     tWaits=[];
%     tDwells=[];
%     for i=1:numel(traces)
%         %eventsHappen=diff(boundStates{i});
%         %assocInds=find(eventsHappen==1)+1;
%         %dissocInds=find(eventsHappen==-1)+1;
%         currState=traces{i}(1);
%         currInd=1;
%         numTrans=0;
%         for j=2:numel(traces{i})
%             if currState~=traces{i}(j)
%                 numTrans=numTrans+1;
%                 if currState==1
%                     if numTrans==1&&onlyCountFirstWait==1
%                         tWaits=[tWaits (j-currInd)*newTimeStep];
%                     elseif onlyCountFirstWait==0
%                         tWaits=[tWaits (j-currInd)*newTimeStep];
%                     end
%                 elseif currState==2
%                      tDwells=[tDwells (j-currInd)*newTimeStep];
%                 end
%                 currState=traces{i}(j);
%                 currInd=j;
%             elseif j==numel(traces{i}) %Also count "the last sate spend"  
%                  %if currState==1
%                  %   tWaits=[tWaits (j-currInd+1)*newTimeStep];
%                 %if currState==2
%                 %     tDwells=[tDwells (j-currInd+1)*newTimeStep];
%                 %end
%             end
%         end
%     end
%     
%     kdTraces(theExp)=1/mean(tDwells);
%     kaTraces(theExp)=1/(mean(tWaits)*protconckon(theExp));
% 
% end
% %%
% 
% figure();
% hold on;
% plot([0 0.1],[0 0.1],'Color',[.7 .7 .7]);
% plot(kdSim(set1),kdTraces(set1),'bx');
% plot(kdSim(set2),kdTraces(set2),'rx');
% plot(kdSim(set3),kdTraces(set3),'cx');
% plot(kdSim(set4),kdTraces(set4),'mx');
% plot(kdSim(set5),kdTraces(set5),'kx');
%  %% Plot intensity traces for manuscrpit on rate 
% theExp=99;%setIndexes{10}(2);%25;%57; %theExp 50 seems reversed in the viterbi states
% timeStep=experiments{theExp}.timeStepOn;
% okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
%  intensityTraces=experiments{theExp}.intensityTracesOn;
%  alltrajsCoLocAllFrames=experiments{theExp}.alltrajsCoLocAllFrames;
%  
%  ind=[127 93 107 ]; %93 107 108
% starti=[1 1 1];
% signs{1}='r-';
% signs{2}='m-';
% signs{3}='b-';
%  %trajInd=okIndsTraces(ind);
% 
%  
% t1=figure();
% hold on;
% 
% 
% for i=1:numel(starti)
%     
%     trajInd=okDNAIndsNotNan(ind(i));
%     yyaxis left
%     %ocu= experiments{theExp}.DNAoccupancy(trajInd,:)+1;
%     %ocu=repmat(ocu,[timeStep/newTimeStep 1]);
%     %ocu=ocu(:);
%     
%     
%     %plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-1),experiments{theExp}.autcorrs2dshifted{ind}(1:100,:),'b-');
%     
%     %ylim([0 4])
%     %yyaxis right
%     hold on
%     plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-starti(i)),intensityTraces{trajInd}(starti(i):end)',signs{i});
%     ylim([-4e4 12e4]);
%     ylabel('Fluorescence intensity (AU)')
%     xlabel('Time (s)')
% end
% yyaxis right
% timeStep=experiments{theExp}.timeStepOn;
% numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
% plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:)-experiments{theExp}.intensityFirstTime(1,1),'k');
% xlim([0 200]);
% ylim([-0.5*(1/3) 0.5]);
% box on;
% title(['Experiment: ' num2str(theExp) 'Tracjeory: ' num2str(okDNAIndsNotNan(ind)) '.fig']);
%  
% 
% 
% savefig(t1,['traces and on curve ' num2str(theExp) 'Tracjeory ' num2str(okDNAIndsNotNan(ind)) '.fig']);
% 
% 
%  %% Plot intensity traces for manuscrpit off rate 
% theExp=99+12;%setIndexes{10}(2);%25;%57; %theExp 50 seems reversed in the viterbi states
% timeStep=experiments{theExp}.timeStepOff;
% okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
%  intensityTraces=experiments{theExp}.intensityTracesOff;
%  alltrajsCoLocAllFrames=experiments{theExp}.alltrajsCoLocAllFrames;
%  
%  ind=[15 16 81]; %93 107 108
% starti=[1 1 26];
% signs{1}='r-';
% signs{2}='m-';
% signs{3}='b-';
%  %trajInd=okIndsTraces(ind);
% 
%  
% t1=figure();
% hold on;
% 
% 
% for i=1:numel(ind)
%     
%     trajInd=okDNAIndsNotNan(ind(i));
%     yyaxis left
%     %ocu= experiments{theExp}.DNAoccupancy(trajInd,:)+1;
%     %ocu=repmat(ocu,[timeStep/newTimeStep 1]);
%     %ocu=ocu(:);
%     
%     
%     %plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-1),experiments{theExp}.autcorrs2dshifted{ind}(1:100,:),'b-');
%     
%     %ylim([0 4])
%     %yyaxis right
%     hold on
%     plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-starti(i)),intensityTraces{trajInd}(starti(i):end)',signs{i});
%     ylim([-4e4 12e4]);
%     ylabel('Fluorescence intensity (AU)')
%     xlabel('Time (s)')
% end
% yyaxis right
% timeStep=experiments{theExp}.timeStepOff;
% numTimePoints=size(experiments{theExp}.intensityAllTime,2);
% plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1),'k');
% xlim([0 160]);
% ylim([0.6 1]);
% box on;
% title(['Experiment: ' num2str(theExp) 'Tracjeory: ' num2str(okDNAIndsNotNan(ind)) '.fig']);
%  
% 
% 
% savefig(t1,['traces and off curve ' num2str(theExp) 'Tracjeory ' num2str(okDNAIndsNotNan(ind)) '.fig']);
% 
% 
% %% Plot intensity trace for manuscript 
% signs{1}='r.';
% signs{2}='m.';
% signs{3}='b.';
% 
% onsetplot=[97 99 101];%[43:48];%43:48;
% %onsetplot=setIndexes{10};%setIndexes(11,:)
% 
% f1=figure();
% hold on;
% k=1;
% for theExp=onsetplot
%     timeStep=experiments{theExp}.timeStepOn;
% 
%     numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
%     plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:)-experiments{theExp}.intensityFirstTime(1,1),signs{k});
%     k=k+1;
% end
% 
% xlim([0 50]);
% ylim([0 0.7]);
% title('association');
% xlabel('Time (s)');
% ylabel('Normalized fluorescence (AU)');
% 
% savefig(f1,['on_curves_' num2str(onsetplot) '.fig']);
% 
% offsetplot=onsetplot+12;
% 
% f2=figure();
% hold on;
% k=1;
% for theExp=offsetplot
%     timeStep=experiments{theExp}.timeStepOff;
%     
%     numTimePoints=size(experiments{theExp}.intensityAllTime,2);
%     plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1),signs{k});
%     k=k+1;
% end
% 
% title('dissocation');
% xlim([0 50]);
% ylim([0.7 1]);
% xlabel('Time (s)');
% ylabel('Normalized fluorescence (AU)');
% savefig(f2,['off_curves_' num2str(offsetplot) '.fig']);
% 
% %% Do on verseus off plots for 4 selected sets
% %Simulations
% %set1=setIndexes(13,:);
% %set2=setIndexes(14,:);
% %set3=setIndexes(15,:);
% 
% 
% %onset1=set1; %Four the on rates, should be an assocation experiemnt
% %onset2=set1;
% %onset3=set1;
% 
% %Experiments
% onset1=[25:29];%[43:48];%[25:29]
% onset2=[61:66];
% onset3=[97:102];%[97:102];%[79:84]%[97:102];
% onset4=[79:82 84];
% set1=onset1;
% set2=onset2;
% set3=onset3;
% set4=onset4;
% 
% 
% h1=figure;
% hold on;
% plot(kdFromSlope(set1),kaFromSlope(onset1),'bx');
% plot(kdFromSlope(set2),kaFromSlope(onset2),'rx');
% plot(kdFromSlope(set3),kaFromSlope(onset3),'cx');
% plot(kdFromSlope(set4),kaFromSlope(onset4),'co');
% hold on;
% %xlim([0.01 0.1]);
% %ylim([0 0.06]);
% ylabel('kon s^-^1 nM^-^1')
% xlabel('koff s^-^1')
% title('From fluorescence intensity slopes')
% 
%  
% %% FRET in vitro
% 
%   %% In vitro salt conc plot fix for manuscript 201124
%    
%    salt=[1 5 10 20 40 80 160];
%    
%    tDwell=[161.8123 156.49452 151.0574 144.09222 132.97872 112.99435 113.50738];
%    tDwellError=[12.48384 14.14675 12.12595 10.42683 9.24908 9.47486 7.87908];
%    
%    
%    kdO1Salt=1./tDwell;
%    kdO1SaltError=kdO1Salt.*(tDwellError./tDwell);
%    
%    tWait=[37.81223 38.66 63.64 89.2 101.04 144.24];
%    tWaitError=[3.94209 4.63147 7.09009 10.50306 12.1427 16.59181];
%    
%    LacIConc=7.9 ;%nM
%    
%    kaO1SaltnM=(1./(tWait*LacIConc));
%    kaO1SaltnMError=kaO1SaltnM.*(tWaitError./tWait);
%    
% 
%    
%  
% 
%    
%  %polyInvitro=polyfit(kdO1Salt(1:end-1),kaO1SaltnM,1);
%  normX=std(kdO1Salt(1:end-1));
%  normY=std(kaO1SaltnM);
%  
%  relX=kdO1Salt(1:end-1)/normX;
%  relY=kaO1SaltnM/normY;
%  
%  bestParams=fitLineErrorxy(relX,relY);
%  polyInvitro=[bestParams(1)*normY/normX bestParams(2)*normY];
%  
%  kamaxInvitro=kaO1SaltnM(1);%polyval(polyInvitro,kdO1Salt(1));%;
%  koffInVitroO1=-kamaxInvitro/polyInvitro(1);
%  koffdirectInvtroO1=(polyInvitro(2)/kamaxInvitro-1)*koffInVitroO1;
%  
%  nBoots=1000;
%  
%  xSamples=kdO1Salt(1:end-1);
%  ySamples=kaO1SaltnM;
%  errorX=kdO1SaltError(1:end-1);
%  errorY=kaO1SaltnMError;
%  numxSamples=numel(xSamples);
%  numySamples=numel(ySamples);
%  
%  xBoots=zeros(nBoots,numxSamples);
%  yBoots=zeros(nBoots,numySamples);
%  polyBoot=zeros(nBoots,2);
%  koffBoot=zeros(nBoots,1);
%  yInterceptBoot=zeros(nBoots,1);
%  xInterceptBoot=zeros(nBoots,1);
%  xValsplot=linspace(0,2*-polyInvitro(2)/polyInvitro(1),200);
%  yValsBoot=zeros(nBoots,numel(xValsplot));
%  
%  parfor i=1:nBoots
%      disp(i);
%      xBoots(i,:)=xSamples+randn()*errorX;
%      yBoots(i,:)=ySamples+randn()*errorY;
%      
%      normX=std(xBoots(i,:));
%      normY=std(yBoots(i,:));
%  
%      relX=xBoots(i,:)/normX;
%      relY=yBoots(i,:)/normY;
%  
%      bestParams=fitLineErrorxy(relX,relY);
%      polyCurr=[bestParams(1)*normY/normX bestParams(2)*normY];
%      polyBoot(i,:)=polyCurr;
%      yCurr= yBoots(i,:); 
%      
%      koffBoot(i)=-yCurr(1)/polyCurr(1);
%      yInterceptBoot(i)=polyCurr(2);
%      xInterceptBoot(i)=-polyCurr(2)/polyCurr(1);
%      yValsBoot(i,:)=polyval(polyBoot(i,:),xValsplot);
%  end
%  
%  xInterceptmMax=-polyInvitro(2)/polyInvitro(1)+std(xInterceptBoot);
%  xInterceptmMin=-polyInvitro(2)/polyInvitro(1)-std(xInterceptBoot);
%  
%  yInterceptmMax=polyInvitro(2)+std(yInterceptBoot);
%  yInterceptmMin=polyInvitro(2)-std(yInterceptBoot);
%  
%  yMaxVals=mean(yValsBoot)+std(yValsBoot);
%  yMinVals=mean(yValsBoot)-std(yValsBoot);
%  
%  koffBootError=std(koffBoot);
%  
% 
%  
%  sortedVals=sort(koffBoot,'ascend');
%  ind=round(numel(sortedVals)*(1-perc)/2);
%  koffmicroLowInVitroO1=sortedVals(ind);
%  koffmicroHighInVitroO1=sortedVals(numel(sortedVals)-ind+1);
%  
%  disp(['Estimated koffmicro for O1 in vitro: ' num2str(koffInVitroO1) ' ± ' num2str(koffBootError) ' s^-^1' ])
%  
%  figure;
%  h=errorbar(xSamples-koffdirectInvtroO1,ySamples,errorY,errorY,errorX,errorX,'r.');
%  test=gca;
%  hold on;
%  
%  
%  
%  xlabel('k_d (s^-^1)');
%  ylabel('k_a (s^-^1 nM^-^1)');
%  
%  
%  
%  yvals=[yMinVals fliplr(yMaxVals)] ;
%  xvals=[xValsplot fliplr(xValsplot)];
%  fill(xvals-koffdirectInvtroO1,yvals,'y');
%  
%  test.Children(1).FaceAlpha=0.2;
%  test.Children(1).EdgeColor=[1 1 1];
%  test.Children(1).EdgeAlpha=0;
%  
%  kdvalsplot=linspace(0,koffInVitroO1+koffdirectInvtroO1,100);
%  hold on;
%  plot(kdvalsplot-koffdirectInvtroO1,polyval(polyInvitro,kdvalsplot),'r');
%  plot([koffInVitroO1 koffInVitroO1],[0 kamaxInvitro*2],'k--');
%  plot([-(koffInVitroO1) 2*(koffInVitroO1)],[kamaxInvitro kamaxInvitro],'k-.')
%  
%  xlim([-5e-4 4*10^-3]);
%  ylim([0 4*10^-3]);
% 
%  
%  
%  for i=1:numel(test.Children)
%      test.Children(i).MarkerSize=12;
%    %  test.Children(i).LineWidth=1;
%      
%  end
%  
%  savefig('InvitrosaltO1_kd_vs_ka_201124')
%  %save('FRETDATA_fitted_201127.mat');
%  figure();
%  hist(koffBoot);
%  
%  %% Barchat of koffmicro both from FRET and coloc
%  
%  meansInVitro= [koffInVitroO1 koffMicrosMeas([2 3 1 4])];
%  lowEInVitro = meansInVitro -[koffmicroLowInVitroO1 lowerBoundkoffMicros([2 3 1 4])];
%  highEInVitro= [koffmicroHighInVitroO1 upperBoundkoffMicros([2 3 1 4])]-meansInVitro;
%  
%  thef=figure();
%  bar(meansInVitro,'b');
%  hold on;
%  %lowE=means-[koffmicroLow(1) koffmicroLow(3) koffmicroLow(2) koffmicroLow(4:6)];
%  %If zeros is included in the lower error, make it tiny bit smaller just for
%  %plotting reasons
%  %lowOrdered=[koffmicroLow(1) koffmicroLow(3) koffmicroLow(2) koffmicroLow(4:6)];
%  %lowE(lowOrdered==0)=lowE(lowOrdered==0)*0.99999;
%  %highE=-(means-[koffmicroHigh(1) koffmicroHigh(3) koffmicroHigh(2) koffmicroHigh(4:6)]);
%  errorbar(1:5,meansInVitro,lowEInVitro,highEInVitro,'k');
%  test=gca;
%  test.YScale='log';
%  test.Children(1).LineStyle='none';
%  ylim([5e-4 0.5]);
%  xlim([0 6])
%  ylabel('koffmicro (s^-^1')
%  
%  savefig(thef,'koffmicro_invitro.fig');
% 
% 
%   %% In vivo ka vs kd
%     
%    % simkas=1./searchTime';
%     %simkds=reshape(1./dissocTime(1,:,:),[numVals,numkoff]);
%     fig=figure();
%     
%     %plot(reshape(1./dissocTime(1,:,1),[numVals,1]),1./searchTime(1,:),'b');
%     %hold on;
%     %plot(reshape(1./dissocTime(1,:,2),[numVals,1]),1./searchTime(1,:),'r');
%     %plot(reshape(1./dissocTime(1,:,3),[numVals,1]),1./searchTime(1,:),'m');
%     %legend(strsplit(num2str(koffVec)));
%     test=gca;
%     %test.XScale='log';
%     %test.YScale='log';
%     
%     xlabel('Macroscopic k_d (s^-^1)');
%     ylabel('Macroscopic k_a (cell volumes × s^-^1)')
%     
%     %expkas=[2.92 2.4 0.24 ]/(60*20);
%     %expkds=[2.15 3.78 120]/(60*20);
%     
%     
%     expkas=[0.73 0.57]/(3*60);
%     expkds=[(1/9.3)/60 (1/5.3)/60];
%     expkdsError=[0.4/9.3 0.2/5.3].*expkds;
%     dwellTime=[9.3*60 5.3*60];
%     dwellTimeError=[0.4 0.2]*60;
%     
%     conversion=1/(6.022*10^23)*(1/10^-15);%st/cellvolume
%     expkasMoles=expkas/conversion;
%     kDsMoles=expkds./expkasMoles;
%     kDsRF=[130*1e-12 0.6*1e-9 200e-9];
%     fracs=kDsMoles(1:2)./kDsRF(1:2);
%     %kdEstRF=kDsRF(1:3).*expkasMoles(1:3);
%     
%     
%     expkasAllPetter=[0.73 0.57 0.25 0.06]/(3*60);
%     expkasAllPetterError=[0.03 0.03 0.1 0.07]/(3*60);
%     genomeSize=5e6;
%     DNAFracFree=1;
%     energiesRFDimer=[-17 -15.3 -13.9 -9.7];%Garcia et al 2011 Fig S7
%     energiesRFDimerError=[0.2 0.2 0.2 0.1];%Garcia et al al 2011 Fig S7
%     KDsRFDimer=genomeSize*DNAFracFree./exp(-energiesRFDimer);
%     kdEstRFDimer=KDsRFDimer.*expkasAllPetter;
%     
%     KDsRFDimerError=KDsRFDimer.*energiesRFDimerError;
%     kdEstRFDimerErroralt=sqrt((KDsRFDimer.*expkasAllPetterError).^2+(expkasAllPetter.*KDsRFDimerError).^2);
%     kdEstRFDimerError=kdEstRFDimer.*sqrt((expkasAllPetterError./expkasAllPetter).^2+(KDsRFDimerError./KDsRFDimer).^2);
%     %hold on;plot(expkds(1:2),expkas(1:2),'ko')
%     
%     expkasAllPetterErrorLow=expkasAllPetterError;
%     %Adjust tiny bit to be able to plot in log scale
%     expkasAllPetterErrorLow(expkasAllPetter-expkasAllPetterErrorLow<0)=expkasAllPetter(expkasAllPetter-expkasAllPetterErrorLow<0)*0.9999;
%     expkasAllPetterErrorHigh=expkasAllPetterError;
%     
%     expkdsErrorLow=expkdsError;
%     %expkdsErrorLow(expkds-expkdsErrorLow<0)=expkds(expkds-expkdsErrorLow<0)*0.9999;
%     expkdsErrorHigh=expkdsError;
%     
%     kdEstRFDimerErrorLow=kdEstRFDimerError;
%     kdEstRFDimerErrorLow(kdEstRFDimer-kdEstRFDimerErrorLow<0)=kdEstRFDimer(kdEstRFDimer-kdEstRFDimerErrorLow<0)*0.999;
%     kdEstRFDimerErrorHigh=kdEstRFDimerError;
%     
%     
%     hold on;
%     h1_1=errorbar(expkds(1),expkasAllPetter(1),expkasAllPetterErrorLow(1),expkasAllPetterErrorHigh(1),expkdsErrorLow(1),expkdsErrorHigh(1),'yx','LineWidth',0.5,'CapSize',1,'MarkerSize',3);
%     h1_2=errorbar(expkds(2),expkasAllPetter(2),expkasAllPetterErrorLow(2),expkasAllPetterErrorHigh(2),expkdsErrorLow(2),expkdsErrorHigh(2),'rx','LineWidth',0.5,'CapSize',1,'MarkerSize',3);
%     
%     %hold on;plot(kdEstRFDimer,expkasAllPetter,'kx');
%     h2_1=errorbar(kdEstRFDimer(1),expkasAllPetter(1),expkasAllPetterErrorLow(1),expkasAllPetterErrorHigh(1),kdEstRFDimerErrorLow(1),kdEstRFDimerErrorHigh(1),'y.','LineWidth',0.5,'CapSize',1,'MarkerSize',6);
%     h2_2=errorbar(kdEstRFDimer(2),expkasAllPetter(2),expkasAllPetterErrorLow(2),expkasAllPetterErrorHigh(2),kdEstRFDimerErrorLow(2),kdEstRFDimerErrorHigh(2),'r.','LineWidth',0.5,'CapSize',1,'MarkerSize',6);
%     h2_3=errorbar(kdEstRFDimer(3),expkasAllPetter(3),expkasAllPetterErrorLow(3),expkasAllPetterErrorHigh(3),kdEstRFDimerErrorLow(3),kdEstRFDimerErrorHigh(3),'m.','LineWidth',0.5,'CapSize',1,'MarkerSize',6);
%     h2_4=errorbar(kdEstRFDimer(4),expkasAllPetter(4),expkasAllPetterErrorLow(4),expkasAllPetterErrorHigh(4),kdEstRFDimerErrorLow(4),kdEstRFDimerErrorHigh(4),'b.','LineWidth',0.5,'CapSize',1,'MarkerSize',6);
%     
%     kasToFit=[expkasAllPetter(1:2) expkasAllPetter(1:end-1)];
%     kdsToFit=[expkds(1:2) kdEstRFDimer(1:end-1)];
%     
%     normX=std(kdsToFit);
%     normY=std(kasToFit);
%  
%     relX=kdsToFit/normX;
%     relY=kasToFit/normY;
%  
%     bestParams=fitLineErrorxy(relX,relY);
%     polyInVivo=[bestParams(1)*normY/normX bestParams(2)*normY];
%     hold on;
%     kdToPlot=[0:1e-3:5e-2];
%     plot(kdToPlot,polyval(polyInVivo,kdToPlot),'r','LineWidth',1);
%     
%     xlim([0 1.1*10^-1]);
%     ylim([0 5*10^-3]);
%     fig.Position=[500 200 400 400];
%     test.Position=[0.2 0.3 0.2 0.2];
%     box on;
%     xticks([0 0.01 0.09 0.1 0.11]);
%     breakxaxis([0.015 0.095])
%     
%     % fix errorbar capsize
%     
%     
%     
%     
%     savefig('kinetic_kd_vs_ka_invivo')
%    
%   %%
%   
%   
%   allkds=[expkds(1:2) kdEstRFDimer];
%   allkas=[expkasAllPetter(1:2) expkasAllPetter];
%   nBoots=100000;
%   kasBoot=zeros(6,nBoots);
%   kdsBoot=zeros(6,nBoots);
%    koffmicroBoot=zeros(6,nBoots);
%    PtotBoot=zeros(1,nBoots);
%    koffdirect=0;
%    kamax=allkas(2)/0.54;
%    koffmicro=kamax*(allkds-koffdirect)./(kamax-allkas);
%    
%    for i=1:nBoots
%        k=1;
%        for j=3:6
%            kasBoot(j,i)=expkasAllPetter(k)+randn(1,1)*expkasAllPetterError(k);
%            k=k+1;
%        end
%        kasBoot(1,i)=kasBoot(3,i);
%        kasBoot(2,i)=kasBoot(4,i);
%        kasBoot(kasBoot(:,i)<0,i)=0;
%        % kamaxMean=kasBoot(2,i)/0.54;
%        % kamaxMeanError=(0.24/0.54)*kamaxMean;
%        % kamax=kamaxMean+randn(1,1)*kamaxMeanError;
%        PtotBoot(i)=0.53+randn(1,1)*0.24;
%        kamax=kasBoot(2,i)/PtotBoot(i);
%        
%        kdsBoot(1,i)=expkds(1)+randn(1,1)*expkdsError(1);
%        kdsBoot(2,i)=expkds(2)+randn(1,1)*expkdsError(2);
%        %kdsBoot(1,i)=1/(dwellTime(1)+randn(1,1)*dwellTimeError(1));
%        %kdsBoot(2,i)=1/(dwellTime(2)+randn(1,1)*dwellTimeError(2));
%         energiesRFDimerTemp=energiesRFDimer+randn(1,1)*energiesRFDimerError;
%        KDstemp=genomeSize*DNAFracFree./exp(-energiesRFDimerTemp);
%        kdsBoot(3:6,i)=KDstemp'.*kasBoot(3:6,i);
%        kdsBoot(kdsBoot(:,i)<0,i)=0;
%        koffmicroBoot(:,i)=kamax*(kdsBoot(:,i)-koffdirect)./(kamax-kasBoot(:,i));
%        koffmicroBoot(kasBoot(:,i)>kamax,i)=inf;
%       % koffmicroBoot(koffmicroBoot(:,i)<0,i)=0;
%       koffmicroBoot(kdsBoot(:,i)<koffdirect,i)=0;
%    end
%    
%    koffmicroLow=zeros(1,size(koffmicroBoot,1));
%    koffmicroHigh=zeros(1,size(koffmicroBoot,1));
%    p=0.67;
%    koffmicroMean=zeros(1,size(koffmicroBoot,1));
%    numOks=zeros(1,size(koffmicroBoot,1));
%   
%    for j=1:size(koffmicroBoot,1)
%        koffmicroBoot(j,koffmicroBoot(j,:)==inf)=1000;
%        okVals=koffmicroBoot(j,:);%koffmicroBoot(j,koffmicroBoot(j,:)<inf);
%        sortedOkVals=sort(okVals,'ascend');
%        ind=round(numel(sortedOkVals)*(1-p)/2);
%        koffmicroLow(j)=sortedOkVals(ind);
%        koffmicroHigh(j)=sortedOkVals(numel(sortedOkVals)-ind+1);
%        koffmicroMean(j)=median(okVals);
%        numOks(j)=numel(okVals);
%    end
%     figure();
%     %means=[koffmicroMean(1) koffmicroMean(3) koffmicroMean(2) koffmicroMean(4:6)];
%     means=[koffmicro(1) koffmicro(3) koffmicro(2) koffmicro(4:6)];
%     bar(means,'b');
%     hold on;
%     lowE=means-[koffmicroLow(1) koffmicroLow(3) koffmicroLow(2) koffmicroLow(4:6)];
%     %If zeros is included in the lower error, make it tiny bit smaller just for
%     %plotting reasons
%     lowOrdered=[koffmicroLow(1) koffmicroLow(3) koffmicroLow(2) koffmicroLow(4:6)];
%     lowE(lowOrdered==0)=lowE(lowOrdered==0)*0.99999;
%     highE=-(means-[koffmicroHigh(1) koffmicroHigh(3) koffmicroHigh(2) koffmicroHigh(4:6)]);
%    errorbar(1:6,means,lowE,highE,'k');
%    test=gca;
%    test.YScale='log';
%    test.Children(1).LineStyle='none';
%    ylim([5e-4 0.5]);
%    xlim([0 7])
%    ylabel('koffmicro (s^-^1)')
%    
%    
%    
%    %figure();
%    %bar([koffmicro(1) koffmicro(3) koffmicro(2) koffmicro(4:6)],'b');
%    %test=gca;
%    %test.YScale='log';
%    %ylim([1e-3 0.2]);
%    %ylabel('koffmicro (s^-^1')
%    
%    savefig('koffmicro_invivoall')
%    %% Plot bar chart in vivo, 1 estimate for osym o1 o2 and o3
%  meansSelected= [means(1) means(3) means(5:6)]; %Osym (kd estimate from petter), O1 (kd estimate from petter), O2 and O (kd estimage from garcia et. al)
%  lowESelected = lowE([1 3 5 6]);
%  highESelected = highE([1 3 5 6]);
%  
%  thef=figure();
%  bar(meansSelected,'b');
%  hold on;
%  errorbar(1:4,meansSelected,lowESelected,highESelected,'k');
%  test=gca;
%  test.YScale='log';
%  test.Children(1).LineStyle='none';
%  ylim([5e-4 0.5]);
%  xlim([0.5 4.5])
%  xticks([1 2 3 4])
%  ylabel('koffmicro (s^-^1')
%  
%  savefig(thef,'koffmicro_invivoselected.fig');
% 
%    
% %% Make combined bar chart of in vivo and in vitro koff micro
% 
% 
% xdata=1:3;
% 
% ydata=[means(4) meansInVitro(2);means(5) meansInVitro(3);means(6) meansInVitro(4)];%O1;O2;O3
% lowError=[lowE(4) lowEInVitro(2);lowE(5) lowEInVitro(3);lowE(6) lowEInVitro(4)];
% highError=[highE(4) highEInVitro(2);highE(5) highEInVitro(3);highE(6) highEInVitro(4)];
% 
% ydatavec=ydata';
% ydatavec=ydatavec(:);
% lowErrorvec=lowError';
% lowErrorvec=lowErrorvec(:);
% highErrorvec=highError';
% highErrorvec=highErrorvec(:);
% 
% cfig=figure();
% hold on;
% bar(xdata,ydata,1);
% errorbar([0.85 1.15 1.85 2.15 2.85 3.15],ydatavec,lowErrorvec,highErrorvec,'k');
% 
% hold on;
% test=gca;
% test.YScale='log';
% test.Children(1).LineStyle='none';
% ylim([5e-4 0.5]);
% xlim([0.5 3.5])
% xticks([1 2 3])
% ylabel('koffmicro (s^-^1)');
% legend('in vivo','in vitro');
% savefig(cfig,'koffmicro_combined');

