% SMeagol runinputfile, created 08-Sep-2015 13:59:06.
% a note on units: SMeagol does not know about units, and so the user is
% charged with using consistent units of length, time, and diffusion
% constants (units of length^2/time).

%bg is around 2100 per pixel, totalt count of a fluorphore is around 60000
%counts over background. For 2 s framerate
%% trj
% ----------------------------------------------------------------------- %
% trj: information about the input data.
trj.reactionFile='./Results/simulate_on_off_experimentver4_nononspecdots/reactions_6.txt';
trj.trajectoryFile='./Results/simulate_on_off_experimentver4_nononspecdots/trajectories_6.txt';
trj.degradedName='-1';
trj.timeScale=1;
trj.voxelSize=70;
trj.speciesNames{1}='D';
trj.speciesNames{2}='U';
trj.D=[0 0];
% ----------------------------------------------------------------------- %
%% output
% ----------------------------------------------------------------------- %
% output: what to output, and where.
output.resultFile='./Results/simulate_on_off_experiment/test/simResults.mat';
output.writeTifMovie=true;
output.plotTifMovie=false;
output.showPhotons=false;
output.showEmitters=false;
output.plotTrj=false;
output.movieLength=3;
output.maxFrames=3;
output.plotTrjZRange=[ -500         500];
output.movieFormat='tiff';
output.movieOptsImwrite = {};
% ----------------------------------------------------------------------- %
%% sample
% ----------------------------------------------------------------------- %
% sample: parameters describing illumination and image capture. SMeagol
% basically assumes that illumination and aquisition coincide, but
% continuous illumination can be modeled by an appropriate choice of
% photophysics-parameters.
sample.dt=2;
sample.tE=1;
% ----------------------------------------------------------------------- %
%% activation
% ----------------------------------------------------------------------- %
% activation: parameters describing the fluorophore activation process.

activation.type='SM_photoActivation_instant';
% ----------------------------------------------------------------------- %
%% baseIntensity
% ----------------------------------------------------------------------- %
% baseIntensity: every fluorescent group in the simulation has a basic
% emission intensity (photons/time) during illumination, which can vary
% from molecule to molecule, as determined at activation by these
% parameters.
baseIntensity.intensity=600;
baseIntensity.type='SM_activationIntensity_uniform';
% ----------------------------------------------------------------------- %
%% photophys
% ----------------------------------------------------------------------- %
% photophys: parameters describing the dynamics of blinking and bleaching
% in terms of a Markov process (independent of the diffusive states
% described by the input trajectories).
photophys.bleach_time=(1/0.025);
photophys.type='SM_fluo_only_bleach';
% ----------------------------------------------------------------------- %
%% psf
% ----------------------------------------------------------------------- %
% psf: parameters to simulate the microscope point-spread-function, i.e.,
% the (stochastic) map from the position of a fluorophore as it emits a
% photon to the position on the camera chip at which that photon is
% detected.
psf.type='SM_psf_GibsonLanni_584nm_NA14';
% ----------------------------------------------------------------------- %
%% camera
% ----------------------------------------------------------------------- %
% camera: these parameters describe a) The region of interest (ROI), i.e.,
% the size, shape, and location of the region imaged by the camera, and b)
% the noise properties of the EMCCD chip.
% (a) is described in terms of the size and number of active camera pixels,
% plus a linear transformation of simulated coordinates x to
% camera-centered coordinates y, given by y = (voxelsize)*A*x+b, where A is
% a 3*3 matrix, and b is a 3*1 vector. 
% (b) is parameterized in terms of the offset, readout noise (standard
% deviation), and EM gain (average number of photons per camera count). We
% use the model described in the Mortensen et al. (Nat Meth 7, 377–381,
% 2010, doi: 10.1038/nmeth.1447).
camera.alpha=0.01;
camera.offset=120;
camera.sigmaReadout=4;
camera.pixLength=70;
camera.xrange_px=1024;
camera.yrange_px=320;
camera.A(1,:)=[1 0 0];
camera.A(2,:)=[0 1 0];
camera.A(3,:)=[0 0 1];
camera.b=[0 0 0]'; %(note transpose!)
% ----------------------------------------------------------------------- %
%% background
% ----------------------------------------------------------------------- %
% background: parameters to describe how the noisy image background is to
% be generated.
background.photons_per_pixel=22;
background.type='SM_bg_constant';
% ----------------------------------------------------------------------- %
