%ver2 chnage so that on and off rates can be chosen mroe freely on an
%koffmicro line. Also fix simulation so that equillibrium starting
%occupancies are sampled properly
%ver3: non specific dots are the same as the specific ones.

%% Add path
addpath(genpath('../../fig_4_andrestofs2/Pol_MatLabScript'))

run('./SMeagol/SMeagol_setup.m')
%%
savepath='./Results/simulate_on_off_experimentver4_nononspecdots/';
runInputTemplate='runinput_simulate_on_off_experimentver4_nononspecdots.m';
protConc=0.5; %in nM
kaMax=0.15; %Assocation rate in s^-1 nM
koffMicros=[0.0001 0.001 0.01 0.02 0.03 100];
maxkd=0.025;
minkas=[0.005 0.005 0.005 0.005 0.005 0.05];  %same as the number of KoffMicros
xDim=1024; %With the length units used in the simualtion, for simplicity here pixels
yDim=320;

numSalts=6;
simTime=700;
numDNAsites=1400;%From experiments, min:478, mean=1412, max =2150
numNonSpecificSites=0;%2600;%2300;%From experiemnts min:  431.1818 mean  1.1387e+03 max=2.2226e+03
timeStep=1;

timeStepMicroscope=[1 2 3 6 12];
equillVec=[0 0 1 1 1]; %Defines if this experimenr is equllibrated a the start or not. If not its and assocation experiment.
numReps=numel(equillVec);

kaNonSpec=kaMax;
kdNonSpec=0.005;%non spec ka=.05 and kd=0.005 gives steady state occupancy of nonspecifi sites of  1/((1/(0.05*0.5)+(1/kdTest))*kdTest) = 0.8333
names={'D','U'}; %species name.

currCount=1;
simcount=numel(koffMicros)*numSalts*numReps;

kaSim=zeros(1,simcount);
kdSim=zeros(1,simcount);
equillibratedSim=zeros(1,simcount);
koffMicrosSim=zeros(1,simcount);
timeStepMicroscopeSim=zeros(1,simcount);
for i=1:numel(koffMicros)
   kaVals=linspace(minkas(i),kaMax,numSalts);
   kdVals=koffMicros(i)-(koffMicros(i)/kaMax)*kaVals;
   
   if sum(kdVals>maxkd)>0
     kdVals=linspace(0,maxkd,numSalts);
     kaVals=kaMax-(kaMax/koffMicros(i))*kdVals;
   end
   
  
   for j=1:numReps 
   
       for k=1:numSalts
       koffMicroSim=koffMicros(i);
       kaSim(currCount)=kaVals(k);
       kdSim(currCount)=kdVals(k);
       equillibratedSim(currCount)=equillVec(j);
       timeStepMicroscopeSim(currCount)=timeStepMicroscope(j);
        
        currCount=currCount+1;
        
       end
       
   end
   
end
%% Run stochastic simulation to generate trajecotries

tic;
trajectoriesCell=cell(1,simcount);
reactionsCell=cell(1,simcount);
dnaCoordsCell=cell(1,simcount);
XCell=cell(1,simcount);
TvecCell{i}=cell(1,simcount);

parfor i=1:simcount
  [trajectories,reactions,dnaCoordsCell{i},XCell{i},TvecCell{i}] = runOnOffSimulationver2([kdSim(i) kdSim(i)],[kaSim(i) kaSim(i)],protConc,[numDNAsites numNonSpecificSites],xDim,yDim,names,timeStep,simTime,equillibratedSim(i));
   
  %writetable(cell2table(reactions),[savepath 'reactions_' num2str(i) '.txt'],'WriteVariableNames',0,'Delimiter','\t');
  
  fileId=fopen([savepath 'reactions_' num2str(i) '.txt'],'w');
  reactionsNew=reactions;
  for index=1:size(reactionsNew,1)
      if reactionsNew{index,3}==-1
        fprintf(fileId,'%f %d %.0f %f %f %f\n',reactionsNew{index,:});
      else
        %fprintf(fileId,'%f\t%.0f\t%s\t%f\t%f\t%f\n',reactionsNew{index,:});
        fprintf(fileId,'%f ',reactionsNew{index,1});
        fprintf(fileId,'%d ',reactionsNew{index,2});
        fprintf(fileId,'%s ',reactionsNew{index,3});
        fprintf(fileId,'%f %f %f\n',reactionsNew{index,4:6});
      end
  end
  fclose(fileId);
  
  fileId=fopen([savepath 'trajectories_' num2str(i) '.txt'],'w');
  for index=1:numel(TvecCell{i})
      fprintf(fileId,'%f ',TvecCell{i}(index));
      for j=1:size(trajectories{index},1)
          
          fprintf(fileId,'%d %s %f %f %f ',trajectories{index}{j,:});
      end
      fprintf(fileId,'\n');
      
  end
  fclose(fileId);
  disp(['Simulation number ' num2str(i) ' done'])
end
simtTime=toc;
disp([num2str(simcount) ' simulations finnished in ' num2str(simTime) ' seconds.']);
%%
save([savepath 'tracesAndDNACoords.mat'])


%% Run SMeagol

%Get the option struct from a runInputfile by doing a short simulation
SM_opt=SM_runsimulation(runInputTemplate);

%%
optOuts=cell(1,simcount);
parfor i=1:simcount
    disp(i)
    SM_optCurr=SM_opt;
    SM_optCurr.runinputfile='';
    SM_optCurr.trj.reactionFile=[savepath 'reactions_' num2str(i) '.txt'];
    SM_optCurr.trj.trajectoryFile=[savepath 'trajectories_' num2str(i) '.txt'];
    SM_optCurr.output.resultFile=[savepath 'simResultSMeagol_' num2str(i) '.mat'];
    SM_optCurr.output.movieLength=floor(simTime/timeStepMicroscopeSim(i));
    SM_optCurr.output.maxFrames=floor(simTime/timeStepMicroscopeSim(i));
    SM_optCurr.sample.dt=timeStepMicroscopeSim(i);
    optOuts{i}=SM_runsimulation(SM_optCurr);
    disp(['SMeagol simulation number ' num2str(i) ' done'])
end