function [theDiff] = diff1To1ModelManyka(params,assocSignal,assocTime,dissocSignal,dissocTime,protconc,numCurves)

%This function calcualtes the sum squared difference between epxerimental and
%theoretical 1to1 model
%params=[ka_1,...ka_n,kd,Rmax,t0,R0_1,...,R0_n,...,Rinfinity_1,...R0_n]
%t0 is t shift for assocation. R0 is inital value for dissocation curves.
%Rinfinity is offset of dissoctio curves

theDiff=0;

R0s=params(numCurves+4:numCurves+4+numCurves-1);
Rinfinities=params(end-numCurves+1:end);
for i = 1:numCurves
    
    assocModel=eval1to1ModelAssoc([params(i) params(numCurves+1:numCurves+3)],protconc(i),assocTime{i});
    theDiff=theDiff+sum((assocSignal{i}-assocModel).^2);
    %R0=assocModel(end)-Rinfinities(i);
    R0=R0s(i);
    theDiff=theDiff+sum((dissocSignal{i}-eval1to1ModelDissoc([params(numCurves+1) R0 Rinfinities(i)],dissocTime{i})).^2);
   
    
end

end

