function [dwellTimes,dwellTimesPreSwitch] = calcDwellTimes(traces,numStates)

dwellTimes=cell(1,numStates);
dwellTimesPreSwitch=cell(numStates,numStates);

numTraces=numel(traces);
numDwellInds=ones(1,numStates);
numDwellIndsPreSwitch=ones(numStates,numStates);
preAlloc=1000;
for j=1:numStates
    dwellTimes{j}=zeros(1,preAlloc);
    for ind=1:numStates
        dwellTimesPreSwitch{j,ind}=zeros(1,preAlloc);
        
    end
end
for i=1:numTraces
    traceL=numel(traces{i}(2,:));
    event=find(diff(traces{i}(2,:))~=0);
    startIndex=[1 event+1];
    endIndex=[event traceL];
    currDwellTimes=traces{i}(1,endIndex)-traces{i}(1,startIndex);
    currDwellInd=traces{i}(2,startIndex);
    k=1;
    for j=currDwellInd(1:end-1)
        dwellTimes{j}(numDwellInds(j))=currDwellTimes(k);
        numDwellInds(j)=numDwellInds(j)+1;
        
        %Also save dwelltimes before switching event indivually
        nextInd=currDwellInd(k+1);
        dwellTimesPreSwitch{j,nextInd}(numDwellIndsPreSwitch(j,nextInd))=currDwellTimes(k);
        numDwellIndsPreSwitch(j,nextInd)= numDwellIndsPreSwitch(j,nextInd)+1;
        k=k+1;
        
        
    end
    %Last dwelltiem is only saved for the normal dwelltime, not
    %switching dwell time
    j=currDwellInd(end);
    dwellTimes{j}(numDwellInds(j))=currDwellTimes(k);
    numDwellInds(j)=numDwellInds(j)+1;
    
    
    
end

for j=1:numStates
    if numDwellInds(j)-1<preAlloc
        dwellTimes{j}=dwellTimes{j}(1:numDwellInds(j)-1);        
    end
    for ind=1:numStates
         if numDwellIndsPreSwitch(j,ind)-1<preAlloc
            dwellTimesPreSwitch{j,ind}=dwellTimesPreSwitch{j,ind}(1:numDwellIndsPreSwitch(j,ind)-1);        
         end 
    end
end    

end

