function [distsSquared] = funDiffStepModelLinearGroups(params,nsteps,numPoints,kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,groupIndexes,uniqueGroupIndexes)
%Returns the differens between the model and  function values given by 
%[kdExpValsAll kaExpValsAll]
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob %outerlockeprob ]% probabilities are to go from state j+1 to j, so inwards
%in the model, towards sfully pecifically bound state. State 1 is the fully
%specifically bound state.


kaFun = @(kdval,PRangeind,x) kaModelRateMultsCurvesv2linear(kdval,x(1),x(2),nsteps,PMatrFun([x(3:end)]),[PRangeind -10 0.999],numPoints);

numVals=numel(kdExpValsAll);
numGroups=numel(uniqueGroupIndexes);

distsSquared=zeros(numVals,nsteps);

%for i=1:nsteps
%    [distsSquared(:,i),closestkd,closestka]=findShortestDist(kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,@(kd) kaFun(kd,i,params),[0 2*kdNorm],5);
%end

for i=1:numGroups
    currSel=groupIndexes==i;
    currkd=kdExpValsAll(currSel);
    currka=kaExpValsAll(currSel);
    
    groupDists=mean(funDiffStepModelLinear(params,nsteps,numPoints,currkd,currka,kdNorm,kaNorm),1);
    for j=1:nsteps
        distsSquared(currSel,j)=groupDists(j);
    end
    
end

end

