function [distsSquared,closestkd,closestka] = funDiffStepModelLinearRetPoint(params,nsteps,numPoints,kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,currStep)
%Returns the differens between the model and  function values given by
%[kdExpValsAll kaExpValsAll]
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob outerlockeprob

kaFun = @(kdval,PRangeind,x) kaModelRateMultsCurvesv2linear(kdval,x(1),x(2),nsteps,PMatrFun([x(3:end)]),[PRangeind 0.001 0.999],numPoints);

numVals=numel(kdExpValsAll);

distsSquared=zeros(numVals,1);
closestkd=zeros(numVals,1);
closestka=zeros(numVals,1);
%for i=1:nsteps
%    [distsSquared(:,i),closestkd,closestka]=findShortestDist(kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,@(kd) kaFun(kd,i,params),[0 2*kdNorm],5);
%end


[~,kval,mval]= kaFun(1,currStep,params);

mNorm=mval/kaNorm;
kNorm=kval*kdNorm/kaNorm;

for j=1:numVals
    
    xzero=kdExpValsAll(j)/kdNorm;
    yzero=kaExpValsAll(j)/kaNorm;
    
    distsSquared(j)=(-kNorm*xzero+yzero-mNorm)^2/(kNorm^2+1);
    closestkd(j)=(((xzero+kNorm*yzero)-kNorm*mNorm)/(kNorm^2+1))*kdNorm;
    closestka(j)=((-kNorm*(-xzero-kNorm*yzero)+mNorm)/(kNorm^2+1))*kaNorm;
    
    
end

end

