function [distsSquared,kdModel,kaModel] = funDiffStepModelRegionsExtended(params,nsteps,kdExpValsAll,kaExpValsAll,kdNorm,kaNorm,regionsAdded,seqIdentifier)
%Returns the differens between the model and  function values given by 
%[kdExpValsAll kaExpValsAll]
%Model is parametrized by params = [kaMax kOffMicroDeep  innerlockedprob %outerlockeprob ]% probabilities are to go from state j+1 to j, so inwards
%in the model, towards sfully pecifically bound state. State 1 is the fully
%specifically bound state.
%Extended model to also handle possibility dissociation from every state with testing 
%params(1) = kaMax
%params(2) = kOffMicroDeep
%params(3:sum(regionsAdded)+2) = tranition probabilities inwards (towards
%specificillary bound
%params(sum(regionsAdded)+3:end) = The probability NOT to dissocatie  at this testing state = pstar,
%so that 1-pstar is the probaiblity to disocate macroscopically directly from this
%state





numVals=numel(kdExpValsAll);
kdModel=zeros(numVals,1);
kaModel=zeros(numVals,1);

distsSquared=zeros(numVals,1);

currParams=zeros(1,nsteps+2);
currParams(1:2)=params(1:2);
currpstarParams=zeros(1,nsteps-1);
k=1;
paramsSplitRegions=cell(1,nsteps);
pstarSplitRegions=cell(1,nsteps-1);
numTransitionProbs=sum(regionsAdded);
for i=1:nsteps
    paramsSplitRegions{i}=params(2+k:2+k+regionsAdded(i)-1);
    if i<nsteps
        pstarSplitRegions{i}=params(numTransitionProbs+2+k:numTransitionProbs+2+k+regionsAdded(i)-1);
    end
    k=k+regionsAdded(i);
end

for i=1:numVals
    for j=1:nsteps
        currParams(2+j)=paramsSplitRegions{j}(seqIdentifier(i,j));
        
    end
    
    for j=1:nsteps-1
        currpstarParams(j)=pstarSplitRegions{j}(seqIdentifier(i,j));
    end
    
    rates=modelRatesVecExtended(currParams(1),currParams(2),currParams(3:end),currpstarParams);
    kd=rates(1);
    ka=rates(2);
    distsSquared(i)=((kdExpValsAll(i)-kd)/kdNorm)^2+((kaExpValsAll(i)-ka)/kaNorm)^2;
    kdModel(i)=kd;
    kaModel(i)=ka;
end



end

