function [transMatr,reBindTimes,currSaveInd,numHops,DAll]=generateReMeetDistrHopv4FlipCalcDv2(D1,hopRate,hopLength,DNAends,DNA,xStep,nSimul,startDisplacement,maxSteps,calcDStep,allowedDerror)
%v2: Normally distributed sampled hopsizes
DNAdiscr=DNA/xStep;
DNAendsdiscr=DNAends/xStep;
x0=[1 zeros(size(DNA))]; %[nonspeciically bound /slidng, operator 1 bound state, operator 2 bound state, operator 3 bound state...];
transMatr = zeros(numel(DNA),numel(DNA));
reBindTimes=cell(numel(DNA),numel(DNA));
numHops=cell(numel(DNA),numel(DNA));
currSaveInd=ones(numel(DNA),numel(DNA));
moves=[-1 1 round(-hopLength/xStep) round(hopLength/xStep)];
startDispl=[-startDisplacement startDisplacement];
tEnds=zeros(1,nSimul);
startIndAll=zeros(1,nSimul);
sampled_rxnAll=zeros(1,nSimul);
numHopsAll=zeros(1,nSimul);
DAll=zeros(1,1000);
errorAll=inf*ones(1,1000);
period=10;
factor=2;

for i=1:numel(DNA)
    for j=1:numel(DNA)
        reBindTimes{i,j}=zeros(1,nSimul);
        numHops{i,j}=zeros(1,nSimul);
    end
end
currDerror=inf;
for startInd = 1 %:numel(DNAdiscr)
    Dind=1;
    while Dind<4||errorAll(Dind-2)>allowedDerror||errorAll(Dind-1)>allowedDerror
        startPos=DNAdiscr(startInd);
        DParfor=zeros(1,nSimul);
        parfor i=1:nSimul
            Xall=zeros(1,maxSteps);
            Tall=zeros(1,maxSteps);
            ind=1;
            % simulation time is kept in t.
            t = 0;
            % The protein can start either one bp to the left or right
            x=startPos+startDispl((rand()<0.5)+1)/xStep;
            Ti=1;
            % The simulation will be stopped after the system state has been saved at
            % the last time point in T.
            is_running=true;
            
            %s=zeros(1,4);
            s=zeros(1,3);
            
            currNHops=0;
            while is_running
                Xall(ind)=x;
                Tall(ind)=t;
                
                % s is a vector containing the rate for each reaction, in this
                % case diffusion to either side
                s(1:2) = getDiffrates(x,D1,xStep,DNAendsdiscr);
                %s(3:4) = [hopRate/2 hopRate/2];
                s(3)=[hopRate];
                
                %sample the time until any evet will happen
                trxn = exprnd(1/(sum(s)));
                
                t = t + trxn;
                ind=ind+1;
                sampled_rxn = find(rand() <= cumsum(s)./sum(s),1);
                
                if sampled_rxn==3 %Make hop
                    currNHops=currNHops+1;
                    bpStep=normrnd(0,hopLength);
                    numberTurns=round(bpStep/period,0);
                    theStep=round(numberTurns*period/xStep,0);
                    x=x+theStep;
                    
                else
                    x=x+moves(sampled_rxn);
                end
                % check if hop was outside DNA, reflective boandary conditions
                % in that case
                
                toHigh=x>DNAendsdiscr(2);
                toLow=x<DNAendsdiscr(1);
                
                while toHigh||toLow
                    
                    if toHigh
                        x=DNAendsdiscr(2)+1-(x-DNAendsdiscr(2));
                    end
                    if toLow
                        x=DNAendsdiscr(1)-1+(DNAendsdiscr(1)-x);
                    end
                    toHigh=x>DNAendsdiscr(2);
                    toLow=x<DNAendsdiscr(1);
                    
                end
                
                
                if ind>=maxSteps
                    
                    
                    totTime=Tall(maxSteps-1);
                    newTimes=0:calcDStep:totTime;
                    numSteps=numel(newTimes);
                    newXs=zeros(1,numSteps);
                    for timeIndex=1:numSteps
                        [~,index]=min(abs(Tall(1:maxSteps-1)-(timeIndex-1)*calcDStep));
                        newXs(timeIndex)=Xall(index);
                    end
                    trajs=cell(1,1);
                    trajs{1}=[newXs' newXs']*xStep;
                    [~,coeffDiffComponents] = getTotalDiffCVE(trajs,calcDStep*1000,1000,2);
                    DParfor(i)=coeffDiffComponents(1);
                     is_running=false;
                end
                
                
                
                % CHeck if on operator
                %              if sum((x==DNAdiscr(2)))>0 %
                %
                %              sampled_rxn=find(x==DNAdiscr>0);
                %             startIndAll(i)=startInd;
                %             sampled_rxnAll(i)=sampled_rxn;
                %             tEnds(i)=t;
                %             numHopsAll(i)=currNHops;
                %              is_running=false;
                %
                %
                %              end
                
            end
        end
        DAll(Dind)=mean(DParfor);
        disp(['Current D = ' num2str(DAll(Dind))])
        if Dind>1
           %DAll(Dind)=DAll(Dind)*factor/(factor+1)+DAll(ind-1)/(factor+1); %Current diffusion estimate is weighted average of this one and al lthe previous ones
           currDerror=abs(DAll(Dind)-DAll(Dind-1))/DAll(Dind); 
           errorAll(Dind)=currDerror;
           disp(['Current error = ' num2str(currDerror)]);
        end    
        maxSteps=maxSteps*factor;  
        Dind=Dind+1;
    end
    
    %     for i=1:nSimul
    %       startInd=startIndAll(i);
    %       sampled_rxn=sampled_rxnAll(i);
    %
    %       transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
    %       reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = tEnds(i);
    %       numHops{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn))=numHopsAll(i);
    %       currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
    %
    %     end
end

end