function [transMatr,reBindTimes,currSaveInd]=generateReMeetDistrHopv4koffSlide(D1,hopRate,hopLength,DNAends,DNA,xStep,nSimul,startDisplacement,koffSlide,kD)
%v2: Normally distributed sampled hopsizes
%V4: based on v2, start displacement (on operator or shifted from it) given
%as input paramter
DNAdiscr=DNA/xStep;
DNAendsdiscr=DNAends/xStep;
x0=[1 zeros(size(DNA))]; %[nonspeciically bound /slidng, operator 1 bound state, operator 2 bound state, operator 3 bound state...];
transMatr = zeros(numel(DNA),numel(DNA)+1);
reBindTimes=cell(numel(DNA),numel(DNA)+1);
currSaveInd=ones(numel(DNA),numel(DNA)+1);
moves=[-1 1 round(-hopLength/xStep) round(hopLength/xStep)];
startDispl=[-startDisplacement startDisplacement];
Xall=zeros(1,1000);
Tall=zeros(1,1000);
ind=1;
tEnds=zeros(1,nSimul);
startIndAll=zeros(1,nSimul);
sampled_rxnAll=zeros(1,nSimul);
period=10;
for i=1:numel(DNA)
  for j=1:numel(DNA)+1
    reBindTimes{i,j}=zeros(1,nSimul);
    
  end
end
numDNA=numel(DNA);

for startInd = 1:numel(DNAdiscr)
    startPos=DNAdiscr(startInd);
    parfor i=1:nSimul
        % simulation time is kept in t.
        t = 0;
        % The protein can start either startDisplacement bp to the left or right
        x=startPos+startDispl((rand()<0.5)+1)/xStep;
        Ti=1;
        % The simulation will be stopped after the system state has been saved at
        % the last time point in T.
        is_running=true;
        
        %s=zeros(1,4);
        s=zeros(1,4);
        while is_running
            %  Xall(ind)=x;
            %  Tall(ind)=t;
            
            % s is a vector containing the rate for each reaction, in this
            % case diffusion to either side
            if t==0 %While on top of the operotr, the protein will slide off with another rate (due to more hydrogen bonding on the operator) 
                s(1:2) = getDiffrates(x,koffSlide,xStep,DNAendsdiscr);
            else
                s(1:2) = getDiffrates(x,D1,xStep,DNAendsdiscr);
            end
            %s(3:4) = [hopRate/2 hopRate/2];
            s(3)=[hopRate];
            
            s(4)=kD;
            
            %sample the time until any evet will happen
            trxn = exprnd(1/(sum(s)));
            
            t = t + trxn;
            
            sampled_rxn = find(rand() <= cumsum(s)./sum(s),1);
            
            if sampled_rxn==3
                bpStep=normrnd(0,hopLength);
                numberTurns=round(bpStep/period,0);
                theStep=round(numberTurns*period/xStep,0);
                x=x+theStep;
                
            else
                x=x+moves(sampled_rxn);
            end
            
            
            % CHeck if dissociated
            if sampled_rxn==4
                
                
                startIndAll(i)=startInd;
                sampled_rxnAll(i)=numDNA+1;
                tEnds(i)=t;
                is_running=false;
                
                
            end
            
            
            % check if hop was outside DNA, reflective boandary conditions
            % in that case
            
            toHigh=x>DNAendsdiscr(2);
            toLow=x<DNAendsdiscr(1);
            
            while toHigh||toLow
                
                if toHigh
                    x=DNAendsdiscr(2)+1-(x-DNAendsdiscr(2));
                end
                if toLow
                    x=DNAendsdiscr(1)-1+(DNAendsdiscr(1)-x);
                end
                toHigh=x>DNAendsdiscr(2);
                toLow=x<DNAendsdiscr(1);
                
            end     
            
            
            
           
              
            %ind=ind+1;
            
            % CHeck if on operator
             if sum((x==DNAdiscr))>0 %
            
            %sampled_rxn = find(rand() <= cumsum(r)./sum(r),1);
             sampled_rxn=find(x==DNAdiscr>0);   
            startIndAll(i)=startInd;
            sampled_rxnAll(i)=sampled_rxn;
            tEnds(i)=t;
            
             is_running=false;
         
              
             end
            
        end
    end
    for i=1:nSimul
      startInd=startIndAll(i);  
      sampled_rxn=sampled_rxnAll(i);
      
      transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
      reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = tEnds(i);
      currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
    end
end

end