function [transMatr,reBindTimes,currSaveInd]=generateRebindDistrPreCalcHop_whilev4(D1,operators,konVec,xStep,nSimul,meetDistr,maxNumTimeSamples,minSamples)

%v3: added so that function only returns maxNumTimeSamples of binding times (to
%not waste memory). curSaveInd is change accordingly. transMatr is not
%changed but contains information about all the evens
%v4: Handle dissocation from hopping
preAllocSamples=50000;

transMatr = zeros(numel(operators)+1,numel(operators)+1);
reBindTimes=cell(numel(operators)+1,numel(operators)+1);
currSaveInd=ones(numel(operators)+1,numel(operators)+1);
moves=[-1 1];
Xall=zeros(1,1000);
Tall=zeros(1,1000);
ind=1;
%tEnds=zeros(1,nSimul);
%startIndAll=zeros(1,nSimul);
%sampled_rxnAll=zeros(1,nSimul);


reMeetTimesCell=cell(numel(operators)+1,numel(operators)+1);
numReMeetSamples=zeros(numel(operators)+1,numel(operators)+1);

transMatrMeetProb=zeros(numel(operators)+1,numel(operators)+1);


reMeetTimes=meetDistr.reMeetTimes;
currSaveIndMeet=meetDistr.currSaveIndMeet;

theStartInds=1:numel(operators);
theStartInds=theStartInds(konVec~=0);
numOperators=numel(operators);
for i=1:numel(operators)+1
   transMatrMeetProb(i,:)=meetDistr.transMatrMeet(i,:)/(sum(meetDistr.transMatrMeet(i,:)));
  for j=1:numel(operators)+1
    reBindTimes{i,j}=zeros(1,preAllocSamples);
    reMeetTimesCell{i,j}=reMeetTimes{i,j}(1:currSaveIndMeet(i,j)-1);
    numReMeetSamples(i,j)=numel(reMeetTimesCell{i,j});
  end
end
for startInd = 1:numel(operators)%theStartInds
    startPos=operators(startInd);
    go=true;
    currNumSimul=0;
    while go
        currNumSimul=currNumSimul+1;
        % simulation time is kept in t.
        t = 0;
        
        x=startPos;
        Ti=1;
    
        is_running=true;
        while is_running
          %  Xall(ind)=x;
          %  Tall(ind)=t;
            
            % r is a vector containing the rate for each reaction
            if t==0 %A miroscopic dissocation ahs just occourded and the protein is 1 bp away from operator
                
               coeff=-1000; %Just to enter the diffision step in if else below
               
            else
            
                if x==numOperators+1
                       
                    coeff=inf;
                    r=[zeros(1,numOperators) inf];
                    
                else
                    r = (operators==x).*konVec/xStep;%getRates(x,konVec,DNAdiscr);
                    
                    
                    s = getDiffrates(x,D1,xStep,[-inf inf]);
                    
                    %sample the time until any evet will happen
                    trxn = exprnd(1/(sum(r)+sum(s)));
                    
                    t = t + trxn;
                    coeff=sum(r)/(sum(r)+sum(s));
                end
            
            end
            
            
          
 
            % sample which reaction that occured.
             %reaction step
             if rand()<coeff %reation step
            
                 %sampled_rxn = find(rand() <= cumsum(r)./sum(r),1);
                 sampled_rxn=find(r>0);
                 transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
                 
                 %Only save times if number of number of saved transitions
                 %is smaller then limit
                 if transMatr(startInd,sampled_rxn)<=maxNumTimeSamples
                     reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = t;
                     currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
                 end
                 
                 
                 is_running=false;
                 % Stop simulation if enough events have been sampled
                 if min(transMatr(startInd,konVec~=0))>=minSamples&&currNumSimul>=nSimul
                    go = false;
                     
                 end    
             else % diffusion step
                 sampled_rxn = find(rand() <= cumsum(transMatrMeetProb(x,:))./sum(transMatrMeetProb(x,:)),1);
                 ind=ceil(rand()* numReMeetSamples(x,sampled_rxn));
              try
                 trxn=reMeetTimesCell{x,sampled_rxn}(ind);
              catch
               a=1;   
              end
                t=t+trxn;
                x=sampled_rxn;
                
              
%                ind=ind+1;
             end
            
        end
    end
 
    
    for nextInd=1:numel(operators)
        % Remove zeros from the pre-allocated rebindtimes to save memory 
        reBindTimes{startInd,nextInd}=reBindTimes{startInd,nextInd}(1:currSaveInd(startInd,nextInd)-1);
        
    end
end

end