function [transMatr,reBindTimes,currSaveInd]=generateRebindDistrPreCalcHop_whilev5(D1,operators,konVec,xStep,nSimul,meetDistr,maxNumTimeSamples,minSamples)

%v3: added so that function only returns maxNumTimeSamples of binding times (to
%not waste memory). curSaveInd is change accordingly. transMatr is not
%changed but contains information about all the evens

%based on v3: Protein starts on top of operator and not net to it
preAllocSamples=50000;

transMatr = zeros(numel(operators),numel(operators));
reBindTimes=cell(numel(operators),numel(operators));
currSaveInd=ones(numel(operators),numel(operators));
moves=[-1 1];
Xall=zeros(1,1000);
Tall=zeros(1,1000);
ind=1;
%tEnds=zeros(1,nSimul);
%startIndAll=zeros(1,nSimul);
%sampled_rxnAll=zeros(1,nSimul);


reMeetTimesCell=cell(numel(operators),numel(operators));
numReMeetSamples=zeros(numel(operators),numel(operators));

transMatrMeetProb=zeros(numel(operators),numel(operators));


reMeetTimes=meetDistr.reMeetTimes;
currSaveIndMeet=meetDistr.currSaveIndMeet;

theStartInds=1:numel(operators);
theStartInds=theStartInds(konVec~=0);

for i=1:numel(operators)
   transMatrMeetProb(i,:)=meetDistr.transMatrMeet(i,:)/(sum(meetDistr.transMatrMeet(i,:)));
  for j=1:numel(operators)
    reBindTimes{i,j}=zeros(1,preAllocSamples);
    reMeetTimesCell{i,j}=reMeetTimes{i,j}(1:currSaveIndMeet(i,j)-1);
    numReMeetSamples(i,j)=numel(reMeetTimesCell{i,j});
  end
end
for startInd = 1:numel(operators)%theStartInds
    startPos=operators(startInd);
    go=true;
    currNumSimul=0;
    while go
        currNumSimul=currNumSimul+1;
        % simulation time is kept in t.
        t = 0;
        
        x=startPos;
        Ti=1;
    
        is_running=true;
        while is_running
          %  Xall(ind)=x;
          %  Tall(ind)=t;
            
            % r is a vector containing the rate for each reaction
        
            r = (operators==x).*konVec/xStep;%getRates(x,konVec,DNAdiscr);
            
            
            s = getDiffrates(x,D1,xStep,[-inf inf]);
            
             %sample the time until any evet will happen
            trxn = exprnd(1/(sum(r)+sum(s)));
            
            t = t + trxn;
            
            
 
            % sample which reaction that occured.
             %reaction step
             if rand()<sum(r)/(sum(r)+sum(s)) %reation step
            
                 %sampled_rxn = find(rand() <= cumsum(r)./sum(r),1);
                 sampled_rxn=find(r>0);
                 transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
                 
                 %Only save times if number of number of saved transitions
                 %is smaller then limit
                 if transMatr(startInd,sampled_rxn)<=maxNumTimeSamples
                     reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = t;
                     currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
                 end
                 
                 
                 is_running=false;
                 % Stop simulation if enough events have been sampled
                 if min(transMatr(startInd,konVec~=0))>=minSamples&&currNumSimul>=nSimul
                    go = false;
                     
                 end    
             else % diffusion step
                 sampled_rxn = find(rand() <= cumsum(transMatrMeetProb(x,:))./sum(transMatrMeetProb(x,:)),1);
                 ind=ceil(rand()* numReMeetSamples(x,sampled_rxn));
                 
                 trxn=reMeetTimesCell{x,sampled_rxn}(ind);
                t=t+trxn;
                x=sampled_rxn;
%                ind=ind+1;
             end
            
        end
    end
 
    
    for nextInd=1:numel(operators)
        % Remove zeros from the pre-allocated rebindtimes to save memory 
        reBindTimes{startInd,nextInd}=reBindTimes{startInd,nextInd}(1:currSaveInd(startInd,nextInd)-1);
        
    end
end

end