function [transMatrTraces,traces,totTime]=generateTracesAssocDissocver2(koffdirect,koff,kon,koffSlide,distrInd,startInd,reMeetDistr,minStateSwitches,endStates,minSamplesTraces)
%V4 macroscopically dissocatied state handeld explicitly (saved as numel(operators)+1). THe
%last state (forbidden or macroscopically dissocatied) is also saved in the
%trace%
%V5: Macrscopic dissocation from DNA is independent of the sliding mode,
%can happen whenever
%based on generateTracesSwitchingv5
%state 1 = bound to operator
%state 2 = on top of operator
%state 3 = macroscopically dissociated
%ver2: Also handles specifaclly operator bound state
numStates=3;

transMatrTraces=zeros(numStates,numStates);
% reBindTimesTraces=cell(numStates,numStates);
% currSaveIndTraces=ones(numStates,numStates);

reBindTimesCell=cell(1,2);
numReBindSamples=zeros(1,2);

transMatrProb=zeros(1,2);

currSaveInd=reMeetDistr{distrInd}.currSaveIndMeet;
transMatr=reMeetDistr{distrInd}.transMatrMeet;
reBindTimes=reMeetDistr{distrInd}.reMeetTimes;

for i=1
    transMatrProb(i,:)=transMatr(i,:)/(sum(transMatr(i,:)));
    for j=1:2
        reBindTimesCell{i,j}=reBindTimes{i,j}(1:currSaveInd(i,j)-1);
        numReBindSamples(i,j)=numel(reBindTimesCell{i,j});
    end
end
% 
% for i=1:numOperators
%   for j=1:numOperators
%     reBindTimesTraces{i,j}=zeros(1,maxStateSwitches);
%   end
% end

go = true;
startPos=startInd;
traceInd=1;
currNStateswitches=0;
totTime=0;
while go
    % simulation time is kept in t.
    t = 0;
    
    x=startPos;
    
    Xall=zeros(1,10000);
    Tall=zeros(1,10000);
    
    ind=1;
    
    
    is_running=true;
    Xall(ind)=x;
    Tall(ind)=t;
    
    ind=ind+1;
    while is_running
        xPrev=x;
        
        if x==1 %SPecfic bound state
        
            rates=[koff koffdirect];
            
            sampled_rxnTemp = find(rand() <= cumsum(rates)./sum(rates),1);
            
             trxn = exprnd(1/(sum([rates])));
             t = t + trxn;
             
             if sampled_rxnTemp==1 %Macroscopiccaly disoscate directly
                 
             
             end     
            
      
        
        elseif x==2 %On top of operator
            
            % r is a vector containing the rate for each reaction
            rates = [kon koffSlide]; %[go to state 1, Do a remeet or macor dissoc]
            
            
            sampled_rxnTemp = find(rand() <= cumsum(rates)./sum(rates),1);
            
            if sampled_rxnTemp==1 % Go to oeprator bound state
                %sample the time until the reaction oocurs
                trxn = exprnd(1/(sum([rates])));
                t = t + trxn;
                
                sampled_rxn=1;
                x=sampled_rxn;
                Xall(ind)=x;
                Tall(ind)=t;
                
                ind=ind+1;
            end
            
            if sampled_rxnTemp==2 % The protein did slide off the operator
                
                sampled_rxnTemp2 = find(rand() <= cumsum(transMatrProb(1,:))./sum(transMatrProb(1,:)),1);
                
                timeInd=ceil(rand()* numReBindSamples(1,sampled_rxnTemp2));
                
                trxn=reBindTimesCell{1,sampled_rxnTemp2}(timeInd);
                t=t+trxn;
                
                if sampled_rxnTemp2==1
                    sampled_rxn=2;
                    x=sampled_rxn; %Is on top of operator again
                    
                elseif sampled_rxnTemp2==2
                    sampled_rxn=3;
                    x=sampled_rxn; %Dissociated macroscopically
                end
                
                Xall(ind)=x;
                Tall(ind)=t;
                
                ind=ind+1;
                
            end
            
        end
        
        transMatrTraces(xPrev,sampled_rxn)=transMatrTraces(xPrev,sampled_rxn)+1;
        if  xPrev~=sampled_rxn %A state switch occoured
            currNStateswitches=currNStateswitches+1;
            %At this time point the trace is both in the new and the old statate
            Xall(ind)=x;
            Xall(ind-1)=xPrev;
            Tall(ind)=t;
            
            ind=ind+1;
        end
        
        if ismember(x,endStates)
            is_running=false;
        end     
        
        if currNStateswitches>=minStateSwitches&&min(transMatrTraces(startPos,:))>=minSamplesTraces %Enough microscopical dissociations sampled and switching events sampled?
            is_running=false;
            go=false;
        end
        
        if ~is_running
            traces{traceInd}=[Tall(1:ind-1);Xall(1:ind-1)];
            traceInd=traceInd+1;
            totTime=totTime+t;
            
        end
        

        
    end  
   % startIndAll(ind-1)=startInd;
   % sampled_rxnAll(ind-1)=sampled_rxn;
   %  tEnds(ind-1)=t;   
end

%for i=1:ind-1
%    startInd=startIndAll(i);
%    sampled_rxn=sampled_rxnAll(i);
%    
%    transMatr(startInd,sampled_rxn)=transMatr(startInd,sampled_rxn)+1;
%    reBindTimes{startInd,sampled_rxn}(currSaveInd(startInd,sampled_rxn)) = tEnds(i);
%    currSaveInd(startInd,sampled_rxn)=currSaveInd(startInd,sampled_rxn)+1;
%end
