function [transMatrTraces,traces,totTime]=generateTracesSwitchingv5(koffVec,konInd,startInd,operators,kD,reBindDistr,maxDissocTraces,forbiddenState,minSamplesTraces)
%V4 macroscopically dissocatied state handeld explicitly (saved as numel(operators)+1). THe
%last state (forbidden or macroscopically dissocatied) is also saved in the
%trace%
%V5: Macrscopic dissocation from DNA is independent of the sliding mode,
%can happen whenever
numOperators=numel(operators);

transMatrTraces=zeros(numel(operators)+1,numel(operators)+1);
reBindTimesCell=cell(numel(operators),numel(operators));
numReBindSamples=zeros(numel(operators),numel(operators));

transMatrProb=zeros(numel(operators),numel(operators));

currSaveInd=reBindDistr.currSaveInd{konInd};
transMatr=reBindDistr.transMatr{konInd};
reBindTimes=reBindDistr.reBindTimes{konInd};

for i=1:numel(operators)
    transMatrProb(i,:)=transMatr(i,:)/(sum(transMatr(i,:)));
    for j=1:numel(operators)
        reBindTimesCell{i,j}=reBindTimes{i,j}(1:currSaveInd(i,j)-1);
        numReBindSamples(i,j)=numel(reBindTimesCell{i,j});
    end
end

go = true;
startPos=operators(startInd);
traceInd=1;
currNDissoc=0;
totTime=0;
allowedStates=ones(1,numel(operators));
allowedStates(forbiddenState)=0;
allowedStates=find(allowedStates>0);
while go
    % simulation time is kept in t.
    t = 0;
    
    x=startPos;
    
    Xall=zeros(1,10000);
    Tall=zeros(1,10000);
    
    ind=1;
    
    
    is_running=true;
    Xall(ind)=x;
    Tall(ind)=t;
    
    ind=ind+1;
    while is_running
        
        % r is a vector containing the rate for each reaction
        r = (operators==x).*koffVec;%getRates(x,konVec,DNAdiscr);
        
        %sample the time until the dissocation accours
        trxn = exprnd(1/(sum([r kD])));
        
        rates=[sum(r) kD]; %rate for microscopical dissocation at index 1, rate for macroscopical dissocation at index 2
        
        sampled_rxn = find(rand() <= cumsum(rates)./sum(rates),1);
        
        t = t + trxn;
        
        Xall(ind)=x;
        Tall(ind)=t;
        
        ind=ind+1;
        
        currNDissoc=currNDissoc+1;
        
        if sampled_rxn==1 %Stays on DNA and goes into sliding Mode
            
            % sample the operator where the protein rebinds
            
            
            
            
            % sample the operator where the protein rebinds
            
            
            sampled_rxn = find(rand() <= cumsum(transMatrProb(x,:))./sum(transMatrProb(x,:)),1);
            
            timeInd=ceil(rand()* numReBindSamples(x,sampled_rxn));
            
            trxn=reBindTimesCell{x,sampled_rxn}(timeInd);
            tMacroDissoc=exprnd(1/kD);
            if tMacroDissoc>trxn %Stays on the DNA
                
                
                if sum(sampled_rxn==forbiddenState)>0
                    is_running=false;
                end
                
                transMatrTraces(x,sampled_rxn)=transMatrTraces(x,sampled_rxn)+1;
                t=t+trxn;
                x=sampled_rxn;
                Xall(ind)=x;
                Tall(ind)=t;
                
                ind=ind+1;
                
            else % Macroscopical dissociation
                is_running=false;
                
                transMatrTraces(x,numOperators+1)=transMatrTraces(x,numOperators+1)+1;
                t=t+tMacroDissoc;
                x=numOperators+1;
                Xall(ind)=x;
                Tall(ind)=t;
                
                ind=ind+1;
                
                
            end
        else  %Macroscopical dissociation directly (didn't go into sliding mode)
            is_running=false;
            
            transMatrTraces(x,numOperators+1)=transMatrTraces(x,numOperators+1)+1;
            x=numOperators+1;
            Xall(ind)=x;
            Tall(ind)=t;
            
            ind=ind+1;
        end
        if currNDissoc>=maxDissocTraces&&min(transMatrTraces(startPos,allowedStates))>=minSamplesTraces %Enough microscopical dissociations sampled and switching events sampled?
            is_running=false;
            go=false;
        end
        
        if ~is_running
            traces{traceInd}=[Tall(1:ind-1);Xall(1:ind-1)];
            traceInd=traceInd+1;
            totTime=totTime+t;
            
        end
        
    end    
end