function [onMatr,offMatr] = getTimeMatrExtended(transMatr)
%Returns matrices that defines linnear system of equations describing the
%mean first passage times of a stepwise continiues markov chain

dim=size(transMatr,1);

onMatr=zeros(dim,dim);
offMatr=zeros(dim,dim);

onMatr(1,1)=1;

onMatr(2,2)=1;
onMatr(2,3)=-transMatr(2,3);


for i=3:dim-1
    onMatr(i,i-1)=-transMatr(i,i-1);  
    onMatr(i,i)=1;
    onMatr(i,i+1)=-transMatr(i,i+1);
    onMatr(i,dim)=-transMatr(i,dim);
end
onMatr(end,end-1)=-1;
onMatr(end,end)=1;

offMatr(1,2)=-1;
offMatr(1,1)=1;

for i=2:dim-2
    offMatr(i,i-1)=-transMatr(i,i-1);
    offMatr(i,i)=1;
     offMatr(i,i+1)=-transMatr(i,i+1);
    
end

offMatr(end-1,end-1)=1;
offMatr(end-1,end-2)=-transMatr(end-1,end-2);

offMatr(end,end)=1;

end

