function [bestParams] = fitLineErrorxyConstr(relX,relY,nguess,minguess,maxguess,tolx,tolfun,xconstr,yconstr)
%This function fits a line to x (relX) and y (relY) data by mnimzing the
%summed squred distances between the line and the data points (error in both x and y, i.e. not just minimizing deviation in y which is the standard)
%ver2: userer can give nguess, minguess,maxguess tolx and tolfun as parameters
 funDiff = @(x) sum(((-x(1)*relX+relY-(yconstr-x(1)*xconstr))/(sqrt((-x(1))^2+1^2))).^2); %Sum of squared distances between a point (normX,normY) and a lines with slope x(1) and intercept x(2)
    
    lb=[-inf];
    ub=[0];
    polySimple=polyfit(relX,relY,1);
    
    guessMin=[minguess*polySimple(1)];
    guessMax=[maxguess*polySimple(1)];
    
    
    
    
    options=optimoptions('fmincon','Display','off','TolX',tolx,'TolFun',tolfun);
    numGuesses=nguess;
    paramsAll=zeros(numGuesses,numel(lb));
    resnormAll=zeros(numGuesses,1);
    for j= 1:numGuesses
        
        params0=(guessMin+rand(1,numel(lb)).*(guessMax-guessMin));
        
        
        
        [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
        resnormAll(j)=resnorm;
        paramsAll(j,:)=paramsCurr;
        
        
    end
    
    [bestResNorm,bestind]=min(resnormAll);
    bestParams=paramsAll(bestind,:);
    bestParams(2)=yconstr-bestParams(1)*xconstr;
end

