function [kdFromSlope,kaFromSlope,intensityAllTime,intensityFirstTime] = getRatesIntensityMethodver15OnConvol(tracesOff,timeVecOff,tracesOn,timeVecOn,startTimeAllTimes,timeToUseAllTimes,protconc,intBounds,minLevel,maxLevel,fitPointsoff,fitPointson,slideWindowOn)
%This function estiamtes on and offrates based on fitting a slope to the
%sum of the fluorescence intensity, reconstructed from single molecule data.
%Slope in the beginning of curve is used to estimate the on and offrate
%ver2: Correcting for the fact that there can be some amount of nonspecific
%binding
%ver3: Adding fit to ODemodel to correct for soem amount of nonspecific
%binding. If parameter kb is set to inf, kd is assumed to be 0 and
%kleaching is the fitted parameter.
%ver4: Combined fitting on on and off rates curve simultaunously. If kaREf
%is infinity it is fitted, otherwise ka is constrained to be kaRef

[~,startIndAll]=min(abs(timeVecOff-startTimeAllTimes));
[~,endInd]=min(abs(timeVecOff-timeToUseAllTimes));
numTraces=numel(tracesOn);
numBoundsCorr=numel(intBounds);
numTimePointsOn=numel(tracesOn{1})-slideWindowOn+1;
numTimePointsOff=numel(tracesOff{1});
intensityFirstTime=zeros(numBoundsCorr,numTimePointsOn);
intensityAllTime=zeros(numBoundsCorr,endInd);
numOffTraces=0;
doCorrection=0;
numTracesOn=0;

for i=1:numTraces
    
    intenseFirst=(tracesOn{i}(1));
    traceOn=tracesOn{i}';
    traceOn(traceOn<minLevel)=minLevel;
    traceOn(traceOn>maxLevel)=maxLevel;
    
    traceOff=tracesOn{i}';
    traceOff(traceOff<minLevel)=minLevel;
    traceOff(traceOff>maxLevel)=maxLevel;
    
    
  %  [~,ind]=min(abs(intBounds-intenseFirst));
  %  intensityFirstTime(ind,:)=intensityFirstTime(ind,:)+trace;
  %  if ind==1
  %    numTracesOn=numTracesOn+1;  
  %  end
    for j=startIndAll:numTimePointsOff-endInd+1
        [~,ind]=min(abs(intBounds-traceOff(j)));
        intensityAllTime(ind,1:endInd)=intensityAllTime(ind,1:endInd)+traceOff(j:j+endInd-1);%nansum([autoCorrsAllTime(ind,:);autcorrs2d{i}(j,:)]);
        if ind==numel(intBounds)
            %break;
            numOffTraces=numOffTraces+1;
        end
    end
    
    for j=1:slideWindowOn
           [~,ind]=min(abs(intBounds-traceOn(j)));
           intensityFirstTime(ind,:)=intensityFirstTime(ind,:)+traceOn(j:numTimePointsOn+j-1);
             if ind==1
                 numTracesOn=numTracesOn+1;  
             end     
    end
    
    
end
if maxLevel<inf
    intensityFirstTime=intensityFirstTime/(numTracesOn*maxLevel);
else
    intensityFirstTime=intensityFirstTime/numTracesOn;
    
end




if doCorrection==1
    endInd=endInd-1;
    intensityAllTimeNew=zeros(numBoundsCorr,endInd);
    intensityFirstTimeNew=zeros(numBoundsCorr,numTimePointsOn-1);
    
    for i=1:numBoundsCorr
        correction=movmean(intensityAllTime(i,:),2);
        intensityAllTimeNew(i,:)=[intensityAllTime(i,1) correction(3:end)];
        
      
        correction=movmean(intensityFirstTime(i,:),2);
        intensityFirstTimeNew(i,:)=[intensityFirstTime(i,1) correction(3:end)];
        
    end
    
    intensityAllTime=intensityAllTimeNew;
    
    intensityFirstTime=intensityFirstTimeNew;
end

p=polyfit(timeVecOn(1:fitPointson),intensityFirstTime(1,1:fitPointson),1);
slopeon=p(1);
kaFromSlope=slopeon/protconc;

%p=polyfit(timeVec(1:fitPointsSlopeoff),intensityAllTime(end,1:fitPointsSlopeoff)/intensityAllTime(end,1),1);
% p=polyfit(timeVec(1:fitPointsSlopeoff),intensityAllTime(end,1:2:2*fitPointsSlopeoff-1)/intensityAllTime(end,1),1);
%slopeoff=p(1);
%kdFromSlope=-slopeoff/(numOffTraces*maxLevel);
%kdFromSlopeOld=-slopeoff;

nump=fitPointsoff;
thestart=1;
offcurve=intensityAllTime(end,:)/(intensityAllTime(end,1));
poffraw=polyfit([timeVecOff(1:nump)],offcurve(thestart:thestart+nump-1),1);
kdFromSlope=-poffraw(1);


timesOn=timeVecOn(1:fitPointson);
numOn=numel(timesOn);
intenseFuncOnTimes = @(x,times,thenum) sum(solveLinearOdes(times,[-(x(1)+x(2)*protconc+x(3)) -x(2)*protconc;x(3) -x(1)],[x(2)*protconc;0],[0;0]).*[ones(1,thenum);zeros(1,thenum)],1)+x(4);
intenseFuncOn = @(x) intenseFuncOnTimes(x,timesOn,numOn);

startIndOff=2;
timesOff=timeVecOff(1:fitPointsoff);
numOff=numel(timesOff);
intenseFuncOffTimes = @(x,times,thenum) sum(solveLinearOdes(times,[-(x(1)+x(2)*protconc+x(3)) -x(2)*protconc;x(3) -x(1)],[x(2)*protconc;0],[1;0]).*[ones(1,thenum);zeros(1,thenum)],1);
intenseFuncOff= @(x) intenseFuncOffTimes(x,timesOff,numOff);

%If kbleaching=0
intenseFuncOnTimesNew= @(x,times) (x(2)*protconc/((x(2)*protconc+x(1))))*(1-exp(-(x(2)*protconc+x(1))*times))+(1-x(5));

intenseFuncOffTimesNew=@(x,times) ((x(2)*protconc/((x(2)*protconc+x(1))))+(x(1)/((x(2)*protconc+x(1))))*exp(-(x(2)*protconc+x(1))*times))*x(4)+x(6);

 %funDiff= @(params) sum((intensityAllTime(end,:)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2)+sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2);

% if kaRef==inf
%     lb=[1e-5 1e-5 1e-5 0 0]; %[kd ka kbbleach maximalFluorescensesignalfromDNAdissocation=1-backgrounddissocation 1-backgroundassocation ]
%     ub=[1 1 1 1 1];
%     funDiff= @(params) sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2);
% 
% else
%     lb=[1e-5 kaRef 1e-5 0 0]; %[kd ka maximalFluorescensesignalfromDNA ]
%     ub=[1 kaRef 1e-2 1 1];
%     funDiff= @(params) sum((intensityAllTime(end,:)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
% 
%     
% end



% if kaRef==inf
%   %  lb=[1e-5 1e-5 kbleachRef 0 0 0]; %[kd ka kbbleach maximalFluorescensesignalfromDNAdissocation(non normalized) 1-backgroundassocation maximalfluorescensesingalfrombackgroundissociation(non normalized)]
%   %  ub=[1 1 kbleachRef inf 1 inf];
%   %  funDiff= @(params)  sum((intensityAllTime(end,startIndOff:endInd)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2)+sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2);
%     
%     lb=[1e-5 1e-5 kbleachRef 0 0 0]; %[kd ka kbbleach maximalFluorescensesignalfromDNAdissocation(non normalized) 1-backgroundassocation maximalfluorescensesingalfrombackgroundissociation(non normalized)]
%     ub=[1 1 kbleachRef inf 1 inf];
%     funDiff= @(params)  sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2);
%     
% elseif kbleachRef==inf
%     %lb=[1e-10 1e-10 1e-5 0 0 0]; 
%     %ub=[1e-10 1e-10 1 inf 1 inf];
%     %funDiff= @(params) sum((intensityAllTime(end,startIndOff:endInd)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
%     
%     lb=[1e-5 1e-5 1e-5 0 0 0]; 
%     ub=[1 1 1 inf 1 inf];
%     funDiff= @(params) sum((intensityAllTime(end,startIndOff:endInd)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
% else
%     lb=[1e-5 kaRef 1e-5 0 0 0]; 
%     ub=[1 kaRef 1 inf 1 inf];
%     funDiff= @(params) sum((intensityAllTime(end,startIndOff:endInd)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
%     
%     
% end


 
lb=[1e-5 1e-5 1e-10 0]; %[kd ka kbbleach maximalFluorescensesignalfromDNAdissocation(non normalized) 1-backgroundassocation maximalfluorescensesingalfrombackgroundissociation(non normalized)]
ub=[1 1 1e-10 1];
funDiff= @(params)  sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2)+sum((intensityAllTime(end,1:fitPointsoff)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);


% if kaRef==inf
%     lb=[1e-5 1e-5 1e-5 0 0]; %[kd ka kbbleach maximalFluorescensesignalfromDNAdissocation=1-backgrounddissocation 1-backgroundassocation ]
%     ub=[1 1 1 1 1];
%     funDiff= @(params) sum((intensityFirstTime(1,1:fitPointson)-intenseFuncOn(params)).^2);
% 
% elseif kbleachRef==inf
%     lb=[1e-10 1e-10 1e-5 0 0]; %[kd ka maximalFluorescensesignalfromDNA ]
%     ub=[1e-10 1e-10 1 1 1];
%     funDiff= @(params) sum((intensityAllTime(end,:)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
% else
%     lb=[1e-5 kaRef kbleachRef 0 0]; %[kd ka maximalFluorescensesignalfromDNA ]
%     ub=[1 kaRef kbleachRef 1 1];
%     funDiff= @(params) sum((intensityAllTime(end,:)/(intensityAllTime(end,1))-intenseFuncOff(params)).^2);
%     
%     
% end

guessMinLog10=[log10(lb(1:3)) -5];
guessMaxLog10=[log10(ub(1:3)) 0];




options=optimoptions('fmincon','Display','off','TolX',1e-5,'TolFun',1e-5);
numGuesses=5;
paramsAll=zeros(numGuesses,numel(lb));
resnormAll=zeros(numGuesses,1);
for i= 1:numGuesses
    
    params0=10.^(guessMinLog10+rand(1,numel(lb)).*(guessMaxLog10-guessMinLog10));
    
    
    
    [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
    resnormAll(i)=resnorm;
    paramsAll(i,:)=paramsCurr;
    
    
end

[bestResNorm,bestind]=min(resnormAll);
bestParams=paramsAll(bestind,:);
%newOffCurve=intensityAllTime(end,:)/(intensityAllTime(end,1))-(1-bestParams(4)); %Remove the background
%newOffCurve=newOffCurve/newOffCurve(1);
%newOffCurve=intensityAllTime(end,:)/(intensityAllTime(end,1))-bestParams(6); %Remove the background
%newOffCurve=newOffCurve/bestParams(4);

fitTimeSlope=0.01;

offCurveTheory=intenseFuncOffTimes(bestParams,[0 fitTimeSlope],2);
%offCurveTheory=offCurveTheory-(bestParams(6));
%offCurveTheory=offCurveTheory/bestParams(4);

onCurveTheory=intenseFuncOnTimes(bestParams,[0 fitTimeSlope],2);


poff=polyfit([0 fitTimeSlope],offCurveTheory,1);
kdFromSlope=-poff(1);

pon=polyfit([0 fitTimeSlope],onCurveTheory,1);
kaFromSlope=pon(1)/protconc;

%kaFromSlope=bestParams(2);
%kdFromSlope=bestParams(1);





% numGuess=10;
% 
% %[funcValues] = solveLinearOdes(timeVec,A,b,xzeros)
% if kbleaching==inf
%      lb=[1e-10 kaFromSlope 1e-5 0]; %[kd ka kbleaching maximalFluorescensesignalfromDNA ]
%     ub=[1e-10 kaFromSlope 1 1 ];
%     
% else
%     lb=[1e-5 kaRef kbleaching 0]; %[kd ka kbleaching maximalFluorescensesignalfromDNA ]
%     ub=[1 kaRef kbleaching 1 ];
% end
% 
% guessMinLog10=[log10(lb(1)) log10(lb(2)) log10(lb(3)) -5];
% guessMaxLog10=[log10(ub(1)) log10(ub(2)) log10(ub(3)) 0];
% % 
% timeStep=timeVec(2)-timeVec(1);
% timeVecOff=0:timeStep:(numel(intensityAllTime(end,:))-1)*timeStep;
% numNewTimepoints=numel(timeVecOff);
% 
% intenseFunc = @(x) sum(solveLinearOdes(timeVecOff,[-(x(1)+x(2)*protconc+x(3)) -x(2)*protconc;x(3) -x(1)],[x(2)*protconc;0],[x(4);0]).*[ones(1,numNewTimepoints);zeros(1,numNewTimepoints)],1)+(1-x(4));
% 
% 
% funDiff= @(params) sum((intensityAllTime(end,:)/(intensityAllTime(end,1))-intenseFunc(params)).^2);
% options=optimoptions('fmincon','Display','off','TolX',1e-3,'TolFun',1e-3);
% numGuesses=5;
% for i= 1:numGuesses
%     
%     params0=10.^(guessMinLog10+rand(1,4).*(guessMaxLog10-guessMinLog10));
%     
%     
%     
%     [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
%     resnormAll(i)=resnorm;
%     paramsAll(i,:)=paramsCurr;
%     
%     
% end
% 
% [bestResNorm,bestind]=min(resnormAll);
% bestParams=paramsAll(bestind,:);
% 
% newOffCurve=intensityAllTime(end,:)/(intensityAllTime(end,1))-(1-bestParams(4)); %Remove the background
% newOffCurve=newOffCurve/newOffCurve(1);
% 
% 
% p=polyfit(timeVec(1:fitPointsSlopeoff),newOffCurve(end,1:fitPointsSlopeoff),1);
% 
% slopeoff=p(1);
% 
% kdFromSlope=-slopeoff;



end

