function [funcValues] = solveLinearOdes(timeVec,A,b,xzeros)
%This function solvs and evalues a system of linear ODEs defined by hte rates in Aover at the
%timepoints defined by time vec

%To be able to write the system on homogeneous form
xstar=-A\b;


numTimes=numel(timeVec);
funcValues=zeros(numel(xzeros),numTimes);
    for i=1:numTimes
        [V,D]=eig(A*timeVec(i));
        expmAt=V*diag(exp(diag(D)))/V; %Same as expm(A*timeVec(i))
        funcValues(:,i)=xstar+expmAt*(xzeros-xstar);
    end
end

