% Paramter file for PipeLine for sliding polarizaton analysis. Run this file to run analysis
%ver5: Fit exponential to HMM fitted data
%Ver7: Only do dot detection and tracking in the DNA channel.
%ver8: total intesnity at dna dots fitting. ALso Correcting for the fact that there can be some amount of nonspecific
%binding
%Ver9: cleaing up and removing things not used in the script

%ver21: mock DNA locations
%% Add path
addpath(genpath('Pol_MatLabScript'))

%%




%plot options
showdots=0;
additionalplots=0;

parameterset='A';



%% Parameters that are the same for different experiments

parameters.square=3;
square=parameters.square; %distane from center in pixels to count intensity
parameters.windowLims=[0 0 0 0];
trans=0;
anglerot=0; %angle to rotate the image
safety=parameters.square; %windsafety if removeEdgeTrajs used


% Standard parameters:
%   - uTrackWindow = 1
%   - uTrackmergeSplit = 0
%   - uTrackminTrackLen = 2
%   - uTrackminSearchRadius = 2
%   - uTrackmaxSearchRadius = 5 (This is very important parameter to tune!)
%   - uTrackbrownStdMult = 3
%   - uTracklinearMotion = 1 (0 if use only motion)

expectedD = 0.1; %(in um^2/s), used to calc maxDist
perc = 0.90; %Percantage of the probability mass that is possible to be considered in berofre cutoff with MaxDist (asuming only 1D diffusion)
parameters.dotTrackingAlg='danuser';
%parameters.scale=scale;
%parameters.maxDist=maxDist;
parameters.minPoints=2;
parameters.useUTrack=1;
parameters.uWindow = 2;%uWindow-1 gives maximum lengthnof gaps allowed
parameters.uMergeSplit = 2;
parameters.uMinTrackLen = 2;
parameters.uMinSearchRadius = 0;
parameters.uBrownStdMult = 100;
parameters.uLinearMotion = 0; %(0 if use only motion)
parameters.numExperiments=1;
parameters.uMaxSearchRadius=2.5;
%parameters.negToPos= 1;

parametersCoLoc=parameters;
parametersCoLoc.uWindow=1;

parameters.smoothparam=500000; % for calculating background with smoothn


analyseLength=4;
analyseLengthHMM=2;
analyseTime=20;
%analyseLengthCoLoc=3; %For the simulation, 1  is okay
analyseLengthCoLocVec=[3*ones(1,114) 2*ones(1,6) 3*ones(1,18) 3*ones(1,7) 2*ones(1,7) 2*ones(1,7) 3*ones(1,10) 2*ones(1,8) 2*ones(1,15) 2*ones(1,15)];

maxDist=2.5; %Between trajectory in DNA and protein laser channel (in piexels);
numSlopePoints=3;



%% Specify pamters that differ for different experiments (paths and so on)

isSim=0;

saltconckon=[10 20 40 80 160 320 50 100 150  200 250 300 1 10 20 30 40 60 80 100 150 200 300 1 4 8 16 32 64 1 4 8 16 32 64 1 1 50 100 150 25 75];
protconckon=[1 1 1 1 1 1 0.2 0.2 0.2 0.2 0.2 0.2 0.2 0.25 0.25 0.25 0.25 0.25 0.25 0.25 0.25 0.25 0.25 0.25 1.7 1.7 1.7 1.7 1.7 1.7 1.7 1.7 1.7 1.7 1.7 1.7 0.2 0.2 0.2 0.2 0.2 0.2];


saltconckon(43:48)=[1 10 20 30 40 100];
saltconckon(49:54)=[1 10 20 30 40 100];
saltconckon(55:60)=[1 10 20 30 40 100];
saltconckon(61:66)=[1 100 125 150 200 250];
saltconckon(67:72)=[1 100 125 150 200 250];
saltconckon(73:78)=[1 100 125 150 200 250];
saltconckon(79:84)=[1 100 125 150 200 250];
saltconckon(85:90)=[1 100 125 150 200 250];
saltconckon(91:96)=[1 100 125 150 200 250];
saltconckon(97:102)=[1 50 100 150 200 250];
saltconckon(103:108)=[1 50 100 150 200 250];
saltconckon(109:114)=[1 50 100 150 200 250];
saltconckon(115:120)=[1 50 100 150 200 250];
saltconckon(121:126)=[1 50 100 150 200 250];
saltconckon(127:132)=[1 50 100 150 200 250];
saltconckon(133:138)=[1 50 100 150 200 250];
saltconckon(139:145)=[1 50 75 100 150 200 250];
saltconckon(146:152)=[1 50 75 100 150 200 250];
saltconckon(153:159)=[1 50 75 100 150 200 250];
saltconckon(160:163)=[1 50 100 300];
saltconckon(164:167)=[1 50 100 300];
saltconckon(168)=1;
saltconckon(169)=1;
saltconckon(170:173)=[1 50 100 300];
saltconckon(174:177)=[1 50 100 300];
saltconckon(178:192)=[1 5 10 15 20 25 30 35 40 50 60 70 80 90 100];
saltconckon(193:207)=[1 5 10 15 20 25 30 35 40 50 60 70 80 90 100];


protconckon(43:60)=0.5*ones(1,18);
protconckon(61:78)=0.5*ones(1,18);
protconckon(79:96)=0.5*ones(1,18);
protconckon(97:120)=0.5*ones(1,24);
protconckon(121:138)=0.5*ones(1,18);
protconckon(121:138)=0.5*ones(1,18);
protconckon(139:159)=0.5*ones(1,21);
protconckon(160:169)=0.5*ones(1,10);
protconckon(170:177)=0.5*ones(1,8);
protconckon(178:192)=0.5*ones(1,15);
protconckon(193:207)=0.5*ones(1,15);

expsToAnalyse=25:207;%[25:114 139:169];%[1:120 139:159];%[1:13];
expsToAnalyseFitkon=25:207;%[25:114 139:169];%[1:120 139:159];

doMockDNA(1:169)=0;
doMockDNA(170:177)=1;
doMockDNA(178:207)=0;
cutoffNoFluo=1200; %For mock DNA, if fluoresnce signal (over background) is larger than this, consider this as no DNA location, i.e. mock DNA location can be sampled here. 
numMockLoc=1300;

%Distributuion fit

maxT=300*ones(1,100);
maxTFit=100*ones(1,100);
binStep=2*ones(1,100);
maxTFitDwell=100*ones(1,100);
binStepDwell=2*ones(1,100);
normIndDistr=19;
%%
experiments{1}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';

experiments{1}.gridFrame=22;

experiments{1}.imscale=[200 10000];

experiments{1}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';

experiments{1}.doDotdetect=1;

experiments{1}.doTracking=1;

experiments{1}.imOrders=0;%Which laser channel is which

experiments{1}.coLocFrames=1:5;

experiments{1}.doPolInt=1;

experiments{1}.dobackgroundCalc=1;

experiments{1}.backgroundparam=0;%0; % relative start frame when calcualting background, [1 numFrames] -> [0 1

experiments{1}.foldersel='/S1 O1 SO3 flow 1nM R2G5 10 mM NaCl 2Hz inject fr30_1*';

experiments{1}.startframe=1;

experiments{1}.startframeFit=40;

experiments{1}.endframeFit=61;

experiments{1}.timeStep=0.5;

experiments{1}.numSlopePoints=3;

experiments{1}.DNAChannelBegin=1; %is the DNa channel laser on in the beginning of the move, or is it flipping back and fort between frame?
%experiments{1}.timeVec=0:1:599;

%'/home/samba/elflab/Projects/polarization/151201/Grid_Binning1/Pos0/img_000000000_Default_000.tif';



%1
experiments{1}.noiseTreshold = 3; % For getDot(), 3 for example
experiments{1}.waveletPlane=2;% For dot detection
experiments{1}.scale = 80; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
experiments{1}.deltat =1000; %in ms
experiments{1}.Dimension =2;%Of camera
experiments{1}.yMax=1024;%szie of image
experiments{1}.xMax=1024;%size of image

imgTop=350;
imgMid=695;


for i=expsToAnalyse
    experiments{i}=experiments{1};
end
%%
experiments{2}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S2 O1 SO3 flow 1nM R1G2 20 mM NaCl 2Hz inject fr30_1_1/S2 O1 SO3 flow 1nM R1G2 20 mM NaCl 2Hz inject fr30_1_1_MMStack.ome.tif';
experiments{2}.gridFrame=22;
experiments{2}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';
experiments{2}.foldersel='/S2 O1 SO3 flow 1nM R1G2 20 mM NaCl 2Hz inject fr30_1_1*';
experiments{2}.noiseTreshold = 3;
experiments{2}.timeStep=0.5;
experiments{2}.startframeFit=44;
experiments{2}.endframeFit=80;
experiments{2}.numSlopePoints=3;
experiments{2}.DNAChannelBegin=1; 

experiments{3}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S3 O1 SO3 flow 1nM R1G2 40 mM NaCl 2Hz inject fr30_1/S3 O1 SO3 flow 1nM R1G2 40 mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{3}.gridFrame=23;
experiments{3}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';
experiments{3}.foldersel='/S3 O1 SO3 flow 1nM R1G2 40 mM NaCl 2Hz inject fr30_1*';
experiments{3}.noiseTreshold = 3;
experiments{3}.timeStep=0.5;
experiments{3}.startframeFit=43;
experiments{3}.endframeFit=65;
experiments{3}.numSlopePoints=3;
experiments{3}.DNAChannelBegin=1; 


experiments{4}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S4 O1 SO3 flow 1nM R1G2 80 mM NaCl 2Hz inject fr30_1/S4 O1 SO3 flow 1nM R1G2 80 mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{4}.gridFrame=30;
experiments{4}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';
experiments{4}.foldersel='/S4 O1 SO3 flow 1nM R1G2 80 mM NaCl 2Hz inject fr30_1*';
experiments{4}.noiseTreshold = 3;
experiments{4}.timeStep=0.5;
experiments{4}.startframeFit=43;
experiments{4}.endframeFit=95;
experiments{4}.numSlopePoints=3;
experiments{4}.DNAChannelBegin=1; 


experiments{5}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S5 O1 SO3 flow 1nM R1G1 160 mM NaCl 1Hz inject fr30_1/S5 O1 SO3 flow 1nM R1G1 160 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{5}.gridFrame=30;
experiments{5}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';
experiments{5}.foldersel='/S5 O1 SO3 flow 1nM R1G1 160 mM NaCl 1Hz inject fr30_1*';
experiments{5}.noiseTreshold = 3;
experiments{5}.timeStep=1;
experiments{5}.startframeFit=49;
experiments{5}.endframeFit=103;
experiments{5}.numSlopePoints=3;
experiments{5}.DNAChannelBegin=1; 


experiments{6}.gridpath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration/S6 O1 SO3 flow 1nM R1G1 320 mM NaCl 1Hz inject fr30_1/S6 O1 SO3 flow 1nM R1G1 320 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{6}.gridFrame=30;
experiments{6}.datapath='../../../data_tirf/200519 O1 Far2 Kon Koff salt titration';
experiments{6}.foldersel='/S6 O1 SO3 flow 1nM R1G1 320 mM NaCl 1Hz inject fr30_1*';
experiments{6}.noiseTreshold = 3;
experiments{6}.timeStep=1;
experiments{6}.startframeFit=48;
experiments{6}.endframeFit=275;
experiments{6}.numSlopePoints=10;
experiments{6}.DNAChannelBegin=1; 

%200713 O1

experiments{7}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S1 flow O1 SO3 Far2 0.2nM NaCl 50mM R1G1 1Hz green only 5s interval injet fr2_1/S1 flow O1 SO3 Far2 0.2nM NaCl 50mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{7}.gridFrame=30;
experiments{7}.noiseTreshold = 3;
experiments{7}.timeStep=5;
experiments{7}.startframeFit=5;
experiments{7}.endframeFit=22;
experiments{7}.numSlopePoints=3;
experiments{7}.DNAChannelBegin=1; 

experiments{8}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S2 flow O1 SO3 Far2 0.2nM NaCl 100mM R1G1 1Hz green only 5s interval injet fr2_1/S2 flow O1 SO3 Far2 0.2nM NaCl 100mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{8}.gridFrame=30;
experiments{8}.noiseTreshold = 3;
experiments{8}.timeStep=5;
experiments{8}.startframeFit=4;
experiments{8}.endframeFit=15;
experiments{8}.numSlopePoints=3;
experiments{8}.DNAChannelBegin=1; 


experiments{9}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S3 flow O1 SO3 Far2 0.2nM NaCl 150mM R1G1 1Hz green only 5s interval injet fr2_1/S3 flow O1 SO3 Far2 0.2nM NaCl 150mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{9}.gridFrame=30;
experiments{9}.noiseTreshold = 3;
experiments{9}.timeStep=5;
experiments{9}.startframeFit=5;
experiments{9}.endframeFit=17;
experiments{9}.numSlopePoints=3;
experiments{9}.DNAChannelBegin=1; 

experiments{10}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S4 flow O1 SO3 Far2 0.2nM NaCl 200mM R1G1 1Hz green only 5s interval injet fr2_1/S4 flow O1 SO3 Far2 0.2nM NaCl 200mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{10}.gridFrame=30;
experiments{10}.noiseTreshold = 3;
experiments{10}.timeStep=5;
experiments{10}.startframeFit=4;
experiments{10}.endframeFit=24;
experiments{10}.numSlopePoints=3;
experiments{10}.DNAChannelBegin=1; 

experiments{11}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S5 flow O1 SO3 Far2 0.2nM NaCl 250mM R1G1 1Hz green only 5s interval injet fr2_1/S5 flow O1 SO3 Far2 0.2nM NaCl 250mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{11}.gridFrame=30;
experiments{11}.noiseTreshold = 3;
experiments{11}.timeStep=5;
experiments{11}.startframeFit=5;
experiments{11}.endframeFit=28;
experiments{11}.numSlopePoints=3;
experiments{11}.DNAChannelBegin=1; 

experiments{12}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S6 flow O1 SO3 Far2 0.2nM NaCl 300mM R1G1 1Hz green only 5s interval injet fr2_1/S6 flow O1 SO3 Far2 0.2nM NaCl 300mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{12}.gridFrame=30;
experiments{12}.noiseTreshold = 3;
experiments{12}.timeStep=5;
experiments{12}.startframeFit=4;
experiments{12}.endframeFit=28;
experiments{12}.numSlopePoints=3;
experiments{12}.DNAChannelBegin=1; 

experiments{13}.gridpath='../../../data_tirf/200713 O1 Far2 Kon Koff salt titration/S7 flow O1 SO3 Far2 0.2nM NaCl 1mM R1G1 1Hz green only 5s interval injet fr2_1/S7 flow O1 SO3 Far2 0.2nM NaCl 1mM R1G1 1Hz green only 5s interval injet fr2_1_MMStack.ome.tif';
experiments{13}.gridFrame=30;
experiments{13}.noiseTreshold = 3;
experiments{13}.timeStep=5;
experiments{13}.startframeFit=4;
experiments{13}.endframeFit=24;
experiments{13}.numSlopePoints=3;
experiments{13}.DNAChannelBegin=1; 

%O2 experiments #1

experiments{14}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S1 O2 flow Far2 0.25nM R1G1 10mM NaCl ALEX interval 2s 1Hz inject fr4_1/S1 O2 flow Far2 0.25nM R1G1 10mM NaCl ALEX interval 2s 1Hz inject fr4_1_MMStack.ome.tif';
experiments{14}.gridFrame=30;
experiments{14}.noiseTreshold = 3;
experiments{14}.timeStep=2*2;
experiments{14}.startframeFit=4;
experiments{14}.endframeFit=30;
experiments{14}.numSlopePoints=3;
experiments{14}.DNAChannelBegin=0; 

experiments{15}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S2 O2 flow Far2 0.25nM R1G1 20mM NaCl ALEX  1Hz inject fr4_1/S2 O2 flow Far2 0.25nM R1G1 20mM NaCl ALEX  1Hz inject fr4_1_MMStack.ome.tif';
experiments{15}.gridFrame=30;
experiments{15}.noiseTreshold = 3;
experiments{15}.timeStep=1*2;
experiments{15}.startframeFit=7;
experiments{15}.endframeFit=38;
experiments{15}.numSlopePoints=3;
experiments{15}.DNAChannelBegin=0; 

experiments{16}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S3 O2 flow Far2 0.25nM R1G1 30mM NaCl ALEX interval 2s 1Hz inject fr4_1/S3 O2 flow Far2 0.25nM R1G1 30mM NaCl ALEX interval 2s 1Hz inject fr4_1_MMStack.ome.tif';
experiments{16}.gridFrame=30;
experiments{16}.noiseTreshold = 3;
experiments{16}.timeStep=2*2;
experiments{16}.startframeFit=4;
experiments{16}.endframeFit=19;
experiments{16}.numSlopePoints=3;
experiments{16}.DNAChannelBegin=0; 

experiments{17}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S4 O2 flow Far2 0.25nM R1G1 40mM NaCl ALEX interval 2s 1Hz inject fr4_1/S4 O2 flow Far2 0.25nM R1G1 40mM NaCl ALEX interval 2s 1Hz inject fr4_1_MMStack.ome.tif';
experiments{17}.gridFrame=30;
experiments{17}.noiseTreshold = 3;
experiments{17}.timeStep=2*2;
experiments{17}.startframeFit=4;
experiments{17}.endframeFit=28;
experiments{17}.numSlopePoints=3;
experiments{17}.DNAChannelBegin=0; 

experiments{18}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S5 O2 flow Far2 0.25nM R1G1 60mM NaCl ALEX interval 2s 1Hz inject fr4_1/S5 O2 flow Far2 0.25nM R1G1 60mM NaCl ALEX interval 2s 1Hz inject fr4_1_MMStack.ome.tif';
experiments{18}.gridFrame=30;
experiments{18}.noiseTreshold = 3;
experiments{18}.timeStep=2*2;
experiments{18}.startframeFit=4;
experiments{18}.endframeFit=20;
experiments{18}.numSlopePoints=3;
experiments{18}.DNAChannelBegin=0; 

%Cy5 channel in beginning
experiments{19}.gridpath='../../../data_tirf/200617 O2 Far2 Kon Koff salt titration/S6 O2 flow Far2 0.25nM R1G1 80mM NaCl 1Hz inject fr10_1/S6 O2 flow Far2 0.25nM R1G1 80mM NaCl 1Hz inject fr10_1_MMStack.ome.tif';
experiments{19}.gridFrame=30;
experiments{19}.noiseTreshold = 3;
experiments{19}.timeStep=1;
experiments{19}.startframeFit=15;
experiments{19}.endframeFit=39;
experiments{19}.numSlopePoints=3;
experiments{19}.DNAChannelBegin=1; 


%O2 experiments #2

experiments{20}.gridpath='../../../data_tirf/200619 O2 Far2 Kon Koff salt titration #2/S1 O2 flow Far2 0.25nM R1G1 100mM NaCl ALEX 1Hz inject fr4_1/S1 O2 flow Far2 0.25nM R1G1 100mM NaCl ALEX 1Hz inject fr4_1_MMStack.ome.tif';
experiments{20}.gridFrame=30;
experiments{20}.noiseTreshold = 3;
experiments{20}.timeStep=1*2;
experiments{20}.startframeFit=5;
experiments{20}.endframeFit=26;
experiments{20}.numSlopePoints=3;
experiments{20}.DNAChannelBegin=0; 

experiments{21}.gridpath='../../../data_tirf/200619 O2 Far2 Kon Koff salt titration #2/S2 O2 flow Far2 0.25nM R1G1 150mM NaCl ALEX 1Hz inject fr4_1/S2 O2 flow Far2 0.25nM R1G1 150mM NaCl ALEX 1Hz inject fr4_1_MMStack.ome.tif';
experiments{21}.gridFrame=30;
experiments{21}.noiseTreshold = 3;
experiments{21}.timeStep=1*2;
experiments{21}.startframeFit=5;
experiments{21}.endframeFit=28;
experiments{21}.numSlopePoints=3;
experiments{21}.DNAChannelBegin=0; 


%Cy5 channel in beginning
experiments{22}.gridpath='../../../data_tirf/200619 O2 Far2 Kon Koff salt titration #2/S3 O2 flow Far2 0.25nM R1G1 200mM NaCl 1Hz inject fr10_1/S3 O2 flow Far2 0.25nM R1G1 200mM NaCl ALEX 1Hz inject fr10_1_MMStack.ome.tif';
experiments{22}.gridFrame=30;
experiments{22}.noiseTreshold = 3;
experiments{22}.timeStep=1;
experiments{22}.startframeFit=8;
experiments{22}.endframeFit=75;
experiments{22}.numSlopePoints=3;
experiments{22}.DNAChannelBegin=1; 


%Cy5 channel in beginning
experiments{23}.gridpath='../../../data_tirf/200619 O2 Far2 Kon Koff salt titration #2/S4 O2 flow Far2 0.25nM R1G1 300mM NaCl 1Hz inject fr10_1/S4 O2 flow Far2 0.25nM R1G1 300mM NaCl 1Hz inject fr10_1_MMStack.ome.tif';
experiments{23}.gridFrame=30;
experiments{23}.noiseTreshold = 3;
experiments{23}.timeStep=1;
experiments{23}.startframeFit=7;
experiments{23}.endframeFit=275;
experiments{23}.numSlopePoints=3;
experiments{23}.DNAChannelBegin=1; 

experiments{24}.gridpath='../../../data_tirf/200619 O2 Far2 Kon Koff salt titration #2/S5 O2 flow Far2 0.25nM R1G1 1mM NaCl ALEX interval 5s 1Hz inject fr2_1/S5 O2 flow Far2 0.25nM R1G1 1mM NaCl ALEX interval 5s 1Hz inject fr2_1_MMStack.ome.tif';
experiments{24}.gridFrame=30;
experiments{24}.noiseTreshold = 3;
experiments{24}.timeStep=5*2;
experiments{24}.startframeFit=4;
experiments{24}.endframeFit=14;
experiments{24}.numSlopePoints=3;
experiments{24}.DNAChannelBegin=0; 

%O3

experiments{25}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S1 O3 flow 1.7nM R1G1 4 mM NaCl 1Hz inject fr30_1/S1 O3 flow 1.7nM R1G1 4 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{25}.gridFrame=30;
experiments{25}.noiseTreshold = 3;
experiments{25}.timeStep=1;
experiments{25}.startframeFit=37;
experiments{25}.endframeFit=52;
experiments{25}.numSlopePoints=3;
experiments{25}.DNAChannelBegin=1; 

experiments{26}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S2 O3 flow 1.7nM R1G1 8 mM NaCl 1Hz inject fr30_1/S2 O3 flow 1.7nM R1G1 8 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{26}.gridFrame=30;
experiments{26}.noiseTreshold = 3;
experiments{26}.timeStep=1;
experiments{26}.startframeFit=38;
experiments{26}.endframeFit=63;
experiments{26}.numSlopePoints=3;
experiments{26}.DNAChannelBegin=1; 

experiments{27}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S3 O3 flow 1.7nM R1G1 16 mM NaCl 1Hz inject fr30_1/S3 O3 flow 1.7nM R1G1 16 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{27}.gridFrame=30;
experiments{27}.noiseTreshold = 3;
experiments{27}.timeStep=1;
experiments{27}.startframeFit=36;
experiments{27}.endframeFit=400;
experiments{27}.numSlopePoints=3;
experiments{27}.DNAChannelBegin=1; 

experiments{28}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S4 O3 flow 1.7nM R1G1 32 mM NaCl 1Hz inject fr30_1/S4 O3 flow 1.7nM R1G1 32 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{28}.gridFrame=30;
experiments{28}.noiseTreshold = 3;
experiments{28}.timeStep=1;
experiments{28}.startframeFit=36;
experiments{28}.endframeFit=400;
experiments{28}.numSlopePoints=3;
experiments{28}.DNAChannelBegin=1; 

experiments{29}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S5 O3 flow 1.7nM R1G1 64 mM NaCl 1Hz inject fr30_1/S5 O3 flow 1.7nM R1G1 64 mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{29}.gridFrame=30;
experiments{29}.noiseTreshold = 3;
experiments{29}.timeStep=1;
experiments{29}.startframeFit=52;
experiments{29}.endframeFit=400;
experiments{29}.numSlopePoints=3;
experiments{29}.DNAChannelBegin=1; 

experiments{30}.gridpath='../../../data_tirf/200521 O3 Far2 Kon Koff salt titration/S6 O3 flow 1.7nM R1G2 1mM NaCl 2Hz inject fr30_1/S6 O3 flow 1.7nM R1G2 1mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{30}.gridFrame=30;
experiments{30}.noiseTreshold = 3;
experiments{30}.timeStep=0.5;
experiments{30}.startframeFit=41;
experiments{30}.endframeFit=62;
experiments{30}.numSlopePoints=3;
experiments{30}.DNAChannelBegin=1; 


experiments{31}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S1 O3 flow 1.7nM R1G2 4mM NaCl 2Hz inject fr30_1/S1 O3 flow 1.7nM R1G2 4mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{31}.gridFrame=30;
experiments{31}.noiseTreshold = 3;
experiments{31}.timeStep=0.5;
experiments{31}.startframeFit=22;
experiments{31}.endframeFit=300;
experiments{31}.numSlopePoints=3;
experiments{31}.DNAChannelBegin=1; 

experiments{32}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S2 O3 flow 1.7nM R1G2 8mM NaCl 2Hz inject fr30_1/S2 O3 flow 1.7nM R1G2 8mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{32}.gridFrame=30;
experiments{32}.noiseTreshold = 3;
experiments{32}.timeStep=0.5;
experiments{32}.startframeFit=39;
experiments{32}.endframeFit=300;
experiments{32}.numSlopePoints=3;
experiments{32}.DNAChannelBegin=1; 

experiments{33}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S3 O3 flow 1.7nM R1G2 16mM NaCl 2Hz inject fr30_1/S3 O3 flow 1.7nM R1G2 16mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{33}.gridFrame=30;
experiments{33}.noiseTreshold = 3;
experiments{33}.timeStep=0.5;
experiments{33}.startframeFit=28;
experiments{33}.endframeFit=52;
experiments{33}.numSlopePoints=3;
experiments{33}.DNAChannelBegin=1; 

experiments{34}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S4 O3 flow 1.7nM R1G1 32mM NaCl 1Hz inject fr30_1/S4 O3 flow 1.7nM R1G1 32mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{34}.gridFrame=30;
experiments{34}.noiseTreshold = 3;
experiments{34}.timeStep=1;
experiments{34}.startframeFit=27;
experiments{34}.endframeFit=45;
experiments{34}.numSlopePoints=3;
experiments{34}.DNAChannelBegin=1; 

experiments{35}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S5 O3 flow 1.7nM R1G1 64mM NaCl 1Hz inject fr30_1/S5 O3 flow 1.7nM R1G1 64mM NaCl 1Hz inject fr30_1_MMStack.ome.tif';
experiments{35}.gridFrame=30;
experiments{35}.noiseTreshold = 3;
experiments{35}.timeStep=1;
experiments{35}.startframeFit=27;
experiments{35}.endframeFit=150;
experiments{35}.numSlopePoints=3;
experiments{35}.DNAChannelBegin=1; 

experiments{36}.gridpath='../../../data_tirf/200523 O3 Far2 Kon Koff salt titration #2/S6 O3 flow 1.7nM R1G2 1mM NaCl 2Hz inject fr30_1/S6 O3 flow 1.7nM R1G2 1mM NaCl 2Hz inject fr30_1_MMStack.ome.tif';
experiments{36}.gridFrame=30;
experiments{36}.noiseTreshold = 3;
experiments{36}.timeStep=0.5;
experiments{36}.startframeFit=54;
experiments{36}.endframeFit=75;
experiments{36}.numSlopePoints=3;
experiments{36}.DNAChannelBegin=1; 

%O3 or O1?
experiments{37}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S1 flow O1 SO3 Far2 0.2nM NaCl 1mM R1G1 1Hz injet fr10_1/S1 flow O1 SO3 Far2 0.2nM NaCl 1mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{37}.gridFrame=30;
experiments{37}.noiseTreshold = 3;
experiments{37}.timeStep=1;
experiments{37}.startframeFit=15;
experiments{37}.endframeFit=60;
experiments{37}.numSlopePoints=3;
experiments{37}.DNAChannelBegin=1; 

experiments{38}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S2 flow O1 SO3 Far2 0.2nM NaCl 50mM R1G1 1Hz injet fr10_1/S2 flow O1 SO3 Far2 0.2nM NaCl 50mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{38}.gridFrame=30;
experiments{38}.noiseTreshold = 3;
experiments{38}.timeStep=1;
experiments{38}.startframeFit=17;
experiments{38}.endframeFit=48;
experiments{38}.numSlopePoints=3;
experiments{38}.DNAChannelBegin=1; 

experiments{39}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S3 flow O1 SO3 Far2 0.2nM NaCl 100mM R1G1 1Hz injet fr10_1/S3 flow O1 SO3 Far2 0.2nM NaCl 100mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{39}.gridFrame=30;
experiments{39}.noiseTreshold = 3;
experiments{39}.timeStep=1;
experiments{39}.startframeFit=20;
experiments{39}.endframeFit=77;
experiments{39}.numSlopePoints=3;
experiments{39}.DNAChannelBegin=1; 

experiments{40}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S4 flow O1 SO3 Far2 0.2nM NaCl 150mM R1G1 1Hz injet fr10_1/S4 flow O1 SO3 Far2 0.2nM NaCl 150mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{40}.gridFrame=30;
experiments{40}.noiseTreshold = 3;
experiments{40}.timeStep=1;
experiments{40}.startframeFit=18;
experiments{40}.endframeFit=150;
experiments{40}.numSlopePoints=3;
experiments{40}.DNAChannelBegin=1; 

experiments{41}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S5 flow O1 SO3 Far2 0.2nM NaCl 25mM R1G1 1Hz injet fr10_1/S5 flow O1 SO3 Far2 0.2nM NaCl 25mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{41}.gridFrame=30;
experiments{41}.noiseTreshold = 3;
experiments{41}.timeStep=1;
experiments{41}.startframeFit=20;
experiments{41}.endframeFit=84;
experiments{41}.numSlopePoints=3;
experiments{41}.DNAChannelBegin=1; 

experiments{42}.gridpath='../../../data_tirf/200715 O3 Far2 Kon Koff salt titration/S6 flow O1 SO3 Far2 0.2nM NaCl 75mM R1G1 1Hz injet fr10_1/S6 flow O1 SO3 Far2 0.2nM NaCl 75mM R1G1 1Hz injet fr10_1_MMStack.ome.tif';
experiments{42}.gridFrame=30;
experiments{42}.noiseTreshold = 3;
experiments{42}.timeStep=1;
experiments{42}.startframeFit=18;
experiments{42}.endframeFit=56;
experiments{42}.numSlopePoints=3;
experiments{42}.DNAChannelBegin=1;

% O3 201005 2 s step

experiments{43}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{43}.gridFrame=10;
experiments{43}.noiseTreshold = 3;
experiments{43}.timeStep=2;
experiments{43}.startframeFit=15;
experiments{43}.endframeFit=45;
experiments{43}.numSlopePoints=3;
experiments{43}.DNAChannelBegin=1;

experiments{44}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{44}.gridFrame=10;
experiments{44}.noiseTreshold = 3;
experiments{44}.timeStep=2;
experiments{44}.startframeFit=12;
experiments{44}.endframeFit=36;
experiments{44}.numSlopePoints=3;
experiments{44}.DNAChannelBegin=1;

experiments{45}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{45}.gridFrame=10;
experiments{45}.noiseTreshold = 3;
experiments{45}.timeStep=2;
experiments{45}.startframeFit=11;
experiments{45}.endframeFit=34;
experiments{45}.numSlopePoints=3;
experiments{45}.DNAChannelBegin=1;


experiments{46}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{46}.gridFrame=10;
experiments{46}.noiseTreshold = 3;
experiments{46}.timeStep=2;
experiments{46}.startframeFit=12;
experiments{46}.endframeFit=37;
experiments{46}.numSlopePoints=3;
experiments{46}.DNAChannelBegin=1;

experiments{47}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{47}.gridFrame=10;
experiments{47}.noiseTreshold = 3;
experiments{47}.timeStep=2;
experiments{47}.startframeFit=13;
experiments{47}.endframeFit=28;
experiments{47}.numSlopePoints=3;
experiments{47}.DNAChannelBegin=1;

experiments{48}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 1s interval_1/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 1s interval_1_MMStack.ome.tif';
experiments{48}.gridFrame=10;
experiments{48}.noiseTreshold = 3;
experiments{48}.timeStep=2;
experiments{48}.startframeFit=11;
experiments{48}.endframeFit=30;
experiments{48}.numSlopePoints=3;
experiments{48}.DNAChannelBegin=1;

% O3 timestep 3 s

experiments{49}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{49}.gridFrame=10;
experiments{49}.noiseTreshold = 3;
experiments{49}.timeStep=3;
experiments{49}.startframeFit=12;
experiments{49}.endframeFit=30;
experiments{49}.numSlopePoints=3;
experiments{49}.DNAChannelBegin=1;

experiments{50}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{50}.gridFrame=27;
experiments{50}.noiseTreshold = 3;
experiments{50}.timeStep=3;
experiments{50}.startframeFit=12;
experiments{50}.endframeFit=30;
experiments{50}.numSlopePoints=3;
experiments{50}.DNAChannelBegin=1;



experiments{51}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{51}.gridFrame=10;
experiments{51}.noiseTreshold = 3;
experiments{51}.timeStep=3;
experiments{51}.startframeFit=12;
experiments{51}.endframeFit=30;
experiments{51}.numSlopePoints=3;
experiments{51}.DNAChannelBegin=1;

experiments{52}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{52}.gridFrame=10;
experiments{52}.noiseTreshold = 3;
experiments{52}.timeStep=3;
experiments{52}.startframeFit=12;
experiments{52}.endframeFit=30;
experiments{52}.numSlopePoints=3;
experiments{52}.DNAChannelBegin=1;

experiments{53}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{53}.gridFrame=10;
experiments{53}.noiseTreshold = 3;
experiments{53}.timeStep=3;
experiments{53}.startframeFit=12;
experiments{53}.endframeFit=30;
experiments{53}.numSlopePoints=3;
experiments{53}.DNAChannelBegin=1;
experiments{53}.coLocFrames=1:3;

experiments{54}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 2s interval_1/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 2s interval_1_MMStack.ome.tif';
experiments{54}.gridFrame=10;
experiments{54}.noiseTreshold = 3;
experiments{54}.timeStep=3;
experiments{54}.startframeFit=12;
experiments{54}.endframeFit=30;
experiments{54}.numSlopePoints=3;
experiments{54}.DNAChannelBegin=1;

% O3 timestep 6 s


experiments{55}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 1mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{55}.gridFrame=10;
experiments{55}.noiseTreshold = 3;
experiments{55}.timeStep=6;
experiments{55}.startframeFit=12;
experiments{55}.endframeFit=30;
experiments{55}.numSlopePoints=3;
experiments{55}.DNAChannelBegin=1;

experiments{56}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 10mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{56}.gridFrame=10;
experiments{56}.noiseTreshold = 3;
experiments{56}.timeStep=6;
experiments{56}.startframeFit=12;
experiments{56}.endframeFit=30;
experiments{56}.numSlopePoints=3;
experiments{56}.DNAChannelBegin=1;
experiments{56}.coLocFrames=1:3;

experiments{57}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 20mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{57}.gridFrame=10;
experiments{57}.noiseTreshold = 3;
experiments{57}.timeStep=6;
experiments{57}.startframeFit=12;
experiments{57}.endframeFit=30;
experiments{57}.numSlopePoints=3;
experiments{57}.DNAChannelBegin=1;

experiments{58}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 30mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{58}.gridFrame=10;
experiments{58}.noiseTreshold = 3;
experiments{58}.timeStep=6;
experiments{58}.startframeFit=12;
experiments{58}.endframeFit=30;
experiments{58}.numSlopePoints=3;
experiments{58}.DNAChannelBegin=1;

experiments{59}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 40mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{59}.gridFrame=10;
experiments{59}.noiseTreshold = 3;
experiments{59}.timeStep=6;
experiments{59}.startframeFit=12;
experiments{59}.endframeFit=30;
experiments{59}.numSlopePoints=3;
experiments{59}.DNAChannelBegin=1;

experiments{60}.gridpath='../../../data_tirf/201005 O3 Far2 flow salt titration/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 5s interval_1/O3 Far2 0.5nM NaCl 100mM R1G1 1Hz Greenonly 5s interval_1_MMStack.ome.tif';
experiments{60}.gridFrame=10;
experiments{60}.noiseTreshold = 3;
experiments{60}.timeStep=6;
experiments{60}.startframeFit=12;
experiments{60}.endframeFit=30;
experiments{60}.numSlopePoints=3;
experiments{60}.DNAChannelBegin=1;


% O1 timestep 2 s timestep 201021

experiments{61}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 2s interval_1/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{61}.gridFrame=10;
experiments{61}.noiseTreshold = 3;
experiments{61}.timeStep=2;
experiments{61}.startframeFit=13;
experiments{61}.endframeFit=45;
experiments{61}.numSlopePoints=3;
experiments{61}.DNAChannelBegin=1;

experiments{62}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 2s interval_1/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{62}.gridFrame=10;
experiments{62}.noiseTreshold = 3;
experiments{62}.timeStep=2;
experiments{62}.startframeFit=13;
experiments{62}.endframeFit=25;
experiments{62}.numSlopePoints=3;
experiments{62}.DNAChannelBegin=1;

experiments{63}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 2s interval_1/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{63}.gridFrame=10;
experiments{63}.noiseTreshold = 3;
experiments{63}.timeStep=2;
experiments{63}.startframeFit=13;
experiments{63}.endframeFit=39;
experiments{63}.numSlopePoints=3;
experiments{63}.DNAChannelBegin=1;


experiments{64}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 2s interval_1/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{64}.gridFrame=15;
experiments{64}.noiseTreshold = 3;
experiments{64}.timeStep=2;
experiments{64}.startframeFit=11;
experiments{64}.endframeFit=45;
experiments{64}.numSlopePoints=3;
experiments{64}.DNAChannelBegin=1;

experiments{65}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 2s interval_1/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{65}.gridFrame=10;
experiments{65}.noiseTreshold = 3;
experiments{65}.timeStep=2;
experiments{65}.startframeFit=14;
experiments{65}.endframeFit=45;
experiments{65}.numSlopePoints=3;
experiments{65}.DNAChannelBegin=1;

experiments{66}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 2s interval_1/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{66}.gridFrame=10;
experiments{66}.noiseTreshold = 3;
experiments{66}.timeStep=2;
experiments{66}.startframeFit=13;
experiments{66}.endframeFit=31;
experiments{66}.numSlopePoints=3;
experiments{66}.DNAChannelBegin=1;

% O1 timestep 3 s timestep 201021

experiments{67}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 3s interval_1/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{67}.gridFrame=15;
experiments{67}.noiseTreshold = 3;
experiments{67}.timeStep=3;
experiments{67}.startframeFit=15;
experiments{67}.endframeFit=45;
experiments{67}.numSlopePoints=3;
experiments{67}.DNAChannelBegin=1;

experiments{68}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 3s interval_1/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{68}.gridFrame=15;
experiments{68}.noiseTreshold = 3;
experiments{68}.timeStep=3;
experiments{68}.startframeFit=12;
experiments{68}.endframeFit=36;
experiments{68}.numSlopePoints=3;
experiments{68}.DNAChannelBegin=1;

experiments{69}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 3s interval_1/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{69}.gridFrame=10;
experiments{69}.noiseTreshold = 3;
experiments{69}.timeStep=3;
experiments{69}.startframeFit=11;
experiments{69}.endframeFit=34;
experiments{69}.numSlopePoints=3;
experiments{69}.DNAChannelBegin=1;


experiments{70}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 3s interval_1/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{70}.gridFrame=10;
experiments{70}.noiseTreshold = 3;
experiments{70}.timeStep=3;
experiments{70}.startframeFit=12;
experiments{70}.endframeFit=37;
experiments{70}.numSlopePoints=3;
experiments{70}.DNAChannelBegin=1;

experiments{71}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 3s interval_1/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{71}.gridFrame=10;
experiments{71}.noiseTreshold = 3;
experiments{71}.timeStep=3;
experiments{71}.startframeFit=13;
experiments{71}.endframeFit=28;
experiments{71}.numSlopePoints=3;
experiments{71}.DNAChannelBegin=1;

experiments{72}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 3s interval_1/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{72}.gridFrame=10;
experiments{72}.noiseTreshold = 3;
experiments{72}.timeStep=3;
experiments{72}.startframeFit=11;
experiments{72}.endframeFit=30;
experiments{72}.numSlopePoints=3;
experiments{72}.DNAChannelBegin=1;


% O1 timestep 6 s 20201021

experiments{73}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 6s interval_1/S1 flow O1 Far2 0.5nM NaCl 1mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{73}.gridFrame=27;
experiments{73}.noiseTreshold = 3;
experiments{73}.timeStep=6;
experiments{73}.startframeFit=15;
experiments{73}.endframeFit=45;
experiments{73}.numSlopePoints=3;
experiments{73}.DNAChannelBegin=1;
experiments{73}.coLocFrames=3:5;




experiments{74}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 6s interval_1/S7 flow O1 Far2 0.5nM NaCl 100mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{74}.gridFrame=10;
experiments{74}.noiseTreshold = 3;
experiments{74}.timeStep=6;
experiments{74}.startframeFit=12;
experiments{74}.endframeFit=36;
experiments{74}.numSlopePoints=3;
experiments{74}.DNAChannelBegin=1;
experiments{74}.coLocFrames=1:4;

experiments{75}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 6s interval_1/S6 flow O1 Far2 0.5nM NaCl 125mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{75}.gridFrame=10;
experiments{75}.noiseTreshold = 3;
experiments{75}.timeStep=6;
experiments{75}.startframeFit=11;
experiments{75}.endframeFit=34;
experiments{75}.numSlopePoints=3;
experiments{75}.DNAChannelBegin=1;


experiments{76}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 6s interval_1/S5 flow O1 Far2 0.5nM NaCl 150mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{76}.gridFrame=10;
experiments{76}.noiseTreshold = 3;
experiments{76}.timeStep=6;
experiments{76}.startframeFit=12;
experiments{76}.endframeFit=37;
experiments{76}.numSlopePoints=3;
experiments{76}.DNAChannelBegin=1;

experiments{77}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 6s interval_1/S4 flow O1 Far2 0.5nM NaCl 200mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{77}.gridFrame=10;
experiments{77}.noiseTreshold = 3;
experiments{77}.timeStep=6;
experiments{77}.startframeFit=13;
experiments{77}.endframeFit=28;
experiments{77}.numSlopePoints=3;
experiments{77}.DNAChannelBegin=1;
experiments{77}.coLocFrames=1:3;

experiments{78}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 6s interval_1/S3 flow O1 Far2 0.5nM NaCl 250mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{78}.gridFrame=10;
experiments{78}.noiseTreshold = 3;
experiments{78}.timeStep=6;
experiments{78}.startframeFit=11;
experiments{78}.endframeFit=30;
experiments{78}.numSlopePoints=3;
experiments{78}.DNAChannelBegin=1;
experiments{78}.coLocFrames=1:3;

%O2 timetep 2s 201027 


experiments{79}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 2s interval_1/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 2s interval_1_MMStack.ome.tif';
experiments{79}.gridFrame=10;
experiments{79}.noiseTreshold = 3;
experiments{79}.timeStep=2;
experiments{79}.startframeFit=12;
experiments{79}.endframeFit=45;
experiments{79}.numSlopePoints=3;
experiments{79}.DNAChannelBegin=1;
experiments{79}.coLocFrames=1:5;

experiments{80}.gridpath='../../../data_tirf/201026 O2 salt titration/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 2s _1/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 2s _1_MMStack.ome.tif';
experiments{80}.gridFrame=10;
experiments{80}.noiseTreshold = 3;
experiments{80}.timeStep=2;
experiments{80}.startframeFit=10;
experiments{80}.endframeFit=25;
experiments{80}.numSlopePoints=3;
experiments{80}.DNAChannelBegin=1;
experiments{80}.coLocFrames=1:5;

experiments{81}.gridpath='../../../data_tirf/201026 O2 salt titration/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 2s_1/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 2s_1_MMStack.ome.tif';
experiments{81}.gridFrame=10;
experiments{81}.noiseTreshold = 3;
experiments{81}.timeStep=2;
experiments{81}.startframeFit=11;
experiments{81}.endframeFit=39;
experiments{81}.numSlopePoints=3;
experiments{81}.DNAChannelBegin=1;
experiments{81}.coLocFrames=1:4;

experiments{82}.gridpath='../../../data_tirf/201026 O2 salt titration/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 2s_1/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 2s_1_MMStack.ome.tif';
experiments{82}.gridFrame=15;
experiments{82}.noiseTreshold = 3;
experiments{82}.timeStep=2;
experiments{82}.startframeFit=11;
experiments{82}.endframeFit=45;
experiments{82}.numSlopePoints=3;
experiments{82}.DNAChannelBegin=1;
experiments{82}.coLocFrames=1:4;

experiments{83}.gridpath='../../../data_tirf/201026 O2 salt titration/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 2s_1/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 2s_1_MMStack.ome.tif';
experiments{83}.gridFrame=10;
experiments{83}.noiseTreshold = 3;
experiments{83}.timeStep=2;
experiments{83}.startframeFit=15;
experiments{83}.endframeFit=45;
experiments{83}.numSlopePoints=3;
experiments{83}.DNAChannelBegin=1;
experiments{83}.coLocFrames=1:5;

experiments{84}.gridpath='../../../data_tirf/201026 O2 salt titration/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 2s_1/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 2s_1_MMStack.ome.tif';
experiments{84}.gridFrame=10;
experiments{84}.noiseTreshold = 3;
experiments{84}.timeStep=2;
experiments{84}.startframeFit=15;
experiments{84}.endframeFit=31;
experiments{84}.numSlopePoints=3;
experiments{84}.DNAChannelBegin=1;
experiments{84}.coLocFrames=1:5;

%O2 timetep 3s 201027 

experiments{85}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 3s interval_1/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 3s interval_1_MMStack.ome.tif';
experiments{85}.gridFrame=16;
experiments{85}.noiseTreshold = 3;
experiments{85}.timeStep=3;
experiments{85}.startframeFit=13;
experiments{85}.endframeFit=45;
experiments{85}.numSlopePoints=3;
experiments{85}.DNAChannelBegin=1;
experiments{85}.coLocFrames=2:5;

experiments{86}.gridpath='../../../data_tirf/201026 O2 salt titration/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 3s _1/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 3s _1_MMStack.ome.tif';
experiments{86}.gridFrame=10;
experiments{86}.noiseTreshold = 3;
experiments{86}.timeStep=3;
experiments{86}.startframeFit=13;
experiments{86}.endframeFit=25;
experiments{86}.numSlopePoints=3;
experiments{86}.DNAChannelBegin=1;
experiments{86}.coLocFrames=1:4;

experiments{87}.gridpath='../../../data_tirf/201026 O2 salt titration/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 3s_1/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 3s_1_MMStack.ome.tif';
experiments{87}.gridFrame=10;
experiments{87}.noiseTreshold = 3;
experiments{87}.timeStep=3;
experiments{87}.startframeFit=13;
experiments{87}.endframeFit=39;
experiments{87}.numSlopePoints=3;
experiments{87}.DNAChannelBegin=1;
experiments{87}.coLocFrames=1:5;

experiments{88}.gridpath='../../../data_tirf/201026 O2 salt titration/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 3s_1/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 3s_1_MMStack.ome.tif';
experiments{88}.gridFrame=15;
experiments{88}.noiseTreshold = 3;
experiments{88}.timeStep=3;
experiments{88}.startframeFit=11;
experiments{88}.endframeFit=45;
experiments{88}.numSlopePoints=3;
experiments{88}.DNAChannelBegin=1;
experiments{88}.coLocFrames=1:4;

experiments{89}.gridpath='../../../data_tirf/201026 O2 salt titration/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 3s_1/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 3s_1_MMStack.ome.tif';
experiments{89}.gridFrame=15;
experiments{89}.noiseTreshold = 3;
experiments{89}.timeStep=3;
experiments{89}.startframeFit=14;
experiments{89}.endframeFit=45;
experiments{89}.numSlopePoints=3;
experiments{89}.DNAChannelBegin=1;
experiments{89}.coLocFrames=1:4;

experiments{90}.gridpath='../../../data_tirf/201026 O2 salt titration/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 3s_1/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 3s_1_MMStack.ome.tif';
experiments{90}.gridFrame=10;
experiments{90}.noiseTreshold = 3;
experiments{90}.timeStep=3;
experiments{90}.startframeFit=13;
experiments{90}.endframeFit=31;
experiments{90}.numSlopePoints=3;
experiments{90}.DNAChannelBegin=1;
experiments{90}.coLocFrames=1:4;

%O2 timetep 6s 201027 

experiments{91}.gridpath='../../../data_tirf/201020 O1 O2 Far2 salt titration/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 6s interval_1/S2 flow O2 Far2 0.5nM NaCl 1mM R1G1 6s interval_1_MMStack.ome.tif';
experiments{91}.gridFrame=10;
experiments{91}.noiseTreshold = 3;
experiments{91}.timeStep=6;
experiments{91}.startframeFit=13;
experiments{91}.endframeFit=45;
experiments{91}.numSlopePoints=3;
experiments{91}.DNAChannelBegin=1;
experiments{91}.coLocFrames=1:4;

experiments{92}.gridpath='../../../data_tirf/201026 O2 salt titration/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 6s _1/S1 O2 0.5nM Far2 100mM NaCl R1G1 interval 6s _1_MMStack.ome.tif';
experiments{92}.gridFrame=10;
experiments{92}.noiseTreshold = 3;
experiments{92}.timeStep=6;
experiments{92}.startframeFit=13;
experiments{92}.endframeFit=25;
experiments{92}.numSlopePoints=3;
experiments{92}.DNAChannelBegin=1;
experiments{92}.coLocFrames=1:4;

experiments{93}.gridpath='../../../data_tirf/201026 O2 salt titration/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 6s_1/S2 O2 0.5nM Far2 125mM NaCl R1G1 interval 6s_1_MMStack.ome.tif';
experiments{93}.gridFrame=10;
experiments{93}.noiseTreshold = 3;
experiments{93}.timeStep=6;
experiments{93}.startframeFit=13;
experiments{93}.endframeFit=39;
experiments{93}.numSlopePoints=3;
experiments{93}.DNAChannelBegin=1;
experiments{93}.coLocFrames=1:4;


experiments{94}.gridpath='../../../data_tirf/201026 O2 salt titration/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 6s_1/S3 O2 0.5nM Far2 150mM NaCl R1G1 interval 6s_1_MMStack.ome.tif';
experiments{94}.gridFrame=15;
experiments{94}.noiseTreshold = 3;
experiments{94}.timeStep=6;
experiments{94}.startframeFit=11;
experiments{94}.endframeFit=45;
experiments{94}.numSlopePoints=3;
experiments{94}.DNAChannelBegin=1;
experiments{94}.coLocFrames=1:4;

experiments{95}.gridpath='../../../data_tirf/201026 O2 salt titration/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 6s_1/S4 O2 0.5nM Far2 200mM NaCl R1G1 interval 6s_1_MMStack.ome.tif';
experiments{95}.gridFrame=10;
experiments{95}.noiseTreshold = 3;
experiments{95}.timeStep=6;
experiments{95}.startframeFit=14;
experiments{95}.endframeFit=45;
experiments{95}.numSlopePoints=3;
experiments{95}.DNAChannelBegin=1;
experiments{95}.coLocFrames=1:4;

experiments{96}.gridpath='../../../data_tirf/201026 O2 salt titration/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 6s_1/S5 O2 0.5nM Far2 250mM NaCl R1G1 interval 6s_1_MMStack.ome.tif';
experiments{96}.gridFrame=10;
experiments{96}.noiseTreshold = 3;
experiments{96}.timeStep=6;
experiments{96}.startframeFit=13;
experiments{96}.endframeFit=31;
experiments{96}.numSlopePoints=3;
experiments{96}.DNAChannelBegin=1;
experiments{96}.coLocFrames=1:4;

%O2 timetep 2s 201111 


experiments{97}.gridpath='../../../data_tirf/201111 O2 salt titration/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 2s flow_1/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{97}.gridFrame=10;
experiments{97}.noiseTreshold = 3;
experiments{97}.timeStep=2;
experiments{97}.startframeFit=12;
experiments{97}.endframeFit=45;
experiments{97}.numSlopePoints=3;
experiments{97}.DNAChannelBegin=1;
experiments{97}.coLocFrames=1:5;

experiments{98}.gridpath='../../../data_tirf/201111 O2 salt titration/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 2s flow_1/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{98}.gridFrame=10;
experiments{98}.noiseTreshold = 3;
experiments{98}.timeStep=2;
experiments{98}.startframeFit=12;
experiments{98}.endframeFit=25;
experiments{98}.numSlopePoints=3;
experiments{98}.DNAChannelBegin=1;
experiments{98}.coLocFrames=1:5;

experiments{99}.gridpath='../../../data_tirf/201111 O2 salt titration/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 2s flow_1/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{99}.gridFrame=17;
experiments{99}.noiseTreshold = 3;
experiments{99}.timeStep=2;
experiments{99}.startframeFit=12;
experiments{99}.endframeFit=39;
experiments{99}.numSlopePoints=3;
experiments{99}.DNAChannelBegin=1;
experiments{99}.coLocFrames=1:3;

experiments{100}.gridpath='../../../data_tirf/201111 O2 salt titration/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 2s flow_1/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{100}.gridFrame=15;
experiments{100}.noiseTreshold = 3;
experiments{100}.timeStep=2;
experiments{100}.startframeFit=12;
experiments{100}.endframeFit=45;
experiments{100}.numSlopePoints=3;
experiments{100}.DNAChannelBegin=1;
experiments{100}.coLocFrames=1:4;

experiments{101}.gridpath='../../../data_tirf/201111 O2 salt titration/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 2s flow_1/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{101}.gridFrame=10;
experiments{101}.noiseTreshold = 3;
experiments{101}.timeStep=2;
experiments{101}.startframeFit=11;
experiments{101}.endframeFit=45;
experiments{101}.numSlopePoints=3;
experiments{101}.DNAChannelBegin=1;
experiments{101}.coLocFrames=1:5;

experiments{102}.gridpath='../../../data_tirf/201111 O2 salt titration/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 2s flow_1/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{102}.gridFrame=10;
experiments{102}.noiseTreshold = 3;
experiments{102}.timeStep=2;
experiments{102}.startframeFit=17;
experiments{102}.endframeFit=31;
experiments{102}.numSlopePoints=3;
experiments{102}.DNAChannelBegin=1;
experiments{102}.coLocFrames=1:5;

%O2 timetep 3s 201111 

experiments{103}.gridpath='../../../data_tirf/201111 O2 salt titration/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 3s flow_2/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 3s flow_2_MMStack.ome.tif';
experiments{103}.gridFrame=25;
experiments{103}.noiseTreshold = 3;
experiments{103}.timeStep=3;
experiments{103}.startframeFit=13;
experiments{103}.endframeFit=45;
experiments{103}.numSlopePoints=3;
experiments{103}.DNAChannelBegin=1;
experiments{103}.coLocFrames=2:5;

experiments{104}.gridpath='../../../data_tirf/201111 O2 salt titration/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 3s flow_1/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{104}.gridFrame=10;
experiments{104}.noiseTreshold = 3;
experiments{104}.timeStep=3;
experiments{104}.startframeFit=13;
experiments{104}.endframeFit=25;
experiments{104}.numSlopePoints=3;
experiments{104}.DNAChannelBegin=1;
experiments{104}.coLocFrames=1:4;

experiments{105}.gridpath='../../../data_tirf/201111 O2 salt titration/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 3s flow_1/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{105}.gridFrame=10;
experiments{105}.noiseTreshold = 3;
experiments{105}.timeStep=3;
experiments{105}.startframeFit=13;
experiments{105}.endframeFit=39;
experiments{105}.numSlopePoints=3;
experiments{105}.DNAChannelBegin=1;
experiments{105}.coLocFrames=1:5;

experiments{106}.gridpath='../../../data_tirf/201111 O2 salt titration/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 3s flow_1/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{106}.gridFrame=15;
experiments{106}.noiseTreshold = 3;
experiments{106}.timeStep=3;
experiments{106}.startframeFit=11;
experiments{106}.endframeFit=45;
experiments{106}.numSlopePoints=3;
experiments{106}.DNAChannelBegin=1;
experiments{106}.coLocFrames=1:4;

experiments{107}.gridpath='../../../data_tirf/201111 O2 salt titration/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 3s flow_1/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{107}.gridFrame=15;
experiments{107}.noiseTreshold = 3;
experiments{107}.timeStep=3;
experiments{107}.startframeFit=14;
experiments{107}.endframeFit=45;
experiments{107}.numSlopePoints=3;
experiments{107}.DNAChannelBegin=1;
experiments{107}.coLocFrames=1:4;

experiments{108}.gridpath='../../../data_tirf/201111 O2 salt titration/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 3s flow_2/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 3s flow_2_MMStack.ome.tif';
experiments{108}.gridFrame=10;
experiments{108}.noiseTreshold = 3;
experiments{108}.timeStep=3;
experiments{108}.startframeFit=13;
experiments{108}.endframeFit=31;
experiments{108}.numSlopePoints=3;
experiments{108}.DNAChannelBegin=1;
experiments{108}.coLocFrames=1:4;

%O2 timetep 6s 201111

experiments{109}.gridpath='../../../data_tirf/201111 O2 salt titration/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 6s flow_1/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{109}.gridFrame=17;
experiments{109}.noiseTreshold = 3;
experiments{109}.timeStep=6;
experiments{109}.startframeFit=13;
experiments{109}.endframeFit=45;
experiments{109}.numSlopePoints=3;
experiments{109}.DNAChannelBegin=1;
experiments{109}.coLocFrames=1:4;

experiments{110}.gridpath='../../../data_tirf/201111 O2 salt titration/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 6s flow_1/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{110}.gridFrame=10;
experiments{110}.noiseTreshold = 3;
experiments{110}.timeStep=6;
experiments{110}.startframeFit=13;
experiments{110}.endframeFit=25;
experiments{110}.numSlopePoints=3;
experiments{110}.DNAChannelBegin=1;
experiments{110}.coLocFrames=1:4;

experiments{111}.gridpath='../../../data_tirf/201111 O2 salt titration/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 6s flow_1/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{111}.gridFrame=10;
experiments{111}.noiseTreshold = 3;
experiments{111}.timeStep=6;
experiments{111}.startframeFit=13;
experiments{111}.endframeFit=39;
experiments{111}.numSlopePoints=3;
experiments{111}.DNAChannelBegin=1;
experiments{111}.coLocFrames=1:4;


experiments{112}.gridpath='../../../data_tirf/201111 O2 salt titration/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 6s flow_1/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{112}.gridFrame=15;
experiments{112}.noiseTreshold = 3;
experiments{112}.timeStep=6;
experiments{112}.startframeFit=11;
experiments{112}.endframeFit=45;
experiments{112}.numSlopePoints=3;
experiments{112}.DNAChannelBegin=1;
experiments{112}.coLocFrames=1:4;

experiments{113}.gridpath='../../../data_tirf/201111 O2 salt titration/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 6s flow_1/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{113}.gridFrame=10;
experiments{113}.noiseTreshold = 3;
experiments{113}.timeStep=6;
experiments{113}.startframeFit=14;
experiments{113}.endframeFit=45;
experiments{113}.numSlopePoints=3;
experiments{113}.DNAChannelBegin=1;
experiments{113}.coLocFrames=1:4;

experiments{114}.gridpath='../../../data_tirf/201111 O2 salt titration/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 6s flow_1/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{114}.gridFrame=10;
experiments{114}.noiseTreshold = 3;
experiments{114}.timeStep=6;
experiments{114}.startframeFit=13;
experiments{114}.endframeFit=31;
experiments{114}.numSlopePoints=3;
experiments{114}.DNAChannelBegin=1;
experiments{114}.coLocFrames=1:4;

%O2 timetep 20s 201111

experiments{115}.gridpath='../../../data_tirf/201111 O2 salt titration/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 20s flow_1/S1 O2 Far2 0.5nM NaCl 1mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{115}.gridFrame=17;
experiments{115}.noiseTreshold = 3;
experiments{115}.timeStep=20;
experiments{115}.startframeFit=13;
experiments{115}.endframeFit=45;
experiments{115}.numSlopePoints=3;
experiments{115}.DNAChannelBegin=1;
experiments{115}.coLocFrames=1:2;

experiments{116}.gridpath='../../../data_tirf/201111 O2 salt titration/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 20s flow_1/S2 O2 Far2 0.5nM NaCl 50mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{116}.gridFrame=10;
experiments{116}.noiseTreshold = 3;
experiments{116}.timeStep=20;
experiments{116}.startframeFit=13;
experiments{116}.endframeFit=25;
experiments{116}.numSlopePoints=3;
experiments{116}.DNAChannelBegin=1;
experiments{116}.coLocFrames=1:2;

experiments{117}.gridpath='../../../data_tirf/201111 O2 salt titration/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 20s flow_1/S3 O2 Far2 0.5nM NaCl 100mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{117}.gridFrame=10;
experiments{117}.noiseTreshold = 3;
experiments{117}.timeStep=20;
experiments{117}.startframeFit=13;
experiments{117}.endframeFit=39;
experiments{117}.numSlopePoints=3;
experiments{117}.DNAChannelBegin=1;
experiments{117}.coLocFrames=1:2;


experiments{118}.gridpath='../../../data_tirf/201111 O2 salt titration/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 20s flow_1/S4 O2 Far2 0.5nM NaCl 150mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{118}.gridFrame=15;
experiments{118}.noiseTreshold = 3;
experiments{118}.timeStep=20;
experiments{118}.startframeFit=11;
experiments{118}.endframeFit=45;
experiments{118}.numSlopePoints=3;
experiments{118}.DNAChannelBegin=1;
experiments{118}.coLocFrames=1:2;

experiments{119}.gridpath='../../../data_tirf/201111 O2 salt titration/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 20s flow_1/S5 O2 Far2 0.5nM NaCl 200mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{119}.gridFrame=10;
experiments{119}.noiseTreshold = 3;
experiments{119}.timeStep=20;
experiments{119}.startframeFit=14;
experiments{119}.endframeFit=45;
experiments{119}.numSlopePoints=3;
experiments{119}.DNAChannelBegin=1;
experiments{119}.coLocFrames=1:2;

experiments{120}.gridpath='../../../data_tirf/201111 O2 salt titration/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 20s flow_1/S6 O2 Far2 0.5nM NaCl 250mM R1G1 interval 20s flow_1_MMStack.ome.tif';
experiments{120}.gridFrame=10;
experiments{120}.noiseTreshold = 3;
experiments{120}.timeStep=20;
experiments{120}.startframeFit=13;
experiments{120}.endframeFit=31;
experiments{120}.numSlopePoints=3;
experiments{120}.DNAChannelBegin=1;
experiments{120}.coLocFrames=1:2;

% O3 repeat 2020-11-25 2s


experiments{121}.gridpath='../../../data_tirf/201124 O3 salt titration/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 2s flow_1/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{121}.gridFrame=17;
experiments{121}.noiseTreshold = 3;
experiments{121}.timeStep=2;
experiments{121}.startframeFit=13;
experiments{121}.endframeFit=45;
experiments{121}.numSlopePoints=3;
experiments{121}.DNAChannelBegin=1;
experiments{121}.coLocFrames=1:5;

experiments{122}.gridpath='../../../data_tirf/201124 O3 salt titration/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 2s flow_1/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{122}.gridFrame=10;
experiments{122}.noiseTreshold = 3;
experiments{122}.timeStep=2;
experiments{122}.startframeFit=18;
experiments{122}.endframeFit=25;
experiments{122}.numSlopePoints=3;
experiments{122}.DNAChannelBegin=1;
experiments{122}.coLocFrames=1:5;

experiments{123}.gridpath='../../../data_tirf/201124 O3 salt titration/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 2s flow_1/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{123}.gridFrame=10;
experiments{123}.noiseTreshold = 3;
experiments{123}.timeStep=2;
experiments{123}.startframeFit=11;
experiments{123}.endframeFit=39;
experiments{123}.numSlopePoints=3;
experiments{123}.DNAChannelBegin=1;
experiments{123}.coLocFrames=1:5;


experiments{124}.gridpath='../../../data_tirf/201124 O3 salt titration/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 2s flow_1/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{124}.gridFrame=15;
experiments{124}.noiseTreshold = 3;
experiments{124}.timeStep=2;
experiments{124}.startframeFit=12;
experiments{124}.endframeFit=45;
experiments{124}.numSlopePoints=3;
experiments{124}.DNAChannelBegin=1;
experiments{124}.coLocFrames=1:4;

experiments{125}.gridpath='../../../data_tirf/201124 O3 salt titration/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 2s flow_1/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{125}.gridFrame=10;
experiments{125}.noiseTreshold = 3;
experiments{125}.timeStep=2;
experiments{125}.startframeFit=9;
experiments{125}.endframeFit=45;
experiments{125}.numSlopePoints=3;
experiments{125}.DNAChannelBegin=1;
experiments{125}.coLocFrames=1:5;

experiments{126}.gridpath='../../../data_tirf/201124 O3 salt titration/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 2s flow_1/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 2s flow_1_MMStack.ome.tif';
experiments{126}.gridFrame=10;
experiments{126}.noiseTreshold = 3;
experiments{126}.timeStep=2;
experiments{126}.startframeFit=17;
experiments{126}.endframeFit=31;
experiments{126}.numSlopePoints=3;
experiments{126}.DNAChannelBegin=1;
experiments{126}.coLocFrames=1:5;

% O3 repeat 2020-11-25 3s


experiments{127}.gridpath='../../../data_tirf/201124 O3 salt titration/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 3s flow_1/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{127}.gridFrame=17;
experiments{127}.noiseTreshold = 3;
experiments{127}.timeStep=3;
experiments{127}.startframeFit=13;
experiments{127}.endframeFit=45;
experiments{127}.numSlopePoints=3;
experiments{127}.DNAChannelBegin=1;
experiments{127}.coLocFrames=1:5;

experiments{128}.gridpath='../../../data_tirf/201124 O3 salt titration/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 3s flow_1/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{128}.gridFrame=10;
experiments{128}.noiseTreshold = 3;
experiments{128}.timeStep=3;
experiments{128}.startframeFit=13;
experiments{128}.endframeFit=25;
experiments{128}.numSlopePoints=3;
experiments{128}.DNAChannelBegin=1;
experiments{128}.coLocFrames=1:5;

experiments{129}.gridpath='../../../data_tirf/201124 O3 salt titration/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 3s flow_1/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{129}.gridFrame=10;
experiments{129}.noiseTreshold = 3;
experiments{129}.timeStep=3;
experiments{129}.startframeFit=13;
experiments{129}.endframeFit=39;
experiments{129}.numSlopePoints=3;
experiments{129}.DNAChannelBegin=1;
experiments{129}.coLocFrames=1:5;


experiments{130}.gridpath='../../../data_tirf/201124 O3 salt titration/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 3s flow_1/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{130}.gridFrame=15;
experiments{130}.noiseTreshold = 3;
experiments{130}.timeStep=3;
experiments{130}.startframeFit=11;
experiments{130}.endframeFit=45;
experiments{130}.numSlopePoints=3;
experiments{130}.DNAChannelBegin=1;
experiments{130}.coLocFrames=1:5;

experiments{131}.gridpath='../../../data_tirf/201124 O3 salt titration/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 3s flow_1/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{131}.gridFrame=10;
experiments{131}.noiseTreshold = 3;
experiments{131}.timeStep=3;
experiments{131}.startframeFit=14;
experiments{131}.endframeFit=45;
experiments{131}.numSlopePoints=3;
experiments{131}.DNAChannelBegin=1;
experiments{131}.coLocFrames=1:5;

experiments{132}.gridpath='../../../data_tirf/201124 O3 salt titration/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 3s flow_1/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 3s flow_1_MMStack.ome.tif';
experiments{132}.gridFrame=10;
experiments{132}.noiseTreshold = 3;
experiments{132}.timeStep=3;
experiments{132}.startframeFit=13;
experiments{132}.endframeFit=31;
experiments{132}.numSlopePoints=3;
experiments{132}.DNAChannelBegin=1;
experiments{132}.coLocFrames=1:5;

% O3 repeat 2020-11-25 6s


experiments{133}.gridpath='../../../data_tirf/201124 O3 salt titration/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 6s flow_1/S1 O3 Far2 0.5nM NaCl 1mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{133}.gridFrame=10;
experiments{133}.noiseTreshold = 3;
experiments{133}.timeStep=6;
experiments{133}.startframeFit=13;
experiments{133}.endframeFit=45;
experiments{133}.numSlopePoints=3;
experiments{133}.DNAChannelBegin=1;
experiments{133}.coLocFrames=1:3;

experiments{134}.gridpath='../../../data_tirf/201124 O3 salt titration/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 6s flow_1/S2 O3 Far2 0.5nM NaCl 25mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{134}.gridFrame=10;
experiments{134}.noiseTreshold = 3;
experiments{134}.timeStep=6;
experiments{134}.startframeFit=13;
experiments{134}.endframeFit=25;
experiments{134}.numSlopePoints=3;
experiments{134}.DNAChannelBegin=1;
experiments{134}.coLocFrames=1:3;

experiments{135}.gridpath='../../../data_tirf/201124 O3 salt titration/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 6s flow_1/S3 O3 Far2 0.5nM NaCl 50mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{135}.gridFrame=10;
experiments{135}.noiseTreshold = 3;
experiments{135}.timeStep=6;
experiments{135}.startframeFit=13;
experiments{135}.endframeFit=39;
experiments{135}.numSlopePoints=3;
experiments{135}.DNAChannelBegin=1;
experiments{135}.coLocFrames=1:3;


experiments{136}.gridpath='../../../data_tirf/201124 O3 salt titration/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 6s flow_1/S4 O3 Far2 0.5nM NaCl 75mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{136}.gridFrame=10;
experiments{136}.noiseTreshold = 3;
experiments{136}.timeStep=6;
experiments{136}.startframeFit=11;
experiments{136}.endframeFit=45;
experiments{136}.numSlopePoints=3;
experiments{136}.DNAChannelBegin=1;
experiments{136}.coLocFrames=1:3;

experiments{137}.gridpath='../../../data_tirf/201124 O3 salt titration/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 6s flow_1/S5 O3 Far2 0.5nM NaCl 100mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{137}.gridFrame=10;
experiments{137}.noiseTreshold = 3;
experiments{137}.timeStep=6;
experiments{137}.startframeFit=14;
experiments{137}.endframeFit=45;
experiments{137}.numSlopePoints=3;
experiments{137}.DNAChannelBegin=1;
experiments{137}.coLocFrames=1:3;

experiments{138}.gridpath='../../../data_tirf/201124 O3 salt titration/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 6s flow_1/S6 O3 Far2 0.5nM NaCl 125mM R1G1 interval 6s flow_1_MMStack.ome.tif';
experiments{138}.gridFrame=15;
experiments{138}.noiseTreshold = 3;
experiments{138}.timeStep=6;
experiments{138}.startframeFit=13;
experiments{138}.endframeFit=31;
experiments{138}.numSlopePoints=3;
experiments{138}.DNAChannelBegin=1;
experiments{138}.coLocFrames=1:3;

% O1 2020-12-08 2s
experiments{139}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 2s _1/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 2s _1_MMStack.ome.tif';
experiments{139}.gridFrame=10;
experiments{139}.noiseTreshold = 3;
experiments{139}.timeStep=2;
experiments{139}.startframeFit=10;
experiments{139}.endframeFit=45;
experiments{139}.numSlopePoints=3;
experiments{139}.DNAChannelBegin=1;
experiments{139}.coLocFrames=1:4;

experiments{140}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 2s _1/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 2s _1_MMStack.ome.tif';
experiments{140}.gridFrame=10;
experiments{140}.noiseTreshold = 3;
experiments{140}.timeStep=2;
experiments{140}.startframeFit=8;
experiments{140}.endframeFit=25;
experiments{140}.numSlopePoints=3;
experiments{140}.DNAChannelBegin=1;
experiments{140}.coLocFrames=1:3;

experiments{141}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 2s _1/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 2s _1_MMStack.ome.tif';
experiments{141}.gridFrame=10;
experiments{141}.noiseTreshold = 3;
experiments{141}.timeStep=2;
experiments{141}.startframeFit=8;
experiments{141}.endframeFit=39;
experiments{141}.numSlopePoints=3;
experiments{141}.DNAChannelBegin=1;
experiments{141}.coLocFrames=1:4;


experiments{142}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 2s _1/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 2s _1_MMStack.ome.tif';
experiments{142}.gridFrame=10;
experiments{142}.noiseTreshold = 3;
experiments{142}.timeStep=2;
experiments{142}.startframeFit=11;
experiments{142}.endframeFit=45;
experiments{142}.numSlopePoints=3;
experiments{142}.DNAChannelBegin=1;
experiments{142}.coLocFrames=1:4;

experiments{143}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 2s _1/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 2s _1_MMStack.ome.tif';
experiments{143}.gridFrame=10;
experiments{143}.noiseTreshold = 3;
experiments{143}.timeStep=2;
experiments{143}.startframeFit=9;
experiments{143}.endframeFit=45;
experiments{143}.numSlopePoints=3;
experiments{143}.DNAChannelBegin=1;
experiments{143}.coLocFrames=1:4;

experiments{144}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 2s _1/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 2s _1_MMStack.ome.tif';
experiments{144}.gridFrame=15;
experiments{144}.noiseTreshold = 3;
experiments{144}.timeStep=2;
experiments{144}.startframeFit=12;
experiments{144}.endframeFit=31;
experiments{144}.numSlopePoints=3;
experiments{144}.DNAChannelBegin=1;
experiments{144}.coLocFrames=1:4;

experiments{145}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 2s _1/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 2s _1_MMStack.ome.tif';
experiments{145}.gridFrame=15;
experiments{145}.noiseTreshold = 3;
experiments{145}.timeStep=2;
experiments{145}.startframeFit=17;
experiments{145}.endframeFit=31;
experiments{145}.numSlopePoints=3; 
experiments{145}.DNAChannelBegin=1;
experiments{145}.coLocFrames=1:4;


% O1 2020-12-08 6s
experiments{146}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 6s _1/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 6s _1_MMStack.ome.tif';
experiments{146}.gridFrame=10;
experiments{146}.noiseTreshold = 3;
experiments{146}.timeStep=6;
experiments{146}.startframeFit=10;
experiments{146}.endframeFit=45;
experiments{146}.numSlopePoints=3;
experiments{146}.DNAChannelBegin=1;
experiments{146}.coLocFrames=1:3;

experiments{147}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 6s _1/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 6s _1_MMStack.ome.tif';
experiments{147}.gridFrame=10;
experiments{147}.noiseTreshold = 3;
experiments{147}.timeStep=6;
experiments{147}.startframeFit=10;
experiments{147}.endframeFit=25;
experiments{147}.numSlopePoints=3;
experiments{147}.DNAChannelBegin=1;
experiments{147}.coLocFrames=1:3;

experiments{148}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 6s _1/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 6s _1_MMStack.ome.tif';
experiments{148}.gridFrame=10;
experiments{148}.noiseTreshold = 3;
experiments{148}.timeStep=6;
experiments{148}.startframeFit=10;
experiments{148}.endframeFit=39;
experiments{148}.numSlopePoints=3;
experiments{148}.DNAChannelBegin=1;
experiments{148}.coLocFrames=1:2;


experiments{149}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 6s _1/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 6s _1_MMStack.ome.tif';
experiments{149}.gridFrame=10;
experiments{149}.noiseTreshold = 3;
experiments{149}.timeStep=6;
experiments{149}.startframeFit=10;
experiments{149}.endframeFit=45;
experiments{149}.numSlopePoints=3;
experiments{149}.DNAChannelBegin=1;
experiments{149}.coLocFrames=1:2;

experiments{150}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 6s _1/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 6s _1_MMStack.ome.tif';
experiments{150}.gridFrame=10;
experiments{150}.noiseTreshold = 3;
experiments{150}.timeStep=6;
experiments{150}.startframeFit=10;
experiments{150}.endframeFit=45;
experiments{150}.numSlopePoints=3;
experiments{150}.DNAChannelBegin=1;
experiments{150}.coLocFrames=1:2;

experiments{151}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 6s _1/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 6s _1_MMStack.ome.tif';
experiments{151}.gridFrame=15;
experiments{151}.noiseTreshold = 3;
experiments{151}.timeStep=6;
experiments{151}.startframeFit=10;
experiments{151}.endframeFit=31;
experiments{151}.numSlopePoints=3;
experiments{151}.DNAChannelBegin=1;
experiments{151}.coLocFrames=1:3;

experiments{152}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 6s _1/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 6s _1_MMStack.ome.tif';
experiments{152}.gridFrame=15;
experiments{152}.noiseTreshold = 3;
experiments{152}.timeStep=6;
experiments{152}.startframeFit=10;
experiments{152}.endframeFit=31;
experiments{152}.numSlopePoints=3;
experiments{152}.DNAChannelBegin=1;
experiments{152}.coLocFrames=1:3;

% O1 2020-12-08 12s
experiments{153}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 12s _1/S1 O1 Far2 0.5nM R1G1 NaCl 1mM interval 12s _1_MMStack.ome.tif';
experiments{153}.gridFrame=10;
experiments{153}.noiseTreshold = 3;
experiments{153}.timeStep=12;
experiments{153}.startframeFit=10;
experiments{153}.endframeFit=45;
experiments{153}.numSlopePoints=3;
experiments{153}.DNAChannelBegin=1;
experiments{153}.coLocFrames=1:2;

experiments{154}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 12s _1/S2 O1 Far2 0.5nM R1G1 NaCl 50mM interval 12s _1_MMStack.ome.tif';
experiments{154}.gridFrame=10;
experiments{154}.noiseTreshold = 3;
experiments{154}.timeStep=12;
experiments{154}.startframeFit=10;
experiments{154}.endframeFit=25;
experiments{154}.numSlopePoints=3;
experiments{154}.DNAChannelBegin=1;
experiments{154}.coLocFrames=1:2;

experiments{155}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 12s _1/S3 O1 Far2 0.5nM R1G1 NaCl 75mM interval 12s _1_MMStack.ome.tif';
experiments{155}.gridFrame=10;
experiments{155}.noiseTreshold = 3;
experiments{155}.timeStep=12;
experiments{155}.startframeFit=10;
experiments{155}.endframeFit=39;
experiments{155}.numSlopePoints=3;
experiments{155}.DNAChannelBegin=1;
experiments{155}.coLocFrames=1:2;


experiments{156}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 12s _1/S4 O1 Far2 0.5nM R1G1 NaCl 100mM interval 12s _1_MMStack.ome.tif';
experiments{156}.gridFrame=10;
experiments{156}.noiseTreshold = 3;
experiments{156}.timeStep=12;
experiments{156}.startframeFit=10;
experiments{156}.endframeFit=45;
experiments{156}.numSlopePoints=3;
experiments{156}.DNAChannelBegin=1;
experiments{156}.coLocFrames=1:2;

experiments{157}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 12s _1/S5 O1 Far2 0.5nM R1G1 NaCl 150mM interval 12s _1_MMStack.ome.tif';
experiments{157}.gridFrame=10;
experiments{157}.noiseTreshold = 3;
experiments{157}.timeStep=12;
experiments{157}.startframeFit=10;
experiments{157}.endframeFit=45;
experiments{157}.numSlopePoints=3;
experiments{157}.DNAChannelBegin=1;
experiments{157}.coLocFrames=1:2;

experiments{158}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 12s _1/S6 O1 Far2 0.5nM R1G1 NaCl 200mM interval 12s _1_MMStack.ome.tif';
experiments{158}.gridFrame=15;
experiments{158}.noiseTreshold = 3;
experiments{158}.timeStep=12;
experiments{158}.startframeFit=10;
experiments{158}.endframeFit=31;
experiments{158}.numSlopePoints=3;
experiments{158}.DNAChannelBegin=1;
experiments{158}.coLocFrames=1:2;

experiments{159}.gridpath='../../../data_tirf/20201205 Far2 O1 salt titration/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 12s _1/S7 O1 Far2 0.5nM R1G1 NaCl 250mM interval 12s _1_MMStack.ome.tif';
experiments{159}.gridFrame=15;
experiments{159}.noiseTreshold = 3;
experiments{159}.timeStep=12;
experiments{159}.startframeFit=10;
experiments{159}.endframeFit=31;
experiments{159}.numSlopePoints=3;
experiments{159}.DNAChannelBegin=1;
experiments{159}.coLocFrames=1:2;

% non operator DNA 2020-12-17 2s
experiments{160}.gridpath='../../../data_tirf/201217 control experiments/S2 RS90 LacI Far2 0.5nM R1G1 2s interval flow_1/S2 RS90 LacI Far2 0.5nM R1G1 2s interval flow_1_MMStack.ome.tif';
experiments{160}.gridFrame=10;
experiments{160}.noiseTreshold = 3;
experiments{160}.timeStep=2;
experiments{160}.startframeFit=8;
experiments{160}.endframeFit=45;
experiments{160}.numSlopePoints=3;
experiments{160}.DNAChannelBegin=1;
experiments{160}.coLocFrames=1:4;

experiments{161}.gridpath='../../../data_tirf/201217 control experiments/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 2s interval flow_1/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 2s interval flow_1_MMStack.ome.tif';
experiments{161}.gridFrame=10;
experiments{161}.noiseTreshold = 3;
experiments{161}.timeStep=2;
experiments{161}.startframeFit=4;
experiments{161}.endframeFit=25;
experiments{161}.numSlopePoints=3;
experiments{161}.DNAChannelBegin=1;
experiments{161}.coLocFrames=1:4;

experiments{162}.gridpath='../../../data_tirf/201217 control experiments/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 2s interval flow_1/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 2s interval flow_1_MMStack.ome.tif';
experiments{162}.gridFrame=10;
experiments{162}.noiseTreshold = 3;
experiments{162}.timeStep=2;
experiments{162}.startframeFit=4;
experiments{162}.endframeFit=39;
experiments{162}.numSlopePoints=3;
experiments{162}.DNAChannelBegin=1;
experiments{162}.coLocFrames=1:4;


experiments{163}.gridpath='../../../data_tirf/201217 control experiments/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 2s interval flow_1/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 2s interval flow_1_MMStack.ome.tif';
experiments{163}.gridFrame=10;
experiments{163}.noiseTreshold = 3;
experiments{163}.timeStep=2;
experiments{163}.startframeFit=5;
experiments{163}.endframeFit=45;
experiments{163}.numSlopePoints=3;
experiments{163}.DNAChannelBegin=1;
experiments{163}.coLocFrames=1:4;

% non operator DNA 2020-12-17 6s
experiments{164}.gridpath='../../../data_tirf/201217 control experiments/S2 RS90 LacI Far2 0.5nM R1G1 6s interval flow_1/S2 RS90 LacI Far2 0.5nM R1G1 6s interval flow_1_MMStack.ome.tif';
experiments{164}.gridFrame=10;
experiments{164}.noiseTreshold = 3;
experiments{164}.timeStep=6;
experiments{164}.startframeFit=10;
experiments{164}.endframeFit=45;
experiments{164}.numSlopePoints=3;
experiments{164}.DNAChannelBegin=1;
experiments{164}.coLocFrames=1:3;

experiments{165}.gridpath='../../../data_tirf/201217 control experiments/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 6s interval flow_1/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 6s interval flow_1_MMStack.ome.tif';
experiments{165}.gridFrame=10;
experiments{165}.noiseTreshold = 3;
experiments{165}.timeStep=6;
experiments{165}.startframeFit=10;
experiments{165}.endframeFit=25;
experiments{165}.numSlopePoints=3;
experiments{165}.DNAChannelBegin=1;
experiments{165}.coLocFrames=1:3;

experiments{166}.gridpath='../../../data_tirf/201217 control experiments/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 6s interval flow_1/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 6s interval flow_1_MMStack.ome.tif';
experiments{166}.gridFrame=10;
experiments{166}.noiseTreshold = 3;
experiments{166}.timeStep=6;
experiments{166}.startframeFit=10;
experiments{166}.endframeFit=39;
experiments{166}.numSlopePoints=3;
experiments{166}.DNAChannelBegin=1;
experiments{166}.coLocFrames=1:3;

experiments{167}.gridpath='../../../data_tirf/201217 control experiments/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 6s interval flow_1/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 6s interval flow_1_MMStack.ome.tif';
experiments{167}.gridFrame=10;
experiments{167}.noiseTreshold = 3;
experiments{167}.timeStep=6;
experiments{167}.startframeFit=10;
experiments{167}.endframeFit=45;
experiments{167}.numSlopePoints=3;
experiments{167}.DNAChannelBegin=1;
experiments{167}.coLocFrames=1:3;

%O1 Far1 2020-12-17 2s


experiments{168}.gridpath='../../../data_tirf/201217 control experiments/S1 O1 LacI Far1 0.5nM R1G1 2s interval flow_1/S1 O1 LacI Far1 0.5nM R1G1 2s interval flow_1_MMStack.ome.tif';
experiments{168}.gridFrame=20;
experiments{168}.noiseTreshold = 3;
experiments{168}.timeStep=2;
experiments{168}.startframeFit=10;
experiments{168}.endframeFit=45;
experiments{168}.numSlopePoints=3;
experiments{168}.DNAChannelBegin=1;
experiments{168}.coLocFrames=1:4;

%O1 Far1 2020-12-17 6s
experiments{169}.gridpath='../../../data_tirf/201217 control experiments/S1 O1 LacI Far1 0.5nM R1G1 6s interval flow_1/S1 O1 LacI Far1 0.5nM R1G1 6s interval flow_1_MMStack.ome.tif';
experiments{169}.gridFrame=20;
experiments{169}.noiseTreshold = 3;
experiments{169}.timeStep=6;
experiments{169}.startframeFit=11;
experiments{169}.endframeFit=45;
experiments{169}.numSlopePoints=3;
experiments{169}.DNAChannelBegin=1;
experiments{169}.coLocFrames=1:3;

% non operator DNA 2020-12-17 2s, for mock DNA
experiments{170}.gridpath='../../../data_tirf/201217 control experiments/S2 RS90 LacI Far2 0.5nM R1G1 2s interval flow_1/S2 RS90 LacI Far2 0.5nM R1G1 2s interval flow_1_MMStack.ome.tif';
experiments{170}.gridFrame=10;
experiments{170}.noiseTreshold = 3;
experiments{170}.timeStep=2;
experiments{170}.startframeFit=8;
experiments{170}.endframeFit=45;
experiments{170}.numSlopePoints=3;
experiments{170}.DNAChannelBegin=1;
experiments{170}.coLocFrames=2:4;

experiments{171}.gridpath='../../../data_tirf/201217 control experiments/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 2s interval flow_1/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 2s interval flow_1_MMStack.ome.tif';
experiments{171}.gridFrame=10;
experiments{171}.noiseTreshold = 3;
experiments{171}.timeStep=2;
experiments{171}.startframeFit=4;
experiments{171}.endframeFit=25;
experiments{171}.numSlopePoints=3;
experiments{171}.DNAChannelBegin=1;
experiments{171}.coLocFrames=2:4;

experiments{172}.gridpath='../../../data_tirf/201217 control experiments/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 2s interval flow_1/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 2s interval flow_1_MMStack.ome.tif';
experiments{172}.gridFrame=10;
experiments{172}.noiseTreshold = 3;
experiments{172}.timeStep=2;
experiments{172}.startframeFit=4;
experiments{172}.endframeFit=39;
experiments{172}.numSlopePoints=3;
experiments{172}.DNAChannelBegin=1;
experiments{172}.coLocFrames=2:4;


experiments{173}.gridpath='../../../data_tirf/201217 control experiments/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 2s interval flow_1/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 2s interval flow_1_MMStack.ome.tif';
experiments{173}.gridFrame=10;
experiments{173}.noiseTreshold = 3;
experiments{173}.timeStep=2;
experiments{173}.startframeFit=5;
experiments{173}.endframeFit=45;
experiments{173}.numSlopePoints=3;
experiments{173}.DNAChannelBegin=1;
experiments{173}.coLocFrames=2:4;

% non operator DNA 2020-12-17 6s
experiments{174}.gridpath='../../../data_tirf/201217 control experiments/S2 RS90 LacI Far2 0.5nM R1G1 6s interval flow_1/S2 RS90 LacI Far2 0.5nM R1G1 6s interval flow_1_MMStack.ome.tif';
experiments{174}.gridFrame=10;
experiments{174}.noiseTreshold = 3;
experiments{174}.timeStep=6;
experiments{174}.startframeFit=10;
experiments{174}.endframeFit=45;
experiments{174}.numSlopePoints=3;
experiments{174}.DNAChannelBegin=1;
experiments{174}.coLocFrames=1:2;

experiments{175}.gridpath='../../../data_tirf/201217 control experiments/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 6s interval flow_1/S3 RS90 LacI Far2 0.5nM R1G1 NaCl 50mM 6s interval flow_1_MMStack.ome.tif';
experiments{175}.gridFrame=10;
experiments{175}.noiseTreshold = 3;
experiments{175}.timeStep=6;
experiments{175}.startframeFit=10;
experiments{175}.endframeFit=25;
experiments{175}.numSlopePoints=3;
experiments{175}.DNAChannelBegin=1;
experiments{175}.coLocFrames=1:2;

experiments{176}.gridpath='../../../data_tirf/201217 control experiments/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 6s interval flow_1/S4 RS90 LacI Far2 0.5nM R1G1 NaCl 100mM 6s interval flow_1_MMStack.ome.tif';
experiments{176}.gridFrame=10;
experiments{176}.noiseTreshold = 3;
experiments{176}.timeStep=6;
experiments{176}.startframeFit=10;
experiments{176}.endframeFit=39;
experiments{176}.numSlopePoints=3;
experiments{176}.DNAChannelBegin=1;
experiments{176}.coLocFrames=1:2;

experiments{177}.gridpath='../../../data_tirf/201217 control experiments/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 6s interval flow_1/S5 RS90 LacI Far2 0.5nM R1G1 NaCl 300mM 6s interval flow_1_MMStack.ome.tif';
experiments{177}.gridFrame=10;
experiments{177}.noiseTreshold = 3;
experiments{177}.timeStep=6;
experiments{177}.startframeFit=10;
experiments{177}.endframeFit=45;
experiments{177}.numSlopePoints=3;
experiments{177}.DNAChannelBegin=1;
experiments{177}.coLocFrames=1:2;

% O3 repeat 2105110 2s
experiments{178}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S1 O3 Far2 0.5nM NaCl 1mM R1G1 1Hz 2s interval flow_1/S1 O3 Far2 0.5nM NaCl 1mM R1G1 1Hz 2s interval flow_1_MMStack.ome-1.tif';
experiments{178}.gridFrame=10;
experiments{178}.noiseTreshold = 3;
experiments{178}.timeStep=2;
experiments{178}.startframeFit=8;
experiments{178}.endframeFit=45;
experiments{178}.numSlopePoints=3;
experiments{178}.DNAChannelBegin=1;
experiments{178}.coLocFrames=1:2;

experiments{179}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S2 O3 Far2 0.5nM NaCl 5mM R1G1 1Hz 2s interval flow_1/S2 O3 Far2 0.5nM NaCl 5mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{179}.gridFrame=10;
experiments{179}.noiseTreshold = 3;
experiments{179}.timeStep=2;
experiments{179}.startframeFit=9;
experiments{179}.endframeFit=45;
experiments{179}.numSlopePoints=3;
experiments{179}.DNAChannelBegin=1;
experiments{179}.coLocFrames=1:2;

experiments{180}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S3 O3 Far2 0.5nM NaCl 10mM R1G1 1Hz 2s interval flow_1/S3 O3 Far2 0.5nM NaCl 10mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{180}.gridFrame=15;
experiments{180}.noiseTreshold = 3;
experiments{180}.timeStep=2;
experiments{180}.startframeFit=10;
experiments{180}.endframeFit=25;
experiments{180}.numSlopePoints=3;
experiments{180}.DNAChannelBegin=1;
experiments{180}.coLocFrames=1:2;

experiments{181}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S4 O3 Far2 0.5nM NaCl 15mM R1G1 1Hz 2s interval flow_1/S4 O3 Far2 0.5nM NaCl 15mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{181}.gridFrame=10;
experiments{181}.noiseTreshold = 3;
experiments{181}.timeStep=2;
experiments{181}.startframeFit=9;
experiments{181}.endframeFit=39;
experiments{181}.numSlopePoints=3;
experiments{181}.DNAChannelBegin=1;
experiments{181}.coLocFrames=1:2;

experiments{182}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S5 O3 Far2 0.5nM NaCl 20mM R1G1 1Hz 2s interval flow_1/S5 O3 Far2 0.5nM NaCl 20mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{182}.gridFrame=10;
experiments{182}.noiseTreshold = 3;
experiments{182}.timeStep=2;
experiments{182}.startframeFit=9;
experiments{182}.endframeFit=45;
experiments{182}.numSlopePoints=3;
experiments{182}.DNAChannelBegin=1;
experiments{182}.coLocFrames=1:2;

experiments{183}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S6 O3 Far2 0.5nM NaCl 25mM R1G1 1Hz 2s interval flow_1/S6 O3 Far2 0.5nM NaCl 25mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{183}.gridFrame=10;
experiments{183}.noiseTreshold = 3;
experiments{183}.timeStep=2;
experiments{183}.startframeFit=11;
experiments{183}.endframeFit=25;
experiments{183}.numSlopePoints=3;
experiments{183}.DNAChannelBegin=1;
experiments{183}.coLocFrames=1:2;

experiments{184}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S7 O3 Far2 0.5nM NaCl 30mM R1G1 1Hz 2s interval flow_1/S7 O3 Far2 0.5nM NaCl 30mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{184}.gridFrame=15;
experiments{184}.noiseTreshold = 3;
experiments{184}.timeStep=2;
experiments{184}.startframeFit=10;
experiments{184}.endframeFit=39;
experiments{184}.numSlopePoints=3;
experiments{184}.DNAChannelBegin=1;
experiments{184}.coLocFrames=1:2;

experiments{185}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S8 O3 Far2 0.5nM NaCl 35mM R1G1 1Hz 2s interval flow_1/S8 O3 Far2 0.5nM NaCl 35mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{185}.gridFrame=15;
experiments{185}.noiseTreshold = 3;
experiments{185}.timeStep=2;
experiments{185}.startframeFit=7;
experiments{185}.endframeFit=45;
experiments{185}.numSlopePoints=3;
experiments{185}.DNAChannelBegin=1;
experiments{185}.coLocFrames=1:2;

experiments{186}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S9 O3 Far2 0.5nM NaCl 40mM R1G1 1Hz 2s interval flow_1/S9 O3 Far2 0.5nM NaCl 40mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{186}.gridFrame=10;
experiments{186}.noiseTreshold = 3;
experiments{186}.timeStep=2;
experiments{186}.startframeFit=18;
experiments{186}.endframeFit=39;
experiments{186}.numSlopePoints=3;
experiments{186}.DNAChannelBegin=1;
experiments{186}.coLocFrames=1:2;

experiments{187}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S10 O3 Far2 0.5nM NaCl 50mM R1G1 1Hz 2s interval flow_1/S10 O3 Far2 0.5nM NaCl 50mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{187}.gridFrame=10;
experiments{187}.noiseTreshold = 3;
experiments{187}.timeStep=2;
experiments{187}.startframeFit=10;
experiments{187}.endframeFit=45;
experiments{187}.numSlopePoints=3;
experiments{187}.DNAChannelBegin=1;
experiments{187}.coLocFrames=1:2;

experiments{188}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S11 O3 Far2 0.5nM NaCl 60mM R1G1 1Hz 2s interval flow_1/S11 O3 Far2 0.5nM NaCl 60mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{188}.gridFrame=10;
experiments{188}.noiseTreshold = 3;
experiments{188}.timeStep=2;
experiments{188}.startframeFit=9;
experiments{188}.endframeFit=25;
experiments{188}.numSlopePoints=3;
experiments{188}.DNAChannelBegin=1;
experiments{188}.coLocFrames=1:2;

experiments{189}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S12 O3 Far2 0.5nM NaCl 70mM R1G1 1Hz 2s interval flow_1/S12 O3 Far2 0.5nM NaCl 70mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{189}.gridFrame=10;
experiments{189}.noiseTreshold = 3;
experiments{189}.timeStep=2;
experiments{189}.startframeFit=10;
experiments{189}.endframeFit=39;
experiments{189}.numSlopePoints=3;
experiments{189}.DNAChannelBegin=1;
experiments{189}.coLocFrames=1:2;

experiments{190}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S13 O3 Far2 0.5nM NaCl 80mM R1G1 1Hz 2s interval flow_1/S13 O3 Far2 0.5nM NaCl 80mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{190}.gridFrame=10;
experiments{190}.noiseTreshold = 3;
experiments{190}.timeStep=2;
experiments{190}.startframeFit=12;
experiments{190}.endframeFit=45;
experiments{190}.numSlopePoints=3;
experiments{190}.DNAChannelBegin=1;
experiments{190}.coLocFrames=1:2;

experiments{191}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S14 O3 Far2 0.5nM NaCl 90mM R1G1 1Hz 2s interval flow_1/S14 O3 Far2 0.5nM NaCl 90mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{191}.gridFrame=15;
experiments{191}.noiseTreshold = 3;
experiments{191}.timeStep=2;
experiments{191}.startframeFit=13;
experiments{191}.endframeFit=39;
experiments{191}.numSlopePoints=3;
experiments{191}.DNAChannelBegin=1;
experiments{191}.coLocFrames=1:2;

experiments{192}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S15 O3 Far2 0.5nM NaCl 100mM R1G1 1Hz 2s interval flow_1/S15 O3 Far2 0.5nM NaCl 100mM R1G1 1Hz 2s interval flow_1_MMStack.ome.tif';
experiments{192}.gridFrame=15;
experiments{192}.noiseTreshold = 3;
experiments{192}.timeStep=2;
experiments{192}.startframeFit=10;
experiments{192}.endframeFit=45;
experiments{192}.numSlopePoints=3;
experiments{192}.DNAChannelBegin=1;
experiments{192}.coLocFrames=1:2;

% O3 210510 6s
experiments{193}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S1 O3 Far2 0.5nM NaCl 1mM R1G1 1Hz 6s interval flow_1/S1 O3 Far2 0.5nM NaCl 1mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{193}.gridFrame=10;
experiments{193}.noiseTreshold = 3;
experiments{193}.timeStep=6;
experiments{193}.startframeFit=10;
experiments{193}.endframeFit=45;
experiments{193}.numSlopePoints=3;
experiments{193}.DNAChannelBegin=1;
experiments{193}.coLocFrames=1:2;

experiments{194}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S2 O3 Far2 0.5nM NaCl 5mM R1G1 1Hz 6s interval flow_1/S2 O3 Far2 0.5nM NaCl 5mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{194}.gridFrame=10;
experiments{194}.noiseTreshold = 3;
experiments{194}.timeStep=6;
experiments{194}.startframeFit=10;
experiments{194}.endframeFit=45;
experiments{194}.numSlopePoints=3;
experiments{194}.DNAChannelBegin=1;
experiments{194}.coLocFrames=1:2;

experiments{195}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S3 O3 Far2 0.5nM NaCl 10mM R1G1 1Hz 6s interval flow_1/S3 O3 Far2 0.5nM NaCl 10mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{195}.gridFrame=10;
experiments{195}.noiseTreshold = 3;
experiments{195}.timeStep=6;
experiments{195}.startframeFit=10;
experiments{195}.endframeFit=25;
experiments{195}.numSlopePoints=3;
experiments{195}.DNAChannelBegin=1;
experiments{195}.coLocFrames=1:2;

experiments{196}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S4 O3 Far2 0.5nM NaCl 15mM R1G1 1Hz 6s interval flow_1/S4 O3 Far2 0.5nM NaCl 15mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{196}.gridFrame=10;
experiments{196}.noiseTreshold = 3;
experiments{196}.timeStep=6;
experiments{196}.startframeFit=10;
experiments{196}.endframeFit=39;
experiments{196}.numSlopePoints=3;
experiments{196}.DNAChannelBegin=1;
experiments{196}.coLocFrames=1:2;

experiments{197}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S5 O3 Far2 0.5nM NaCl 20mM R1G1 1Hz 6s interval flow_1/S5 O3 Far2 0.5nM NaCl 20mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{197}.gridFrame=10;
experiments{197}.noiseTreshold = 3;
experiments{197}.timeStep=6;
experiments{197}.startframeFit=10;
experiments{197}.endframeFit=45;
experiments{197}.numSlopePoints=3;
experiments{197}.DNAChannelBegin=1;
experiments{197}.coLocFrames=1:2;

experiments{198}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S6 O3 Far2 0.5nM NaCl 25mM R1G1 1Hz 6s interval flow_1/S6 O3 Far2 0.5nM NaCl 25mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{198}.gridFrame=10;
experiments{198}.noiseTreshold = 3;
experiments{198}.timeStep=6;
experiments{198}.startframeFit=10;
experiments{198}.endframeFit=25;
experiments{198}.numSlopePoints=3;
experiments{198}.DNAChannelBegin=1;
experiments{198}.coLocFrames=1:2;

experiments{199}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S7 O3 Far2 0.5nM NaCl 30mM R1G1 1Hz 6s interval flow_1/S7 O3 Far2 0.5nM NaCl 30mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{199}.gridFrame=10;
experiments{199}.noiseTreshold = 3;
experiments{199}.timeStep=6;
experiments{199}.startframeFit=10;
experiments{199}.endframeFit=39;
experiments{199}.numSlopePoints=3;
experiments{199}.DNAChannelBegin=1;
experiments{199}.coLocFrames=1:2;

experiments{200}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S8 O3 Far2 0.5nM NaCl 35mM R1G1 1Hz 6s interval flow_2/S8 O3 Far2 0.5nM NaCl 35mM R1G1 1Hz 6s interval flow_2_MMStack.ome.tif';
experiments{200}.gridFrame=10;
experiments{200}.noiseTreshold = 3;
experiments{200}.timeStep=6;
experiments{200}.startframeFit=10;
experiments{200}.endframeFit=45;
experiments{200}.numSlopePoints=3;
experiments{200}.DNAChannelBegin=1;
experiments{200}.coLocFrames=1:2;

experiments{201}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S9 O3 Far2 0.5nM NaCl 40mM R1G1 1Hz 6s interval flow_1/S9 O3 Far2 0.5nM NaCl 40mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{201}.gridFrame=10;
experiments{201}.noiseTreshold = 3;
experiments{201}.timeStep=6;
experiments{201}.startframeFit=10;
experiments{201}.endframeFit=39;
experiments{201}.numSlopePoints=3;
experiments{201}.DNAChannelBegin=1;
experiments{201}.coLocFrames=1:2;

experiments{202}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S10 O3 Far2 0.5nM NaCl 50mM R1G1 1Hz 6s interval flow_1/S10 O3 Far2 0.5nM NaCl 50mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{202}.gridFrame=10;
experiments{202}.noiseTreshold = 3;
experiments{202}.timeStep=6;
experiments{202}.startframeFit=10;
experiments{202}.endframeFit=45;
experiments{202}.numSlopePoints=3;
experiments{202}.DNAChannelBegin=1;
experiments{202}.coLocFrames=1:2;

experiments{203}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S11 O3 Far2 0.5nM NaCl 60mM R1G1 1Hz 6s interval flow_1/S11 O3 Far2 0.5nM NaCl 60mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{203}.gridFrame=10;
experiments{203}.noiseTreshold = 3;
experiments{203}.timeStep=6;
experiments{203}.startframeFit=10;
experiments{203}.endframeFit=25;
experiments{203}.numSlopePoints=3;
experiments{203}.DNAChannelBegin=1;
experiments{203}.coLocFrames=1:2;

experiments{204}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S12 O3 Far2 0.5nM NaCl 70mM R1G1 1Hz 6s interval flow_1/S12 O3 Far2 0.5nM NaCl 70mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{204}.gridFrame=10;
experiments{204}.noiseTreshold = 3;
experiments{204}.timeStep=6;
experiments{204}.startframeFit=10;
experiments{204}.endframeFit=39;
experiments{204}.numSlopePoints=3;
experiments{204}.DNAChannelBegin=1;
experiments{204}.coLocFrames=1:2;

experiments{205}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S13 O3 Far2 0.5nM NaCl 80mM R1G1 1Hz 6s interval flow_1/S13 O3 Far2 0.5nM NaCl 80mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{205}.gridFrame=10;
experiments{205}.noiseTreshold = 3;
experiments{205}.timeStep=6;
experiments{205}.startframeFit=10;
experiments{205}.endframeFit=45;
experiments{205}.numSlopePoints=3;
experiments{205}.DNAChannelBegin=1;
experiments{205}.coLocFrames=1:2;

experiments{206}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S14 O3 Far2 0.5nM NaCl 90mM R1G1 1Hz 6s interval flow_1/S14 O3 Far2 0.5nM NaCl 90mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{206}.gridFrame=10;
experiments{206}.noiseTreshold = 3;
experiments{206}.timeStep=6;
experiments{206}.startframeFit=10;
experiments{206}.endframeFit=39;
experiments{206}.numSlopePoints=3;
experiments{206}.DNAChannelBegin=1;
experiments{206}.coLocFrames=1:2;

experiments{207}.gridpath='../../../data_tirf/20210507 Far2 O3 titration IB3 buffer/S15 O3 Far2 0.5nM NaCl 100mM R1G1 1Hz 6s interval flow_1/S15 O3 Far2 0.5nM NaCl 100mM R1G1 1Hz 6s interval flow_1_MMStack.ome.tif';
experiments{207}.gridFrame=10;
experiments{207}.noiseTreshold = 3;
experiments{207}.timeStep=6;
experiments{207}.startframeFit=10;
experiments{207}.endframeFit=45;
experiments{207}.numSlopePoints=3;
experiments{207}.DNAChannelBegin=1;
experiments{207}.coLocFrames=1:2;

numSaltsVec=[6*ones(1,23) 7*ones(1,3) 4 4 1 1 4 4 15 15];
numSalts=6;

numExps=numel(experiments);
allExpInds=1:numExps;
numCurves=numel(numSaltsVec);%numExps/numSalts;
setIndexes=cell(numCurves,1);
k=1;
for i=1:23
    
    setIndexes{i}=allExpInds(k:k+numSalts-1);
    k=k+numSalts;
    
end  


numSalts2=7;
for i=24:26
    
    setIndexes{i}=allExpInds(k:k+numSalts2-1);
    k=k+numSalts2;
    
end  

numSalts3=4;
for i=27:28
    
    setIndexes{i}=allExpInds(k:k+numSalts3-1);
    k=k+numSalts3;
    
end  

numSalts4=1;
for i=29:30
    
    setIndexes{i}=allExpInds(k:k+numSalts4-1);
    k=k+numSalts4;
    
end 

numSalts5=4;
for i=31:32
    
    setIndexes{i}=allExpInds(k:k+numSalts5-1);
    k=k+numSalts5;
    
end 

numSalts5=15;
for i=33:34
    
    setIndexes{i}=allExpInds(k:k+numSalts5-1);
    k=k+numSalts5;
    
end 
%%
for i=1:numExps
    experiments{i}.dobackgroundCalc=1;
    experiments{i}.doDotdetect=0;
    experiments{i}.doTracking=0;
     experiments{i}.doPolInt=0;
     experiments{i}.doDotdetectCoLoc=1;
    experiments{i}.doTrackingCoLoc=1;
     experiments{i}.doPolIntCoLoc=1;
     
     
end


%% Start analysis



tic;
test=0;
xTransAll=zeros(1,numExps);
yTransAll=zeros(1,numExps);
%%
parfor theExp=expsToAnalyse
    %% Set the parameters for this experiment
    %pause(mod(theExp,10)*10);
    if isSim==0
        xTrans=0;
        yTrans=0;
        
    end
    
    noiseTreshold = experiments{theExp}.noiseTreshold; % For getDot(), 3 for example
    waveletPlane=experiments{theExp}.waveletPlane;% For dot detection
    scale = experiments{theExp}.scale; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
    deltat =experiments{theExp}.deltat; %in ms
    Dimension =experiments{theExp}.Dimension;%Of camera
    yMax=experiments{theExp}.yMax;%szie of image
    xMax=experiments{theExp}.xMax;%size of image
    backgroundparam=experiments{theExp}.backgroundparam;
    coLocFrames=experiments{theExp}.coLocFrames;
    
    % paramters for classifciation of sliding
    
    
    
    
    imOrders=experiments{theExp}.imOrders;
    gridpath=experiments{theExp}.gridpath;
    %datapath=experiments{theExp}.datapath;
    datapath=gridpath;
    imscale=experiments{theExp}.imscale;
    gridFrame=experiments{theExp}.gridFrame;
    
   
    
    %% Extract polarization images and get translation of images from grid
    if isSim==0
    thegrid=imrotate(imread(gridpath,gridFrame),anglerot);
    %thegrid=IMG{7}(:,:,100);
    %thegrid=IMG{1}(:,:,50);
    figure();
    [xTrans,yTrans,xForward,yForward,xBackward,yBackward]=getTranslationFromGridSkipTop(thegrid,0,imgTop,imgMid);
    disp(['Image registration for experiment :' num2str(theExp) ' xTrans: ' num2str(xTrans) 'yTrans :' num2str(yTrans)]);
    windowLims=zeros(1,4);
    
    newxMax=xMax-abs(round(xTrans));
    newyMax=yMax-abs(round(yTrans));
    
%     if xTrans>0
%         windowLims(1)=1+parameters.square+safety;
%         windowLims(2)=newxMax-parameters.square-safety;
%     else
%         windowLims(1)=1+parameters.square+safety;
%         windowLims(2)=newxMax-parameters.square-safety;
%     end
%     if yTrans>0
%         windowLims(3)=1+parameters.square+safety;
%         windowLims(4)=newyMax-parameters.square-safety;
%     else
%         windowLims(3)=1+parameters.square+safety;
%         windowLims(4)=newyMax-parameters.square-safety;
%     end
    % newWindowLims is windowLims without the square (radius of dot)
    % removed, used when border is handled in dotdetection instead of after
    %newWindowLims=[windowLims(1)-parameters.square windowLims(2)+parameters.square windowLims(3)-parameters.square windowLims(4)+parameters.square];
    %parameters.windowLims=windowLims;
    experiments{theExp}.xTransCalc=xTrans;
    experiments{theExp}.yTransCalc=yTrans;
    
    %Paramters for Remove edge of polarization images before dot detection
    %(where the second poalrization image has 0 values)
    elseif isSim==1
        experiments{theExp}.xTrans=0;
        experiments{theExp}.yTrans=0;
        
    end
    
    xTransAll(theExp)=xTrans;
    yTransAll(theExp)=yTrans;
    
end

%%
xTransToUse=zeros(1,numExps);
yTransToUse=zeros(1,numExps);

for i=1:numel(setIndexes)
   currExpInds=setIndexes{i};
   currXTrans=median(xTransAll(currExpInds));
   currYTrans=median(yTransAll(currExpInds));
    for j=currExpInds
        xTransToUse(j)=currXTrans;
        yTransToUse(j)=currYTrans;
        
        experiments{j}.xTrans=currXTrans;
        experiments{j}.yTrans=currYTrans;
    end
end    
%%

makeExampleMovie=0;
parfor theExp=expsToAnalyse
    %% Load Img
    
     %% Set the parameters for this experiment
    %pause(mod(theExp,10)*10);
    if isSim==0
        dnaCoordsCell=[];
        
    end
    
    noiseTreshold = experiments{theExp}.noiseTreshold; % For getDot(), 3 for example
    waveletPlane=experiments{theExp}.waveletPlane;% For dot detection
    scale = experiments{theExp}.scale; %Length of Pixel in nm (16 um/200), for buildTrajectoris2D
    deltat =experiments{theExp}.deltat; %in ms
    Dimension =experiments{theExp}.Dimension;%Of camera
    yMax=experiments{theExp}.yMax;%szie of image
    xMax=experiments{theExp}.xMax;%size of image
    backgroundparam=experiments{theExp}.backgroundparam;
    coLocFrames=experiments{theExp}.coLocFrames;
    xTrans=experiments{theExp}.xTrans;
    yTrans=experiments{theExp}.yTrans;
    
    
    % paramters for classifciation of sliding
    
    
    
    
    imOrders=experiments{theExp}.imOrders;
    gridpath=experiments{theExp}.gridpath;
    %datapath=experiments{theExp}.datapath;
    datapath=gridpath;
    imscale=experiments{theExp}.imscale;
    gridFrame=experiments{theExp}.gridFrame;
    
   
    disp(['Analysing experiment nr : ' num2str(theExp) ' found in folder : ' datapath]);
    
    dirs=dir([datapath]);
    numStacks = length(dirs);
    experiments{theExp}.numStacks=numStacks;
    IMG=cell(1,numStacks);
    % if ~exist('Stacks')
    Stacks=cell(1,numStacks);
    %end
    numFrames=0;
    startframe=experiments{theExp}.startframe*ones(1,numStacks);
    fluorIMGS=cell(1,numStacks);
    backgroundallFrames=cell(1,numStacks);
    DotsCoor=cell(1,numStacks);
    DotsCoorCoLoc=cell(1,numStacks);
    %%
    if test==0
        try
            %%
            for stack=1:numStacks
                %pause different workers for different times to not use so much
                %memory
                
                % pause(mod(stack,10)*10);
                disp(['loading stack nr: ' num2str(theExp) ' with file name: ' num2str(dirs(stack).name)]);
                
                %imfolder = [datapath '/' dirs(stack).name];
                %im = dir([imfolder '/*.tif']);
                im = dir(datapath);
                
                %Extract the number of frames from the tiff file's information. The
                %number of columns in structure is equal to the number of frames.
                %imageInfo=imfinfo([imfolder '/' im.name]);
                
                imageInfo=imfinfo(datapath);
                numFrames=length(imageInfo);
                
                %Pre-size the movie matrix
                imSize=[imageInfo(1).Height,imageInfo(1).Width,numFrames-startframe(stack)+1];
                %myMovie=ones(zeros(imSize));
                IMG{stack} = zeros(imSize);
                k=1;
                
                for frame=startframe(stack):numFrames
                    %90 deg rotation added
                    IMG{stack}(:,:,k)=imrotate(imread(datapath,frame),anglerot);
                    if trans
                        IMG{stack}(:,:,k)=IMG{stack}(:,:,k)';
                    end
                    k=k+1;
                end
                
                %% Get Pol Image according to translation data
                
                disp(['Extracting fluor channel images for stack : ' num2str(theExp)]);
                if isSim==0
                    fluorIMGS{stack}=stackHalfImagesEliasRemoveEdgeSkipTop(IMG{stack},xTrans,yTrans,xMax,yMax,imgTop,imgMid); % Change so that different images returned in different variables
                    if experiments{theExp}.DNAChannelBegin==0
                        tempIMGS=fluorIMGS{stack};
                        fluorIMGS{stack}=zeros(size(tempIMGS,1),size(tempIMGS,2),2,ceil(numFrames/2));
                        k=1;
                        for frame =1:numFrames
                            if mod(frame,2)==0
                                fluorIMGS{stack}(:,:,1,k)=tempIMGS(:,:,1,frame-1);
                                fluorIMGS{stack}(:,:,2,k)=tempIMGS(:,:,2,frame);
                                k=k+1;
                            end
                            
                        end
                    end
                elseif isSim==1 %JFor simplcity to make it go through the same pipeline as experimental data, set both fluorescence images the same
                    [xDim,yDim,~]=size(IMG{stack});
                    fluorIMGS{stack}=zeros(xDim,yDim,2,numFrames);
                    
                    for frame=1:numFrames
                        fluorIMGS{stack}(:,:,1,frame)=IMG{stack}(:,:,frame);
                        fluorIMGS{stack}(:,:,2,frame)=IMG{stack}(:,:,frame);
                        
                    end
                    
                end
                
                IMG{stack}=[];
                
                %% Calculate background
                
                
                if experiments{theExp}.dobackgroundCalc
                    disp(['Calculating background for stack: ' num2str(theExp)]);
                    [~,~,~,stackL]=size(fluorIMGS{stack});
                    backgroundstartframe=round(backgroundparam*stackL)+1;
                    %          %backgroundall{stack}{1} = smoothn(mean(POLIMGS{stack}(:,:,1,:),4),parameters.smoothparam,'robust');
                    %          %backgroundall{stack}{2} = smoothn(mean(POLIMGS{stack}(:,:,2,:),4),parameters.smoothparam,'robust');
                    bgFrames=cell(2,1);
                    for index=backgroundstartframe:stackL
                        %backgroundallFrames{stack}{1,index}=zeros(size(POLIMGS{stack}(:,:,1,1)));
                        %backgroundallFrames{stack}{2,index}=zeros(size(POLIMGS{stack}(:,:,1,1)));
                        bgFrames{1}(:,:,index) =smoothn(fluorIMGS{stack}(:,:,1,index),parameters.smoothparam,'robust');
                        bgFrames{2}(:,:,index) =smoothn(fluorIMGS{stack}(:,:,2,index),parameters.smoothparam,'robust');
                    end
                    bgMeans=zeros(1,stackL-backgroundstartframe+1);
                    for index=backgroundstartframe:stackL
                        temp=bgFrames{2}(:,:,index);
                        bgMeans(index)=mean(temp(:));
                    end
                    experiments{theExp}.bgMeans=bgMeans;
                    
                    
                else
                    %bgFrames=experiments{theExp}.backgroundallFrames;
                    bgFrames=[];
                end
                
               
%                                      figure();
%                                      exampleImgInd=2; % pol img index, 1 or 2
%                                      imagesc(bgFrames{exampleImgInd}(:,:,300),[400 12000]);
%                                      axis equal;
%                                      colormap(gray);
%                                      colorbar;
%                                      title('Example background');
%                                      figure();
%                                       plot(fluorIMGS{stack}(192,:,exampleImgInd,300));
%                                       hold on;
%                                      plot(bgFrames{exampleImgInd}(192,:,300),'r');
%                                      figure();
%                                       exampleImgInd=2; % pol img index, 1 or 2
%                                      imagesc(mean(fluorIMGS{stack}(:,:,2,:),4),[400 12000]);
%                                       axis equal;
%                                       colormap(gray);
%                                       colorbar;
%                                       title('average image');
%                 
                
                
                %% Calcualte sum of polIMGS to use for dot detection
                %disp(['calculating imagesum for stack: ' num2str(stack)]);
                %[~,~,~,stackL]=size(POLIMGS{stack});
                % calculate IMG sum
                Stacks{stack}.imageStack1=reshape(fluorIMGS{stack}(:,:,1,:),[size(fluorIMGS{stack},1) size(fluorIMGS{stack},2) size(fluorIMGS{stack},4)]);
                Stacks{stack}.imageStack2=reshape(fluorIMGS{stack}(:,:,2,:),[size(fluorIMGS{stack},1) size(fluorIMGS{stack},2) size(fluorIMGS{stack},4)]);
                
                if makeExampleMovie==1
                   xLoc=275:325;
                   yLoc=175:225;
                    imwrite(uint16(Stacks{stack}.imageStack1(yLoc,xLoc,1)),['Experiment: ' num2str(theExp) 'example Cy5.tif']);
                    imwrite(uint16(Stacks{stack}.imageStack2(yLoc,xLoc,1)),['Experiment: ' num2str(theExp) 'example Cy3.tif']);
                    for frame=2:size(Stacks{stack}.imageStack2,3)
                         imwrite(uint16(Stacks{stack}.imageStack1(yLoc,xLoc,1)),['Experiment: ' num2str(theExp) 'example Cy5.tif'],'WriteMode','append');
                        imwrite(uint16(Stacks{stack}.imageStack2(yLoc,xLoc,frame)),['Experiment: ' num2str(theExp) 'example Cy3.tif'],'WriteMode','append');
                    end
                    
                end
                
                %% DO dot detection
                if experiments{theExp}.doDotdetect
                    disp(['Doing dot detection for stack nr:' num2str(theExp)]);
                    % Handling border (don't detect dots here) in do detection
                    % instead of after traj building
                    %mask=zeros(yMax,xMax,stackL);
                    %mask(newWindowLims(3):newWindowLims(4),newWindowLims(1):newWindowLims(2),:)=ones(newWindowLims(4)-newWindowLims(3)+1,newWindowLims(2)-newWindowLims(1)+1,stackL);
                    bgRem=Stacks{stack}.imageStack2(:,:,:)-bgFrames{2}(:,:,:);
                    
                    for i=1:size(bgRem,3)
                        bgRem(:,:,i)=bgRem(:,:,i)-min(min(bgRem(:,:,i)));
                        
                    end
                    
                    Stacks{stack}.dots=BuildTrajectories.getDotsSelPlane_ver3(bgRem,noiseTreshold,showdots,waveletPlane,imscale);
                    
                    
    
                    %Stacks{stack}.dots=BuildTrajectories.getDotsFRS(Stacks{stack}.imageStack,[1 2 3],2,0,2,10,showdots);
                    %getDotsFRS(imageStack,radii,alphaParameter,betaParameter,radiusForThreshold,thresholdParameter,showDots)
                    %DotsCoor{stack}=Stacks{stack}.dots;
                else
                    %Stacks{stack}.dots=experiments{theExp}.Stacks{stack}.dots;
                end
                %% Do tracking
                if experiments{theExp}.doTracking
                    disp(['Building trajsfor stack nr:' num2str(theExp)]);
                    Stacks{stack}.finalTraj = BuildTrajectories.buildTrajectories(Stacks{stack}.dots,size(Stacks{stack}.imageStack2,3), parameters );
                    
                    
                    for i = 1:length(Stacks{stack}.finalTraj)
                        [l,~]=size(Stacks{stack}.finalTraj{i});
                        Stacks{stack}.finalTraj{i} = [Stacks{stack}.finalTraj{i} stack*ones(l,1) zeros(l,4)]; % 6th column is stack index,col 7 set to NaN later if a gap ehre , col 8 is intensity in pol channel 1, col 9 is intensity in pol channel 2, col 10 is error to be calcualted from gain
                    end
                else
                   % Stacks{stack}.finalTraj=experiments{theExp}.Stacks{stack}.finalTraj;
                end
                
                %% DO dot detection in DNA channel
                if isSim==0
                    if experiments{theExp}.doDotdetectCoLoc
                        disp(['Doing dot detection in DNA channel for stack nr:' num2str(theExp)]);
                        % Handling border (don't detect dots here) in do detection
                        % instead of after traj building
                        %mask=zeros(yMax,xMax,stackL);
                        %mask(newWindowLims(3):newWindowLims(4),newWindowLims(1):newWindowLims(2),:)=ones(newWindowLims(4)-newWindowLims(3)+1,newWindowLims(2)-newWindowLims(1)+1,stackL);
                        
                        bgRem=Stacks{stack}.imageStack1(:,:,coLocFrames)-bgFrames{1}(:,:,coLocFrames);
                        
                        for i=1:size(bgRem,3)
                            bgRem(:,:,i)=bgRem(:,:,i)-min(min(bgRem(:,:,i)));
                            
                        end
                        
                        
                        if doMockDNA(theExp)==0
                            
                            Stacks{stack}.dotsCoLoc=BuildTrajectories.getDotsSelPlane_ver3(bgRem,noiseTreshold,showdots,waveletPlane,imscale);
                        elseif doMockDNA(theExp)==1
                            
                            avgMask=mean(bgRem,3);
                            avgMask=avgMask-min(min(avgMask));
                            
                            noDNApixels=avgMask<cutoffNoFluo;
                            noDNApixelsVec=noDNApixels(:);
                            okIndexes=find(noDNApixelsVec>0);
                            
                            numOkLocs=numel(okIndexes);
                            dnaMockCoords=zeros(numMockLoc,2);
                            rng(theExp);
                            for i=1:numMockLoc
                                randInd=ceil(rand()*numOkLocs);
                            
                                locInd=okIndexes(randInd);
                                [row,col]=ind2sub(size(noDNApixels),locInd);
                                %intenVal(i)=avgMask(row,col);
                                dnaMockCoords(i,:)=[col row];
                            end
                            
                            numDNAs=numMockLoc;
                            Stacks{stack}.dotsCoLoc=zeros(numel(coLocFrames)*numDNAs,4);
                            k=1;
                            for i = coLocFrames
                                Stacks{stack}.dotsCoLoc(k:k+numDNAs-1,:) =[ dnaMockCoords i*ones(numDNAs,1) ones(numDNAs,1)];
                                k=k+numDNAs;
                            end
                        end
                        
                        %Stacks{stack}.dots=BuildTrajectories.getDotsFRS(Stacks{stack}.imageStack,[1 2 3],2,0,2,10,showdots);
                        %getDotsFRS(imageStack,radii,alphaParameter,betaParameter,radiusForThreshold,thresholdParameter,showDots)
                        %DotsCoorCoLoc{stack}=Stacks{stack}.dotsCoLoc;
                    else
                        %Stacks{stack}.dotsCoLoc=experiments{theExp}.Stacks{stack}.dotsCoLoc;
                    end
                elseif isSim==1 %Get the DNA localisation from the simulation result
                    disp(['Getting DNA coordianted for stack nr' num2str(theExp)])
                    numDNAs=size(dnaCoordsCell{theExp},1);
                    rng(theExp);
                    %Add some noise to add uncerteinty in DNA localisation
                    %and image registration
                    dnaCoordsNew=dnaCoordsCell{theExp}(:,1:2)+randn(numDNAs,2)*DNALocNoise;
                    Stacks{stack}.dotsCoLoc=zeros(numel(coLocFrames)*numDNAs,4);
                    k=1;
                    for i = coLocFrames
                        Stacks{stack}.dotsCoLoc(k:k+numDNAs-1,:) =[ dnaCoordsNew i*ones(numDNAs,1) ones(numDNAs,1)];
                        k=k+numDNAs;
                    end
                end    
                
                %% Do tracking in DNA channel
                if experiments{theExp}.doTrackingCoLoc
                    disp(['Building trajs in DNA channel for stack nr:' num2str(theExp)]);
                    Stacks{stack}.finalTrajCoLoc = BuildTrajectories.buildTrajectories(Stacks{stack}.dotsCoLoc,numel(coLocFrames), parametersCoLoc );
                   % numRealFrames=size(fluorIMGS{stack},4);
                    numRealFrames=size(Stacks{stack}.imageStack1,3);
                    for i = 1:length(Stacks{stack}.finalTrajCoLoc)
                        [l,~]=size(Stacks{stack}.finalTrajCoLoc{i});
                        Stacks{stack}.finalTrajCoLoc{i} = [Stacks{stack}.finalTrajCoLoc{i} stack*ones(l,1) zeros(l,4)]; % 6th column is stack index,col 7 set to NaN later if a gap ehre , col 8 is intensity in pol channel 1, col 9 is intensity in pol channel 2, col 10 is error to be calcualted from gain
                        xPos=mean(Stacks{stack}.finalTrajCoLoc{i}(:,1));
                        yPos=mean(Stacks{stack}.finalTrajCoLoc{i}(:,2));
                        
                        Stacks{stack}.finalTrajCoLocAllFrames{i}=[xPos*ones(numRealFrames,1) yPos*ones(numRealFrames,1) Stacks{stack}.finalTrajCoLoc{i}(1,3)*ones(numRealFrames,1) [1:numRealFrames]' repmat(Stacks{stack}.finalTrajCoLoc{i}(1,5:end),numRealFrames,1)];
                        
                        
                    end
                else
                    %Stacks{stack}.finalTrajCoLoc=experiments{theExp}.Stacks{stack}.finalTrajCoLoc;
                end
                
                %% Calculate fluorescence intensity of trajectory
                
                if experiments{theExp}.doPolInt
                    disp(['Calcualting fluorescne intensities for trajectories in stack nr:' num2str(theExp)]);
                    numStacktrajs=length(Stacks{stack}.finalTraj);
                    trajStackInts=cell(1,numStacktrajs);
                    for i=1:numStacktrajs
                        trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},Stacks{stack}.finalTraj{i},square,bgFrames);
                        %trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},experiments{25}.alltrajs{i},square,bgFrames);
                        if imOrders==0 %(upper H lower V, to get PHV)
                            Stacks{stack}.finalTraj{i}(:,8:9)=trajStackInts{i};
                        elseif imOrders==1 %Reerse intensiti order (upper V lower H)
                            Stacks{stack}.finalTraj{i}(:,8:9)=trajStackInts{i}(:,[2 1]);
                        end
                    end
                    
                end
                if experiments{theExp}.doPolIntCoLoc
                    
                    disp(['Calcualting fluorescne intensities for DNA trajectories in stack nr:' num2str(theExp)]);
                    numStacktrajsCoLocAllFrames=length(Stacks{stack}.finalTrajCoLocAllFrames);
                    trajStackIntsCoLocAllFrames=cell(1,numStacktrajsCoLocAllFrames);
                    for i=1:numStacktrajsCoLocAllFrames
                        trajStackIntsCoLocAllFrames{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},Stacks{stack}.finalTrajCoLocAllFrames{i},square,bgFrames);
                        %trajStackInts{i}=polIntensitieswbgandGapPerFramever2(fluorIMGS{stack},experiments{25}.alltrajs{i},square,bgFrames);
                        if imOrders==0 %(upper H lower V, to get PHV)
                            Stacks{stack}.finalTrajCoLocAllFrames{i}(:,8:9)=trajStackIntsCoLocAllFrames{i};
                        elseif imOrders==1 %Reerse intensiti order (upper V lower H)
                            Stacks{stack}.finalTrajCoLocAllFrames{i}(:,8:9)=trajStackIntsCoLocAllFrames{i}(:,[2 1]);
                        end
                    end
                    
                    
                    
                end
                %Comment away if you wanna keep these images in memorey (to look at
                %in the plot GUI for example)
                fluorIMGS{stack}=[];
                Stacks{stack}.imageStack=[];
                Stacks{stack}.imageStack1=[];
                Stacks{stack}.imageStack2=[];
                backgroundallFrames{stack}=bgFrames;
                bgRem=[];
            end
            
            
            %% Finnish up trajecotires
            if experiments{theExp}.doTracking
                numtrajs=0;
                alltrajs=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajsfor stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTraj)
                        [l,~]=size(Stacks{stack}.finalTraj{i});
                        alltrajs{1,numtrajs+i} = [Stacks{stack}.finalTraj{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajs = numtrajs+length(Stacks{stack}.finalTraj);
                end
                rawtrajs=alltrajs;
                trajIndex=1:numtrajs;
                numtrajs=length(alltrajs);
                
                alltrajs=interpolateGaps(alltrajs);
                experiments{theExp}.numtrajs=numtrajs;
                experiments{theExp}.trajIndex=trajIndex;
                experiments{theExp}.rawtrajs=rawtrajs;
                experiments{theExp}.alltrajs=alltrajs;
                
            end
            
            if  experiments{theExp}.doTrackingCoLoc
                numtrajsCoLoc=0;
                alltrajsCoLoc=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajs CoLoc for stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTrajCoLoc)
                        [l,~]=size(Stacks{stack}.finalTrajCoLoc{i});
                        alltrajsCoLoc{1,numtrajsCoLoc+i} = [Stacks{stack}.finalTrajCoLoc{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajsCoLoc = numtrajsCoLoc+length(Stacks{stack}.finalTrajCoLoc);
                end
                rawtrajsCoLoc=alltrajsCoLoc;
                trajIndexCoLoc=1:numtrajsCoLoc;
                numtrajsCoLoc=length(alltrajsCoLoc);
                
                alltrajsCoLoc=interpolateGaps(alltrajsCoLoc);
                
                numtrajsCoLocAllFrames=0;
                alltrajsCoLocAllFrames=cell(1,1);
                for stack = 1:numStacks
                    disp(['Finnishing trajs CoLoc all frames for stack nr:' num2str(theExp)]);
                    % Stacks{stack}.finalTraj=removeEdgeTrajs(Stacks{stack}.finalTraj,parameters.windowLims);
                    for i = 1:length(Stacks{stack}.finalTrajCoLocAllFrames)
                        [l,~]=size(Stacks{stack}.finalTrajCoLocAllFrames{i});
                        alltrajsCoLocAllFrames{1,numtrajsCoLocAllFrames+i} = [Stacks{stack}.finalTrajCoLocAllFrames{i} stack*ones(l,1)]; % 6th column is stack index,
                    end
                    numtrajsCoLocAllFrames = numtrajsCoLocAllFrames+length(Stacks{stack}.finalTrajCoLocAllFrames);
                end
                rawtrajsCoLocAllFrames=alltrajsCoLocAllFrames;
                trajIndexCoLocAllFrames=1:numtrajsCoLocAllFrames;
                numtrajsCoLocAllFrames=length(alltrajsCoLocAllFrames);
                
                
                
             
                %clear alltrajs;
                experiments{theExp}.alltrajsCoLoc=alltrajsCoLoc;
                experiments{theExp}.alltrajsCoLocAllFrames=alltrajsCoLocAllFrames;
                %clear alltrajsCoLoc;
               
                
            end
            experiments{theExp}.Stacks=Stacks;
        catch le
            getReport(le)
            disp(['Failed at experiment ' num2str(theExp)]);
        end
        
        %%
        
        
        
        
    end 
end
analysisiTime=toc;
%%

%save([savepath 'results for parameters ' parameterset ' ' datestr(now)],'-v7.3');


%% Plotting and data interpretation analysis

for theExp=expsToAnalyse
    [~,okDNAInds]=selectTrajsonL(experiments{theExp}.alltrajsCoLoc,analyseLengthCoLocVec(theExp),inf);
    alltrajsCoLocAllFrames=cell(1,numel(okDNAInds));
    okDNAIndsNotNan=[];
    intensity=zeros(1,size(experiments{theExp}.alltrajsCoLocAllFrames{1},1));
    numFrames=size(experiments{theExp}.alltrajsCoLocAllFrames{1},1);
    for i=1:numel(okDNAInds)
        alltrajsCoLocAllFrames{i}=experiments{theExp}.alltrajsCoLocAllFrames{okDNAInds(i)};
        intensity=nansum([intensity;alltrajsCoLocAllFrames{i}(:,9)'],1);
        
        
    end
    
%    figure();
%    hold on;
%    %datacursormode on;
%    title(['Experiment number :' num2str(theExp)]);
%    plot(1:numFrames,intensity);
%    
%    xlabel('Frame number');
%    ylabel('Intensity');
    %
    
end

%%
newTimeStep=0.5; %Chose a smaller timestep that all, all traces are changed to have this tiemtep (just add extra timepoints wit same value)
underSampleTimeOff=6; %If frame rate is fater than this, frames in between are removed.  
underSampleTimeOn=2;
doUnderSample=0;
numEmissions=80;
  numEmissionsHist=1600;
 maxLevel=5e4;%max(maxLevelAll);
 minLevel=-2e4;%min(minLevelAll);
 minBoundInt=-inf;
 xValsModel=linspace(minLevel,maxLevel,numEmissions);
 numPreBoots=500;
 %Extra filtering
 filter.rollingAvgTime=12;
 filter.minMaxMean=5e4;%-inf;
 extraAddStart=3;
relIntensity=ones(1,numExps);
relIntensity(97:end)=1;%2/3;
 %%
 numDNAs=zeros(1,numExps);
 numDNAsBound=zeros(1,numExps);
 %%
 parfor theExp=expsToAnalyse%[25:169]%25:114%25:114%139:169%139:169%expsToAnalyseFitkon%[139:159]%25:114expsToAnalyseFitkon
    try
     if isSim==0
        startFrameFitNew=experiments{theExp}.startframeFit+extraAddStart;
     else
      startFrameFitNew=experiments{theExp}.startframeFit+extraAddStart;   
     end
    disp(theExp)
    timeStep=experiments{theExp}.timeStep;
    
    
    [~,okDNAInds]=selectTrajsonL(experiments{theExp}.alltrajsCoLoc,analyseLengthCoLocVec(theExp),inf);
    alltrajsCoLocAllFrames=cell(1,numel(okDNAInds));
    okDNAIndsNotNan=[];
    okOldInds=[];
    for i=1:numel(okDNAInds)
        alltrajsCoLocAllFrames{i}=experiments{theExp}.alltrajsCoLocAllFrames{okDNAInds(i)};
        rollingMean=movmean(alltrajsCoLocAllFrames{i}(startFrameFitNew:end,9),round(filter.rollingAvgTime/timeStep));
        maxMean=max(rollingMean);
        
        if sum(isnan(alltrajsCoLocAllFrames{i}(:,9)))==0&&maxMean>filter.minMaxMean*relIntensity(theExp)
            okDNAIndsNotNan=[okDNAIndsNotNan i];
            okOldInds=[okOldInds okDNAInds(i)];
        end
        
    end
    
    numDNABoundsBoot=zeros(1,numPreBoots);
    
    for i=1:numPreBoots
       currInds=ceil(rand(1,numel(okDNAInds))*numel(okDNAInds));
       currInds2=okDNAInds(currInds);
       for j=1:numel(currInds2)
            if sum(currInds2(j)==okOldInds)==1
                numDNABoundsBoot(i)= numDNABoundsBoot(i)+1;
            end
           
       end
    end    
      
    
    %
   % clusterLowAll=zeros(1,numel(okDNAIndsNotNan));
   % clusterHighAll=zeros(1,numel(okDNAIndsNotNan));
   % for trajInd=1:numel(okDNAIndsNotNan)
   %    try
   %    [idx,C]=kmeans(alltrajsCoLocAllFrames{okDNAIndsNotNan(trajInd)}(:,9),2);
%       Csort=sort(C,'ascend');
   %    clusterLowAll(trajInd)=Csort(1);
   %    clusterHighAll(trajInd)=Csort(2);
   %    catch
   %        clusterLowAll(trajInd)=NaN;
   %        clusterHighAll(trajInd)=NaN;
   %    end
   % end
    
   % okDNAIndsNotNan=okDNAIndsNotNan(clusterHighAll>-inf);
    
   %[sortedHighClust,sortIndsHighClust]=sort(clusterHighAll,'descend');
    
    %notNaNInds=~isnan(sortedHighClust);
    
    %okDNAIndsSorted=sortIndsHighClust(notNaNInds);
    
    
    %%
  
    
    maxLevelAll=zeros(1,numel(okDNAIndsNotNan));
    minLevelAll=zeros(1,numel(okDNAIndsNotNan));
    %for i=1:numel(okDNAIndsNotNan)
    %    
    %   maxLevelAll(i)=max(alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(experiments{theExp}.startframeFit:end,9));
    %    minLevelAll(i)=min(alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(experiments{theExp}.startframeFit:end,9));
    %end
    
   if doUnderSample==1
    newStepUnderSampleOn=ceil(underSampleTimeOn/timeStep);
    newStepUnderSampleOff=ceil(underSampleTimeOff/timeStep);
    
   else
       newStepUnderSampleOn=1;
       newStepUnderSampleOff=1;
       
   end
    timeStepOn=newStepUnderSampleOn*timeStep;
    timeStepOff=newStepUnderSampleOff*timeStep;
   
    seqIntegers=cell(1,numel(okDNAIndsNotNan));
    intensityTracesOn=cell(1,numel(okDNAIndsNotNan));
    intensityTracesOff=cell(1,numel(okDNAIndsNotNan));
    allInts=[];
    for i=1:numel(okDNAIndsNotNan)
        intensityTracesOn{i}=alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:newStepUnderSampleOn:end,9);
        intensityTracesOff{i}=alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:newStepUnderSampleOff:end,9);
        seqIntegers{i}=round((alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:end,9)-minLevelAll(i)-minLevel)*numEmissions/(maxLevel-minLevel))';
        seqIntegers{i}(seqIntegers{i}<1)=1;
        seqIntegers{i}(seqIntegers{i}>numEmissions)=numEmissions;
        seqIntegers{i}=repmat(seqIntegers{i},[timeStep/newTimeStep 1]);
        seqIntegers{i}=seqIntegers{i}(:)';
        allInts=[allInts alltrajsCoLocAllFrames{okDNAIndsNotNan(i)}(startFrameFitNew:end,9)];
    end
        experiments{theExp}.intensityTracesOn=intensityTracesOn;
        experiments{theExp}.intensityTracesOff=intensityTracesOff;
        experiments{theExp}.seqIntegers=seqIntegers;
        experiments{theExp}.allInts=allInts;
        experiments{theExp}.okDNAIndsNotNan=okDNAIndsNotNan;
        experiments{theExp}.timeStepOff=timeStepOff;
        experiments{theExp}.timeStepOn=timeStepOn;
        experiments{theExp}.numDNABoundsBoot=numDNABoundsBoot;
        
        numDNAs(theExp)=numel(okDNAInds);
        numDNAsBound(theExp)=numel(okDNAIndsNotNan);
     catch
         
        disp(['Failed at experiments: ' num2str(theExp)]);    
     end   
 end
 
%%
% % % % % % % % % figure();
% % % % % % % % % 
% % % % % % % % % plot(numDNAsBound./numDNAs);
% % % % % % % % % 
% % % % % % % % % xlabel('Experiment index');
% % % % % % % % % ylabel('Fraction of DNAs where binding occured');
% % % % % % % % % 
% % % % % % %% Estimate the boundries for high annd flourecence for different experiments (on/off)
% % % % % % meanAllInts=zeros(1,numExps);
% % % % % % minX=-5e4;
% % % % % % maxX=20e4;
% % % % % % numX=80;
% % % % % % bumpVal1=zeros(1,numExps);
% % % % % % bumpVal2=zeros(1,numExps);
% % % % % % for theExp=expsToAnalyse
% % % % % %     try
% % % % % %     allInts=experiments{theExp}.allInts(:);
% % % % % %     meanAllInts(theExp)=mean(allInts);
% % % % % %     [intCounts,histXVals]=hist(allInts,linspace(minX,maxX,numX));
% % % % % %     firstDiff=diff(intCounts);
% % % % % %     secondDiff=diff(firstDiff);
% % % % % %     stepX=histXVals(2)-histXVals(1);
% % % % % %     firstXvals=histXVals(1:end-1)+stepX/2;
% % % % % %     secondXvals=firstXvals(1:end-1)+stepX/2;
% % % % % %     
% % % % % %    % figure();
% % % % % %     hold on;
% % % % % %     plot(histXVals,intCounts,'r');
% % % % % %     yyaxis right
% % % % % %     plot(firstXvals,firstDiff,'b');
% % % % % %     plot(secondXvals,secondDiff,'g');
% % % % % %     
% % % % % %     
% % % % % % 
% % % % % %     signal=firstDiff;
% % % % % %     x=firstXvals;
% % % % % %     % find next point after zero crossing
% % % % % %     sigPos = logical(signal>0); % find all positive points
% % % % % %     cross = sigPos - circshift(sigPos,1); % find changeover points
% % % % % %     cross(1)=0;
% % % % % %     % add to plot
% % % % % %     %plot(x(logical(cross)), signal(logical(cross)), 'ko');
% % % % % %     % assume straight line approximation between adjacent points
% % % % % %     crossInd = find(cross); % x indices of cross points
% % % % % %     nCross = length(crossInd); % number of cross points found
% % % % % %     x0 = NaN(1,nCross); % vector of x-values for cross points
% % % % % %     for aa = 1:nCross
% % % % % %         thisCross = crossInd(aa);
% % % % % %         
% % % % % %         % interpolate to get x coordinate of approx 0
% % % % % %         x1 = thisCross-1; % before-crossing x-value
% % % % % %         x2 = thisCross; % after-crossing x-value
% % % % % %         y1 = signal(thisCross-1); % before-crossing y-value
% % % % % %         y2 = signal(thisCross); % after-crossing y-value
% % % % % %         
% % % % % %         ratio = (0-y1) / (y2-y1); % interpolate between to find 0
% % % % % %         x0(aa) = x(x1) + (ratio*(x(x2)-x(x1))); % estimate of x-value
% % % % % %         
% % % % % %     end
% % % % % %     
% % % % % %     zerosFirst=x0;
% % % % % %     plot(zerosFirst,zeros(1,nCross),'kx');
% % % % % %     
% % % % % %     signal=secondDiff;
% % % % % %     x=secondXvals;
% % % % % %     % find next point after zero crossing
% % % % % %     sigPos = logical(signal>0); % find all positive points
% % % % % %     cross = sigPos - circshift(sigPos,1); % find changeover points
% % % % % %     cross(1)=0;
% % % % % %     % add to plot
% % % % % %     %plot(x(logical(cross)), signal(logical(cross)), 'ko');
% % % % % %     % assume straight line approximation between adjacent points
% % % % % %     crossInd = find(cross); % x indices of cross points
% % % % % %     nCross = length(crossInd); % number of cross points found
% % % % % %     x0 = NaN(1,nCross); % vector of x-values for cross points
% % % % % %     for aa = 1:nCross
% % % % % %         thisCross = crossInd(aa);
% % % % % %         
% % % % % %         % interpolate to get x coordinate of approx 0
% % % % % %         x1 = thisCross-1; % before-crossing x-value
% % % % % %         x2 = thisCross; % after-crossing x-value
% % % % % %         y1 = signal(thisCross-1); % before-crossing y-value
% % % % % %         y2 = signal(thisCross); % after-crossing y-value
% % % % % %         
% % % % % %         ratio = (0-y1) / (y2-y1); % interpolate between to find 0
% % % % % %         x0(aa) = x(x1) + (ratio*(x(x2)-x(x1))); % estimate of x-value
% % % % % %         
% % % % % %     end
% % % % % %     
% % % % % %     zerosSecond=x0;
% % % % % %     plot(zerosSecond,zeros(1,nCross),'co');
% % % % % %     
% % % % % %     allZeros=[zerosFirst zerosSecond];
% % % % % %     
% % % % % %     
% % % % % %     [allZerosSorted,allZerosInds]=sort(allZeros,'ascend');
% % % % % %     
% % % % % %     numZerosTot=numel(allZerosSorted);
% % % % % %     numZerosFirst=numel(zerosFirst);
% % % % % %     
% % % % % %     zerosClass=ones(1,numZerosTot);
% % % % % %     zerosClass(allZerosInds>numZerosFirst)=2;
% % % % % %     val1=NaN;
% % % % % %     val2=NaN;
% % % % % %     for i=3:numZerosTot
% % % % % %         
% % % % % %         if zerosClass(i-2)==1&&zerosClass(i-1)==2&&zerosClass(i)==2&&allZerosSorted(i)>0
% % % % % %             val1=allZerosSorted(i-1);
% % % % % %             val2=allZerosSorted(i);
% % % % % %             break;
% % % % % %         end
% % % % % %     end
% % % % % %     
% % % % % %     bumpVal1(theExp)=val1;
% % % % % %     bumpVal2(theExp)=val2;
% % % % % %     
% % % % % %     catch
% % % % % %        disp(['Failed at experiments: ' num2str(theExp)]);      
% % % % % %     end
% % % % % % 
% % % % % % end
% % % % % % 
% % % % % % lowSaltExps=zeros(1,numel(setIndexes));
% % % % % % for i=1:numel(setIndexes)
% % % % % %    lowSaltExps(i)=setIndexes{i}(1);
% % % % % %    
% % % % % % end
% % % % % % 
% % % % % % indsToShow=[43 25 79 97 139 160 178];
% % % % % % %indsToShow=[25:207];

% % % % figure();
% % % % plot(indsToShow,meanAllInts(indsToShow),'bx');
% % % % xlabel('experiment number');
% % % % ylabel('Mean intensity');
% % % % 
% % % % figure();
% % % % plot(indsToShow,bumpVal2(indsToShow),'bx');
% % % % xlabel('experiment number')
% % % % ylabel('Location of second bump');
%%Looking at the mean intensity plot per experiment, how does it chan ge
%over time? 1 is the instensity of the first experiemtns ~3e . put element values in relIntensity 
% (threshold will  be uploaded (also go up and rerun previus secion
% (picking out the traces) with these settings.
%relIntensity=ones(1,numExps);
%relIntensity(97:end)=2/3;


%%
% allIntsTot=[];
%  startHistfit=-5e4;
%  endHistfit=3e5;
%  minL=-2e4;
%  maxL=20e4;
% 
% modelTestInd=43;%67%55
% for theExp=modelTestInd
%     disp(theExp);
%     %allIntsTot=[allIntsTot;experiments{theExp}.allInts];
%     %allInts=experiments{theExp}.allInts;
%     intensityTraces=experiments{theExp}.intensityTracesOn;
%     allInts=[];
%     allInts2=[];
%     for i=1:numel(intensityTraces)
%         allInts=[allInts;intensityTraces{i}];
%         allInts2=[intensityTraces{i}(1:end-1) intensityTraces{i}(2:end);allInts2];
%     end
%     [intCounts,histXVals]=hist(allInts,linspace(minL,maxL,numEmissionsHist));
%     intCounts=intCounts/trapz(histXVals,intCounts);
%     
%     [val,startind]=min(abs(histXVals-startHistfit));
%     [val,endind]=min(abs(histXVals-endHistfit));
%     
%     funGauss2= @(params,xdata) params(1)*params(2)*exp(-0.5*(((xdata-params(3))./params(5))).^2)+params(1)*(1-params(2))*exp(-0.5*(((xdata-params(4))./params(6)).^2));
%     funDiff = @(params) sum((funGauss2(params,histXVals(startind:endind))-intCounts(startind:endind)).^2);
%     
%     numGuesses=5000;%500000;
%     
%     
%     lb=[0 0.05 1e4 0 0 0];
%     
%     ub =[max(intCounts)*2 0.95 inf 1e-5 inf inf];
%     
%     nParams=numel(lb);
%     
%     guessMax=[max(intCounts)*2 0.95 1e5 1e5 1e5 1e5 ];
%   
%     resnormAll=inf*ones(numGuesses,1);
%     paramsAll=zeros(numGuesses,nParams);
%     
%     options=optimoptions('fmincon','Display','off','TolX',1e-7,'TolFun',1e-7,'MaxFunEvals',2000000,'MaxIter',200000);
%     
%     parfor i= 1:numGuesses
%         
%         params0=[rand(1,2).*guessMax(1:2) rand()*(guessMax(3)-lb(3))+lb(3) rand()*(guessMax(4)-lb(4))+lb(4) rand(1,2).*guessMax(5:6)];
%         
%         
%         
%         [paramsCurr,resnorm] = fmincon(funDiff,params0,[],[],[],[],lb,ub,[],options);
%         resnormAll(i)=resnorm;
%         paramsAll(i,:)=paramsCurr;
%         
%         
%     end
% 
%     [bestResNorm,bestind]=min(resnormAll);
%     bestParams=paramsAll(bestind,:);
%     
%     histGauss=[];
%     histGauss.bestParams=bestParams;
%     histGauss.bestResNorm=bestResNorm;
%     
%      experiments{theExp}.intCounts=intCounts;
%     experiments{theExp}.histXVals=histXVals;
%     experiments{theExp}.histGauss=histGauss;
%     
% end
% %%
% 
% 
% histXVals=experiments{modelTestInd}.histXVals;
% intCounts=experiments{modelTestInd}.intCounts;
% %figure();
% %bar(experiments{modelTestInd}.histXVals,experiments{modelTestInd}.intCounts*numEmissionsHist/numEmissions,1);
% %hold on;
% %plot(linspace(minLevel,maxLevel,numEmissions),experiments{theExp}.ESTEMIT(1,:),'g--');
% %plot(linspace(minLevel,maxLevel,numEmissions),experiments{theExp}.ESTEMIT(2,:),'r--');
% %plot(linspace(minLevel,maxLevel,numEmissions),experiments{theExp}.ESTEMIT(1,:)+experiments{theExp}.ESTEMIT(2,:),'m--');
% %title('HMM fitted')
% 
% 
% funGauss1= @(params,xdata) params(1)*exp(-0.5*(((xdata-params(2))./params(3)).^2));
% xvals=linspace(minL,maxL,numEmissionsHist);
% figure();
% bar(experiments{modelTestInd}.histXVals,experiments{modelTestInd}.intCounts,1);
% hold on;
% func1=funGauss1([experiments{modelTestInd}.histGauss.bestParams(1)*experiments{modelTestInd}.histGauss.bestParams(2) experiments{modelTestInd}.histGauss.bestParams([3 5])],xvals);
% func2=funGauss1([experiments{modelTestInd}.histGauss.bestParams(1)*(1-experiments{modelTestInd}.histGauss.bestParams(2)) experiments{modelTestInd}.histGauss.bestParams([4 6])],xvals);
% plot(xvals,func1,'g');
% plot(xvals,func2,'r');
% totProbDens=func1+func2;
% plot(xvals,totProbDens,'k--');
% xlim([-5e4 5e5]);
% ylim([0 max(totProbDens)*2]);

%% Calculate sum of fluorescence at DNA location
 norm=0;
 toSave=zeros(1,100);
 useTraceMean=0;
 
 %maxLevelCorr=7e4;%max(maxLevelAll);
 %minLevelCorr=1e4;%min(minLevelAll);
 numBoundsCorr=3;
 %autoCorrIntBounds=linspace(minLevelCorr,maxLevelCorr,numBoundsCorr);
 %intBounds=[1e4 3e4 5e4];
 intBounds=[2e4 2.000001e4 3.5e4 3.50001e4];
 
 doGroundTruth=0;
 
 startTimeAllTimes=0; %time in sec when to start, f you dont wish tto count very beginning of traces/timepoints when calculating the dissociation curve.
 endTimeAllTimes=200;
 endTimeAllTimesBleach=200;
 maxLevel=5e4;%4e4;%max(maxLevelAll);
 minLevel=0e4;%-2e4;%2e4;%min(minLevelAll);
 fitTimeOn=4;
 %Must be updated for every added experiment
 fitTimeOffVec=[6*ones(1,152) 12*ones(1,7) 6*ones(1,10) 6*ones(1,8) 6*ones(1,15) 6*ones(1,15)];
 %fitPointsOff=2;
 fitTimeSlope=2;
 onConvolutePoints=3;

% fitPointsSlopeon=7;
 
 numBoots=500;
 


if isSim==1
   illumTime=2;
    setIndexesNew=setIndexes;
   
    onIndexes=[repmat(setIndexesNew{1},[1 3]) repmat(setIndexesNew{4},[1 3]) repmat(setIndexesNew{7},[1 3]) repmat(setIndexesNew{10},[1 3]) repmat(setIndexesNew{13},[1 3])]; %Fo each experiment, which experiment does the onrate come from (can't estiamte on rate from off experiemnts)
    normInds(1:6)=6; %For eeach experiment, what is the experiment index of this set to normalize to when doing nomrmalized plots (high ka low kd)
    normInds(7:12)=12; 
    normInds(13:18)=18;
    
    normInds(19:24)=24;
    normInds(25:30)=30;
    normInds(31:36)=36;
    
    normInds(37:42)=42;
    normInds(43:48)=48;
    normInds(49:54)=54;
    
    normInds(55:60)=55;
    normInds(61:66)=61;
    normInds(67:72)=67;
    
    normInds(73:78)=73;
    normInds(79:84)=79;
    normInds(85:90)=85;
   
    bleachInds(1:6)=6;  %For each experiment, what experiment to use bleachig epxeriment from (preferebly low kd high ka, high frame rate)
    bleachInds(7:12)=6;
    bleachInds(13:18)=6;
    
    bleachInds(19:24)=24;
    bleachInds(25:30)=24;
    bleachInds(31:36)=24;
    
    bleachInds(37:42)=42;
    bleachInds(43:48)=42;
    bleachInds(49:54)=42;
    
    bleachInds(55:60)=55;
    bleachInds(61:66)=55;
    bleachInds(67:72)=55;
    
    bleachInds(73:78)=73;
    bleachInds(79:84)=73;
    bleachInds(85:90)=73;
    

    
else
    illumTime=1;
    setIndexesNew=setIndexes;
    setIndexesNew{5}=setIndexes{5}(1:end-1);
    %This must be updated for each added experiemtns, defines with on experiments corrrespoinds to same salt and occation as each experiemnt
    onIndexes=[ones(1,24) setIndexesNew{5} ones(1,13) repmat(setIndexesNew{8},[1 3]) repmat(setIndexesNew{11},[1 3]) repmat(setIndexesNew{14},[1 3]) repmat(setIndexesNew{17},[1 4])  repmat(setIndexesNew{21},[1 3]) repmat(setIndexesNew{24},[1 3]) repmat(setIndexesNew{27},[1 2]) repmat(setIndexesNew{29},[1 2]) repmat(setIndexesNew{31},[1 2]) repmat(setIndexesNew{33},[1 2]) ]; 
    k=0;
    for i=1:numel(setIndexesNew)
        normInds(k+1:k+numSaltsVec(i))=setIndexesNew{i}(1);
        k=k+numSaltsVec(i);
    end
    bleachInds(1:42)=1;
    
%     bleachInds(43:48)=43;
%     bleachInds(49:54)=43;
%     bleachInds(55:60)=43;
% 
%     bleachInds(61:66)=61;
%     bleachInds(67:72)=61;
%     bleachInds(73:78)=61;
%     
%     bleachInds(79:84)=79;
%     bleachInds(85:90)=79;
%     bleachInds(91:96)=79;
%     
%     bleachInds(97:102)=97;
%     bleachInds(103:108)=97;
%     bleachInds(109:114)=97;
%     bleachInds(115:120)=97;
bleachInds(25:42)=25;    
bleachInds(43:120)=61;
bleachInds(139:159)=61;    
    TvecCell=cell(1,numExps);
   XCell=cell(1,numExps);
end

 
 % ontraces should be from the associatio nexperiments in all datasets
 
 
 
 for theExp=expsToAnalyseFitkon
     try
    experiments{theExp}.intensityTracesOn=experiments{onIndexes(theExp)}.intensityTracesOn;
    experiments{theExp}.timeStepOn=experiments{onIndexes(theExp)}.timeStepOn;
     catch 
         disp([num2str(theExp) ]);
         
     end
 end

%%


kdFromSlopeRaw=zeros(1,numExps);
 kaFromSlopeRaw=zeros(1,numExps);
 kbleachFromSlope=zeros(1,numExps);
fractionNonSpecBind=zeros(1,numExps);
steadyStateLevel=zeros(1,numExps);
kdFromRawSlope=zeros(1,numExps);
kaFromRawSlope=zeros(1,numExps);
bgLevel=zeros(1,numExps);
kdFromSlope=zeros(1,numExps);
kaFromSlope=zeros(1,numExps);
numUniqueOn=zeros(1,numExps);
numUniqueOff=zeros(1,numExps);
%%
parfor theExp=expsToAnalyse%178:207%25:169%39:169%139:169%expsToAnalyseFitkon%[139:159]%expsToAnalyseFitkon25:114
    try
    disp(theExp);
    timeStep=experiments{theExp}.timeStep;
    seqIntegers=experiments{theExp}.seqIntegers;
    allInts=experiments{theExp}.allInts;
    okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
    intensityTracesOn=experiments{theExp}.intensityTracesOn;
    intensityTracesOff=experiments{theExp}.intensityTracesOff;
    numTimePointsOn=numel(intensityTracesOn{1});
    numTimePointsOff=numel(intensityTracesOff{1});
    numTracesOn=numel(intensityTracesOn);
    numTracesOff=numel(intensityTracesOff);
    
    timeStepOn=experiments{theExp}.timeStepOn;
    timeStepOff=experiments{theExp}.timeStepOff;

    
     traces=cell(1,numTracesOn);
    if doGroundTruth==1
    %  intBounds=[0 0.5 1];  
    %   maxLevel=inf;
    %  minLevel=-inf;
      timeStepOn=TvecCell{theExp}(2)-TvecCell{theExp}(1);
      timeStepOff=timeStepOn;
      numTimePointsOn=size(XCell{theExp},1);
      numTimePointsOff=numTimePointsOn;
      numTraces=size(XCell{theExp},2);
      for i=1:numTraces
        traces{i}=XCell{theExp}(:,i);
      end
      tracesOn=traces;
      tracesOff=traces;
    else
        tracesOn=intensityTracesOn;
        tracesOff=intensityTracesOff;
    end   
    
    
  
    timeVecOn=0:timeStepOn:timeStepOn*(numTimePointsOn-1);
    timeVecOff=0:timeStepOff:timeStepOff*(numTimePointsOff-1);
    %fitPointsSlope=2;
    %fitPointsOn=round(fitTimeOn/timeStep);
    %fitPointsOff=round(fitTimeOff/timeStep);
    fitTimeOff=fitTimeOffVec(theExp);
    [~,fitPointsOn]=min(abs(timeVecOn-fitTimeOn));
    [~,fitPointsOff]=min(abs(timeVecOff-fitTimeOff));
   
    
     
        
       
     
    

    
    [kd,ka,intensityAllTime,intensityFirstTime,results] = getRatesIntensityMethodver16OnConvolNewCorr(tracesOff,timeVecOff,tracesOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds*relIntensity(theExp),minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints,illumTime);
    %[~,ka,~,intensityFirstTime] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
    %[kd,ka,intensityAllTime,intensityFirstTime] = getRatesIntensityMethod(traces,timeVec,startTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsSlopeoff,fitPointsSlopeon);
    %kdFromRawSlope(theExp)=-log(-kd*(fitTimeOff*0.5)+1)/(fitTimeOff*0.5);
    %kaFromRawSlope(theExp)=-log(-ka*(fitTimeOn*0.5)+1)/(fitTimeOn*0.5);
   
     kdFromRawSlope(theExp)=kd;
     kaFromRawSlope(theExp)=ka;
     
     numUniqueOff(theExp)=results.numUniqueOff;
     numUniqueOn(theExp)=results.numUniqueOn;
     
    %steadyStateLevel(theExp)=mean(experiments{theExp}.intensityFirstTime(1,end-50:end));
    
  %  [kd,background] = getkdFromSlopeandSteady(-kdFromRawSlope(theExp),steadyStateLevel(theExp),ka*protconckon(theExp),kbleachingRef(theExp));
    
   % ka=kaFromSlope(theExp);
   % slopeoff=-kd;
   % steadyState=steadyStateLevel(theExp);
   % kbleach=kbleachingRef(theExp);
  
 %   kdFromSlopeCorrection(theExp)=-(ka*slopeoff*steadyState)/(ka + slopeoff*steadyState);
 %   bgLevel(theExp)=(steadyState*(ka*kbleach + ka*slopeoff + slopeoff^2*steadyState - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState))/(ka*kbleach - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState)
 %   
  
    
    kaRawBootSamples=zeros(1,numBoots);
    kdRawBootSamples=zeros(1,numBoots);
    
    for i=1:numBoots
        tracesCurrOn=cell(1,numTracesOn);
        tracesCurrOff=cell(1,numTracesOff);
        for j=1:numTracesOn
            currind=ceil(rand()*numTracesOn);
            tracesCurrOn{j}=tracesOn{currind};
            
            
        end
        for j=1:numTracesOff
            currind=ceil(rand()*numTracesOff);
            
            tracesCurrOff{j}=tracesOff{currind};
            
        end
        
        % [kdRawBootSamples(i),~,~,~] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesCurrOff,timeVecOff,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
        % [~,kaRawBootSamples(i),~,~] = getRatesIntensityMethodver11OnCorrectionOnConvol(tracesCurrOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds,minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints);
        [kdRawBootSamples(i),kaRawBootSamples(i),~,~,~] = getRatesIntensityMethodver16OnConvolNewCorr(tracesCurrOff,timeVecOff,tracesCurrOn,timeVecOn,startTimeAllTimes,endTimeAllTimes,protconckon(theExp),intBounds*relIntensity(theExp),minLevel,maxLevel,fitPointsOff,fitPointsOn,onConvolutePoints,illumTime);
        
    end
    
    meankdBoot(theExp)=mean(kdRawBootSamples);
    meankaBoot(theExp)=mean(kaRawBootSamples);
    
    errorkd(theExp)=std(kdRawBootSamples);
    errorka(theExp)=std(kaRawBootSamples);
    
    
    
    
    experiments{theExp}.kdRawBootSamples=kdRawBootSamples;
    experiments{theExp}.kaRawBootSamples=kaRawBootSamples;
    experiments{theExp}.intensityFirstTime=intensityFirstTime;
    experiments{theExp}.intensityAllTime=intensityAllTime;
   % experiments{theExp}.newOffCurve=newOffCurve;
    %experiments{theExp}.bestParams=bestParams;
   % fractionNonSpecBind(theExp)=bestParams(4)/(bestParams(4)+bestParams(6));
    experiments{theExp}.results=results;
    
    catch
         
        disp(['Failed at experiments: ' num2str(theExp)]);    
     end   
    
end

%%
%save([savepath 'Intensities with bootstrappig calculated' parameterset ' ' datestr(now)],'-v7.3');

%% Solve symbolic equations


syms kd background ka kbleach slopeoff steadyState
eqn1 = ((ka/(ka+kd))*(kd/(kbleach+kd)))/(((ka/(ka+kd))*(kd/(kbleach+kd)))+background)*(-1)*(kd+kbleach)-slopeoff == 0;
eqn2= ((ka/(ka+kd))*(kd/(kbleach+kd))) +background - steadyState == 0;
S=solve([eqn1 eqn2],[kd background]);

%solutionkd=-(ka*slopeoff*steadyState)/(ka + slopeoff*steadyState)
%solutionbackground =(steadyState*(ka*kbleach + ka*slopeoff + slopeoff^2*steadyState - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState))/(ka*kbleach - ka*slopeoff*steadyState + kbleach*slopeoff*steadyState)



%%
%onsetplot=setIndexes{24};%[97:102]+12;%[43:48];%43:48;
%onsetplot=setIndexes{10};%setIndexes(11,:)
%onsetplot=[43 61 168];
% % % % onsetplot=[43:48];%setIndexes{33}(1:6);
% % % % 
% % % % figure();
% % % % hold on;
% % % % for theExp=onsetplot
% % % %     timeStep=experiments{theExp}.timeStepOn;
% % % % 
% % % %     numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
% % % %     plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:));
% % % %     
% % % % end
% % % % legend(strsplit(num2str(onsetplot)))
% % % % 
% % % % title('association');
% % % % 
% % % % 
% % % % %offsetplot=onsetplot+12;
% % % % %offsetplot=[43+12 61+12 169];
% % % % %offsetplot=onsetplot;
% % % % offsetplot=169;%[109:113];%setIndexes{26};%[43:48]+12;%setIndexes{34}(1:6);%[43:48]+12;%setIndexes{33}(1:6);
% % % % figure();
% % % % hold on;
% % % % for theExp=offsetplot
% % % %     timeStep=experiments{theExp}.timeStepOff;
% % % %     
% % % %     numTimePoints=size(experiments{theExp}.intensityAllTime,2);
% % % %     plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1));
% % % %     
% % % % end
% % % % legend(strsplit(num2str(offsetplot)))
% % % % title('dissocation')




%%
perc=0.68;
for theExp=expsToAnalyseFitkon
    disp(theExp)
    kdRawBootSamples=experiments{theExp}.kdRawBootSamples;
    kaRawBootSamples=experiments{theExp}.kaRawBootSamples;
    relka(theExp)=kaFromRawSlope(theExp)/kaFromRawSlope(normInds(theExp));
    relkd(theExp)=kdFromRawSlope(theExp)-kdFromRawSlope(normInds(theExp));
    if isSim==1
        relkaModel(theExp)=kaSim(theExp)/kaSim(normInds(theExp));
        relkdModel(theExp)=kdSim(theExp)-kdSim(normInds(theExp));
    end
    relkaBoots=zeros(1,numBoots);
    relkdBoots=zeros(1,numBoots);
    
    for i=1:numBoots
        relkaBoots(i)=experiments{theExp}.kaRawBootSamples(i)/experiments{normInds(theExp)}.kaRawBootSamples(i);
        relkdBoots(i)=experiments{theExp}.kdRawBootSamples(i)-experiments{normInds(theExp)}.kdRawBootSamples(i);
    end   
    meanrelkaBoot(theExp)=mean(relkaBoots);
    meanrelkdBoot(theExp)= mean(relkdBoots);
    
     
    errorrelka(theExp)=std(relkaBoots);
    errorrelkd(theExp)=std(relkdBoots);
    
    
    lowErrorka(theExp)=(meankaBoot(theExp)+errorka(theExp)/2)-kaFromRawSlope(theExp);
    highErrorka(theExp)=kaFromRawSlope(theExp)-(meankaBoot(theExp)-errorka(theExp)/2);
    
    lowErrorrelka(theExp)=(meanrelkaBoot(theExp)+errorrelka(theExp)/2)-relka(theExp);
    highErrorrelka(theExp)=relka(theExp)-(meanrelkaBoot(theExp)-errorrelka(theExp)/2);
    
    lowErrorkd(theExp)=(meankdBoot(theExp)+errorkd(theExp)/2)-kdFromRawSlope(theExp);
    highErrorkd(theExp)=kdFromRawSlope(theExp)-(meankdBoot(theExp)-errorkd(theExp)/2);
    
    lowErrorrelkd(theExp)=(meanrelkdBoot(theExp)+errorrelkd(theExp)/2)-relkd(theExp);
    highErrorrelkd(theExp)=relkd(theExp)-(meanrelkdBoot(theExp)-errorrelkd(theExp)/2);
    
    sortedkons=sort(kaRawBootSamples,'ascend');
    
    borderInd=round(numBoots*(1-perc)/2);
    
    lowerBoundkaRaw(theExp)=sortedkons(borderInd);
    upperBoundaRaw(theExp)=sortedkons(end-borderInd+1);
    
    sortedkoffs=sort(kdRawBootSamples,'ascend');
    
    borderInd=round(numBoots*(1-perc)/2);
    
    lowerBoundkdRaw(theExp)=sortedkoffs(borderInd);
    upperBoundkdRaw(theExp)=sortedkoffs(end-borderInd+1);
    
end

realConfidenceInterval=1-((borderInd-1)/numBoots+(1-(numBoots-(borderInd)+1)/numBoots));
realConfidenceIntervalEst2=numel(borderInd:(numBoots-borderInd))/numBoots;
%% Bleaching callibration

signs{1}={'.b','b-','b'};

refInds=[];
refInds{1}=[25 43 43+6 43+12];

fractionlaserOnTime{1}=[1 1/2 1/3 1/6];

facLaserOnTime=1; % if 1/timeStep isn't the fraction of time the laser is on



kbleach=zeros(1,numel(refInds));
fbleach=figure();
hold on;
bleachpoly=cell(1,numel(refInds));
kbleachBoots=zeros(numBoots,numel(refInds));
for i=1:numel(refInds)
    errorbar(fractionlaserOnTime{i},kdFromRawSlope(refInds{i}),kdFromRawSlope(refInds{i})-lowerBoundkdRaw(refInds{i}),upperBoundkdRaw(refInds{i})-kdFromRawSlope(refInds{i}),signs{i}{1});
    bleachpoly{i}=polyfit(fractionlaserOnTime{i},kdFromRawSlope(refInds{i}),1);
    fracsplot=[0:0.01:1];
    plot(fracsplot,polyval(bleachpoly{i},fracsplot),signs{i}{2})
    kbleach(i)=bleachpoly{i}(1);
  
    for j=1:numBoots
        currkd=zeros(1,numel(refInds{i}));
        for k=1:numel(refInds{i})
            currkd(k)=experiments{refInds{i}(k)}.kdRawBootSamples(j);
            
        end
        
        bp=polyfit(fractionlaserOnTime{i},currkd,1);
        kbleachBoots(j,i)=bp(1);
        
    end
end

xlim([0 1]);
ylim([0 0.04]);
ylabel('k_d_,o_b_s (s^-^1)');
xlabel('Fraction of time laser is on');
title('Fig. S2E')
savefig(fbleach,'bleaching_calibration.fig')

kbleachAll=kbleach(1);
kbleachAllBoots=kbleachBoots(:,1);

kdMin=zeros(1,numExps);
kdMinBoots=zeros(numBoots,numExps);
kdFromSlopeCorrected=zeros(1,numExps);
kdFromSlopeCorrectedBoots=zeros(numBoots,numExps);

for theExp=expsToAnalyse
    kdMin(theExp)=facLaserOnTime*kbleachAll*(1/experiments{theExp}.timeStep);
    kdFromSlopeCorrected(theExp)=kdFromRawSlope(theExp)-kdMin(theExp);
    for j=1:numBoots
        kdMinBoots(j,theExp)=facLaserOnTime*kbleachAllBoots(j)*(1/experiments{theExp}.timeStep);
        kdFromSlopeCorrectedBoots(j,theExp)=experiments{theExp}.kdRawBootSamples(j)-kdMinBoots(j,theExp);
        
    end
end

%% Estiamte koff micros




onset=[];
onset{1}=[61:66]; %O1 rep 1
onset{2}=[139:144 139:144]; %O1 rep 2
onset{3}=[61:66 139:144 139:144]; %Both O1 reps %use this on rate two times to se both 6s and 12s frame rate for O1 off
onset{4}=[43:45]; %And O3, just for the one point needed ffor bleaching calibaration and Fig. S2
onset{5}=[160:163]; %random sequence
onset{6}=[170:173]; %surrounding of random sequence (binding to surface)

set=[];
set{1}=[73:78]; %Four the on rates, should be an assocation experiemnt
set{2}=[146:151 153:158];
set{3}=[73:78 146:151 153:158];%%Both 6s and 12s data for second O1 experiment
set{4}=[55:57];
set{5}=[164:167];
set{6}=[174:177];

defineAveraging=[];
defineAveraging{1}=1:numel(onset{1});
defineAveraging{2}=1:numel(onset{2});
defineAveraging{3}=1:numel(onset{3});
defineAveraging{4}=[1 2 2];
defineAveraging{5}=1:numel(onset{5});
defineAveraging{6}=1:numel(onset{6});

%onset{1}=[160:163];

%set{1}=[164:167];

%defineAveraging{1}=1:numel(onset{1});



%normIndCurves(1)=61;
%normIndCurves(2)=61;
%normIndCurves(3)=61;
%normIndCurves(4)=61;

kaValsSelected=cell(1,numel(onset));
kdValsSelected=cell(1,numel(onset));
KDValsSelected=cell(1,numel(onset));
fracsBoundSelected=cell(1,numel(onset));
saltconcSelectedon=cell(1,numel(onset));

kaValsBootsSelected=cell(1,numel(onset));
kdValsBootsSelected=cell(1,numel(onset));
fracsBoundBootsSelected=cell(1,numel(onset));

errorkaSelected=cell(1,numel(onset));
errorkdSelected=cell(1,numel(onset));

lowerBoundkaSelected=cell(1,numel(onset));
upperBoundkaSelected=cell(1,numel(onset));

lowerBoundkdSelected=cell(1,numel(onset));
upperBoundkdSelected=cell(1,numel(onset));

lowerBoundfracsBoundSelected=cell(1,numel(onset));
upperBoundfracsBoundSelected=cell(1,numel(onset));

lowerBoundKDSelected=cell(1,numel(onset));
upperBoundKDSelected=cell(1,numel(onset));

koffMicrosMeas=zeros(1,numel(onset));
koffMicrosBootkoffMicrosBoot=zeros(numBoots,numel(onset));

kaMax=zeros(1,numel(onset));
%kdMin=zeros(1,numel(onset));
kdMinAll=0;%min(kdFromRawSlope(set{2}));

koffMicrosMeanBoot=zeros(1,numel(onset));
koffMicrosError=zeros(1,numel(onset));
lowerBoundkoffMicros=zeros(1,numel(onset));
upperBoundkoffMicros=zeros(1,numel(onset));
perc=0.68;
%%
for i=1:numel(onset)
    % pointsPerCurve=numel(onset{i});
    % kaVals=kaFromRawSlope(onset{i});
    % kdVals=kdFromRawSlope(set{i});
    
    pointsPerCurve=defineAveraging{i}(end);
    if pointsPerCurve>1
    kdValsSelected{i}=zeros(1,pointsPerCurve);
    kaValsSelected{i}=zeros(1,pointsPerCurve);
    KDValsSelected{i}=zeros(1,pointsPerCurve);
    fracsBoundSelected{i}=zeros(1,pointsPerCurve);
    saltconcSelectedon{i}=zeros(1,pointsPerCurve);
    
    for j=1:pointsPerCurve
        kaValsSelected{i}(j)=mean(kaFromRawSlope(onset{i}(defineAveraging{i}==j)));
        if isnan(kaValsSelected{i}(j))
            kaValsSelected{i}(j)=0;
        end
        kdValsSelected{i}(j)=mean(kdFromSlopeCorrected(set{i}(defineAveraging{i}==j)));
        if isnan(kdValsSelected{i}(j))
             kdValsSelected{i}(j)=0;
        end
        
        KDValsSelected{i}(j)=kdValsSelected{i}(j)/kaValsSelected{i}(j);
        fracsBoundHere=numDNAsBound(onset{i}(defineAveraging{i}==j))./numDNAs(onset{i}(defineAveraging{i}==j));
        fracsBoundSelected{i}(j)=mean(fracsBoundHere);
        saltconcSelectedon{i}(j)=mean(saltconckon(onset{i}(defineAveraging{i}==j)));
    end 
    
    
    
    %pfit{i}=polyfit(kdValsSelected{i},kaValsSelected{i},1);
    %reversePoly=polyfit(kaValsSelected{i},kdValsSelected{i},1);
    
    normX=std(kdValsSelected{i});
    normY=std(kaValsSelected{i});
    relX=kdValsSelected{i}/normX;
    relY=kaValsSelected{i}/normY;
    
    bestParams=fitLineErrorxyver3(relX,relY,10,0.5,1.5,1e-3,1e-3);
   
    
    pfit{i} = [bestParams(1)*normY/normX bestParams(2)*normY];
    
    %figure();
    %plot(relX,relY,'bx');
    %hold on;
    %plot(relX,polyval(bestParams,relX,1));
    
    %kaMax(i)=kaFromRawSlope(normIndCurves(i));
    %kdMin(i)=polyval(reversePoly,kaMax(i));
    
    if pfit{i}(1)>0
        
        if std(kdValsSelected{i})<1e-3%pfitCurr(2)<0%pfit{i}(1)>(max(kaValsSelected{i})/(max(kdValsSelected{i})-min(kdValsSelected{i}))) %A very steep slope,s => koff,micro is essentialy 0
             koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1);
        else
            koffMicrosMeas(i)=inf;
        end
    else
        %koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1)-kdVals(normIndCurves(i));
        
        koffMicrosMeas(i)=-pfit{i}(2)/pfit{i}(1);
    end
    kdValsBootsSelectedTemp=zeros(numBoots,pointsPerCurve);
    kaValsBootsSelectedTemp=zeros(numBoots,pointsPerCurve);
    fracsBoundBootsSelectedTemp=zeros(numBoots,pointsPerCurve);
    if numBoots>2
        for j=1:numBoots
            disp(j);
            kaValsCurr=zeros(1,pointsPerCurve);
            kdValsCurr=zeros(1,pointsPerCurve);
            fracsBoundCurr=zeros(1,pointsPerCurve);
            %KDValsCurr=zeros(1,pointsPerCurve);
            for k=1:pointsPerCurve
                onInds=onset{i}(defineAveraging{i}==k);
                offInds=set{i}(defineAveraging{i}==k);
                for index=1:numel(onInds)
                    kdtoAdd=kdFromSlopeCorrectedBoots(j,offInds(index));
                    if isnan(kdtoAdd)
                        kdtoAdd=0;
                    end
                    kdValsCurr(k)=kdValsCurr(k)+kdtoAdd;
                    
                    katoAdd=experiments{onInds(index)}.kaRawBootSamples(j);
                    
                    if isnan(katoAdd)
                        katoAdd=0;
                    end
                    kaValsCurr(k)= kaValsCurr(k)+katoAdd;
                    fracsBoundCurr(k)=fracsBoundCurr(k)+experiments{onInds(index)}.numDNABoundsBoot(j)/numDNAs(onInds(index));
                    
                end
                
                kaValsCurr(k)=kaValsCurr(k)/numel(onInds);
                kdValsCurr(k)=kdValsCurr(k)/numel(onInds);
                fracsBoundCurr(k)= fracsBoundCurr(k)/numel(onInds);
            end
            kaValsBootsSelectedTemp(j,:)=kaValsCurr;
            kdValsBootsSelectedTemp(j,:)=kdValsCurr;
            fracsBoundBootsSelectedTemp(j,:)=fracsBoundCurr;
            
            % pfitCurr=polyfit(kdValsCurr,kaValsCurr,1);
            %reversePoly=polyfit(kaValsCurr,kdValsCurr,1);
            %kaMaxCurr=kaFromRawSlope(normIndCurves(i));experiments{normIndCurves(i)}.kaRawBootSamples(j);
            %kdMinCurr=polyval(reversePoly,kaMaxCurr);
            
            kdMinCurr=kdMin(set{i}(1));
            
            normX=std(kdValsCurr);
            normY=std(kaValsCurr);
            relX=kdValsCurr/normX;
            relY=kaValsCurr/normY;
            
            
            bestParams=fitLineErrorxyver3(relX,relY,10,0.5,1.5,1e-3,1e-3);
            
            
            pfitCurr = [bestParams(1)*normY/normX bestParams(2)*normY];
            
            
            if pfitCurr(1)>0
                if std(kdValsCurr)<1e-3%pfitCurr(1)>(max(kaValsCurr)/(max(kdValsCurr)-min(kdValsCurr)))*10 %A very steep slope, => koff,micro is essentialy 0
                    koffMicrosBoot(j,i)=-pfitCurr(2)/pfitCurr(1);
                else
                    koffMicrosBoot(j,i)=inf;
                end
            else
                koffMicrosBoot(j,i)=-pfitCurr(2)/pfitCurr(1);
                
            end
        end
        kaValsBootsSelected{i}=kaValsBootsSelectedTemp;
        kdValsBootsSelected{i}=kdValsBootsSelectedTemp;
        fracsBoundBootsSelected{i}=fracsBoundBootsSelectedTemp;
        
        errorkaSelected{i}=std(kaValsBootsSelected{i});
        errorkdSelected{i}=std(kdValsBootsSelected{i});
        
        lowerBoundkaSelected{i}=zeros(1,pointsPerCurve);
        upperBoundkaSelected{i}=zeros(1,pointsPerCurve);
        
        lowerBoundkdSelected{i}=zeros(1,pointsPerCurve);
        upperBoundkdSelected{i}=zeros(1,pointsPerCurve);
        
        lowerBoundfracsBoundSelected{i}=zeros(1,pointsPerCurve);
        upperBoundfracsBoundSelected{i}=zeros(1,pointsPerCurve);
        
        lowerBoundKDSelected{i}=zeros(1,pointsPerCurve);
        upperBoundKDSelected{i}=zeros(1,pointsPerCurve);
        end
        
        for j=1:pointsPerCurve
            sortedkas=sort(kaValsBootsSelected{i}(:,j),'ascend');
            sortedkds=sort(kdValsBootsSelected{i}(:,j),'ascend');
            sortedfracsBound=sort(fracsBoundBootsSelected{i}(:,j),'ascend');
            borderInd=round(numBoots*(1-perc)/2);
            
            lowerBoundkaSelected{i}(j)=sortedkas(borderInd);
            upperBoundkaSelected{i}(j)=sortedkas(end-borderInd+1);
            
            lowerBoundkdSelected{i}(j)=sortedkds(borderInd);
            upperBoundkdSelected{i}(j)=sortedkds(end-borderInd+1);
            
            lowerBoundfracsBoundSelected{i}(j)=sortedfracsBound(borderInd);
            upperBoundfracsBoundSelected{i}(j)=sortedfracsBound(end-borderInd+1);
            
            
            
        end
        
        koffMicrosMeanBoot(i)=mean(koffMicrosBoot(:,i));
        koffMicrosError(i)=std(koffMicrosBoot(:,i));
        temp=koffMicrosBoot(:,i);
        
        sortedkoffs=sort(temp,'ascend');
        
        borderInd=round(numBoots*(1-perc)/2);
        
        lowerBoundkoffMicros(i)=sortedkoffs(borderInd);
        upperBoundkoffMicros(i)=sortedkoffs(end-borderInd+1);
    end
    
    
end

% disp('Numbers for comparsion in supplement:')
% mean([KDValsSelected{5}(2) KDValsSelected{6}(4)]) %100 mM 
% std([KDValsSelected{5}(2) KDValsSelected{6}(4)])/sqrt(2)
% mean([KDValsSelected{5}(5) KDValsSelected{6}(6)]) %and 200 mM
% std([KDValsSelected{5}(5) KDValsSelected{6}(6)])/sqrt(2)
% 
% 
% mean([kaValsSelected{5}(2) kaValsSelected{6}(4)])
% std([kaValsSelected{5}(2) kaValsSelected{6}(4)])/sqrt(2)
% mean([kaValsSelected{5}(5) kaValsSelected{6}(6)])
% std([kaValsSelected{5}(5) kaValsSelected{6}(6)])/sqrt(2)
% 
% mean([kdValsSelected{5}(2) kdValsSelected{6}(4)])
% std([kdValsSelected{5}(2) kdValsSelected{6}(4)])/sqrt(2)
% mean([kdValsSelected{5}(5) kdValsSelected{6}(6)])
% std([kdValsSelected{5}(5) kdValsSelected{6}(6)])/sqrt(2)

%compare O1 and O3 at 100 mM

%%
%save([savepath 'Intensities with bootstrappig calculated' parameterset ' ' datestr(now)],'-v7.3');
%% Barchat of koffmicro coloc, errorbars from repeats
 
%  meansColoc= [mean(koffMicrosMeas(5:6)) mean(koffMicrosMeas(3:4)) mean(koffMicrosMeas(1:2))];
%  lowEColoc = [std(koffMicrosMeas(5:6))/sqrt(2) std(koffMicrosMeas(3:4))/sqrt(2) std(koffMicrosMeas(1:2))/sqrt(2)];
%  highEColoc= [std(koffMicrosMeas(5:6))/sqrt(2) std(koffMicrosMeas(3:4))/sqrt(2) std(koffMicrosMeas(1:2))/sqrt(2)];
%  
%  thef=figure();
%  bar(meansColoc,'b');
%  hold on;
%  errorbar(1:3,meansColoc,lowEColoc,highEColoc,'k');
%  test=gca;
%  test.YScale='log';
%  test.Children(1).LineStyle='none';
%  ylim([5e-4 0.5]);
%  xlim([0.5 3.5])
%  xticks([1 2 3])
%  ylabel('koffmicro (s^-^1')
%  
%  savefig(thef,'koffmicro_coloc.fig');

% %%
% for i=1:numel(onset)
%     figure();
%     title(num2str(onset{i}));
%     hist(koffMicrosBoot(:,i));
% end

%% Do on verseus off plots 
%onset{1}=setIndexesNew{1};
%onset{2}=setIndexesNew{4};
%onset{3}=setIndexesNew{7};
%onset{4}=setIndexesNew{10};
%onset{5}=setIndexesNew{13};

%set{1}=onset{1}+12; %Four the on rates, should be an assocation experiemnt
%set{2}=onset{2}+12;
%set{3}=onset{3}+12;
%set{4}=onset{4}+12;
%set{5}=onset{5}+12;



%signs{1}={'.b','b','b'};
%signs{2}={'.r','r','r'};
%signs{3}={'.c','c','c'};
%signs{4}={'.m','m','m'};
%signs{5}={'.y','y','y'};
%signs{6}={'.k','k','k'};

%signs{1}={'.b','b-','b'};
%signs{2}={'.c','c-','c'};
%signs{3}={'.m','m-','m'};
%signs{4}={'.y','y-','y'};
%signs{5}={'.r','r-','r'};
%signs{6}={'.g','g-','g'};
%signs{7}={'.k','k-','k'};
%signs{8}={'.k','k-','k'};

signs{1}={'.b','b-','b'}; %O1 rep1

signs{2}={'.m','m-','m'};%O1 rep2

signs{3}={'.r','r-','r'};%O1 both reps

signs{4}={'.b','b-','b'};%O3
signs{5}={'.k','k-','k'};%non-operator DNA
signs{6}={'.c','c-','c'};%Glass surface

h1=figure;
hold on;
%plot(kdFromSlope(set1),kaFromSlope(onset1),'bx');
%plot(kdFromSlope(set2),kaFromSlope(onset2),'rx');
%plot(kdFromSlope(set3),kaFromSlope(onset3),'cx');
%plot(kdFromSlope(set4),kaFromSlope(onset4),'mx');
%plot(kdFromSlope(set5),kaFromSlope(onset5),'kx');
kdPlot=-0.005:0.0005:0.1;
for i=3%1:numel(onset)
errorbar(kdValsSelected{i},kaValsSelected{i},kaValsSelected{i}-lowerBoundkaSelected{i},upperBoundkaSelected{i}-kaValsSelected{i},kdValsSelected{i}-lowerBoundkdSelected{i},upperBoundkdSelected{i}-kdValsSelected{i},signs{i}{1});
plot(kdPlot,polyval(pfit{i},kdPlot),signs{i}{2});
end

xlim([-0.0005 0.004]);
ylim([0 0.2]);
hold on;
%xlim([0.01 0.1]);
%ylim([0 0.06]);
ylabel('kon s^-^1 nM^-^1')
xlabel('koff s^-^1')
title('Fig. 4D')

savefig(h1,'ka_vs_kd_colocexperiments.fig');


%also make fracs bound plot
h2=figure();
hold on;
for i=3:6%1:numel(onset)
   % errorbar(saltconcSelectedon{i},fracsBoundSelected{i},fracsBoundSelected{i}-lowerBoundfracsBoundSelected{i},upperBoundfracsBoundSelected{i}-fracsBoundSelected{i},signs{i}{1});
    plot(saltconcSelectedon{i},fracsBoundSelected{i},signs{i}{1});
end

ylabel('Fraction of DNA spots with binding event');
xlabel('[NaCl] (mm)')
title('Fig. S2A');
savefig(h2,'fracbound_vs_salt.fig')

h3=figure();
hold on;
for i=3%1:numel(onset)
   plot(saltconcSelectedon{i},KDValsSelected{i},cell2mat(signs{i}(1)));
end

ax=gca;
%ax.YScale='log';
ylabel('KD nM');
xlabel('[NaCl] (mm)')
title('Fig. S2B')
savefig(h3,'KD_vs_salt.fig');

h4=figure();
hold on;
for i=3%1:numel(onset)
   plot(saltconcSelectedon{i},kaValsSelected{i},cell2mat(signs{i}(1)));
end


ax=gca;
%ax.YScale='log';

ylabel('ka nM^-1 s^-1');
xlabel('[NaCl] (mm)')
title('fig. S2D')
savefig(h4,'ka_vs_salt.fig');

h5=figure();
hold on;
for i=3%1:numel(onset)
   plot(saltconcSelectedon{i},kdValsSelected{i},cell2mat(signs{i}(1)));
end


ax=gca;
%ax.YScale='log';


ylabel('kd  s^-1');
xlabel('[NaCl] (mm)')
title('Fig. S2C')
savefig(h5,'kd_vs_salt.fig');



%% Eestimate variation in koffmicro ptot, from the two repats with O1
varRatio=[];
for i=1:2
    numcurrvals=numel(kdValsSelected{i});
    koffmicrovals=pfit{i}(2).*kdValsSelected{i}./(pfit{i}(2)-kaValsSelected{i});
    ptotvals=kaValsSelected{i}./pfit{i}(2);
    
    okkas=kaValsSelected{i}<0.95*pfit{i}(2); %Only stiamte koffmicro and ptot for point which are samller than 95% of konmax
    ptotvals=ptotvals(okkas);
    koffmicrovals=koffmicrovals(okkas);
    
    ptotVar=std(ptotvals)/mean(ptotvals);
    koffmicroVar=std(koffmicrovals)/mean(koffmicrovals);
    
    varRatio(i)=ptotVar/koffmicroVar;
    
end


disp(['Ratio in variance in ptot/koffmicro is : ' num2str(mean(varRatio)) '+-' num2str(std(varRatio)/sqrt(2)) ]);
 %% Plot intensity traces for manuscrpit on rate 
theExp=142;%setIndexes{10}(2);%25;%57; %theExp 50 seems reversed in the viterbi states
timeStep=experiments{theExp}.timeStepOn;
okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
 intensityTraces=experiments{theExp}.intensityTracesOn;
 alltrajsCoLocAllFrames=experiments{theExp}.alltrajsCoLocAllFrames;

 ind=[32 24 29]; %16
starti=[1 1 1];
signs{1}='r-';
signs{2}='m-';
signs{3}='b-';
 %trajInd=okIndsTraces(ind);

 
t1=figure();
hold on;


for i=1:numel(starti)
    
    trajInd=okDNAIndsNotNan(ind(i));
    yyaxis left
    %ocu= experiments{theExp}.DNAoccupancy(trajInd,:)+1;
    %ocu=repmat(ocu,[timeStep/newTimeStep 1]);
    %ocu=ocu(:);
    
    
    %plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-1),experiments{theExp}.autcorrs2dshifted{ind}(1:100,:),'b-');
    
    %ylim([0 4])
    %yyaxis right
    hold on
    plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-starti(i)),intensityTraces{trajInd}(starti(i):end)',signs{i});
    ylim([-4e4 12e4]);
    ylabel('Fluorescence intensity (AU)')
    xlabel('Time (s)')
end
yyaxis right
timeStep=experiments{theExp}.timeStepOn;
numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:)-experiments{theExp}.intensityFirstTime(1,1),'k');
xlim([0 150]);
ylim([-0.6*(1/3) 0.6]);
box on;
%title(['Experiment: ' num2str(theExp) 'Tracjeory: ' num2str(okDNAIndsNotNan(ind)) '.fig']);
title('Fig. 4B') 


savefig(t1,['traces and on curve ' num2str(theExp) 'Tracjeory ' num2str(okDNAIndsNotNan(ind)) '.fig']);


 %% Plot intensity traces for manuscrpit off rate 
theExp=142+14;
timeStep=experiments{theExp}.timeStepOff;
okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
 intensityTraces=experiments{theExp}.intensityTracesOff;
 alltrajsCoLocAllFrames=experiments{theExp}.alltrajsCoLocAllFrames;
 
 ind=[8 160 100]; %93 107 108
starti=[1 13 45];
signs{1}='r-';
signs{2}='m-';
signs{3}='b-';
 %trajInd=okIndsTraces(ind);

 
t1=figure();
hold on;


for i=1:numel(ind)
    
    trajInd=okDNAIndsNotNan(ind(i));
    yyaxis left
    %ocu= experiments{theExp}.DNAoccupancy(trajInd,:)+1;
    %ocu=repmat(ocu,[timeStep/newTimeStep 1]);
    %ocu=ocu(:);
    
    
    %plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-1),experiments{theExp}.autcorrs2dshifted{ind}(1:100,:),'b-');
    
    %ylim([0 4])
    %yyaxis right
    hold on
    plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-starti(i)),intensityTraces{trajInd}(starti(i):end)',signs{i});
    ylim([-4e4 12e4]);
    ylabel('Fluorescence intensity (AU)')
    xlabel('Time (s)')
end
yyaxis right
timeStep=experiments{theExp}.timeStepOff;
numTimePoints=size(experiments{theExp}.intensityAllTime,2);
plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1),'k');
xlim([0 150]);
ylim([0.6 1]);
box on;
%title(['Experiment: ' num2str(theExp) 'Tracjeory: ' num2str(okDNAIndsNotNan(ind)) '.fig']);
title('Fig. 4B') 


savefig(t1,['traces and off curve ' num2str(theExp) 'Tracjeory ' num2str(okDNAIndsNotNan(ind)) '.fig']);
%% Plot intensity traces off rate testing
% theExp=142;%setIndexes{10}(2);%25;%57; %theExp 50 seems reversed in the viterbi states
% timeStep=experiments{theExp}.timeStepOff;
% okDNAIndsNotNan=experiments{theExp}.okDNAIndsNotNan;
%  intensityTraces=experiments{theExp}.intensityTracesOff;
%  alltrajsCoLocAllFrames=experiments{theExp}.alltrajsCoLocAllFrames;
%  
%  ind=[3 4 5]; %93 107 108
% starti=[1 1 26];
% signs{1}='r-';
% signs{2}='m-';
% signs{3}='b-';
%  %trajInd=okIndsTraces(ind);
% 
%  
% t1=figure();
% hold on;
% 
% 
% for i=1:numel(ind)
%     
%     trajInd=okDNAIndsNotNan(ind(i));
%     yyaxis left
%     %ocu= experiments{theExp}.DNAoccupancy(trajInd,:)+1;
%     %ocu=repmat(ocu,[timeStep/newTimeStep 1]);
%     %ocu=ocu(:);
%     
%     
%     %plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-1),experiments{theExp}.autcorrs2dshifted{ind}(1:100,:),'b-');
%     
%     %ylim([0 4])
%     %yyaxis right
%     hold on
%     plot(0:timeStep:timeStep*(numel(intensityTraces{trajInd})-starti(i)),intensityTraces{trajInd}(starti(i):end)',signs{i});
%     ylim([-4e4 12e4]);
%     ylabel('Fluorescence intensity (AU)')
%     xlabel('Time (s)')
% end
% yyaxis right
% timeStep=experiments{theExp}.timeStepOff;
% numTimePoints=size(experiments{theExp}.intensityAllTime,2);
% plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1),'k');
% %xlim([0 160]);
% ylim([0.6 1]);
% box on;
% yyaxis right
% title(['Experiment: ' num2str(theExp) 'Tracjeory: ' num2str(okDNAIndsNotNan(ind)) '.fig']);


%% Plot intensity curves for manuscript 
signs{1}='r-.';
signs{2}='r-';
signs{3}='r--';

onsetplot=[139 142 144];%[61 63 66];%[43:48];%43:48;
%onsetplot=setIndexes{10};%setIndexes(11,:)

f1=figure();
hold on;
k=1;
for theExp=onsetplot
    timeStep=experiments{theExp}.timeStepOn;

    numTimePoints=size(experiments{theExp}.intensityFirstTime,2);
    plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityFirstTime(1,:)-experiments{theExp}.intensityFirstTime(1,1),signs{k});
    k=k+1;
end

xlim([0 50]);
ylim([0 0.7]);
title('Fig. 4C association');
xlabel('Time (s)');
ylabel('Normalized fluorescence (AU)');

savefig(f1,['on_curves_' num2str(onsetplot) '.fig']);

offsetplot=onsetplot+14;%[146 149 151];

f2=figure();
hold on;
k=1;
for theExp=offsetplot
    timeStep=experiments{theExp}.timeStepOff;
    
    numTimePoints=size(experiments{theExp}.intensityAllTime,2);
    plot(0:timeStep:(numTimePoints-1)*timeStep,experiments{theExp}.intensityAllTime(end,:)/experiments{theExp}.intensityAllTime(end,1),signs{k});
    k=k+1;
end

title('Fig. 4C dissocation');
xlim([0 50]);
ylim([0.7 1]);
xlabel('Time (s)');
ylabel('Normalized fluorescence (AU)');
savefig(f2,['off_curves_' num2str(offsetplot) '.fig']);

